﻿local addonInfo, privateVars = ...

if not nkItemBase then nkItemBase = {} else return end
if not nkItemBase.db then nkItemBase.db = {} end

privateVars.debug = false

nkItemBase = {
	updateDate = '26.4.2015',
	db = {},
	db2 = {},
	addInfo = {},
	Query = {},	
	Execute = {},
	armorType = { rogue = 'leather', warrior = 'plate', mage = 'cloth', cleric = 'chain' },
	factions = { guardian =	{'Guardians', 'Guardian', 'Quicksilver Scholars', 'The Keepers', 'Caretakers', 'The Unspoken', 'Whitefall Brigade', 'Noble Guard', 'Order of the Death Serpent', 'Order of Life Serene', 'Mendicant Order', 'The Storm Inquisition', 'Order of Purity', 'Order of the Flame', 'Icewatch', 'Dragonslayer Covenant', 'Order of Mathos', 'Gloamwood Waykeepers', 'The Order of the Eye', 'Runic Sages', 'Arcane Hand', 'The Runeguard', 'Quarry Rats', 'Iron Claw Trappers', 'The Farclan', 'The Achyati', 'Empyreal Alliance', 'Eternal City Survivors', 'Hailol', 'Necropolis Caretakers', 'Ridgerunner Mercenaries', 'The Lycini', 'The Qaijiri', 'Torvan Hunters'},
					     defiant =	{'Defiants', 'Defiant', 'The Keepers', 'The Moribund' , 'Eldritch Seekers', 'The Storm Guard', 'Eldritch Vanguard', 'The Grim Disciples', 'Students of the Vale', 'The Shale Collegiate', 'Zephyrian Collective', 'Mercurial Savants', 'Ember Scholars', 'Icewatch', 'Dragonslayer Covenant', 'Order of Mathos', 'Freemarch Wardens', 'Granite Falls', 'The Unseen', 'The Seekers', 'Arcane Hand', 'The Runeguard', 'Quarry Rats', 'Red Scar Trackers', 'Kelari Expedition', 'The Achyati', 'Empyreal Alliance', 'Eternal City Survivors', 'Hailol', 'Necropolis Caretakers', 'Ridgerunner Mercenaries', 'The Lycini', 'The Qaijiri', 'Torvan Hunters'}
  },
	qualityColor = {{0.149, 0.498, 0, 1}, { 0.278, 0.467, 0.718, 1 }, { 0.596, 0.365, 0.788, 1 }, { 1, 0.416, 0, 1 }}
}

nkItemBase.texts = {}
local internal = {}
privateVars.lang = Inspect.System.Language()

--- Alte Varianten, werden bei nächster Gelegenheit gelöscht

function nkItemBase.getByKey(key) return nkItemBase.Query.byKey (key) end
function nkItemBase.getItemCategory (itemtype) return nkItemBase.Query.itemCategory (itemtype) end

---------- Datenbank Queries ----------------------------------------------------------------------

function internal.checkEntries (checkKey, mainCategory, mainTable, riftKeyFlag, augmentKey)

  for key, subTable in pairs (mainTable) do
    subTable = internal.unzip (mainCategory, key, subTable)
  
    if type(subTable) == 'table' then
  
      if riftKeyFlag ~= true then
        
        if subTable[checkKey] ~= nil then
          local err, retVal = pcall(internal.GetItemData, checkKey, augmentKey, mainCategory, key, subTable[checkKey])
          if err == true then
            return retVal
          else
            EnKai.tools.error.display (addonInfo.toc.Identifier, 'error getting item for : ' .. checkKey .. ' ' .. tostring(augmentKey) .. ' ' .. mainCategory .. ' ' .. key, 2)
            return nil
          end
        end
      else        
        for itemKey, itemDetails in pairs (subTable) do
        
          local key1, key2 = itemDetails.akey, checkKey
          if string.find(key1, ",") ~= nil then key1 = EnKai.strings.split(key1, ",")[1] end
          if string.find(key2, ",") ~= nil then key2 = EnKai.strings.split(key2, ",")[1] end
        
          if key1 == key2 then
            local err, retVal = pcall (internal.GetItemData, itemKey, nil, mainCategory, key, itemDetails)
            if err == true then
              return retVal
            else
              EnKai.tools.error.display (addonInfo.toc.Identifier, 'error getting item for : ' .. itemKey .. ' ' .. mainCategory .. ' ' .. key, 2)
              return nil
            end
          end
        end
      end
    end
  end
  
  return nil
end

function nkItemBase.Query.byKeyWithinCategories(key, categories)

  if privateVars.debug == true then 
    print ('nkItemBase.Query.byKeyWithinCategories')
    dump (categories)
  end
  
  for idx = 1, #categories, 1 do
    local data = nkItemBase.Query.byKey (key, nil, categories[idx])
    if data ~= nil then return data end
  end
  
  return nil

end

function nkItemBase.Query.byKey (key, riftKeyFlag, mainCategory, filterByFaction)

  if nkDebug then 
    print ('nkItemBase.Query.byKey')
    print (key, riftKeyFlag, mainCategory) 
  end
	
	local effectiveKey, augmentKey = key, nil

	if string.find (key, '-') ~= nil then
		augmentKey = string.sub(key, string.find(key, '-')+1)
		effectiveKey = string.sub(key, 1, string.find(key,'-')-1)
	end

	if mainCategory == nil then
		for k, v in pairs (nkItemBase.db) do
			local tempData = internal.checkEntries (effectiveKey, k, v, riftKeyFlag, augmentKey)
			
			if tempData ~= nil then
				if filterByFaction ~= true or tempData.rf == nil then return tempData end
				
				if nkItemBase.playerFaction == nil then internal.getPlayerDetails () end
				if EnKai.tools.table.isMember(nkItemBase.factions[nkItemBase.playerFaction], tempData.rf) then return tempData end
			end
		end
	elseif string.find(mainCategory, ",") ~= nil or string.find(mainCategory, ";") ~= nil then
	  local categories = EnKai.strings.split(mainCategory, ",")
	  if string.find(mainCategory, ";") ~= nil then
	    categories = EnKai.strings.split(mainCategory, ";")
	  end
	  
	  for idx = 1, #categories, 1 do
	    local this =  internal.checkEntries (effectiveKey, categories[idx], nkItemBase.db[categories[idx]], riftKeyFlag, augmentKey)
	    if this ~= nil then return this end
	  end
	else
		return internal.checkEntries (effectiveKey, mainCategory, nkItemBase.db[mainCategory], riftKeyFlag, augmentKey)
	end

	return nil
	
end

function nkItemBase.Query.byRiftInternalKey (key, mainCategory)


	
	local getDBKey = function (checkKey, mainCategory, mainTable)
	   
    for thisKey, subTable in pairs (mainTable) do
      if thisKey ~= "itemType" then
      
        if #subTable > 0 then
          subTable = internal.unzip (mainCategory, thisKey, subTable)
        end
        
        for itemKey, itemDetails in pairs (subTable) do
          if itemDetails.akey == checkKey then return itemKey end
        end
			end
		end
		
		return nil
	end
	
	if mainCategory == nil then
		for k, v in pairs (nkItemBase.db) do
		  local dbKey = getDBKey (key, k, v)
      if dbKey ~= nil then return dbKey end
		end
	else
		return getDBKey (key, mainCategory, nkitemBase.db[mainCategory])
	end

	return nil
	
end

function internal.GetItemData (effectiveKey, augmentKey, mainCategory, subCategory, itemData)

	local thisData = nil

	if augmentKey ~= nil then
		local gem = nkItemBase.Query.getAugmentationByKey (augmentKey)
		if subCategory == 'staff' then
			thisData = nkItemBase.Query.augmentItem (effectiveKey, gem, subCategory)
		else
			thisData = nkItemBase.Query.augmentItem (effectiveKey, gem, mainCategory)
		end
	else
		thisData = EnKai.tools.table.copy(itemData)
	end
	
	if mainCategory == 'recipe' then
		if EnKai.tools.lang.getLanguage() == 'French' then	
			thisData['use' .. EnKai.tools.lang.getLanguageShort()] = string.format (nkItemBase.texts.recipeUse, EnKai.strings.rightRegEx(thisData[string.lower(EnKai.tools.lang.getLanguageShort())], '(.+ : )'))
		else
			thisData['use' .. EnKai.tools.lang.getLanguageShort()] = string.format (nkItemBase.texts.recipeUse, EnKai.strings.rightRegEx(thisData[string.lower(EnKai.tools.lang.getLanguageShort())], '(.+: )'))
		end
		
		if thisData.rsslvl ~= nil then
			thisData['desc' .. EnKai.tools.lang.getLanguageShort()] = string.format (nkItemBase.texts.requires, nkItemBase.texts.profession[subCategory], thisData.rsslvl)
		end	
	end
	
	thisData.type = mainCategory .. ':' .. subCategory
	thisData.key = effectiveKey
	
	return thisData

end

function nkItemBase.Query.allByType (itemtype, subtype, calling, filterByCalling, filterByFaction)	
	
	if privateVars.debug == true then print ('nkItemBase.Query.allByType', itemtype, subtype) end
	
	local useCalling = calling	
	local useFaction = nil
	
	if useCalling == nil then		
		if nkItemBase.playerCalling == nil then internal.getPlayerDetails () end
		if nkItemBase.playerCalling == nil then return nil end
		useCalling = nkItemBase.playerCalling
	end
	
	if filterByFaction == true then
		if nkItemBase.playerFaction == nil then internal.getPlayerDetails () end
		if nkItemBase.playerFaction == nil then return nil end
		useFaction = nkItemBase.playerFaction
	end

	local result = nil
	
	if subtype == nil then	 
		if nkItemBase.db[itemtype].itemType == 'armor' then			
			local armorType = nkItemBase.armorType[useCalling]
			internal.unzip (itemtype, armorType, nkItemBase.db[itemtype][armorType])			
			result = nkItemBase.Query.MixinAddInfos (nkItemBase.db[itemtype][armorType], itemtype, armorType)
		elseif nkItemBase.db[itemtype].itemType == 'single' or nkItemBase.db[itemtype].itemType == 'trinket' or nkItemBase.db[itemtype].itemType == 'shield' or nkItemBase.db[itemtype].itemType == 'offhand' then
			if itemtype == 'cape' then 
			  internal.unzip (itemtype, "cloth", nkItemBase.db[itemtype]["cloth"])
				result = nkItemBase.Query.MixinAddInfos (nkItemBase.db[itemtype].cloth, itemtype, 'items')
			else
			  internal.unzip (itemtype, "items", nkItemBase.db[itemtype]["items"])
				result = nkItemBase.Query.MixinAddInfos (nkItemBase.db[itemtype].items, itemtype, 'items')
			end
		else
			result = {}
			for k, v in pairs (nkItemBase.db[itemtype]) do
			  v = internal.unzip (itemtype, k, v)
				if k ~= 'itemType' then EnKai.tools.table.mergeIndexed (result, nkItemBase.Query.MixinAddInfos (v, itemtype, k)) end
			end
		end
	elseif string.find(subtype, ',') ~= nil then
		result = {}
		local subtypeList = EnKai.strings.split(subtype, ',')
		
		for k, v in pairs (subtypeList) do
--		  print (itemtype, v)
		  internal.unzip (itemtype, v, nkItemBase.db[itemtype][v])
			local items = nkItemBase.Query.MixinAddInfos (nkItemBase.db[itemtype][v], itemtype, v)
			if items ~= nil then
				EnKai.tools.table.mergeIndexed(result, items)
			end
		end
	else
		local temp = nkItemBase.db[itemtype]		
		if temp ~= nil then
		  internal.unzip (itemtype, subtype, nkItemBase.db[itemtype][subtype]) 
		  result = nkItemBase.Query.MixinAddInfos (nkItemBase.db[itemtype][subtype], itemtype, subtype) 
		end
	end
			
	if result ~= nil then
		if filterByCalling == true then
			result = nkItemBase.Query.filterResultByCalling (result, useCalling)
		end
		
		if filterByFaction == true and useFaction ~= nil then
			result = nkItemBase.Query.filterResultByFaction (result, useFaction)
		end
		
		return result
	else
		return nil
	end

end

function nkItemBase.Query.getUpgrade(itemKey)
	
	return privateVars.upgrades[itemKey]
	
end

--------------------------------------------------------------------------------

function nkItemBase.Query.MixinAddInfos (itemTable, mainSlot, subSlot)

  if nkItemBase.addInfo[mainSlot] == nil then return itemTable end
	if nkItemBase.addInfo[mainSlot][subSlot] == nil then return itemTable end
	
	local addInfoTable = nkItemBase.addInfo[mainSlot][subSlot]
	
	if #addInfoTable > 0 then
    addInfoTable = internal.processzipped (addInfoTable)
    nkItemBase.addInfo[mainSlot][subSlot] = addInfoTable
  end
	
	for k, v in pairs (itemTable) do
		if addInfoTable[k] ~= nil then
			for l, w in pairs (addInfoTable[k]) do				
				itemTable[k][l] = w
			end
		end
	end
	
	return itemTable

end

function nkItemBase.Query.filterResultByCalling (items, calling)

	local tempTable = {}
	local compare = string.upper(string.sub (calling, 1, 1))
	
	for k, v in pairs (items) do	
		if v.rcall == nil then
			tempTable[k] = v
		else
			if string.find (v.rcall, ',') == nil then
				if v.rcall == compare then tempTable[k] = v end
			else			
				if EnKai.tools.table.isMember(EnKai.strings.split(v.rcall,','), compare) == true then tempTable[k] = v end
			end
		end
	end
	
	return tempTable
	
end

function nkItemBase.Query.filterResultByFaction (items, faction)

  local tempTable = {}

	for k, v in pairs (items) do
		if v.rf == nil then
			tempTable[k] = v
		else
			if EnKai.tools.table.isMember(nkItemBase.factions[faction], v.rf) then tempTable[k] = v end
		end
	end
	
	return tempTable	

end

function nkItemBase.Query.allCraftingByType (itemtype, subtype, calling, filterByCalling)

  if privateVars.debug == true then print ('nkItemBase.Query.allCraftingByType', itemtype, subtype) end

	local useCalling = calling	
	
	if useCalling == nil then		
		if nkItemBase.playerCalling == nil then internal.getPlayerDetails () end
		if nkItemBase.playerCalling ~= nil then useCalling = nkItemBase.playerCalling end
	end

	local items = {}
	
	for profkey, profdetails in pairs (nkItemBase.crafting.prof) do
		for slot, details in pairs (profdetails) do
			if itemtype == slot then
				for thistype, itemkeys in pairs (details) do
					if (thistype ~= "cloth" and thistype ~= "leather" and thistype ~= "plate" and thistype ~= "chain") or (thistype == nkItemBase.armorType[useCalling]) then
						if subtype == nil or string.find(subtype, thistype) ~= nil then
							for idx = 1, #itemkeys, 1 do							
								for gemkey, gem in pairs(nkItemBase.crafting.gems) do
									local itemData = nkItemBase.Query.augmentItem (itemkeys[idx], gem, slot)
									if itemData ~= nil then items[itemData.key .. '-' .. gemkey] = itemData end
								end
							end
						end
					end
				end
			end
		end
	end
	
	if filterByCalling == true then
		local useCalling = calling

		if useCalling == nil then
			if nkItemBase.playerCalling == nil then internal.getPlayerDetails () end
			if nkItemBase.playerCalling == nil then return nil end
			useCalling = nkItemBase.playerCalling
		end
			
		return nkItemBase.Query.filterResultByCalling (items, useCalling)
	else	
		return items
	end
	
end

function nkItemBase.Query.augmentItem (itemKey, gem, slot)

  if privateVars.debug == true then print ('nkItemBase.Query.augmentItem', itemKey, slot) end

	local itemData = EnKai.tools.table.copy(nkItemBase.Query.byKey(itemKey, nil, slot))
	
	if itemData == nil then return nil end
	
	itemData.de = string.format ("%s (%s)", itemData.de, gem.de)
	itemData.fr = string.format ("%s (%s)", itemData.fr, gem.fr)
	itemData.en = string.format ("%s (%s)", itemData.en, gem.en)
	itemData.ru = string.format ("%s (%s)", itemData.ru, gem.ru)
	
	if privateVars.lang  == 'German' then
		itemData.name = itemData.de
	elseif privateVars.lang  == 'French' then
		itemData.name = itemData.fr
	elseif privateVars.lang  == 'Russian' then
		itemData.name = itemData.ru	
	else
		itemData.name = itemData.en
	end 
		
	for idx = 1, #gem.stats, 1 do
		local index = nil
		if slot == 'onehanded' or slot == 'offhand' or slot == 'ranged' or slot == 'mainhand' then
			index = 1
		elseif slot == 'neck' then
			index = 2
		elseif slot == 'twohanded' then
			index = 3
		elseif slot == 'chest' or slot == 'legs' then
			index = 4
		elseif slot == 'ring' then
			index = 5
		elseif slot == 'gloves' then
			index = 6
		elseif slot == 'seal' then
			index = 7
		elseif slot == 'helmet' or slot == 'shoulders' or slot == 'cape' then
			index = 8
		end
		
		if index ~= nil then
			if itemData[gem.stats[idx]] == nil then
				itemData[gem.stats[idx]] = gem.statval[index][idx]
			else
				itemData[gem.stats[idx]] = itemData[gem.stats[idx]] + gem.statval[index][idx]
			end
		end
	end
	
	itemData.augmented = true
	
	return itemData

end

function nkItemBase.Query.professionOfItem (key)

	for profKey, slots in pairs (nkItemBase.crafting.prof) do
		for itemtype, subtype in pairs (slots) do
			for k, v in pairs (subtype) do
				
				if EnKai.tools.table.isMember(v, key) then				
					return profKey
				end
			end
		end		
	end
	
	return nil

end

function nkItemBase.Query.getCraftingResults (profession, slot) 

	local keyTable = {}
	if nkItemBase.crafting.prof[profession] == nil then return keyTable end
	
	for k, v in pairs (nkItemBase.crafting.prof[profession][slot]) do
		EnKai.tools.table.merge (keyTable, v)
	end

	return keyTable

end

function nkItemBase.Query.getAugmentationByKey (key) return nkItemBase.crafting.gems[key] end
function nkItemBase.Query.itemCategory (itemtype) return nkItemBase.db[itemtype].itemType end

function nkItemBase.Query.itemName (itemData) 

	local language = EnKai.tools.lang.getLanguage()
	
	if language == 'German' then
		return itemData.de
	elseif language == 'French' then
		return itemData.fr
	elseif language == 'Russian' then
		return itemData.ru
	else
		return itemData.en
	end

end

function nkItemBase.Query.byName (itemtype, name, exactFlag)

	local details = nkItemBase.Query.allByType (itemtype, nil, nil, true, true)
	
	if details ~= nil then
		for k, v in pairs (details) do
			if exactFlag == true then
				if v.de == name then
					return v
				elseif v.fr == name then
					return v
				elseif v.ru == name then
					return v
				elseif v.en == name then
					return v
				end
			else
				if string.find (v.de, name) ~= nil then
					return v
				elseif string.find (v.fr, name) ~= nil then
					return v
				elseif string.find (v.ru, name) ~= nil then
					return v
				elseif string.find (v.en, name) ~= nil then
					return v
				end				
			end
		end
	end

	return nil
	
end

function nkItemBase.Query.itemNameByKey (key, riftKeyFlag, mainCategory)

	local details = nkItemBase.Query.byKey(key, riftKeyFlag, mainCategory)
	
	if details == nil then return nil end
	
	if EnKai.tools.lang.getLanguage() == 'German' then
		return details.de
	elseif EnKai.tools.lang.getLanguage() == 'French' then
		return details.fr
	elseif EnKai.tools.lang.getLanguage() == 'Russian' then
		return details.ru
	else
		return details.en
	end
	
	return nil

end

function nkItemBase.Query.multipleTables ( tableList)

  if privateVars.debug == true then print ('nkItemBase.Query.multipleTables') end

	local retTable = {}
	
	for _, id in pairs (tableList) do
		local tempId = EnKai.strings.split(tostring(id),':')
		local tempTable = internal.unzip (tempId[1], tempId[2], nkItemBase.db[tempId[1]][tempId[2]])
		
		for k, v in pairs (tempTable) do
			retTable [k] = v
		end
	end
	
	return retTable

end

function internal.getPlayerDetails ()

	local userDetails

	if nkItemBase.playerCalling == nil then		
		userDetails = Inspect.Unit.Detail ('player')
		if userDetails == nil then return end
		nkItemBase.playerCalling = userDetails.calling		
	end
	
	if nkItemBase.playerFaction == nil then
		if userDetails == nil then userDetails = Inspect.Unit.Detail ('player') end
		nkItemBase.playerFaction = userDetails.alliance
	end
	
end

function nkItemBase.Execute.addItem (slot, subSlot, key, itemData)
		
	if privateVars.debug == true then print ('nkItemBase.Execute.addItem') end
		
	if nkItemBase.db[slot] == nil then nkItemBase.db[slot] = {} end
	if nkItemBase.db[slot][subSlot] == nil then nkItemBase.db[slot][subSlot] = {} end
	
	internal.unzip (slot, subSlot, nkItemBase.db[slot][subSlot])
	
	nkItemBase.db[slot][subSlot][key] = itemData

end

-- Items verändern

function nkItemBase.Execute.modifyItem (key, entry, value)

  if privateVars.debug == true then print ('nkItemBase.Execute.modifyItem') end

	local itemData = nkItemBase.Query.byKey (key)
	local slots = EnKai.strings.split(itemData.type, ":")
	if nkItemBase.db[slots[1]] ~= nil and nkItemBase.db[slots[1]][slots[2]] ~= nil and nkItemBase.db[slots[1]][slots[2]][key] ~= nil then
	
	  internal.unzip (slots[1], slots[2], nkItemBase.db[slots[1]][slots[2]])
	
		if type(value) == 'table' then
		
			if nkItemBase.db[slots[1]][slots[2]][key][entry] == nil then
				nkItemBase.db[slots[1]][slots[2]][key][entry] = {} 
			end
		
			for k, v in pairs (value) do
				nkItemBase.db[slots[1]][slots[2]][key][entry][k] = v
			end
		
		elseif nkItemBase.db[slots[1]][slots[2]][key][entry] == nil or type(nkItemBase.db[slots[1]][slots[2]][key][entry]) ~= 'table' then
			
			nkItemBase.db[slots[1]][slots[2]][key][entry] = value
		
		else
			
			EnKai.tools.error.display (addonInfo.toc.Identifier, 'error modifiy item : ' .. key.. ' cannot add string to table ' .. entry , 2)				
			
		end
	end

end

-- Unzip data

function internal.unzip (main, sub, data)

  --print (main, sub, type(data))

  if type(data) == "table" then
    
    if #data > 0 then
      --print (#data, main, sub)
      
      if #data > 5 and Inspect.System.Secure() == false then Command.System.Watchdog.Quiet() end
    
      nkItemBase.db[main][sub] = internal.processzipped (data)
      data = nkItemBase.db[main][sub]
    end
  end

  return data

end

function internal.processzipped (data)

  local temp = {} 

  for idx = 1, #data, 1 do
    local error, unzippedData = pcall (EnKai.zip.uncompress, data[idx])
    if error == true then
      local err, func = pcall(loadstring, "return {" .. unzippedData .. "}")
      if err == true then
        local tempData = func()
        for k, v in pairs(tempData) do
          temp[k] = v
        end
      end
    end    
  end
  
  return temp

end

EnKai.internal.checkEvents ("nkItemBase", true)
EnKai.eventHandlers["nkItemBase"]["queryByKeyFinished"], EnKai.events["nkItemBase"]["queryByKeyFinished"] = Utility.Event.Create(addonInfo.identifier, "nkItemBasequeryByKeyFinished")