local addonInfo, privateVars = ...

nkAAPI = {}
nkAAPI.uiElements = {}

function nkAAPI.test ()

  local data = nil
  nkAdvisorSetup = {}
  local checksum, data = EnKai.zip.compress (EnKai.tools.table.serialize(nkItemBase.db)) 
  
  print (EnKai.tools.table.serialize(nkItemBase.db))
  
  nkAdvisorSetup.checksum  = checksum
  nkAdvisorSetup.data  = data
  
  print(EnKai.zip.checksum(data), checksum)
  dump (EnKai.zip.uncompress(data))
  
  print ('done')

end

function nkAAPI.addModule(name, version, set, label, func) 
	
	table.insert (privateVars.modules, { name = name, version = version, set = set, label = label, func = func })
	
	if nkPanel ~= nil and nkAdvisorSettings.nkPanel == true then
		local func = function ()
			if privateVars.uiElements.window == nil then
				nkAdvisor.Show()
			else
				privateVars.uiElements.window:SetVisible(true)
			end
			
			local info = privateVars.uiElements.window:GetTabPane():GetPaneInfo()
			for idx = 1, #info, 1 do			
				if info[idx].label == label then
					privateVars.uiElements.window:GetTabPane():SwitchToPane(idx)
					break
				end
			end
		end
	
		privateVars.uiElements.panel:AddMenuEntry({ closeOnClick = true, label = label, macro = nil, callBack = func})
	end

 end
 
function nkAAPI.checkVersion (name, lookFor, version)

	local checkVersion = nil
	
	if lookFor == 'nkAdvisor' then
		checkVersion = addonInfo.toc.Version
	else
		for k, v in pairs (privateVars.modules) do
			if v.name == lookFor then
				checkVersion = v.version
				break
			end
		end
	end	
	
	if checkVersion == nil then 
		nkAAPI.showErrorDialog( string.format (nkAdvisor.langTexts.messages.errVersionMismatch, name, lookFor, version))
		return false 
	end

	local versionArray = EnKai.strings.split(version, '%.')
	local checkVersionArray = EnKai.strings.split(checkVersion, '%.')
	
	if #versionArray ~= #checkVersionArray then 
		nkAAPI.showErrorDialog( string.format (nkAdvisor.langTexts.messages.errVersionMismatch, name, lookFor, version))
		return false 
	end
	
	for idx = 1, #versionArray, 1 do
		if tonumber(versionArray[idx]) < tonumber(checkVersionArray[idx]) then
			return true
		elseif tonumber(versionArray[idx]) > tonumber(checkVersionArray[idx]) then
			nkAAPI.showErrorDialog( string.format (nkAdvisor.langTexts.messages.errVersionMismatch, name, lookFor, version))
			return false 
		end
	end	

	return true
	
end
 
function nkAAPI.registerModuleFunc(name, id, func) 
 
	if privateVars.moduleFunc == nil then 
		privateVars.moduleFunc = {}
	end
 
	if privateVars.moduleFunc[name] == nil then 
		privateVars.moduleFunc[name] = {}
	end
	
	privateVars.moduleFunc[name][id] = func
 
 end

function nkAAPI.registerCloseFunc (name, func, paraTable)

	if privateVars.closeFunc == nil then privateVars.closeFunc = {} end
	privateVars.closeFunc[name] = { func = func, paraTable = paraTable }
		
end 
 
function nkAAPI.createTooltip(riftKey, itemData, parent, xpos, ypos, showCompare )

  if riftKey == nil then return end

	if privateVars.uiElements.tooltip == nil then privateVars.uiElements.tooltip = EnKai.uiCreateFrame("nkItemTooltip", 'nkAdvisorMainTooltip', privateVars.uiElements.tooltipContext) end
	
	privateVars.uiElements.tooltip:ClearAll()
	privateVars.uiElements.tooltip:SetPoint("TOPLEFT", parent, "TOPLEFT", xpos, ypos)
	privateVars.uiElements.tooltip:SetLayer(99)
	
	nkAAPI.getBoni(itemData)
	
	privateVars.uiElements.tooltip:SetItem(riftKey, itemData)
	privateVars.uiElements.tooltip:SetVisible(true)

	if nkAAPI.isModuleRegistered ('nkAdvisor_Loot') == true or nkAAPI.isModuleRegistered ('nkAdvisor_Level') == true then
		if privateVars.uiElements.tooltipDropLocation == nil then 
			privateVars.uiElements.tooltipDropLocation = EnKai.uiCreateFrame("nkTooltip", 'nkAdvisorMainTooltip.DropLocation', privateVars.uiElements.tooltip) 			
			privateVars.uiElements.tooltipDropLocation:SetLayer(99)
			privateVars.uiElements.tooltipDropLocation:SetTitle(nkAdvisor.langTexts.tooltip.txtDroppedBy)
		end

		privateVars.uiElements.tooltipDropLocation:ClearAll()
		privateVars.uiElements.tooltipDropLocation:SetPoint("TOPLEFT", privateVars.uiElements.tooltip, "BOTTOMLEFT", 0, 5)		
		
		local dropLine1, dropLine2 = nil, nil
		
		dropLine1, dropLine2 = nkAAPI.callModuleFunc('nkAdvisor_Loot', 'getDropLocation', {key = itemData.key})
		
		if (dropLine1 == nil or dropLine1=="") and nkAAPI.isModuleRegistered ('nkAdvisor_Level') == true then
		  dropLine1, dropLine2 = nkAAPI.callModuleFunc('nkAdvisor_Level', 'getDropLocation', {key = itemData.key})
		end
		local lines = {}
			
		if dropLine1 ~= nil and dropLine1 ~= "" then
			if dropLine1 ~= '' then table.insert (lines, { text = dropLine1, height = 16 }) end
			table.insert (lines, { text = dropLine2, height = 16 })
						
			privateVars.uiElements.tooltipDropLocation:SetLines(lines)
			
			if privateVars.uiElements.tooltipDropLocation:GetWidth() < privateVars.uiElements.tooltip:GetWidth() then  
        privateVars.uiElements.tooltipDropLocation:SetWidth(privateVars.uiElements.tooltip:GetWidth())
			end
			
			privateVars.uiElements.tooltipDropLocation:SetVisible(true)
		else
		  privateVars.uiElements.tooltipDropLocation:SetVisible(false)
		end
	end
	
	if showCompare ~= true then return end
	
	if privateVars.uiElements.tooltipCompare1 == nil then 
		privateVars.uiElements.tooltipCompare1 = EnKai.uiCreateFrame("nkItemTooltip", 'nkAdvisorCompare1Tooltip', privateVars.uiElements.tooltipContext)
		privateVars.uiElements.tooltipCompare1:SetPoint("TOPLEFT", privateVars.uiElements.tooltip, "TOPRIGHT", 2, 0)		
	end
	
	if privateVars.uiElements.tooltipCompare2 == nil then 
		privateVars.uiElements.tooltipCompare2 = EnKai.uiCreateFrame("nkItemTooltip", 'nkAdvisorCompare2Tooltip', privateVars.uiElements.tooltipContext)
		privateVars.uiElements.tooltipCompare2:SetPoint("TOPLEFT", privateVars.uiElements.tooltipCompare1, "TOPRIGHT", 2, 0)		
	end	
	
	privateVars.uiElements.tooltipCompare1:SetVisible(false)
	privateVars.uiElements.tooltipCompare2:SetVisible(false)

	local details = privateVars.uiElements.tooltip:GetDetails()

	if details == nil then return end
		
	if details.category == nil or string.find(details.category, 'planar') ~= nil or string.find(details.category, 'consumable') ~= nil then return end
	local tempType = EnKai.items.translateRiftCategory(details.category)	
	if (tempType == nil) then return end
	local tmpItemBase = EnKai.strings.split(tempType, ':')	
	
	local riftSlot = string.sub(tempType, 1, string.find(tempType, ':')-1)
	
	if nkAAPI.getRessource ('typeToSlot', riftSlot) ~= nil then riftSlot = nkAAPI.getRessource ('typeToSlot', riftSlot) end
	
	if string.find(riftSlot, '+') ~= nil then
	
		local tempSlot = EnKai.strings.split(riftSlot, '+')
		
		local equipSlot = Utility.Item.Slot.Equipment(tempSlot[1])			
		local equipedItem = Inspect.Item.Detail(equipSlot)
		
		if equipedItem == nil then return end
		
		local itemLibDetails = nkItemBase.Query.byKey (equipedItem.type, true, tmpItemBase[1], tmpItemBase[2])
		
		privateVars.uiElements.tooltipCompare1:SetItem(equipedItem.id, itemLibDetails)
		privateVars.uiElements.tooltipCompare1:SetVisible(true)
	elseif string.find(riftSlot, ':') ~= nil then
		local tempSlot = EnKai.strings.split(riftSlot, ':')
		
		local equipSlot = Utility.Item.Slot.Equipment(tempSlot[1])
		local equipedItem = Inspect.Item.Detail(equipSlot)
		
		if equipedItem == nil then return end
		
		privateVars.uiElements.tooltipCompare1:SetItem(equipedItem.id, nil)
		privateVars.uiElements.tooltipCompare1:SetVisible(true)
		
		local equipSlot = Utility.Item.Slot.Equipment(tempSlot[2])
		local equipedItem = Inspect.Item.Detail(equipSlot)
		
		if equipedItem == nil then return end
		
		local itemLibDetails = nkItemBase.Query.byKey (equipedItem.type, true, tmpItemBase[1], true)
		
		privateVars.uiElements.tooltipCompare2:SetItem(equipedItem.id, itemLibDetails)
		privateVars.uiElements.tooltipCompare2:SetVisible(true)
	else
		local err, slot = pcall (Utility.Item.Slot.Equipment, riftSlot)
		if err == true then
			local equipedItem = Inspect.Item.Detail(slot)
			if equipedItem == nil then return end
		
			local itemLibDetails = nkItemBase.Query.byKey (equipedItem.type, true, tmpItemBase[1], tmpItemBase[2])
			
			privateVars.uiElements.tooltipCompare1:SetItem(equipedItem.id, itemLibDetails)
			privateVars.uiElements.tooltipCompare1:SetVisible(true)
		end
	end
end

function nkAAPI.getBoni(itemData)
	if itemData.itemSetID ~= nil and itemData.type ~= "synergycrystal:items" then
		for k, v in pairs (nkItemBase.db.synergycrystal.items) do
			if v.itemSetID == itemData.itemSetID then
				itemData.itemSetBonus = v.itemSetBonus
				break
			end
		end
	end
end
 
function nkAAPI.hideTooltip()
 
	if privateVars.uiElements.tooltip ~= nil then privateVars.uiElements.tooltip:SetVisible(false) end
	if privateVars.uiElements.tooltipCompare1 ~= nil then privateVars.uiElements.tooltipCompare1:SetVisible(false) end
	if privateVars.uiElements.tooltipCompare2 ~= nil then privateVars.uiElements.tooltipCompare2:SetVisible(false) end
 
 end
 
function nkAAPI.isModuleRegistered (name)
	
	for _, values  in pairs (privateVars.modules) do
		if values.name == name then return true end
	end
	
	return false
 
 end

function nkAAPI.callModuleFunc (name, id, paraTable)

	if privateVars.moduleFunc == nil then return end
	if privateVars.moduleFunc[name] == nil then return end

	for key, func in pairs (privateVars.moduleFunc[name]) do
		if key == id then return func (paraTable) end
	end

end
 
function nkAAPI.getRessource (ID, subID) 

	if subID == nil then
		return nkAdvisor.ressources[ID]
	else
		return nkAdvisor.ressources[ID][subID]
	end
		
end
 
function nkAAPI.getFaction()	
	if privateVars.faction == nil then nkAdvisor.getPlayerDetails () end
	return privateVars.faction 
end 

function nkAAPI.getCalling() return privateVars.activeCalling end
function nkAAPI.setCalling(calling) privateVars.activeCalling = calling end
function nkAAPI.getPane(name) return nkAAPI.uiElements.panes[name] end
function nkAAPI.getPlayerDetails() return nkAdvisor.getPlayerDetails() end

function nkAAPI.closeUI() 

	if privateVars.closeFunc ~= nil then
		for _, details in pairs (privateVars.closeFunc) do
			details.func(details.paraTable)
		end
	end

	privateVars.uiElements.window:SetVisible(false)  
	
end

function nkAAPI.showInfoDialog (title, message)

	if nkAAPI.uiElements.messageDialog == nil then
		nkAAPI.uiElements.messageDialog = EnKai.uiCreateFrame("nkDialog", "nkAAPI.messageDialog", privateVars.uiElements.dialogContext)
		nkAAPI.uiElements.messageDialog:SetWidth(500)
		nkAAPI.uiElements.messageDialog:SetHeight(200)
		nkAAPI.uiElements.messageDialog:SetType('message')
	end
	
	nkAAPI.uiElements.messageDialog:SetMessage(message)
	nkAAPI.uiElements.messageDialog:SetVisible(true)
		
end

function nkAAPI.showConfirmDialog (title, message, funcYes)

	if nkAAPI.uiElements.confirmDialog == nil then
		nkAAPI.uiElements.confirmDialog = EnKai.uiCreateFrame("nkDialog", "nkAAPI.confirmDialog", privateVars.uiElements.dialogContext)
		nkAAPI.uiElements.confirmDialog:SetWidth(500)
		nkAAPI.uiElements.confirmDialog:SetHeight(250)
		nkAAPI.uiElements.confirmDialog:SetType('confirm')
	end
	
	nkAAPI.uiElements.confirmDialog:SetMessage(message)
	nkAAPI.uiElements.confirmDialog:SetVisible(true)
	
	Command.Event.Detach(EnKai.events['nkAAPI.confirmDialog'].LeftButtonClicked, nil, "nkAAPI.confirmDialog.LeftButtonClicked") -- delete possible earlier event handler and replace with new one
	
	Command.Event.Attach(EnKai.events['nkAAPI.confirmDialog'].LeftButtonClicked, function ()
		funcYes()
	end, "nkAAPI.confirmDialog.LeftButtonClicked")

end

function nkAAPI.showErrorDialog (message)
	
	if nkAAPI.uiElements.errorDialog == nil then
		nkAAPI.uiElements.errorDialog = EnKai.uiCreateFrame("nkDialog", "nkAAPI.errorDialog", privateVars.uiElements.dialogContext)
		nkAAPI.uiElements.errorDialog:SetWidth(500)
		nkAAPI.uiElements.errorDialog:SetHeight(200)
		nkAAPI.uiElements.errorDialog:SetType('message')
	end
	
	nkAAPI.uiElements.errorDialog:SetTitle(nkAdvisor.langTexts.messages.dialogTitle)
	nkAAPI.uiElements.errorDialog:SetMessage(message)
	nkAAPI.uiElements.errorDialog:SetVisible(true)

end

function nkAAPI.convertRiftStats (equipedItem)

	local tempItem = {}
	
	if equipedItem == nil then return tempItem end
	
	tempItem.type = EnKai.items.translateRiftCategory(equipedItem.category)
	
	tempItem.de = equipedItem.name		
	tempItem.fr = equipedItem.name
	tempItem.en = equipedItem.name
	
	if equipedItem.damageDelay ~= nil then
		tempItem.dps = math.floor ((equipedItem.damageMax + equipedItem.damageMin) / 2 / equipedItem.damageDelay * 10 ) / 10
	end
	
	if equipedItem.rarity == nil then
		tempItem.q = 0
	elseif equipedItem.rarity == 'uncommon' then
		tempItem.q = 1
	elseif equipedItem.rarity == 'rare' then
		tempItem.q = 2
	elseif equipedItem.rarity == 'epic' then
		tempItem.q = 3
	elseif equipedItem.rarity == 'relic' then
		tempItem.q = 4
	end		
	
	if equipedItem.stats ~= nil then
		tempItem.armor = equipedItem.stats.armor
		
		tempItem.endu = equipedItem.stats.endurance
		tempItem.dex = equipedItem.stats.dexterity
		tempItem.str = equipedItem.stats.strength
		tempItem.dodge = equipedItem.stats.dodge
		tempItem.hit = equipedItem.stats.hit
		tempItem.atp = equipedItem.stats.powerAttack
		tempItem.crit = equipedItem.stats.critAttack
		tempItem.int = equipedItem.stats.intelligence
		tempItem.sp = equipedItem.stats.powerSpell
		tempItem.scrit = equipedItem.stats.critSpell		
		tempItem.cp = equipedItem.stats.critPower
		tempItem.wis = equipedItem.stats.wisdom
		tempItem.block = equipedItem.stats.block		
		tempItem.prot= equipedItem.stats.guard
		
		tempItem.resiA = equipedItem.stats.resistAir
		tempItem.resiD = equipedItem.stats.resistDeath
		tempItem.resiE = equipedItem.stats.resistEarth
		tempItem.resiF = equipedItem.stats.resistFire
		tempItem.resiL = equipedItem.stats.resistLife
		tempItem.resiW = equipedItem.stats.resistWater
	end
	
	return tempItem

end

function nkAAPI.showUpgrade(equippedItem)

	if nkAAPI.uiElements.upgradeWindow == nil then

		local window = EnKai.uiCreateFrame("nkWindow", "nkAdvisor.upgradeWindow", privateVars.uiElements.window:GetContent())
		window:SetWidth(200)
		window:SetHeight(425)
		window:SetTitle("")
		window:SetPoint("TOPLEFT", privateVars.uiElements.window, "TOPRIGHT")
		
		window.item1Title = UI.CreateFrame("Text", "nkAdvisor.upgradeWindow.item1Title", window)
		window.item1Title:SetPoint("CENTERTOP", window:GetContent(), "CENTERTOP", 0, 10)
		--window.item1Title:SetWordwrap(true)
		window.item1Title:SetWidth(window:GetContent():GetWidth()-10)
		window.item1Title:SetFontColor(1,1,1,1)
		window.item1Title:SetFontSize(13)
		window.item1Title:SetEffectGlow({ offsetX = 2, offsetY = 2})
		window.item1Title:SetLayer(8)
		
		window.item1 = EnKai.uiCreateFrame("nkActionButton", "nkAdvisor.upgradeWindow.item1", window)
		window.item1:SetPoint("CENTERTOP", window.item1Title, "CENTERBOTTOM", 0, 5)
		window.item1:SetLayer(7)
		
		window.arrow = UI.CreateFrame("Texture", "nkAdvisor.upgradeWindow.arrow", window)
		window.arrow:SetWidth(34)
		window.arrow:SetHeight(194)
		window.arrow:SetTextureAsync("nkAdvisor", "gfx/upgradeArrow.png")
		window.arrow:SetPoint("CENTERTOP", window.item1, "CENTERBOTTOM")
		window.arrow:SetLayer(1)
		
		window.item2 = EnKai.uiCreateFrame("nkActionButton", "nkAdvisor.upgradeWindow.item2", window)
		window.item2:SetPoint("CENTERTOP", window.arrow, "CENTERBOTTOM", 0, 0)
		window.item2:SetLayer(6)
		
		window.item2Title = UI.CreateFrame("Text", "nkAdvisor.upgradeWindow.item2Title", window)
		window.item2Title:SetPoint("CENTERTOP", window.item2, "CENTERBOTTOM", 0, 5)
		--window.item2Title:SetWordwrap(true)
		window.item2Title:SetWidth(window:GetContent():GetWidth()-10)
		window.item2Title:SetFontColor(1,1,1,1)
		window.item2Title:SetFontSize(13)
		window.item2Title:SetEffectGlow({ offsetX = 2, offsetY = 2})
		window.item2Title:SetLayer(5)
		
		window.upgradeItem1 = EnKai.uiCreateFrame("nkActionButton", "nkAdvisor.upgradeWindow.upgradeItem1", window)
		window.upgradeItem1:SetPoint("CENTER", window.arrow, "CENTER", 0, 5)
		window.upgradeItem1:SetScale(0.65)
		window.upgradeItem1:SetLayer(4)
		
		window.upgradeItem2 = EnKai.uiCreateFrame("nkActionButton", "nkAdvisor.upgradeWindow.upgradeItem2", window)
		window.upgradeItem2:SetPoint("CENTERLEFT", window.upgradeItem1, "CENTERRIGHT", 5, 0)
		window.upgradeItem2:SetScale(0.65)
		window.upgradeItem2:SetLayer(3)
		
		window.upgradeItem3 = EnKai.uiCreateFrame("nkActionButton", "nkAdvisor.upgradeWindow.upgradeItem3", window)
		window.upgradeItem3:SetPoint("CENTERLEFT", window.upgradeItem2, "CENTERRIGHT", 5, 0)
		window.upgradeItem3:SetScale(0.65)
		window.upgradeItem3:SetLayer(2)
		
		Command.Event.Attach(EnKai.events['nkAdvisor.upgradeWindow.item1'].MouseOut, function ()
			nkAAPI.hideTooltip()
		end, "nkAdvisor.upgradeWindow.item1.MouseOut")
		
		Command.Event.Attach(EnKai.events['nkAdvisor.upgradeWindow.item2'].MouseOut, function ()
			nkAAPI.hideTooltip()
		end, "nkAdvisor.upgradeWindow.item2.MouseOut")
				
		Command.Event.Attach(EnKai.events['nkAdvisor.upgradeWindow.upgradeItem1'].MouseOut, function ()
			nkAAPI.hideTooltip()
		end, "nkAdvisor.upgradeWindow.upgradeItem1.MouseOut")
		
		Command.Event.Attach(EnKai.events['nkAdvisor.upgradeWindow.upgradeItem2'].MouseOut, function ()
			nkAAPI.hideTooltip()
		end, "nkAdvisor.upgradeWindow.upgradeItem2.MouseOut")
		
		Command.Event.Attach(EnKai.events['nkAdvisor.upgradeWindow.upgradeItem3'].MouseOut, function ()
			nkAAPI.hideTooltip()
		end, "nkAdvisor.upgradeWindow.upgradeItem3.MouseOut")
								
		nkAAPI.uiElements.upgradeWindow = window
	end 
	
	nkAAPI.uiElements.upgradeWindow:SetVisible(false)
	
	if privateVars.debug == true then print ("get item1Details") end
	local item1Details = nkItemBase.Query.byKey (equippedItem, false)
	if item1Details == nil then return end
	
	local upgradeKey = nkItemBase.Query.getUpgrade(equippedItem)
	if upgradeKey == nil then return end
	
	local item2Details = nkItemBase.Query.byKey (upgradeKey, false)
	if item2Details == nil then return end
	
	if item2Details.cost == nil then return end
		
	Command.Event.Detach(EnKai.events['nkAdvisor.upgradeWindow.item1'].MouseIn, nil, "nkAdvisor.upgradeWindow.item1.MouseIn")
	Command.Event.Detach(EnKai.events['nkAdvisor.upgradeWindow.item2'].MouseIn, nil, "nkAdvisor.upgradeWindow.item2.MouseIn")
	Command.Event.Detach(EnKai.events['nkAdvisor.upgradeWindow.upgradeItem1'].MouseIn, nil, "nkAdvisor.upgradeWindow.upgradeItem1.MouseIn")
	Command.Event.Detach(EnKai.events['nkAdvisor.upgradeWindow.upgradeItem2'].MouseIn, nil, "nkAdvisor.upgradeWindow.upgradeItem2.MouseIn")
	Command.Event.Detach(EnKai.events['nkAdvisor.upgradeWindow.upgradeItem3'].MouseIn, nil, "nkAdvisor.upgradeWindow.upgradeItem3.MouseIn")	
	
	for idx = 1, 3, 1 do
		nkAAPI.uiElements.upgradeWindow['upgradeItem' .. idx]:SetVisible(false)
	end
	
	local counter = 1
	
	for k, v in pairs (item2Details.cost) do
		if k ~= equippedItem then
			local upgradeItem = nkItemBase.Query.byKey (k, false)
			if upgradeItem ~= nil then		
				nkAAPI.uiElements.upgradeWindow['upgradeItem' .. counter]:SetTexture('Rift', string.format('Data/\\UI\\item_icons\\%s.dds', upgradeItem.icon))
				nkAAPI.uiElements.upgradeWindow['upgradeItem' .. counter]:SetVisible(true)
				
				Command.Event.Attach(EnKai.events['nkAdvisor.upgradeWindow.upgradeItem' .. counter].MouseIn, function ()
					nkAAPI.createTooltip(upgradeItem.akey, upgradeItem, nkAAPI.uiElements.upgradeWindow['upgradeItem' .. counter], 10, 10, true)
				end, "nkAdvisor.upgradeWindow.upgradeItem"..counter ..".MouseIn")
				
				counter = counter + 1
			end
		end
	end
	
	if counter == 2 then
		nkAAPI.uiElements.upgradeWindow.upgradeItem1:SetPoint("CENTER", nkAAPI.uiElements.upgradeWindow.arrow, "CENTER", 0, -10)
	elseif counter == 3 then
		nkAAPI.uiElements.upgradeWindow.upgradeItem1:SetPoint("CENTER", nkAAPI.uiElements.upgradeWindow.arrow, "CENTER", -20, -10)
	else
		nkAAPI.uiElements.upgradeWindow.upgradeItem1:SetPoint("CENTER", nkAAPI.uiElements.upgradeWindow.arrow, "CENTER", -57, -10)
	end 
	
	nkAAPI.uiElements.upgradeWindow.item1:SetTexture("Rift", string.format('Data/\\UI\\item_icons\\%s.dds', item1Details.icon))
	nkAAPI.uiElements.upgradeWindow.item1Title:ClearHeight()
	nkAAPI.uiElements.upgradeWindow.item1Title:SetText(item1Details[string.lower(EnKai.tools.lang.getLanguageShort())])
	
	nkAAPI.uiElements.upgradeWindow.item2:SetTexture("Rift", string.format('Data/\\UI\\item_icons\\%s.dds', item2Details.icon))
	nkAAPI.uiElements.upgradeWindow.item2Title:ClearHeight()
	nkAAPI.uiElements.upgradeWindow.item2Title:SetText(item2Details[string.lower(EnKai.tools.lang.getLanguageShort())])
	
	Command.Event.Attach(EnKai.events['nkAdvisor.upgradeWindow.item1'].MouseIn, function ()
		nkAAPI.createTooltip(item1Details.akey, item1Details, nkAAPI.uiElements.upgradeWindow.item1, 20, 20, true)
	end, "nkAdvisor.upgradeWindow.item1.MouseIn")
				
	Command.Event.Attach(EnKai.events['nkAdvisor.upgradeWindow.item2'].MouseIn, function ()
		nkAAPI.createTooltip(item2Details.akey, item2Details, nkAAPI.uiElements.upgradeWindow.item2, 20, 20, true)
	end, "nkAdvisor.upgradeWindow.item2.MouseIn")
		
	nkAAPI.uiElements.upgradeWindow:SetVisible(true)

end

function nkAAPI.unzippData (data)

  local temp = {} 

  if #data > 5 then Command.System.Watchdog.Quiet() end

  for idx = 1, #data, 1 do
    local error, unzippedData = pcall (EnKai.zip.uncompress, data[idx])
    if error == true then
      local err, func = pcall(loadstring, "return {" .. unzippedData .. "}")
      if err == true then
        local tempData = func()
        for k, v in pairs(tempData) do
          temp[k] = v
        end
      end
    end    
  end
  
  return temp

end