local addonInfo, privateVars = ...

nkItemBase.crafting = {}
nkItemBase.db.recipe = {}

nkItemBase.crafting.gems = {
["A5928AEF0F01010101"] = {akey="IFDE28925538225A0,52054B7723015143,,,,,,",de="Stellare Verstärkung der Exaktheit",en="Stellar Accurate Augment",fr="Augmentation de précision stellaire",ru="Звездное точное усиление",stats={'atp'},statval={{21},{20},{40},{24},{16},{18},{11},{21}},rlvl=60,icon="bloody_stinger",descEN="Grants a bonus to Attack Power when added to a crafting recipe. Appropriate for level 60.",descFR="Confère un bonus à la puissance d'attaque en l'ajoutant à une recette d'artisanat. Accessible au niveau 60.",val=34000,q=3,descDE="Das Hinzufügen zu einer Handwerksanleitung verleiht einen Angriffskraftbonus. Geeignet für Stufe 60."},
["B7B3E0F90F01010101"] = {akey="IFF3819B74E88ACF3,4F6071400212DE88,,,,,,",de="Stellare Verstärkung der Flüchtigkeit",en="Stellar Elusive Augment",fr="Augmentation insaisissable stellaire",ru="Звездное проворное усиление",stats={'dodge'},statval={{24},{22},{45},{27},{18},{20},{12},{24}},rlvl=60,icon="paragon-improved_predicatable_movements_a",descEN="Grants a bonus to Dodge when added to a crafting recipe. Appropriate for level 60.",descFR="Confère un bonus à l'esquive en l'ajoutant à une recette d'artisanat. Accessible au niveau 60.",val=34000,q=3,descDE="Das Hinzufügen zu einer Handwerksanleitung verleiht einen Ausweichbonus. Geeignet für Stufe 60."},
["E3F2B8DC0F01010101"] = {akey="IFB8E39633DE0C0BF,8292F879FC944831,,,,,,",de="Stellare Verstärkung der Undurchdringlichkeit",en="Stellar Impenetrable Augment",fr="Augmentation d'impénétrabilité stellaire",ru="Звездное непробиваемое усиление",stats={'endu','block'},statval={{19,33},{17,31},{35,61},{21,37},{14,25},{16,28},{10,17},{19,33}},rlvl=60,icon="1h_shield_054a",descEN="Grants a bonus to both Block and Endurance when added to a crafted recipe. Appropriate for level 60.",descFR="Accorde un bonus au blocage et à l'endurance en l'ajoutant à une recette d'artisanat. Accessible au niveau 60.",val=34000,q=3,descDE="Das Hinzufügen zu einer Handwerksanleitung verleiht einen Bonus auf Blocken und Ausdauer. Geeignet für Stufe 60."},
["C3B3E0F90F01010101"] = {akey="IFF3819C378DED18F,8C06F50CE30718A6,,,,,,",de="Stellare Verstärkung der Gewandtheit",en="Stellar Deft Augment",fr="Augmentation d'adresse stellaire",ru="Звездное ловкое усиление",stats={'parry'},statval={{24},{22},{45},{27},{18},{20},{12},{24}},rlvl=60,icon="barghest_fang1_a",descEN="Grants a bonus to Parry when added to a crafting recipe. Appropriate for level 60.",descFR="Confère un bonus à la parade en l'ajoutant à une recette d'artisanat. Accessible au niveau 60.",val=34000,q=3,descDE="Das Hinzufügen zu einer Handwerksanleitung verleiht einen Parierbonus. Geeignet für Stufe 60."},
["9ED8B6E40F01010101"] = {akey="IFC8DAC1E5628AA17,760DCE6A5870DEFD,,,,,,",de="Stellare Verstärkung der Listigkeit",en="Stellar Wily Augment",fr="Augmentation de roublardise stellaire",ru="Звездное лукавое усиление",stats={'endu','dodge'},statval={{19,16},{17,15},{35,30},{21,18},{14,12},{16,14},{10,8},{19,16}},rlvl=60,icon="cliff_bambler_horn",descEN="Grants a bonus to both Endurance and Dodge when added to a crafted recipe. Appropriate for level 60.",descFR="Accorde un bonus à l'endurance et à l'esquive en l'ajoutant à une recette d'artisanat. Accessible au niveau 60.",val=34000,q=3,descDE="Das Hinzufügen zu einer Handwerksanleitung verleiht einen Bonus auf Ausdauer und Ausweichen. Geeignet für Stufe 60."},
["83A785E30F01010101"] = {akey="IFC61538346D028FC,03453B04C4572993,,,,,,",de="Stellare Verstärkung der Scharfsinnigkeit",en="Stellar Keen Augment",fr="Augmentation d'intensité stellaire",ru="Звездное вострое усиление",stats={'dex','atp'},statval={{19,14},{17,13},{35,27},{21,16},{14,11},{16,12},{10,7},{19,14}},rlvl=60,icon="horn_09_a",descEN="Grants a bonus to both Dexterity and Attack Power when added to a crafted recipe. Appropriate for level 60.",descFR="Accorde un bonus à la dextérité et à la puissance d'attaque en l'ajoutant à une recette d'artisanat. Accessible au niveau 60.",val=34000,q=3,descDE="Das Hinzufügen zu einer Handwerksanleitung verleiht einen Bonus auf Geschicklichkeit und Angriffskraft. Geeignet für Stufe 60."},
["89CD9CEB0F01010101"] = {akey="IFD6726895CC70C36,F443A5F97AE9A626,,,,,,",de="Stellare Verstärkung der Gerissenheit",en="Stellar Cunning Augment",fr="Augmentation d'astuce stellaire",ru="Звездное хитрое усиление",stats={'int','sp'},statval={{19,14},{17,13},{35,27},{21,16},{14,11},{16,12},{10,7},{19,14}},rlvl=60,icon="leather02",descEN="Grants a bonus to both Intelligence and Spell Power when added to a crafted recipe. Appropriate for level 60.",descFR="Accorde un bonus à l'intelligence et à la puissance des sorts en l'ajoutant à une recette d'artisanat. Accessible au niveau 60.",val=34000,q=3,descDE="Das Hinzufügen zu einer Handwerksanleitung verleiht einen Bonus auf Intelligenz und Zauberkraft. Geeignet für Stufe 60."},
["C5A6C3D30F01010101"] = {akey="IFA70D34570CF858B,46931EC226786B76,,,,,,",de="Stellare Verstärkung des Fanatismus",en="Stellar Fanatical Augment",fr="Augmentation fanatique stellaire",ru="Звездное фанатичное усиление",stats={'wis','cp'},statval={{19,24},{17,23},{35,45},{21,28},{14,19},{16,21},{10,12},{19,24}},rlvl=60,icon="greater_life_04",descEN="Grants a bonus to both Wisdom and Crit Power when added to a crafted recipe. Appropriate for level 60.",descFR="Accorde un bonus à la sagesse et à la puissance des coups critiques en l'ajoutant à une recette d'artisanat. Accessible au niveau 60.",val=34000,q=3,descDE="Das Hinzufügen zu einer Handwerksanleitung verleiht einen Bonus auf Weisheit und Kritische Kraft. Geeignet für Stufe 60."},
["BAB3E0F90F01010101"] = {akey="IFF3819BA1A31B3A6,86D615B877FB4F6D,,,,,,",de="Stellare Verstärkung der Standhaftigkeit",en="Stellar Unwavering Augment",fr="Augmentation de détermination stellaire",ru="Звездное стойкое усиление",stats={'sp'},statval={{21},{20},{40},{24},{16},{18},{11},{21}},rlvl=60,icon="soul_fragment2_b",descEN="Grants a bonus to Spell Power when added to a crafting recipe. Appropriate for level 60.",descFR="Confère un bonus à la puissance des sorts en l'ajoutant à une recette d'artisanat. Accessible au niveau 60.",val=34000,q=3,descDE="Das Hinzufügen zu einer Handwerksanleitung verleiht einen Zauberkraftbonus. Geeignet für Stufe 60."},
["B8C4A5FD0F01010101"] = {akey="IFFA96238074E1D7D,CEC62EE150CA5B33,,,,,,",de="Stellare Verstärkung der Macht",en="Stellar Mighty Augment",fr="Augmentation de puissance stellaire",ru="Звездное могучее усиление",stats={'str'},statval={{28},{26},{51},{31},{21},{23},{14},{28}},rlvl=60,icon="titan_shards_b",descEN="Grants a bonus to Strength when added to a crafting recipe. Appropriate for level 60.",descFR="Confère un bonus à la force en l'ajoutant à une recette d'artisanat. Accessible au niveau 60.",val=34000,q=3,descDE="Das Hinzufügen zu einer Handwerksanleitung verleiht einen Stärkebonus. Geeignet für Stufe 60."},
["B9C4A5FD0F01010101"] = {akey="IFFA962394B70F90E,D7F8AF608233717D,,,,,,",de="Stellare Verstärkung der Klugheit",en="Stellar Clever Augment",fr="Augmentation d'esprit stellaire",ru="Звездное умное усиление",stats={'int'},statval={{28},{26},{51},{31},{21},{23},{14},{28}},rlvl=60,icon="titan_shards_c",descEN="Grants a bonus to Intelligence when added to a crafting recipe. Appropriate for level 60.",descFR="Confère un bonus à l'intelligence en l'ajoutant à une recette d'artisanat. Accessible au niveau 60.",val=34000,q=3,descDE="Das Hinzufügen zu einer Handwerksanleitung verleiht einen Intelligenzbonus. Geeignet für Stufe 60."},
["BDB3E0F90F01010101"] = {akey="IFF3819BD68F8B1E4,87CD8861FF38019B,,,,,,",de="Stellare Verstärkung der Abwehr",en="Stellar Deflecting Augment",fr="Augmentation de déviation stellaire",ru="Звездное отклоняющее усиление",stats={'defl'},statval={{49},{45},{90},{55},{37},{41},{25},{49}},rlvl=60,icon="deflect2",descEN="Grants a bonus to Deflect when added to a crafting recipe. Appropriate for level 60.",descFR="Confère un bonus à la déviation en l'ajoutant à une recette d'artisanat. Accessible au niveau 60.",val=34000,q=3,descDE="Das Hinzufügen zu einer Handwerksanleitung verleiht einen Abwehrbonus. Geeignet für Stufe 60."},
["C8D2F3D40F01010101"] = {akey="IFA9CE948057535FD,EFB7DC9ACFEA982F,,,,,,",de="Stellare Verstärkung der Hinterlist",en="Stellar Insidious Augment",fr="Augmentation insidieuse stellaire",ru="Звездное скрытное усиление",stats={'dex','cp'},statval={{19,24},{17,23},{35,45},{21,28},{14,19},{16,21},{10,12},{19,24}},rlvl=60,icon="greater_earth_10",descEN="Grants a bonus to both Dexterity and Crit Power when added to a crafted recipe. Appropriate for level 60.",descFR="Accorde un bonus à la dextérité et à la puissance des coups critiques en l'ajoutant à une recette d'artisanat. Accessible au niveau 60.",val=34000,q=3,descDE="Das Hinzufügen zu einer Handwerksanleitung verleiht einen Bonus auf Geschicklichkeit und Kritische Kraft. Geeignet für Stufe 60."},
["80B686F20F01010101"] = {akey="IFE419B006F7F8409,298E6B7FAB79FEEB,,,,,,",de="Stellare Verstärkung der Wildheit",en="Stellar Savage Augment",fr="Augmentation de sauvagerie stellaire",ru="Звездное дикарское усиление",stats={'str','crit'},statval={{19,22},{17,20},{35,41},{21,25},{14,17},{16,19},{10,11},{19,22}},rlvl=60,icon="troll_skin_b",descEN="Grants a bonus to both Strength and Melee Critical Hit when added to a crafting recipe. Appropriate for level 60.",descFR="Accorde un bonus à la force et aux coups critiques au corps à corps en l'ajoutant à une recette d'artisanat. Accessible au niveau 60.",val=34000,q=3,descDE="Das Hinzufügen zu einer Handwerksanleitung verleiht einen Bonus auf Stärke und kritische Nahkampftreffer. Geeignet für Stufe 60."},
["F394CDE30F01010101"] = {akey="IFC734A731FB80C19,D9C08787929582E3,,,,,,",de="Stellare Verstärkung der Erleuchtung",en="Stellar Enlightened Augment",fr="Augmentation de la lumière stellaire",ru="Звездное просветленное усиление",stats={'wis','sp'},statval={{19,14},{17,13},{35,27},{21,16},{14,11},{16,12},{10,7},{19,14}},rlvl=60,icon="thick_shell_fragment",descEN="Grants a bonus to both Wisdom and Spell Power when added to a crafted recipe. Appropriate for level 60.",descFR="Accorde un bonus à la sagesse et à la puissance des sorts en l'ajoutant à une recette d'artisanat. Accessible au niveau 60.",val=34000,q=3,descDE="Das Hinzufügen zu einer Handwerksanleitung verleiht einen Bonus auf Weisheit und Zauberkraft. Geeignet für Stufe 60."},
["EEBCE3D90F01010101"] = {akey="IFB38DE6E2ADFE918,09B3C055DE20B045,,,,,,",de="Stellare Verstärkung der Brutalität",en="Stellar Brutal Augment",fr="Augmentation de brutalité stellaire",ru="Звездное зверское усиление",stats={'str','atp'},statval={{19,14},{17,13},{35,27},{21,16},{14,11},{16,12},{10,7},{19,14}},rlvl=60,icon="trinket31",descEN="Grants a bonus to both Strength and Attack Power when added to a crafting recipe. Appropriate for level 60.",descFR="Accorde un bonus à la force et à la puissance d'attaque en l'ajoutant à une recette d'artisanat. Accessible au niveau 60.",val=34000,q=3,descDE="Das Hinzufügen zu einer Handwerksanleitung verleiht Bonus auf Stärke und Angriffskraft. Geeignet für Stufe 60."},
["BAC4A5FD0F01010101"] = {akey="IFFA9623A2ECEAD31,E9FB06758D9038A6,,,,,,",de="Stellare Verstärkung des Segens",en="Stellar Blessed Augment",fr="Augmentation de bénédiction stellaire",ru="Звездное благословенное усиление",stats={'wis'},statval={{28},{26},{51},{31},{21},{23},{14},{28}},rlvl=60,icon="titan_shards_a",descEN="Grants a bonus to Wisdom when added to a crafting recipe. Appropriate for level 60.",descFR="Confère un bonus à la sagesse en l'ajoutant à une recette d'artisanat. Accessible au niveau 60.",val=34000,q=3,descDE="Das Hinzufügen zu einer Handwerksanleitung verleiht einen Weisheitsbonus. Geeignet für Stufe 60."},
["F9F9E7D70F01010101"] = {akey="IFAF9FCF968C931A0,4EAD29933AE5F4AC,,,,,,",de="Stellare Verstärkung des Eiferers",en="Stellar Zealous Augment",fr="Augmentation de zèle stellaire",ru="Звездное ревностное усиление",stats={'wis','scrit'},statval={{19,22},{17,20},{35,41},{21,25},{14,17},{16,19},{10,11},{19,22}},rlvl=60,icon="exotic_leather_b",descEN="Grants a bonus to both Wisdom and Spell Critical Hit when added to a crafted recipe. Appropriate for level 60.",descFR="Accorde un bonus à la sagesse et aux sorts critiques en l'ajoutant à une recette d'artisanat. Accessible au niveau 60.",val=34000,q=3,descDE="Das Hinzufügen zu einer Handwerksanleitung verleiht einen Bonus auf Weisheit und kritische Zaubertreffer. Geeignet für Stufe 60."},
["BBC4A5FD0F01010101"] = {akey="IFFA9623B67E96762,E0F6167FE891BD08,,,,,,",de="Stellare Verstärkung der Wendigkeit",en="Stellar Nimble Augment",fr="Augmentation d'agilité stellaire",ru="Звездное шустрое усиление",stats={'dex'},statval={{28},{26},{51},{31},{21},{23},{14},{28}},rlvl=60,icon="titan_shards",descEN="Grants a bonus to Dexterity when added to a crafting recipe. Appropriate for level 60.",descFR="Confère un bonus à la dextérité en l'ajoutant à une recette d'artisanat. Accessible au niveau 60.",val=34000,q=3,descDE="Das Hinzufügen zu einer Handwerksanleitung verleiht einen Geschicklichkeitsbonus. Geeignet für Stufe 60."},
["C1C4DDE40F01010101"] = {akey="IFC97624146B6948B,48CC1A4854DAD78C,,,,,,",de="Stellare Verstärkung der Unempfindlichkeit",en="Stellar Impervious Augment",fr="Augmentation insensible stellaire",ru="Звездное непроницаемое усиление",stats={'block'},statval={{49},{45},{90},{55},{37},{41},{25},{49}},rlvl=60,icon="riftblade_stone_shield_01_d",descEN="Grants a bonus to Block when added to a crafting recipe. Appropriate for level 60.",descFR="Confère un bonus au blocage en l'ajoutant à une recette d'artisanat. Accessible au niveau 60.",val=30000,q=3,descDE="Das Hinzufügen zu einer Handwerksanleitung verleiht einen Bonus auf Blocken. Geeignet für Stufe 60."},
["ABC3ECE40F01010101"] = {akey="IFC9B21AB6DD6CB20,196ADE588B3FEAE7,,,,,,",de="Stellare Verstärkung der Unerschütterlichkeit",en="Stellar Stalwart Augment",fr="Augmentation de loyauté stellaire",ru="Звездное несгибаемое усиление",stats={'endu','parry'},statval={{19,16},{17,15},{35,30},{21,18},{14,12},{16,14},{10,8},{19,16}},rlvl=60,icon="black_heart",descEN="Grants a bonus to both Endurance and Parry when added to a crafting recipe. Appropriate for level 60.",descFR="Accorde un bonus à l'endurance et à la parade en l'ajoutant à une recette d'artisanat. Accessible au niveau 60.",val=34000,q=3,descDE="Das Hinzufügen zu einer Handwerksanleitung verleiht einen Bonus auf Ausdauer und Parieren. Geeignet für Stufe 60."},
["BCC4A5FD0F01010101"] = {akey="IFFA9623C59C31FF0,C194A895E148C996,,,,,,",de="Stellare Verstärkung der Robustheit",en="Stellar Rugged Augment",fr="Augmentation d'endurance stellaire",ru="Звездное жесткое усиление",stats={'endu'},statval={{28},{26},{51},{31},{21},{23},{14},{28}},rlvl=60,icon="crystallized_nothing",descEN="Grants a bonus to Endurance when added to a crafting recipe. Appropriate for level 60.",descFR="Confère un bonus à l'endurance en l'ajoutant à une recette d'artisanat. Accessible au niveau 60.",val=34000,q=3,descDE="Das Hinzufügen zu einer Handwerksanleitung verleiht einen Ausdauerbonus. Geeignet für Stufe 60."},
["B4B3E0F90F01010101"] = {akey="IFF3819B47B40DAC3,2FAE6C05F67AD18A,,,,,,",de="Stellare Verstärkung der Besonnenheit",en="Stellar Canny Augment",fr="Augmentation de ruse stellaire",ru="Звездное мудрое усиление",stats={'int'},statval={{28},{26},{51},{31},{21},{23},{14},{28}},rlvl=60,icon="intact_shambler_eye",descEN="Grants a bonus to Spell Critical Hit when added to a crafting recipe. Appropriate for level 60.",descFR="Accorde un bonus aux dégâts infligés par les sorts critiques en l'ajoutant à une recette d'artisanat. Accessible au niveau 60.",val=34000,q=3,descDE="Das Hinzufügen zu einer Handwerksanleitung verleiht einen Bonus auf kritische Zaubertreffer. Geeignet für Stufe 60."},
["A5AAABE00F01010101"] = {akey="IFC0AD5250D5D1416,67043C92928B000F,,,,,,",de="Stellare Verstärkung der Tücke",en="Stellar Treacherous Augment",fr="Augmentation de traîtrise stellaire",ru="Звездное предательское усиление",stats={'dex','crit'},statval={{19,22},{17,20},{35,41},{21,25},{14,17},{16,19},{10,11},{19,22}},rlvl=60,icon="spine2",descEN="Grants a bonus to both Dexterity and Melee Critical Hit when added to a crafted recipe. Appropriate for level 60.",descFR="Accorde un bonus à la dextérité et aux coups critiques au corps à corps en l'ajoutant à une recette d'artisanat. Accessible au niveau 60.",val=34000,q=3,descDE="Das Hinzufügen zu einer Handwerksanleitung verleiht einen Bonus auf Geschicklichkeit und kritische Nahkampftreffer. Geeignet für Stufe 60."},
["E698A8EC0F01010101"] = {akey="IFD8A0C662826194E,E8423705B618B306,,,,,,",de="Stellare Verstärkung der Schändlichkeit",en="Stellar Nefarious Augment",fr="Augmentation abominable stellaire",ru="Звездное подлое усиление",stats={'cp'},statval={{36},{33},{67},{41},{28},{31},{19},{36}},rlvl=60,icon="fiery_spike_01",descEN="Grants a bonus to Crit Power when added to a crafting recipe. Appropriate for level 60.",descFR="Confère un bonus à la puissance de coups critiques en l'ajoutant à une recette d'artisanat. Accessible au niveau 60.",val=34000,q=3,descDE="Das Hinzufügen zu einer Handwerksanleitung verleiht einen Bonus auf die Stärke kritischer Treffer. Geeignet für Stufe 60."},
["C0B3E0F90F01010101"] = {akey="IFF3819C07C338720,61BEB52F775DA0DE,,,,,,",de="Stellare Verstärkung der Gnadenlosigkeit",en="Stellar Ruthless Augment",fr="Augmentation de férocité stellaire",ru="Звездное безжалостное усиление",stats={'crit'},statval={{32},{30},{60},{37},{25},{27},{17},{32}},rlvl=60,icon="jeweled_scale",descEN="Grants a bonus to Melee Crit when added to a crafting recipe. Appropriate for level 60.",descFR="Confère un bonus aux coups critiques au corps à corps en l'ajoutant à une recette d'artisanat. Accessible au niveau 60.",val=34000,q=3,descDE="Das Hinzufügen zu einer Handwerksanleitung verleiht einen Bonus auf kritische Nahkampftreffer. Geeignet für Stufe 60."},
["F7B3E5F20F01010101"] = {akey="IFE5959F75304CC8D,FA9A53A89D4BE4BD,,,,,,",de="Stellare Verstärkung der Verschlagenheit",en="Stellar Devious Augment",fr="Augmentation de sournoiserie stellaire",ru="Звездное коварное усиление",stats={'int','scrit'},statval={{19,22},{17,20},{35,41},{21,25},{14,17},{16,19},{10,11},{19,22}},rlvl=60,icon="muck_covered_claw_a",descEN="Grants a bonus to both Intelligence and Spell Critical Hit when added to a crafted recipe. Appropriate for level 60.",descFR="Accorde un bonus à l'intelligence et aux sorts critiques en l'ajoutant à une recette d'artisanat. Accessible au niveau 60.",val=34000,q=3,descDE="Das Hinzufügen zu einer Handwerksanleitung verleiht einen Bonus auf Intelligenz und kritische Zaubertreffer. Geeignet für Stufe 60."},
["AAF0E6F10F01010101"] = {akey="IFE39B82A5A7E2B04,0829C124D86403CA,,,,,,",de="Stellare Verstärkung der Abwendung",en="Stellar Averting Augment",fr="Augmentation d'évitement stellaire",ru="Звездное охранное усиление",stats={'endu','defl'},statval={{19,33},{17,31},{35,61},{21,37},{14,25},{16,28},{10,17},{19,33}},rlvl=60,icon="deflection3aa",descEN="Grants a bonus to both Endurance and Deflect when added to a crafted recipe. Appropriate for level 60.",descFR="Accorde un bonus à l'endurance et à la déviation en l'ajoutant à une recette d'artisanat. Accessible au niveau 60.",val=34000,q=3,descDE="Das Hinzufügen zu einer Handwerksanleitung verleiht einen Bonus auf Ausdauer und Abwehr. Geeignet für Stufe 60."},
["91B585EC0F01010101"] = {akey="IFD815A910182F98B,6C1A02EC53B0A261,,,,,,",de="Stellare Verstärkung der Barbarei",en="Stellar Barbaric Augment",fr="Augmentation de barbarie stellaire",ru="Звездное варварское усиление",stats={'str','cp'},statval={{19,24},{17,23},{35,45},{21,28},{14,19},{16,21},{10,12},{19,24}},rlvl=60,icon="greater_fire_03",descEN="Grants a bonus to both Strength and Crit Power when added to a crafted recipe. Appropriate for level 60.",descFR="Accorde un bonus à la force et à la puissance des coups critiques en l'ajoutant à une recette d'artisanat. Accessible au niveau 60.",val=34000,q=3,descDE="Das Hinzufügen zu einer Handwerksanleitung verleiht einen Bonus auf Stärke und Kritische Kraft. Geeignet für Stufe 60."},
["B4DABFDF0F01010101"] = {akey="IFBEFED342E6B9C25,DB516D7E759F64C4,,,,,,",de="Stellare Verstärkung der Genialität",en="Stellar Brilliant Augment",fr="Augmentation éclatante stellaire",ru="Звездное гениальное усиление",stats={'int','cp'},statval={{19,24},{17,23},{35,45},{21,28},{14,19},{16,21},{10,12},{19,24}},rlvl=60,icon="greater_air_04",descEN="Grants a bonus to both Intelligence and Crit Power when added to a crafted recipe. Appropriate for level 60.",descFR="Accorde un bonus à l'intelligence et à la puissance des coups critiques en l'ajoutant à une recette d'artisanat. Accessible au niveau 60.",val=34000,q=3,descDE="Das Hinzufügen zu einer Handwerksanleitung verleiht einen Bonus auf Intelligenz und Kritische Kraft. Geeignet für Stufe 60."},
}

nkItemBase.crafting.prof = {
armorsmith={shoulders={chain={'8A9BD8DC0F01010101'},
plate={'809BD8DC0F01010101'}
},
legs={chain={'8B9BD8DC0F01010101'},
plate={'819BD8DC0F01010101'}
},
belt={chain={'87E9EAF10701010101','8C9BD8DC0F01010101','88E9EAF10701010101'},
plate={'86E9EAF10701010101','829BD8DC0F01010101','85E9EAF10701010101'}
},
helmet={chain={'83E9EAF10701010101','84E9EAF10701010101'},
plate={'82E9EAF10701010101','81E9EAF10701010101'}
},
feet={chain={'8D9BD8DC0F01010101'},
plate={'839BD8DC0F01010101'}
}
},
weaponsmith={twohanded={polearm={'C99484E60F01010101'},
hammer={'A7A7CFF50301010101','C59484E60F01010101'},
sword={'CD9484E60F01010101'}
}
},
artificer={ring={items={'B2A7CFF50301010101','B1A7CFF50301010101','B3A7CFF50301010101','ADA7CFF50301010101','AFA7CFF50301010101','AEA7CFF50301010101','B0A7CFF50301010101'}
},
twohanded={staff={'8F82ECE60F01010101','8E82ECE60F01010101'}
},
offhand={totem={'9382ECE60F01010101'},
shield={'8E9BD8DC0F01010101','849BD8DC0F01010101','C5C0D9AD0301010101'}
},
neck={items={'9482ECE60F01010101','9582ECE60F01010101','9082ECE60F01010101','9182ECE60F01010101'}
}
},
outfitter={shoulders={leather={'A1C5DFEC0F01010101'},
cloth={'AAC5DFEC0F01010101'}
},
cape={cloth={'8F9BD8DC0F01010101','AEC5DFEC0F01010101','A5C5DFEC0F01010101','859BD8DC0F01010101'}
},
legs={leather={'A2C5DFEC0F01010101'},
cloth={'ABC5DFEC0F01010101'}
},
belt={leather={'BAC9A38B0201010101','A3C5DFEC0F01010101','B9C9A38B0201010101'},
cloth={'BBC9A38B0201010101','ACC5DFEC0F01010101'}
},
helmet={leather={'B6C9A38B0201010101','B7C9A38B0201010101'},
cloth={'B8C9A38B0201010101'}
},
feet={leather={'A4C5DFEC0F01010101'},
cloth={'ADC5DFEC0F01010101'}
}
}
}

nkItemBase.db.recipe.alchemist={
["98ACF59C0701010101"] = {akey="I739D56184EC41ADA,1990EBD25ACD3502,,,,,,",de="Anleitung: Großes Feuerwerk",en="Recipe: Grand Fireworks",fr="Recette : Feu d'artifice grandiose",ru="Чертеж: грандиозный фейерверк",icon="scroll8b",val=10000,q=2,bop=true,accBound=true,Consumable=true,rss="Alchemist",rsslvl=170,rf="Gloamwood Waykeepers",rfl=3},
["F38DF1E30301010101"] = {akey="I3C7C46F31366D26E,00F8AF1784C2663D,,,,,,",de="Anleitung: Mächtiger Unheiliger Schutztrank",en="Recipe: Mighty Unholy Warding Potion",fr="Recette : Potion de protection puissante impie",ru="Рецепт: могучее зелье защиты от Смерти",icon="scroll9a",val=0,q=2,bop=true,accBound=true,Consumable=true,rss="Alchemist",rsslvl=260,rf="The Grim Disciples",rfl=3},
["CF8BBBF30F01010101"] = {akey="IFE6EC5CF24305B31,497869909CCF2BD8,,,,,,",de="Anleitung: Hervorragende Phiole des Lebenswiderstandes",en="Recipe: Excellent Vial of Life Resistance",fr="Recette : Fiole de résistance à la Vie excellente",ru="Рецепт: Отличный флакон сопротивляемости жизни",icon="scroll9",val=0,q=1,bop=true,Consumable=true,rss="Alchemist",rsslvl=375},
["F9EBF2EB0101010101"] = {akey="I1D7CB5F943970792,15014712C688EFBE,,,,,,",de="Anleitung: Mächtiger Zaubertrank der Kraft",en="Recipe: Mighty Philter of Power",fr="Recette : Puissant philtre de puissance",ru="Рецепт: могучее снадобье мощи",icon="scroll9a",val=0,q=2,bop=true,Consumable=true,rss="Alchemist",rsslvl=260},
["8AE1ECAD0701010101"] = {akey="I75BB308A48C74887,1741A5450DCE2734,,,,,,",de="Anleitung: Starker Heiliger Schutztrank",en="Recipe: Greater Holy Warding Potion",fr="Recette : Potion de protection supérieure sacrée",ru="Рецепт: крепкое зелье защиты от Жизни",icon="scroll8b",val=0,q=1,bop=true,accBound=true,Consumable=true,rss="Alchemist",rsslvl=210,rf="Students of the Vale",rfl=2},
["85ECF2EB0101010101"] = {akey="I1D7CB60512B8AACC,D3281A72B0243B47,,,,,,",de="Anleitung: Heroischer Heilzaubertrank",en="Recipe: Heroic Healing Philter",fr="Recette : Philtre de guérison héroïque",ru="Рецепт: превосходное снадобье исцеления",icon="scroll2",val=0,q=3,bop=true,Consumable=true,rss="Alchemist",rsslvl=290},
["D4F09D4B01010101"] = {akey="I096778543A490279,EB9DD6EA8F22E595,,,,,,",de="Anleitung: Starker Gezeiten-Schutztrank",en="Recipe: Greater Tidal Warding Potion",fr="Recette : Potion de protection supérieure des marées",ru="Рецепт: крепкое зелье защиты от Воды",icon="scroll8b",val=0,q=1,bop=true,accBound=true,Consumable=true,rss="Alchemist",rsslvl=180,rf="Order of Purity",rfl=1},
["C2869FD30F01010101"] = {akey="IFA67C3424AD6E816,4456EF3E04423C61,,,,,,",de="Anleitung: Hervorragender Giftzaubertrank",en="Recipe: Excellent Venom Philter",fr="Recette : Philtre venimeux excellent",ru="Рецепт: Отличное ядовитое снадобье",icon="scroll9",val=0,q=1,bop=true,Consumable=true,rss="Alchemist",rsslvl=325},
["DA898DED0401010101"] = {akey="I4DA344DA038CD701,0F034E2C50232368,,,,,,",de="Anleitung: Einfaches Beweglichkeitsserum",en="Recipe: Basic Agility Serum",fr="Recette : Sérum d'agilité essentiel",ru="Рецепт: простая сыворотка уклонения",icon="scroll1a",val=0,q=1,bop=true,Consumable=true,rss="Alchemist",rsslvl=130},
["9AFA880F01010101"] = {akey="I01E23D1A41D5BEED,03DC3C37DC33A0EC,,,,,,",de="Anleitung: Stellare Quelle des Lebenswiderstandes",en="Recipe: Stellar Wellspring of Life Resistance",fr="Plan : Source-puits stellaire de résistance à la Vie",ru="Рецепт: Звездный источник сопротивления силе Жизни",icon="sealed_parchment",val=0,q=3,bop=true,Consumable=true,rss="Alchemist",rsslvl=375},
["93AF8AA90301010101"] = {akey="I352297936E703AB7,D50AC3BD52DEDB12,,,,,,",de="Anleitung: Größere Verstärkung der Macht",en="Recipe: Major Mighty Augment",fr="Recette : Augmentation de puissance majeure",ru="Чертеж: Большое усиление могущества",icon="scroll9a",val=0,q=2,bop=true,Consumable=true,rss="Alchemist",rsslvl=300},
["F6F2ACE60301010101"] = {akey="I3CCB397662CBE947,7FBE0AF711FA4876,,,,,,",de="Anleitung: Mittlere Verstärkung der Wendigkeit",en="Recipe: Median Nimble Augment",fr="Recette : Augmentation d'agilité moyenne",ru="Чертеж: Большое усиление гибкости",icon="scroll8b",val=0,q=1,bop=true,Consumable=true,rss="Alchemist",rsslvl=225},
["A3DDFF850101010101"] = {akey="I10BFEEA3A544363C,11BAF7696A50B1B8,,,,,,",de="Anleitung: Reiner Vergeltungsstein",en="Recipe: Pure Vengeancestone",fr="Patron : Pierre de vengeance pure",ru="Чертеж: Чистый камень отмщения",icon="scroll9a",val=0,q=2,bop=true,Consumable=true,rss="Alchemist",rsslvl=300},
["9C8D9E860501010101"] = {akey="I50C7869C71BCC610,2AC42179C2C8D54E,,,,,,",de="Anleitung: Festgelegte Physik",en="Recipe: Defined Physique",fr="Plan : Physique défini",ru="Рецепт: Определенное сложение",icon="scroll8b",val=0,q=3,bop=true,Consumable=true,rss="Alchemist",rsslvl=375},
["9BF7FCFF0601010101"] = {akey="I6FFF3B9B6FAAB33F,053B0AF493D07550,,,,,,",de="Anleitung: Mächtiger Flammen-Schutztrank",en="Recipe: Mighty Flame Warding Potion",fr="Recette : Potion de protection puissante des flammes",ru="Рецепт: могучее зелье защиты от Огня",icon="scroll9a",val=0,q=1,bop=true,accBound=true,Consumable=true,rss="Alchemist",rsslvl=240,rf="Order of the Flame",rfl=2},
["96A9E7F50F01010101"] = {akey="IFEB9D49673843F60,E078BB407EDB1846,,,,,,",de="Anleitung: Empyreum-Verstärkung der Robustheit",en="Recipe: Empyrean Rugged Augment",fr="Recette : Augmentation d'endurance empyréenne",ru="Рецепт: Суровое эмпирейское усиление",icon="scroll9",val=0,q=2,bop=true,Consumable=true,rss="Alchemist",rsslvl=340},
["E3F5A56B01010101"] = {akey="I0D697AE33B085FD1,4D587819851944D4,,,,,,",de="Anleitung: Verherrlichter Heiltrank",en="Recipe: Glorified Healing Potion",fr="Recette : Potion de soins glorifiée",ru="Рецепт: знаменитое зелье исцеления",icon="scroll1",val=0,q=2,bop=true,accBound=true,Consumable=true,rss="Alchemist",rsslvl=300,rf="The Farclan",rfl=3},
["C48BBBF30F01010101"] = {akey="IFE6EC5C469C44B6F,16C1450E98FEC3E2,,,,,,",de="Anleitung: Hervorragende Flasche der kritischen Treffer",en="Recipe: Excellent Bottle of Critical Strikes",fr="Recette : Bouteille de coups critiques excellente",ru="Рецепт: Отличное зелье критических ударов",icon="scroll9",val=0,q=1,bop=true,Consumable=true,rss="Alchemist",rsslvl=375},
["A7F7FCFF0601010101"] = {akey="I6FFF3BA71CEFC544,D77638281EAF4735,,,,,,",de="Anleitung: Heroischer Flammen-Schutztrank",en="Recipe: Heroic Flame Warding Potion",fr="Recette : Potion de protection héroïque des flammes",ru="Рецепт: превосходное зелье защиты от Огня",icon="scroll9a",val=0,q=2,bop=true,accBound=true,Consumable=true,rss="Alchemist",rsslvl=300,rf="Order of the Flame",rfl=3},
["E88BDDD80601010101"] = {akey="I6B1745E865589AC5,C79D58C27CE8FC7B,,,,,,",de="Anleitung für Farbe: Dunkles Magenta",en="Recipe: Dark Magenta Dye",fr="Recette : Teinture magenta foncé",ru="Рецепт: темно-сиреневый краситель",icon="scroll9a",val=0,q=1,bop=true,Consumable=true,rss="Alchemist",rsslvl=270},
["A790AF800201010101"] = {akey="I200BC8277E2D9052,2DBF60F66E200D91,,,,,,",de="Anleitung: Heroische Beständige Phiole",en="Recipe: Heroic Enduring Vial",fr="Recette : Fiole d'endurance héroïque",ru="Рецепт: превосходный флакон выносливости",icon="scroll9a",val=0,q=2,bop=true,Consumable=true,rss="Alchemist",rsslvl=300},
["94F1FAFD0F01010101"] = {akey="IFFBEB89447BFDA23,3183809D6909B319,,,,,,",de="Anleitung: Hervorragende Lichtflut-Phiole",en="Recipe: Excellent Brightsurge Vial",fr="Recette : Fiole de flambée rayonnante excellente",ru="Рецепт: Отличный флакон озарения",icon="scroll9",val=0,q=1,bop=true,Consumable=true,rss="Alchemist",rsslvl=330},
["99ACF59C0701010101"] = {akey="I739D56196D51F507,DB2D287579B39528,,,,,,",de="Anleitung: Mächtiges Schnelligkeitsgebräu",en="Recipe: Mighty Quickening Brew",fr="Recette : Breuvage puissant d'accélération",ru="Рецепт: могучая настойка скорости",rlvl=40,icon="scroll9a",val=25000,q=2,bop=true,accBound=true,Consumable=true,rss="Alchemist",rsslvl=230,rf="Quarry Rats",rfl=2},
["D08BBBF30F01010101"] = {akey="IFE6EC5D07FAEE7FD,68A9ED2C67E93148,,,,,,",de="Anleitung: Hervorragende Phiole des Wasserwiderstandes",en="Recipe: Excellent Vial of Water Resistance",fr="Recette : Fiole de résistance à l'Eau excellente",ru="Рецепт: Отличный флакон сопротивляемости воде",icon="scroll9",val=0,q=1,bop=true,Consumable=true,rss="Alchemist",rsslvl=375},
["FAEBF2EB0101010101"] = {akey="I1D7CB5FA0BE6E3D7,0A1F6DBDD6AF02FD,,,,,,",de="Anleitung: Fluch-Elixir",en="Recipe: Curse Elixir",fr="Recette : Élixir de malédiction",ru="Рецепт: эликсир проклятия",icon="scroll9a",val=0,q=2,bop=true,Consumable=true,rss="Alchemist",rsslvl=270},
["BBFBDB0B01010101"] = {akey="I0176FDBB1F211F2A,100C5D5880B503F6,,,,,,",de="Anleitung: Starker Gezeiten-Schutztrank",en="Recipe: Greater Tidal Warding Potion",fr="Recette : Potion de protection supérieure des marées",ru="Рецепт: крепкое зелье защиты от воды",icon="scroll8b",val=0,q=1,bop=true,accBound=true,Consumable=true,rss="Alchemist",rsslvl=180,rf="Mercurial Savants",rfl=1},
["D5F09D4B01010101"] = {akey="I096778556B664B9D,FDA02DFF1A80300D,,,,,,",de="Anleitung: Starker Titanen-Schutztrank",en="Recipe: Greater Titan Warding Potion",fr="Recette : Potion de protection supérieure des titans",ru="Рецепт: крепкое зелье защиты от Земли",icon="scroll8b",val=0,q=1,bop=true,accBound=true,Consumable=true,rss="Alchemist",rsslvl=180,rf="Mendicant Order",rfl=1},
["C3869FD30F01010101"] = {akey="IFA67C34329919404,47528B0C3B63754A,,,,,,",de="Anleitung: Hervorragender Heilzaubertrank",en="Recipe: Excellent Healing Philter",fr="Recette : Philtre de guérison excellent",ru="Рецепт: Отличное снадобье исцеления",icon="scroll9",val=0,q=1,bop=true,Consumable=true,rss="Alchemist",rsslvl=325},
["DB898DED0401010101"] = {akey="I4DA344DB17248262,2B441B1009463A29,,,,,,",de="Anleitung: Einfaches Manatonikum",en="Recipe: Basic Mana Tonic",fr="Recette : Fortifiant de mana essentiel",ru="Рецепт: простая микстура маны",icon="scroll1a",val=0,q=1,bop=true,Consumable=true,rss="Alchemist",rsslvl=140},
["9BFA880F01010101"] = {akey="I01E23D1B3FC10B4C,18CD8218440994EA,,,,,,",de="Anleitung: Stellare Quelle des Wasserwiderstandes",en="Recipe: Stellar Wellspring of Water Resistance",fr="Plan : Source-puits stellaire de résistance à l'Eau",ru="Рецепт: Звездный источник сопротивления силе Воды",icon="sealed_parchment",val=0,q=3,bop=true,Consumable=true,rss="Alchemist",rsslvl=375},
["94AF8AA90301010101"] = {akey="I352297941E270E54,0793C2629381AAFF,,,,,,",de="Anleitung: Größere Verstärkung der Klugheit",en="Recipe: Major Clever Augment",fr="Recette : Augmentation d'esprit majeure",ru="Чертеж: Большое усиление ума",icon="scroll9a",val=0,q=2,bop=true,Consumable=true,rss="Alchemist",rsslvl=300},
["9CF7FCFF0601010101"] = {akey="I6FFF3B9C0BFA25CA,251E4EFE07025D9C,,,,,,",de="Anleitung: Mächtiger Gezeiten-Schutztrank",en="Recipe: Mighty Tidal Warding Potion",fr="Recette : Potion de protection puissante des marées",ru="Рецепт: могучее зелье защиты от Воды",icon="scroll9a",val=0,q=1,bop=true,accBound=true,Consumable=true,rss="Alchemist",rsslvl=240,rf="Order of Purity",rfl=2},
["8D85A4970201010101"] = {akey="I22E9028D43C8BD9E,D50B4FEB36F8614D,,,,,,",de="Anleitung: Phiole des Lebenswiderstandes",en="Recipe: Vial of Life Resistance",fr="Recette : Fiole de résistance à la Vie",ru="Рецепт: флакон сопротивляемости Жизни",icon="scroll9a",val=0,q=2,bop=true,accBound=true,Consumable=true,rss="Alchemist",rsslvl=280,rf="Students of the Vale",rfl=3},
["97A9E7F50F01010101"] = {akey="IFEB9D4977949CA49,0F5F42BF856F16A9,,,,,,",de="Anleitung: Stellare Verstärkung der Macht",en="Recipe: Stellar Mighty Augment",fr="Recette : Augmentation de puissance stellaire",ru="Рецепт: Звездная сила",icon="sealed_parchment",val=0,q=3,bop=true,Consumable=true,rss="Alchemist",rsslvl=375},
["C58BBBF30F01010101"] = {akey="IFE6EC5C527AA57E6,156102BDAB2EE0EF,,,,,,",de="Anleitung: Hervorragende Flasche der Zauberschläge",en="Recipe: Excellent Bottle of Spellstrikes",fr="Recette : Bouteille de sorts critiques excellente",ru="Рецепт: Отличное зелье магических ударов",icon="scroll9",val=0,q=1,bop=true,Consumable=true,rss="Alchemist",rsslvl=375},
["A8F7FCFF0601010101"] = {akey="I6FFF3BA85B7437CD,E9788F3DAA0C0E5D,,,,,,",de="Anleitung: Heroischer Gezeiten-Schutztrank",en="Recipe: Heroic Tidal Warding Potion",fr="Recette : Potion de protection héroïque des marées",ru="Рецепт: превосходное зелье защиты от Воды",icon="scroll9a",val=0,q=2,bop=true,accBound=true,Consumable=true,rss="Alchemist",rsslvl=300,rf="Order of Purity",rfl=3},
["E98BDDD80601010101"] = {akey="I6B1745E902424A81,D99FAFD708454055,,,,,,",de="Anleitung für Farbe: Schwarz",en="Recipe: Black Dye",fr="Recette : Teinture noire",ru="Рецепт: черный краситель",icon="scroll9a",val=0,q=3,bop=true,Consumable=true,rss="Alchemist",rsslvl=290},
["A890AF800201010101"] = {akey="I200BC8287D3B88B6,31E14E6411A836E7,,,,,,",de="Anleitung: Heroische Machtschub-Phiole",en="Recipe: Heroic Powersurge Vial",fr="Recette : Fiole d'afflux de pouvoir héroïque",ru="Рецепт: превосходный флакон силы",icon="scroll9a",val=0,q=2,bop=true,Consumable=true,rss="Alchemist",rsslvl=300},
["95F1FAFD0F01010101"] = {akey="IFFBEB8952A637744,75A67B7C32C6F0BB,,,,,,",de="Anleitung: Hervorragende Machtschub-Phiole",en="Recipe: Excellent Powersurge Vial",fr="Recette : Fiole d'afflux de pouvoir excellente",ru="Рецепт: Отличный флакон силы",icon="scroll9",val=0,q=1,bop=true,Consumable=true,rss="Alchemist",rsslvl=330},
["94D3F4930201010101"] = {akey="I227D2994671DC19A,EDC8EA6B1B4F1398,,,,,,",de="Anleitung: Balsam der Heilung",en="Recipe: Balm of Healing",fr="Recette : Baume de soins",ru="Рецепт: бальзам исцеления",icon="scroll1a",val=0,q=3,bop=true,Consumable=true,rss="Alchemist",rsslvl=210},
["9AACF59C0701010101"] = {akey="I739D561A50D084CC,BD9599FD71864006,,,,,,",de="Anleitung: Wachstumsgebräu",en="Recipe: Growth Brew",fr="Recette : Breuvage de croissance",ru="Рецепт: настойка роста",icon="scroll9a",val=10000,q=2,bop=true,accBound=true,Consumable=true,rss="Alchemist",rsslvl=260,rf="Iron Claw Trappers",rfl=4},
["FBEBF2EB0101010101"] = {akey="I1D7CB5FB4AE3965E,05710147A0437B72,,,,,,",de="Anleitung: Heroische Flasche der kritischen Treffer",en="Recipe: Heroic Bottle of Critical Strikes",fr="Recette : Bouteille héroïque de coups critiques",ru="Рецепт: превосходная бутыль критических ударов",icon="scroll9a",val=0,q=2,bop=true,Consumable=true,rss="Alchemist",rsslvl=270},
["FC9EF9D30201010101"] = {akey="I2A7E4F7C2DA95C97,023398A9C89D6437,,,,,,",de="Anleitung: Phiole des Feuerwiderstandes",en="Recipe: Vial of Fire Resistance",fr="Recette : Fiole de résistance au Feu",ru="Рецепт: флакон сопротивляемости Огню",icon="scroll9a",val=0,q=2,bop=true,accBound=true,Consumable=true,rss="Alchemist",rsslvl=280,rf="Ember Scholars",rfl=3},
["D6F09D4B01010101"] = {akey="I09677856380336A4,DAA5FC6BD6C3AA0A,,,,,,",de="Anleitung: Starker Zephir-Schutztrank",en="Recipe: Greater Zephyr Warding Potion",fr="Recette : Potion de protection supérieure du zéphyr",ru="Рецепт: крепкое зелье защиты от Воздуха",icon="scroll8b",val=0,q=1,bop=true,accBound=true,Consumable=true,rss="Alchemist",rsslvl=180,rf="The Storm Inquisition",rfl=1},
["C4869FD30F01010101"] = {akey="IFA67C3446D299A3A,210DA725EFE43F8C,,,,,,",de="Anleitung: Hervorragender Zaubertrank der Wiederherstellung",en="Recipe: Excellent Philter of Restoration",fr="Recette : Philtre de restauration excellent",ru="Рецепт: Отличное снадобье восстановления",icon="scroll9",val=0,q=1,bop=true,Consumable=true,rss="Alchemist",rsslvl=325},
["F7B2F1AE0601010101"] = {akey="I65DC59773CDCA530,24B35B2CFFD1207E,,,,,,",de="Anleitung: Starker Titanen-Schutztrank",en="Recipe: Greater Titan Warding Potion",fr="Recette : Potion de protection supérieure des titans",ru="Рецепт: крепкое зелье защиты от Земли",icon="scroll8b",val=0,q=1,bop=true,accBound=true,Consumable=true,rss="Alchemist",rsslvl=180,rf="The Shale Collegiate",rfl=1},
["9CFA880F01010101"] = {akey="I01E23D1C7BC2C838,486791F128333802,,,,,,",de="Anleitung: Stellare Prismatische Quelle",en="Recipe: Stellar Prismatic Wellspring",fr="Plan : Source-puits stellaire prismatique",ru="Рецепт: Звездный призматический источник",icon="sealed_parchment",val=0,q=3,bop=true,Consumable=true,rss="Alchemist",rsslvl=375},
["95AF8AA90301010101"] = {akey="I352297955F82F8CE,09DECA5A2DE5B0BE,,,,,,",de="Anleitung: Größere Verstärkung der Robustheit",en="Recipe: Major Rugged Augment",fr="Recette : Augmentation d'endurance majeure",ru="Чертеж: Большое усиление грубости",icon="scroll9a",val=0,q=2,bop=true,Consumable=true,rss="Alchemist",rsslvl=300},
["E5979C6C01010101"] = {akey="I0D870BE55C8F3401,F8BEB60CA90E6F19,,,,,,",de="Anleitung: Mächtiger Gezeiten-Schutztrank",en="Recipe: Mighty Tidal Warding Potion",fr="Recette : Potion de protection puissante des marées",ru="Рецепт: могучее зелье защиты от Воды",icon="scroll9a",val=0,q=1,bop=true,accBound=true,Consumable=true,rss="Alchemist",rsslvl=240,rf="Mercurial Savants",rfl=2},
["F4E0F1C70301010101"] = {akey="I38FC70744723B84D,AA1B66700A995072,,,,,,",de="Anleitung: Großes Feuerwerk",en="Recipe: Grand Fireworks",fr="Recette : Feu d'artifice grandiose",ru="Чертеж: грандиозный фейерверк",icon="scroll8b",val=10000,q=2,bop=true,accBound=true,Consumable=true,rss="Alchemist",rsslvl=170,rf="Granite Falls",rfl=3},
["9DF7FCFF0601010101"] = {akey="I6FFF3B9D464E39BA,BA0F94E06ED7CE4C,,,,,,",de="Anleitung: Mächtiger Titanen-Schutztrank",en="Recipe: Mighty Titan Warding Potion",fr="Recette : Potion de protection puissante des titants",ru="Рецепт: могучее зелье защиты от Земли",icon="scroll9a",val=0,q=1,bop=true,accBound=true,Consumable=true,rss="Alchemist",rsslvl=240,rf="Mendicant Order",rfl=2},
["98A9E7F50F01010101"] = {akey="IFEB9D49816A8C12D,1091BE134C7E1329,,,,,,",de="Anleitung: Stellare Verstärkung der Klugheit",en="Recipe: Stellar Clever Augment",fr="Recette : Augmentation d'esprit stellaire",ru="Рецепт: Звездный интеллект",icon="sealed_parchment",val=0,q=3,bop=true,Consumable=true,rss="Alchemist",rsslvl=375},
["A9F7FCFF0601010101"] = {akey="I6FFF3BA91D2B46B5,C38F6EDD09D6DED3,,,,,,",de="Anleitung: Heroischer Titanen-Schutztrank",en="Recipe: Heroic Titan Warding Potion",fr="Recette : Potion de protection héroïque des titans",ru="Рецепт: превосходное зелье защиты от Земли",icon="scroll9a",val=0,q=2,bop=true,accBound=true,Consumable=true,rss="Alchemist",rsslvl=300,rf="Mendicant Order",rfl=3},
["EA8BDDD80601010101"] = {akey="I6B1745EA3A8848DB,EE90F5B8701B3455,,,,,,",de="Anleitung für Farbe: Weiß",en="Recipe: White Dye",fr="Recette : Teinture blanche",ru="Рецепт: белый краситель",icon="scroll9a",val=0,q=3,bop=true,Consumable=true,rss="Alchemist",rsslvl=290},
["A990AF800201010101"] = {akey="I200BC8291F151AB8,D688DCC76A766900,,,,,,",de="Anleitung: Heroische Lichtflut-Phiole",en="Recipe: Heroic Brightsurge Vial",fr="Recette : Fiole de flambée rayonnante héroïque",ru="Рецепт: превосходный флакон озарения",icon="scroll9a",val=0,q=2,bop=true,Consumable=true,rss="Alchemist",rsslvl=300},
["96F1FAFD0F01010101"] = {akey="IFFBEB8964C2348EA,6AC4A227C2EC80AB,,,,,,",de="Anleitung: Hervorragende Manaschub-Phiole",en="Recipe: Excellent Manasurge Vial",fr="Recette : Fiole d'afflux de mana excellente",ru="Рецепт: Отличный флакон увеличения маны",icon="scroll9",val=0,q=1,bop=true,Consumable=true,rss="Alchemist",rsslvl=330},
["8FA6919A0401010101"] = {akey="I4344530F83F334DF,257B496A84D3E6F8,,,,,,",de="Anleitung: Überwältigende Macht",en="Recipe: Overwhelming Might",fr="Recette : Puissance accablante",ru="Рецепт: ошеломляющая мощь",icon="scroll9a",val=0,q=3,bop=true,Consumable=true,rss="Alchemist",rsslvl=300},
["95D3F4930201010101"] = {akey="I227D29953F3E2860,DA7BD12A4AF01006,,,,,,",de="Anleitung: Balsam der Schnelligkeit beim Reiten",en="Recipe: Balm of Mounted Swiftness",fr="Recette : Baume de vitesse pour monture",ru="Рецепт: бальзам быстрой езды",icon="scroll1a",val=0,q=3,bop=true,Consumable=true,rss="Alchemist",rsslvl=210},
["9BACF59C0701010101"] = {akey="I739D561B2FD057F4,D45CBEB86280579A,,,,,,",de="Anleitung: Heroischer Wurzelfangtrank",en="Recipe: Heroic Rootcatch Brew",fr="Recette : Breuvage capte-racine héroïque",ru="Рецепт: превосходная настойка корней",rlvl=50,icon="scroll9a",val=10000,q=2,bop=true,accBound=true,Consumable=true,rss="Alchemist",rsslvl=290,rf="The Runeguard",rfl=3},
["D3F2988A0101010101"] = {akey="I114639536648E3D1,5277FD3846649AE4,,,,,,",de="Anleitung: Starker Zephir-Schutztrank",en="Recipe: Greater Zephyr Warding Potion",fr="Recette : Potion de protection supérieure du zéphyr",ru="Рецепт: крепкое зелье защиты от Воздуха",icon="scroll8b",val=0,q=1,bop=true,accBound=true,Consumable=true,rss="Alchemist",rsslvl=180,rf="Zephyrian Collective",rfl=1},
["FCEBF2EB0101010101"] = {akey="I1D7CB5FC7230BE63,23321DBE620D2050,,,,,,",de="Anleitung: Heroische Flasche der Zauberschläge",en="Recipe: Heroic Bottle of Spellstrikes",fr="Recette : Bouteille héroïque de sorts critiques",ru="Рецепт: превосходная бутыль магической мощи",icon="scroll9a",val=0,q=2,bop=true,Consumable=true,rss="Alchemist",rsslvl=270},
["B581C3990101010101"] = {akey="I1330C0B50A47AD84,38712DCF835D5177,,,,,,",de="Anleitung für Farbe: Dunkles Blaugrün",en="Recipe: Dark Cyan Dye",fr="Recette : Teinture cyan foncé",ru="Рецепт: темно-бирюзовый краситель",icon="scroll4",val=0,q=1,bop=true,Consumable=true,rss="Alchemist",rsslvl=50},
["D7F09D4B01010101"] = {akey="I096778572C90C0B7,DA02159714AF0642,,,,,,",de="Anleitung: Starker Heiliger Schutztrank",en="Recipe: Greater Holy Warding Potion",fr="Recette : Potion de protection supérieure sacrée",ru="Рецепт: крепкое зелье защиты от Жизни",icon="scroll8b",val=0,q=1,bop=true,accBound=true,Consumable=true,rss="Alchemist",rsslvl=210,rf="Order of Life Serene",rfl=2},
["96AF8AA90301010101"] = {akey="I352297964352D6B4,FEFD74533E0BC3FD,,,,,,",de="Anleitung: Größere Verstärkung der Wendigkeit",en="Recipe: Major Nimble Augment",fr="Recette : Augmentation d'agilité majeure",ru="Чертеж: Большое усиление гибкости",icon="scroll9a",val=0,q=2,bop=true,Consumable=true,rss="Alchemist",rsslvl=300},
["CCEBE9960301010101"] = {akey="I32DA75CC64E80A15,56F55765D8643609,,,,,,",de="Anleitung: Wachstumsgebräu",en="Recipe: Growth Brew",fr="Recette : Breuvage de croissance",ru="Рецепт: настойка роста",icon="scroll9a",val=10000,q=2,bop=true,accBound=true,Consumable=true,rss="Alchemist",rsslvl=260,rf="Red Scar Trackers",rfl=4},
["9EF7FCFF0601010101"] = {akey="I6FFF3B9E67D05D86,2F2DBB8A7EFDE189,,,,,,",de="Anleitung: Mächtiger Zephir-Schutztrank",en="Recipe: Mighty Zephyr Warding Potion",fr="Recette : Potion de protection puissante du zéphyr",ru="Рецепт: могучее зелье защиты от Воздуха",icon="scroll9a",val=0,q=1,bop=true,accBound=true,Consumable=true,rss="Alchemist",rsslvl=240,rf="The Storm Inquisition",rfl=2},
["F8F3CBBD0601010101"] = {akey="I67B2F9F8E6960060,F23A6384E0442F28,,,,,,",de="Anleitung: Muskelkraft",en="Recipe: Brawn",fr="Recette : Constitution",ru="Рецепт: мускулы",icon="scroll9a",val=0,q=3,bop=true,Consumable=true,rss="Alchemist",rsslvl=300},
["FDA4EBC00701010101"] = {akey="I781AD27D0AC921C9,308E2D9DAA4AAE0F,,,,,,",de="Anleitung: Gebräu des Abgründigen Lehrlings",en="Recipe: Brew of the Abyssal Apprentice",fr="Recette : Breuvage de l'Apprenti abyssal",ru="Рецепт: настойка послушника Глубинных",icon="scroll9a",val=0,q=3,bop=true,Consumable=true,rss="Alchemist",rsslvl=300},
["99A9E7F50F01010101"] = {akey="IFEB9D499525E1ED6,C4410E59798856D2,,,,,,",de="Anleitung: Stellare Verstärkung des Segens",en="Recipe: Stellar Blessed Augment",fr="Recette : Augmentation de bénédiction stellaire",ru="Рецепт: Звездная мудрость",icon="sealed_parchment",val=0,q=3,bop=true,Consumable=true,rss="Alchemist",rsslvl=375},
["94D8FBB00301010101"] = {akey="I361EEC1411C7A37D,79AF63A42BAE973F,,,,,,",de="Anleitung: Einfacher Kraftzaubertrank",en="Recipe: Basic Philter of Power",fr="Recette : Philtre essentiel de puissance",ru="Рецепт: простое снадобье мощи",icon="scroll8b",val=0,q=2,bop=true,Consumable=true,rss="Alchemist",rsslvl=160},
["C78BBBF30F01010101"] = {akey="IFE6EC5C72694F4CB,4694DD6E81A630D6,,,,,,",de="Anleitung: Gewicht",en="Recipe: Weight",fr="Recette : Poids",ru="Чертеж: Гиря",icon="scroll9",val=0,q=1,bop=true,Consumable=true,rss="Alchemist",rsslvl=315},
["AAF7FCFF0601010101"] = {akey="I6FFF3BAA195343F2,C2EC0B57C7C23B0C,,,,,,",de="Anleitung: Heroischer Zephir-Schutztrank",en="Recipe: Heroic Zephyr Warding Potion",fr="Recette : Potion de protection héroïque du zéphyr",ru="Рецепт: превосходное зелье защиты от Воздуха",icon="scroll9a",val=0,q=2,bop=true,accBound=true,Consumable=true,rss="Alchemist",rsslvl=300,rf="The Storm Inquisition",rfl=3},
["97F1FAFD0F01010101"] = {akey="IFFBEB8974ACC1725,227B003D23742FEC,,,,,,",de="Anleitung: Hervorragende Beständige Phiole",en="Recipe: Excellent Enduring Vial",fr="Recette : Fiole d'endurance excellente",ru="Рецепт: Отличный флакон выносливости",icon="scroll9",val=0,q=1,bop=true,Consumable=true,rss="Alchemist",rsslvl=320},
["9CACF59C0701010101"] = {akey="I739D561C59AAD428,CAE9849C467802F4,,,,,,",de="Anleitung: Erhabene Flasche der Tricks",en="Recipe: Exalted Bottle of Tricks",fr="Recette : Bouteille de tromperie exaltée",ru="Рецепт: несравненная бутыль шуток",rlvl=50,icon="scroll2a",val=10000,q=2,bop=true,accBound=true,Consumable=true,rss="Alchemist",rsslvl=300,rf="Arcane Hand",rfl=4},
["F1CABD1301010101"] = {akey="I026F6571214BF69E,B91B995C406EC4E7,,,,,,",de="Anleitung: Einfacher Unheiliger Schutztrank",en="Recipe: Basic Unholy Warding Potion",fr="Recette : Potion de protection essentielle impie",ru="Рецепт: простое зелье защиты от Смерти",icon="scroll8b",val=0,q=1,bop=true,accBound=true,Consumable=true,rss="Alchemist",rsslvl=160,rf="The Grim Disciples",rfl=1},
["FDEBF2EB0101010101"] = {akey="I1D7CB5FD18D365C3,F47926C8E7E3BC99,,,,,,",de="Anleitung: Mächtige Beständige Phiole",en="Recipe: Mighty Enduring Vial",fr="Recette : Fiole d'endurance puissante",ru="Рецепт: могучий флакон выносливости",icon="scroll9a",val=0,q=2,bop=true,Consumable=true,rss="Alchemist",rsslvl=270},
["B8AAA6920601010101"] = {akey="I624995382F0EC9A7,F2F66488076B6F67,,,,,,",de="Anleitung: Mächtiger Flammen-Schutztrank",en="Recipe: Mighty Flame Warding Potion",fr="Recette : Potion de protection puissante des flammes",ru="Рецепт: могучее зелье защиты от Огня",icon="scroll9a",val=0,q=1,bop=true,accBound=true,Consumable=true,rss="Alchemist",rsslvl=240,rf="Ember Scholars",rfl=2},
["EAB3FAF40501010101"] = {akey="I5E9E99EA2AE231BD,4BBA591D4C731B27,,,,,,",de="Anleitung: Heroischer Flammen-Schutztrank",en="Recipe: Heroic Flame Warding Potion",fr="Recette : Potion de protection héroïque des flammes",ru="Рецепт: превосходное зелье защиты от Огня",icon="scroll9a",val=0,q=2,bop=true,accBound=true,Consumable=true,rss="Alchemist",rsslvl=300,rf="Ember Scholars",rfl=3},
["D8F09D4B01010101"] = {akey="I0967785855465298,BF657553F302DFED,,,,,,",de="Anleitung: Starker Unheiliger Schutztrank",en="Recipe: Greater Unholy Warding Potion",fr="Recette : Potion de protection supérieure impie",ru="Рецепт: крепкое зелье защиты от Смерти",icon="scroll8b",val=0,q=1,bop=true,accBound=true,Consumable=true,rss="Alchemist",rsslvl=210,rf="Order of the Death Serpent",rfl=2},
["D1B3D41401010101"] = {akey="I029519D164AEFA18,354553498832A11B,,,,,,",de="Anleitung: Heroischer Zephir-Schutztrank",en="Recipe: Heroic Zephyr Warding Potion",fr="Recette : Potion de protection héroïque du zéphyr",ru="Рецепт: превосходное зелье защиты от Воздуха",icon="scroll9a",val=0,q=2,bop=true,accBound=true,Consumable=true,rss="Alchemist",rsslvl=300,rf="Zephyrian Collective",rfl=3},
["B4F8D20301010101"] = {akey="I0074BC34495F0CDA,01C4D2F875C61FA1,,,,,,",de="Anleitung: Mächtiger Heiliger Schutztrank",en="Recipe: Mighty Holy Warding Potion",fr="Recette : Potion de protection puissante sacrée",ru="Рецепт: могучее зелье защиты от Жизни",icon="scroll9a",val=0,q=2,bop=true,accBound=true,Consumable=true,rss="Alchemist",rsslvl=260,rf="Students of the Vale",rfl=3},
["9FF7FCFF0601010101"] = {akey="I6FFF3B9F5D726917,CD44EA9741441543,,,,,,",de="Anleitung: Mächtiger Heiliger Schutztrank",en="Recipe: Mighty Holy Warding Potion",fr="Recette : Potion de protection puissante sacrée",ru="Рецепт: могучее зелье защиты от Жизни",icon="scroll9a",val=0,q=2,bop=true,accBound=true,Consumable=true,rss="Alchemist",rsslvl=260,rf="Order of Life Serene",rfl=3},
["9AA9E7F50F01010101"] = {akey="IFEB9D49A26A55E4E,B4966C3E6337A17B,,,,,,",de="Anleitung: Stellare Verstärkung der Wendigkeit",en="Recipe: Stellar Nimble Augment",fr="Recette : Augmentation d'agilité stellaire",ru="Рецепт: Звездная ловкость",icon="sealed_parchment",val=0,q=3,bop=true,Consumable=true,rss="Alchemist",rsslvl=375},
["95D8FBB00301010101"] = {akey="I361EEC15544A293C,51FC63D28C5DC965,,,,,,",de="Anleitung: Starker Heilzaubertrank",en="Recipe: Greater Healing Philter",fr="Recette : Philtre de guérison supérieur",ru="Рецепт: крепкое снадобье исцеления",icon="scroll8b",val=0,q=2,bop=true,Consumable=true,rss="Alchemist",rsslvl=170},
["CC88A74E01010101"] = {akey="I09C9C44C0C0E8FC0,FD1C5DC69B590D9C,,,,,,",de="Anleitung: Starker Unheiliger Schutztrank",en="Recipe: Greater Unholy Warding Potion",fr="Recette : Potion de protection supérieure impie",ru="Рецепт: крепкое зелье защиты от Смерти",icon="scroll8b",val=0,q=1,bop=true,accBound=true,Consumable=true,rss="Alchemist",rsslvl=210,rf="The Grim Disciples",rfl=2},
["C88BBBF30F01010101"] = {akey="IFE6EC5C8342FE968,4DA4B30C01A703B2,,,,,,",de="Anleitung: Ungetüm",en="Recipe: Hulk",fr="Recette : Mastodonte",ru="Рецепт: Увалень",icon="scroll9",val=0,q=1,bop=true,Consumable=true,rss="Alchemist",rsslvl=345},
["E2F6D9FE0601010101"] = {akey="I6FD67B6203DA5651,26182B80585DBF21,,,,,,",de="Anleitung: Grüne Trankflasche",en="Recipe: Green Potion Bottle",fr="Recette : Potion verte",ru="Рецепт: Бутыль зеленого зелья",icon="scroll4c",val=0,bop=true,Consumable=true,rss="Alchemist",rsslvl=60},
["98F1FAFD0F01010101"] = {akey="IFFBEB8983FFC8376,59CC445A0A8CC1D0,,,,,,",de="Anleitung: Hervorragende Bewehrte Phiole",en="Recipe: Excellent Fortified Vial",fr="Recette : Fiole renforcée excellente",ru="Рецепт: Отличный флакон защиты",icon="scroll9",val=0,q=1,bop=true,Consumable=true,rss="Alchemist",rsslvl=320},
["97D3F4930201010101"] = {akey="I227D299738FC31E5,C0B42015B89D239C,,,,,,",de="Anleitung: Transportierbare Lebensquelle",en="Recipe: Portable Lifespring",fr="Plan : Source de vie portable",ru="Чертеж: портативный источник Жизни",icon="scroll1a",val=0,q=3,bop=true,Consumable=true,rss="Alchemist",rsslvl=260},
["9DACF59C0701010101"] = {akey="I739D561D1EAEC4C3,076828294D75742C,,,,,,",de="Anleitung: Heroische Verstärkte Phiole",en="Recipe: Heroic Fortified Vial",fr="Recette : Fiole renforcée héroïque",ru="Рецепт: превосходный флакон защиты",rlvl=50,icon="scroll9a",val=1,q=2,Consumable=true,rss="Alchemist",rsslvl=300},
["FEEBF2EB0101010101"] = {akey="I1D7CB5FE6D1E8236,C4F99D8BC4645E0B,,,,,,",de="Anleitung: Mächtige Machtschub-Phiole",en="Recipe: Mighty Powersurge Vial",fr="Recette : Fiole d'afflux de pouvoir puissante",ru="Рецепт: могучий флакон силы",icon="scroll9a",val=0,q=2,bop=true,Consumable=true,rss="Alchemist",rsslvl=270},
["C7869FD30F01010101"] = {akey="IFA67C34751EC925C,1D3CD456D0AB2FC1,,,,,,",de="Anleitung: Stellarer Sprengzaubertrank",en="Recipe: Stellar Explosive Philter",fr="Recette : Philtre explosif stellaire",ru="Рецепт: Звездное взрывное снадобье",icon="sealed_parchment",val=0,q=2,bop=true,Consumable=true,rss="Alchemist",rsslvl=370},
["88CBE7B80701010101"] = {akey="I7719E58833A90547,C98B9269E740E42B,,,,,,",de="Anleitung für Farbe: Helles Himmelblau",en="Recipe: Light Sky Blue Dye",fr="Recette : Teinture bleu pastel",ru="Рецепт: светло-голубой краситель",icon="scroll8b",val=0,q=2,bop=true,Consumable=true,rss="Alchemist",rsslvl=170},
["9A9AF78B0301010101"] = {akey="I317DCD1A2D3E4CFD,6771F4B25353E04F,,,,,,",de="Anleitung: Beweglichkeitsserum",en="Recipe: Agility Serum",fr="Recette : Sérum d'agilité",ru="Рецепт: сыворотка уклонения",icon="scroll4",val=0,q=1,bop=true,Consumable=true,rss="Alchemist",rsslvl=70},
["A0F7FCFF0601010101"] = {akey="I6FFF3BA059F9F5FD,0ED4A483D6227371,,,,,,",de="Anleitung: Mächtiger Unheiliger Schutztrank",en="Recipe: Mighty Unholy Warding Potion",fr="Recette : Potion de protection puissante impie",ru="Рецепт: могучее зелье защиты от Смерти",icon="scroll9a",val=0,q=2,bop=true,accBound=true,Consumable=true,rss="Alchemist",rsslvl=260,rf="Order of the Death Serpent",rfl=3},
["A090AF800201010101"] = {akey="I200BC8200C588FA3,18FE3BD75CCE4CBF,,,,,,",de="Anleitung: Legendäre Flasche der kritischen Treffer",en="Recipe: Legendary Bottle of Critical Strikes",fr="Recette : Bouteille légendaire de coups critiques",ru="Рецепт: великолепная бутыль критических ударов",icon="scroll2",val=1,q=3,Consumable=true,rss="Alchemist",rsslvl=300},
["9BA9E7F50F01010101"] = {akey="IFEB9D49B0EF0F5E9,D7689F14B2E2334D,,,,,,",de="Anleitung: Stellare Verstärkung der Robustheit",en="Recipe: Stellar Rugged Augment",fr="Recette : Augmentation d'endurance stellaire",ru="Рецепт: Звездная выносливость",icon="sealed_parchment",val=0,q=3,bop=true,Consumable=true,rss="Alchemist",rsslvl=375},
["96D8FBB00301010101"] = {akey="I361EEC16101B8390,4BD358BB7818247A,,,,,,",de="Anleitung: Starkes Manatonikum",en="Recipe: Greater Mana Tonic",fr="Recette : Fortifiant de mana supérieur",ru="Рецепт: крепкая микстура маны",icon="scroll8b",val=0,q=1,bop=true,Consumable=true,rss="Alchemist",rsslvl=190},
["C98BBBF30F01010101"] = {akey="IFE6EC5C9431CE458,3BBD65E1B6F50463,,,,,,",de="Anleitung: Antrieb",en="Recipe: Drive",fr="Recette : Motivation",ru="Рецепт: Мотивация",icon="sealed_parchment",val=0,q=2,bop=true,Consumable=true,rss="Alchemist",rsslvl=375},
["E3F6D9FE0601010101"] = {akey="I6FD67B635F7E7F78,CAC03D31312C7489,,,,,,",de="Anleitung: Schrank des Trankbereiters",en="Recipe: Potionmaker's Cabinet",fr="Plan : Vitrine de préparateur de potions",ru="Чертеж: Шкаф зельеварителя",icon="scroll4c",val=0,bop=true,Consumable=true,rss="Alchemist",rsslvl=120},
["99F1FAFD0F01010101"] = {akey="IFFBEB8993F5727CE,88A0453A45606A11,,,,,,",de="Anleitung: Stellare Lichtflut-Phiole",en="Recipe: Stellar Brightsurge Vial",fr="Recette : Fiole de flambée rayonnante stellaire",ru="Рецепт: Звездный флакон яркой вспышки",icon="sealed_parchment",val=0,q=2,bop=true,Consumable=true,rss="Alchemist",rsslvl=375},
["9EACF59C0701010101"] = {akey="I739D561E3DBEB2C2,F86FC9CADF3C1E63,,,,,,",de="Anleitung: Heroische Manaschub-Phiole",en="Recipe: Heroic Manasurge Vial",fr="Recette : Fiole d'afflux de mana héroïque",ru="Рецепт: превосходный флакон увеличения маны ",rlvl=50,icon="scroll9a",val=1,q=2,Consumable=true,rss="Alchemist",rsslvl=300},
["FFEBF2EB0101010101"] = {akey="I1D7CB5FF3A750BFF,BC54F29488EC3E91,,,,,,",de="Anleitung: Mächtige Lichtflut-Phiole",en="Recipe: Mighty Brightsurge Vial",fr="Recette : Fiole de flambée rayonnante puissante",ru="Рецепт: могучий флакон озарения",icon="scroll9a",val=0,q=2,bop=true,Consumable=true,rss="Alchemist",rsslvl=270},
["94FA880F01010101"] = {akey="I01E23D14082173D8,289E0D795C54C09E,,,,,,",de="Anleitung: Hervorragender Antiplanarer Krafttrank",en="Recipe: Excellent Anti-Planar Power Potion",fr="Recette : Potion de puissance antiplanaire excellente",ru="Рецепт: Отличное снадобье антипланарной силы",icon="sealed_parchment",val=0,q=2,bop=true,Consumable=true,rss="Alchemist",rsslvl=375},
["F3DD92F10F01010101"] = {akey="IFE24AEF37679984E,19F0B5E4890A6072,,,,,,",de="Anleitung: Empyreum-Verstärkung der Schändlichkeit",en="Recipe: Empyrean Nefarious Augment",fr="Recette : Augmentation abominable empyréenne",ru="Рецепт: Подлое эмпирейское усиление",icon="scroll8b",val=0,q=2,bop=true,Consumable=true,rss="Alchemist",rsslvl=340},
["8DAF8AA90301010101"] = {akey="I3522978D71BD77B4,D81F9BCF31527E45,,,,,,",de="Anleitung: Große Verstärkung des Segens",en="Recipe: Greater Blessed Augment",fr="Recette : Augmentation de bénédiction supérieure",ru="Чертеж: Крепкое усиление благословения",icon="scroll9a",val=0,q=3,bop=true,Consumable=true,rss="Alchemist",rsslvl=300},
["CD988DF80301010101"] = {akey="I3F034C4D381883ED,1DA0C50E81478F30,,,,,,",de="Anleitung: Geringe Verstärkung des Segens",en="Recipe: Minor Blessed Augment",fr="Recette : Augmentation de bénédiction mineure",ru="Чертеж: Малое усиление благословения",icon="scroll1a",val=0,q=1,bop=true,Consumable=true,rss="Alchemist",rsslvl=150},
["C8869FD30F01010101"] = {akey="IFA67C34842A0854B,397DA13A09CDC335,,,,,,",de="Anleitung: Stellarer Giftzaubertrank",en="Recipe: Stellar Venom Philter",fr="Recette : Philtre venimeux stellaire",ru="Рецепт: Звездное ядовитое снадобье",icon="sealed_parchment",val=0,q=2,bop=true,Consumable=true,rss="Alchemist",rsslvl=370},
["97BA8FED0401010101"] = {akey="I4DA3DD176FE09789,2D8FCFC9AA86BF95,,,,,,",de="Anleitung: Schwache Verstärkung des Segens",en="Recipe: Lesser Blessed Augment",fr="Recette : Augmentation de bénédiction inférieure",ru="Чертеж: Слабейшее усиление благословения",icon="scroll4",val=0,q=1,bop=true,Consumable=true,rss="Alchemist",rsslvl=50},
["89CBE7B80701010101"] = {akey="I7719E58922E52242,CBD69A6181A4E9EA,,,,,,",de="Anleitung für Farbe: Dunkles Himmelblau",en="Recipe: Dark Sky Blue Dye",fr="Recette : Teinture bleu nuit",ru="Рецепт: темно-голубой краситель",icon="scroll8b",val=0,q=1,bop=true,Consumable=true,rss="Alchemist",rsslvl=190},
["9EFDF3CA0601010101"] = {akey="I695CFE9E64E23ABA,D47CC05472DCCAE4,,,,,,",de="Anleitung: Phiole des Todeswiderstandes",en="Recipe: Vial of Death Resistance",fr="Recette : Fiole de résistance à la Mort",ru="Рецепт: флакон сопротивляемости Смерти",icon="scroll9a",val=0,q=2,bop=true,accBound=true,Consumable=true,rss="Alchemist",rsslvl=280,rf="The Grim Disciples",rfl=3},
["A1F7FCFF0601010101"] = {akey="I6FFF3BA118BCB6C3,0218F1349C4AEAF0,,,,,,",de="Anleitung: Phiole des Feuerwiderstandes",en="Recipe: Vial of Fire Resistance",fr="Recette : Fiole de résistance au Feu",ru="Рецепт: флакон сопротивляемости Огню",icon="scroll9a",val=0,q=2,bop=true,accBound=true,Consumable=true,rss="Alchemist",rsslvl=280,rf="Order of the Flame",rfl=3},
["A190AF800201010101"] = {akey="I200BC8217E065BBE,CCAD8C1D09D80D19,,,,,,",de="Anleitung: Legendäre Flasche der Zauberschläge",en="Recipe: Legendary Bottle of Spellstrikes",fr="Recette : Bouteille légendaire de sorts critiques",ru="Рецепт: великолепная бутыль магической мощи",icon="scroll2",val=1,q=3,Consumable=true,rss="Alchemist",rsslvl=300},
["97D8FBB00301010101"] = {akey="I361EEC172C950075,2C71EAD170CF3108,,,,,,",de="Anleitung: Starkes Beweglichkeitsserum",en="Recipe: Greater Agility Serum",fr="Recette : Sérum d'agilité supérieur",ru="Рецепт: крепкая сыворотка уклонения",icon="scroll8b",val=0,q=1,bop=true,Consumable=true,rss="Alchemist",rsslvl=190},
["CA8BBBF30F01010101"] = {akey="IFE6EC5CA030B6E81,0B9F2623371F1FB8,,,,,,",de="Anleitung: Gewalt",en="Recipe: Force",fr="Recette : Force",ru="Рецепт: Сила",icon="sealed_parchment",val=0,q=3,bop=true,Consumable=true,rss="Alchemist",rsslvl=375},
["F4EBF2EB0101010101"] = {akey="I1D7CB5F436A6650F,10307649AAADBA31,,,,,,",de="Anleitung: Mächtiger Heilzaubertrank",en="Recipe: Mighty Healing Philter",fr="Recette : Philtre de guérison puissant",ru="Рецепт: могучее снадобье исцеления",icon="scroll9a",val=0,q=2,bop=true,Consumable=true,rss="Alchemist",rsslvl=230},
["E4F6D9FE0601010101"] = {akey="I6FD67B6404E76E6B,C14D031515241FE3,,,,,,",de="Anleitung: Roter Samtstuhl",en="Recipe: Red Velvet Chair",fr="Patron : Chaise en velours rouge",ru="Чертеж: Красное бархатное кресло",icon="scroll4c",val=0,bop=true,Consumable=true,rss="Alchemist",rsslvl=180},
["9AF1FAFD0F01010101"] = {akey="IFFBEB89A4B84465D,7DD175D22146D372,,,,,,",de="Anleitung: Stellare Machtschub-Phiole",en="Recipe: Stellar Powersurge Vial",fr="Recette : Fiole d'afflux de pouvoir stellaire",ru="Рецепт: Звездный флакон восстановления силы",icon="sealed_parchment",val=0,q=2,bop=true,Consumable=true,rss="Alchemist",rsslvl=375},
["99D3F4930201010101"] = {akey="I227D29997288E9E5,A5741C4BD4DBD631,,,,,,",de="Anleitung: Transportierbares Geschütz",en="Recipe: Portable Turret",fr="Plan : Tourelle portable",ru="Чертеж: портативная огневая установка",icon="scroll1a",val=0,q=3,bop=true,Consumable=true,rss="Alchemist",rsslvl=260},
["80ECF2EB0101010101"] = {akey="I1D7CB600570A8605,20FE950307EF84F8,,,,,,",de="Anleitung: Mächtige Verstärkte Phiole",en="Recipe: Mighty Fortified Vial",fr="Recette : Fiole renforcée puissante",ru="Рецепт: могучий флакон защиты",icon="scroll9a",val=0,q=2,bop=true,Consumable=true,rss="Alchemist",rsslvl=270},
["95FA880F01010101"] = {akey="I01E23D1569391BA8,37B175C20B385AF2,,,,,,",de="Anleitung: Stellarer Antiplanarer Krafttrank",en="Recipe: Stellar Anti-Planar Power Potion",fr="Recette : Potion de puissance antiplanaire stellaire",ru="Рецепт: Звездное зелье антипланарной силы",icon="sealed_parchment",val=0,q=3,bop=true,Consumable=true,rss="Alchemist",rsslvl=375},
["F4DD92F10F01010101"] = {akey="IFE24AEF4731609C6,1A0A8EE6F9149AE0,,,,,,",de="Anleitung: Stellare Verstärkung der Schändlichkeit",en="Recipe: Stellar Nefarious Augment",fr="Recette : Augmentation abominable stellaire",ru="Рецепт: Звездная сила критического удара",icon="scroll8b",val=0,q=3,bop=true,Consumable=true,rss="Alchemist",rsslvl=375},
["8EAF8AA90301010101"] = {akey="I3522978E306A8B3F,0BCEEC14DE5C3E9F,,,,,,",de="Anleitung: Große Verstärkung der Macht",en="Recipe: Greater Mighty Augment",fr="Recette : Augmentation de puissance supérieure",ru="Чертеж: Крепкое усиление могущества",icon="scroll9a",val=0,q=3,bop=true,Consumable=true,rss="Alchemist",rsslvl=300},
["CE988DF80301010101"] = {akey="I3F034C4E43099829,12BEEBB9116DA26E,,,,,,",de="Anleitung: Geringe Verstärkung der Macht",en="Recipe: Minor Mighty Augment",fr="Recette : Augmentation de puissance mineure",ru="Чертеж: Малое усиление могущества",icon="scroll1a",val=0,q=1,bop=true,Consumable=true,rss="Alchemist",rsslvl=150},
["C9869FD30F01010101"] = {akey="IFA67C3490006997A,414182806764BE14,,,,,,",de="Anleitung: Stellarer Heilzaubertrank",en="Recipe: Stellar Healing Philter",fr="Recette : Philtre de guérison stellaire",ru="Рецепт: Звездное снадобье исцеления",icon="sealed_parchment",val=0,q=2,bop=true,Consumable=true,rss="Alchemist",rsslvl=370},
["98BA8FED0401010101"] = {akey="I4DA3DD187AF07A0A,479EEA69394F87B5,,,,,,",de="Anleitung: Schwache Verstärkung der Macht",en="Recipe: Lesser Mighty Augment",fr="Recette : Augmentation de puissance inférieure",ru="Чертеж: Слабейшее усиление могущества",icon="scroll4",val=0,q=1,bop=true,Consumable=true,rss="Alchemist",rsslvl=50},
["A2F7FCFF0601010101"] = {akey="I6FFF3BA24EF58F3F,063A5B54BFD31445,,,,,,",de="Anleitung: Phiole des Wasserwiderstandes",en="Recipe: Vial of Water Resistance",fr="Recette : Fiole de résistance à l'Eau",ru="Рецепт: флакон сопротивляемости Воде",icon="scroll9a",val=0,q=2,bop=true,accBound=true,Consumable=true,rss="Alchemist",rsslvl=280,rf="Order of Purity",rfl=3},
["A290AF800201010101"] = {akey="I200BC82250E8AFD7,C8C1AF64A9F4B8C5,,,,,,",de="Anleitung: Heroischer Schutztrank",en="Recipe: Heroic Warding Potion",fr="Recette : Potion de protection héroïque",ru="Рецепт: превосходное зелье защиты",icon="scroll9a",val=11000,q=2,bop=true,accBound=true,Consumable=true,rss="Alchemist",rsslvl=300,rf="Dragonslayer Covenant",rfl=3},
["98D8FBB00301010101"] = {akey="I361EEC186B8E4015,2DA4662537DE2D88,,,,,,",de="Anleitung: Krankheits-Elixier",en="Recipe: Disease Elixir",fr="Recette : Élixir de maladie",ru="Рецепт: эликсир болезни",icon="scroll8b",val=0,q=2,bop=true,Consumable=true,rss="Alchemist",rsslvl=200},
["CB8BBBF30F01010101"] = {akey="IFE6EC5CB6BCDA2B9,F7ED7638ED50FEC9,,,,,,",de="Anleitung: Hervorragende Phiole des Luftwiderstandes",en="Recipe: Excellent Vial of Air Resistance",fr="Recette : Fiole de résistance à l'Air excellente",ru="Рецепт: Отличный флакон сопротивляемости воздуху",icon="scroll9",val=0,q=1,bop=true,Consumable=true,rss="Alchemist",rsslvl=375},
["F5EBF2EB0101010101"] = {akey="I1D7CB5F554125799,0137949C3C746468,,,,,,",de="Anleitung: Mächtiges Beweglichkeitsserum",en="Recipe: Mighty Agility Serum",fr="Recette : Sérum puissant d'agilité",ru="Рецепт: могучая сыворотка уклонения",icon="scroll9a",val=0,q=1,bop=true,Consumable=true,rss="Alchemist",rsslvl=250},
["E5F6D9FE0601010101"] = {akey="I6FD67B656228D62B,FCA5D8502FBAA0AF,,,,,,",de="Anleitung: Beistelltisch",en="Recipe: End Table",fr="Plan : Table d'appoint",ru="Чертеж: Столик",icon="scroll4c",val=0,bop=true,Consumable=true,rss="Alchemist",rsslvl=240},
["9BF1FAFD0F01010101"] = {akey="IFFBEB89B5A80E7BA,5E6F849A99FDDFFF,,,,,,",de="Anleitung: Stellare Manaschub-Phiole",en="Recipe: Stellar Manasurge Vial",fr="Recette : Fiole d'afflux de mana stellaire",ru="Рецепт: Звездный флакон восстановления маны",icon="sealed_parchment",val=0,q=2,bop=true,Consumable=true,rss="Alchemist",rsslvl=375},
["81ECF2EB0101010101"] = {akey="I1D7CB6017EF73235,082FCF512638751C,,,,,,",de="Anleitung: Mächtige Manaschub-Phiole",en="Recipe: Mighty Manasurge Vial",fr="Recette : Fiole d'afflux de mana puissante",ru="Рецепт: могучий флакон увеличения маны",icon="scroll9a",val=0,q=2,bop=true,Consumable=true,rss="Alchemist",rsslvl=270},
["96FA880F01010101"] = {akey="I01E23D164E9FF04B,7E05FD5405B3863C,,,,,,",de="Anleitung: Stellare Quelle des Luftwiderstandes",en="Recipe: Stellar Wellspring of Air Resistance",fr="Plan : Source-puits stellaire de résistance à l'Air",ru="Рецепт: Звездный источник сопротивления силе Воздуха",icon="sealed_parchment",val=0,q=3,bop=true,Consumable=true,rss="Alchemist",rsslvl=375},
["A1F9B45101010101"] = {akey="I0A2D3CA1292E2432,41271FDDC05C79A9,,,,,,",de="Anleitung: Phiole des Wasserwiderstandes",en="Recipe: Vial of Water Resistance",fr="Recette : Fiole de résistance à l'Eau",ru="Рецепт: флакон сопротивляемости Воде",icon="scroll9a",val=0,q=2,bop=true,accBound=true,Consumable=true,rss="Alchemist",rsslvl=280,rf="Mercurial Savants",rfl=3},
["8FAF8AA90301010101"] = {akey="I3522978F6844B17A,0D016768A56B3B1F,,,,,,",de="Anleitung: Große Verstärkung der Klugheit",en="Recipe: Greater Clever Augment",fr="Recette : Augmentation d'esprit supérieure",ru="Чертеж: Крепкое усиление ума",icon="scroll9a",val=0,q=3,bop=true,Consumable=true,rss="Alchemist",rsslvl=300},
["F2F2ACE60301010101"] = {akey="I3CCB39724824D580,79E7CC15BB7A2DC7,,,,,,",de="Anleitung: Mittlere Verstärkung des Segens",en="Recipe: Median Blessed Augment",fr="Recette : Augmentation de bénédiction moyenne",ru="Чертеж: Крепкое усиление благословения",icon="scroll8b",val=0,q=1,bop=true,Consumable=true,rss="Alchemist",rsslvl=225},
["CF988DF80301010101"] = {akey="I3F034C4F62C53D28,38D59CA23E0DEFF2,,,,,,",de="Anleitung: Geringe Verstärkung der Klugheit",en="Recipe: Minor Clever Augment",fr="Recette : Augmentation d'esprit mineure",ru="Чертеж: Малое усиление ума",icon="scroll1a",val=0,q=1,bop=true,Consumable=true,rss="Alchemist",rsslvl=150},
["CA869FD30F01010101"] = {akey="IFA67C34A5061077C,4FA1626FB8B2B3B2,,,,,,",de="Anleitung: Stellarer Zaubertrank der Wiederherstellung",en="Recipe: Stellar Philter of Restoration",fr="Recette : Philtre de restauration stellaire",ru="Рецепт: Звездное снадобье восстановления",icon="sealed_parchment",val=0,q=2,bop=true,Consumable=true,rss="Alchemist",rsslvl=370},
["99BA8FED0401010101"] = {akey="I4DA3DD1977EA1C8D,5DA8D29CF82A3DC7,,,,,,",de="Anleitung: Schwache Verstärkung der Klugheit",en="Recipe: Lesser Clever Augment",fr="Recette : Augmentation d'esprit inférieure",ru="Чертеж: Слабейшее усиление ума",icon="scroll4",val=0,q=1,bop=true,Consumable=true,rss="Alchemist",rsslvl=50},
["92A9E7F50F01010101"] = {akey="IFEB9D4925BD4D6C8,1BB3DCFE2E5DB754,,,,,,",de="Anleitung: Empyreum-Verstärkung der Macht",en="Recipe: Empyrean Mighty Augment",fr="Recette : Augmentation de puissance empyréenne",ru="Рецепт: Мощное эмпирейское усиление",icon="scroll9",val=0,q=2,bop=true,Consumable=true,rss="Alchemist",rsslvl=340},
["A3F7FCFF0601010101"] = {akey="I6FFF3BA32484A7C1,183CB2694B2FDB6F,,,,,,",de="Anleitung: Phiole des Erdwiderstandes",en="Recipe: Vial of Earth Resistance",fr="Recette : Fiole de résistance à la Terre",ru="Рецепт: флакон сопротивляемости Земле",icon="scroll9a",val=0,q=2,bop=true,accBound=true,Consumable=true,rss="Alchemist",rsslvl=280,rf="Mendicant Order",rfl=3},
["A390AF800201010101"] = {akey="I200BC82362BFF584,E5B604A240ACF0ED,,,,,,",de="Anleitung: Heroischer Zaubertrank der Kraft",en="Recipe: Heroic Philter of Power",fr="Recette : Philtre héroïque de puissance",ru="Рецепт: превосходное снадобье мощи",icon="scroll9a",val=11000,q=2,bop=true,accBound=true,Consumable=true,rss="Alchemist",rsslvl=300,rf="Order of Mathos",rfl=3},
["F3EA83C00501010101"] = {akey="I5800F5732362BD72,4488BCA2CB244256,,,,,,",de="Anleitung für Farbe: Dunkles Meergrün",en="Recipe: Dark Seafoam Green Dye",fr="Recette : Teinture vert écume de mer foncé",ru="Рецепт: темно-малахитовый краситель",icon="scroll1a",val=0,q=1,bop=true,Consumable=true,rss="Alchemist",rsslvl=110},
["99D8FBB00301010101"] = {akey="I361EEC191FF79552,4295AC069FB39E38,,,,,,",de="Anleitung: Elixier der Freiheit",en="Recipe: Elixir of Freedom",fr="Recette : Élixir de liberté",ru="Рецепт: эликсир свободы",icon="scroll8b",val=0,q=2,bop=true,Consumable=true,rss="Alchemist",rsslvl=200},
["CC8BBBF30F01010101"] = {akey="IFE6EC5CC5571B476,26D3FDB773E4FD2B,,,,,,",de="Anleitung: Hervorragende Phiole des Todeswiderstandes",en="Recipe: Excellent Vial of Death Resistance",fr="Recette : Fiole de résistance à la Mort excellente",ru="Рецепт: Отличный флакон сопротивляемости смерти",icon="scroll9",val=0,q=1,bop=true,Consumable=true,rss="Alchemist",rsslvl=375},
["F6EBF2EB0101010101"] = {akey="I1D7CB5F670ACC1F9,2820CFCA8A7DDBF3,,,,,,",de="Anleitung: Mächtiges Manatonikum",en="Recipe: Mighty Mana Tonic",fr="Recette : Fortifiant de mana puissant",ru="Рецепт: могучая микстура маны",icon="scroll9a",val=0,q=1,bop=true,Consumable=true,rss="Alchemist",rsslvl=250},
["D6CCB2E50401010101"] = {akey="I4CACA6566FF22C8E,2FFD345A7DAB0C2C,,,,,,",de="Anleitung: Heroischer Gezeiten-Schutztrank",en="Recipe: Heroic Tidal Warding Potion",fr="Recette : Potion de protection héroïque des marées",ru="Рецепт: превосходное зелье защиты от воды",icon="scroll9a",val=0,q=2,bop=true,accBound=true,Consumable=true,rss="Alchemist",rsslvl=300,rf="Mercurial Savants",rfl=3},
["E6F6D9FE0601010101"] = {akey="I6FD67B665F1D0070,0EA82F653B1767D8,,,,,,",de="Anleitung: Mahagonibücherregal",en="Recipe: Mahogany Bookcase",fr="Plan : Bibliothèque en acajou",ru="Чертеж: Книжный шкаф красного дерева",icon="scroll4c",val=0,bop=true,Consumable=true,rss="Alchemist",rsslvl=300},
["9CF1FAFD0F01010101"] = {akey="IFFBEB89C5FDD1F1B,6290EEBABD858606,,,,,,",de="Anleitung: Stellare Beständige Phiole",en="Recipe: Stellar Enduring Vial",fr="Recette : Fiole d'endurance stellaire",ru="Рецепт: Звездный флакон выносливости",icon="sealed_parchment",val=0,q=2,bop=true,Consumable=true,rss="Alchemist",rsslvl=375},
["9180F19E0501010101"] = {akey="I53DC40117637340C,5364F9B794189A00,,,,,,",de="Anleitung: Phiole des Luftwiderstandes",en="Recipe: Vial of Air Resistance",fr="Recette : Fiole de résistance à l'Air",ru="Рецепт: флакон сопротивляемости Воздуху",icon="scroll9a",val=0,q=2,bop=true,accBound=true,Consumable=true,rss="Alchemist",rsslvl=280,rf="Zephyrian Collective",rfl=3},
["82ECF2EB0101010101"] = {akey="I1D7CB6021C46492B,1D2115328E0DE5CC,,,,,,",de="Anleitung: Heroische Gemütszerrüttende Phiole",en="Recipe: Heroic Spiritshatter Vial",fr="Recette : Fiole de brisesprit héroïque",ru="Рецепт: превосходный флакон магической мощи",icon="scroll2",val=1,q=3,Consumable=true,rss="Alchemist",rsslvl=280},
["D1F09D4B01010101"] = {akey="I09677851606E404A,1FA89DDC81CC749C,,,,,,",de="Anleitung: Einfacher Heiliger Schutztrank",en="Recipe: Basic Holy Warding Potion",fr="Recette : Potion de protection essentielle sacrée",ru="Рецепт: простое зелье защиты от Жизни",icon="scroll8b",val=0,q=1,bop=true,accBound=true,Consumable=true,rss="Alchemist",rsslvl=160,rf="Order of Life Serene",rfl=1},
["FBF6DEE10301010101"] = {akey="I3C37BB7B4EF9DEBC,25B5534E8D41F6A8,,,,,,",de="Anleitung: Mächtiger Zephir-Schutztrank",en="Recipe: Mighty Zephyr Warding Potion",fr="Recette : Potion de protection puissante du zéphyr",ru="Рецепт: могучее зелье защиты от Воздуха",icon="scroll9a",val=0,q=1,bop=true,accBound=true,Consumable=true,rss="Alchemist",rsslvl=240,rf="Zephyrian Collective",rfl=2},
["D7898DED0401010101"] = {akey="I4DA344D7711C5B56,2FA5CAC61ED39798,,,,,,",de="Anleitung: Manatonikum",en="Recipe: Mana Tonic",fr="Recette : Fortifiant de mana",ru="Рецепт: микстура маны",icon="scroll1a",val=0,q=1,bop=true,Consumable=true,rss="Alchemist",rsslvl=80},
["97FA880F01010101"] = {akey="I01E23D176BEEB2D9,0227EAC3A93C32E0,,,,,,",de="Anleitung: Stellare Quelle des Todeswiderstandes",en="Recipe: Stellar Wellspring of Death Resistance",fr="Plan : Source-puits stellaire de résistance à la Mort",ru="Рецепт: Звездный источник сопротивления силе Смерти",icon="sealed_parchment",val=0,q=3,bop=true,Consumable=true,rss="Alchemist",rsslvl=375},
["9EFACEEA0301010101"] = {akey="I3D53BD1E6BAE6A9C,D4F311B8B66F2F26,,,,,,",de="Anleitung: Heroischer Titanen-Schutztrank",en="Recipe: Heroic Titan Warding Potion",fr="Recette : Potion de protection héroïque des titans",ru="Рецепт: превосходное зелье защиты от Земли",icon="scroll9a",val=0,q=2,bop=true,accBound=true,Consumable=true,rss="Alchemist",rsslvl=300,rf="The Shale Collegiate",rfl=3},
["90AF8AA90301010101"] = {akey="I352297905349DC71,1F03BE7D30C88597,,,,,,",de="Anleitung: Große Verstärkung der Robustheit",en="Recipe: Greater Rugged Augment",fr="Recette : Augmentation d'endurance supérieure",ru="Чертеж: Крепкое усиление грубости",icon="scroll9a",val=0,q=3,bop=true,Consumable=true,rss="Alchemist",rsslvl=300},
["F3F2ACE60301010101"] = {akey="I3CCB39736C3B0E50,747C231752EFC808,,,,,,",de="Anleitung: Mittlere Verstärkung der Macht",en="Recipe: Median Mighty Augment",fr="Recette : Augmentation de puissance moyenne",ru="Чертеж: Большое усиление могущества",icon="scroll8b",val=0,q=1,bop=true,Consumable=true,rss="Alchemist",rsslvl=225},
["D0988DF80301010101"] = {akey="I3F034C5005838FE9,F8F73AA4FF1A32B5,,,,,,",de="Anleitung: Geringe Verstärkung der Robustheit",en="Recipe: Minor Rugged Augment",fr="Recette : Augmentation d'endurance mineure",ru="Чертеж: Малое усиление грубости",icon="scroll1a",val=0,q=1,bop=true,Consumable=true,rss="Alchemist",rsslvl=150},
["E4D6C5EB0201010101"] = {akey="I2D716B6434E883A7,C9F74B50C0AA04E0,,,,,,",de="Anleitung: Große Flasche der Tricks",en="Recipe: Greater Bottle of Tricks",fr="Recette : Bouteille de tromperie supérieure",ru="Рецепт: крепкая бутыль шуток",icon="scroll8b",val=10000,q=2,bop=true,accBound=true,Consumable=true,rss="Alchemist",rsslvl=150,rf="Granite Falls",rfl=3},
["9ABA8FED0401010101"] = {akey="I4DA3DD1A1DDE8949,6FAB29B1038704F0,,,,,,",de="Anleitung: Schwache Verstärkung der Robustheit",en="Recipe: Lesser Rugged Augment",fr="Recette : Augmentation d'endurance inférieure",ru="Чертеж: Слабейшее усиление грубости",icon="scroll4",val=0,q=1,bop=true,Consumable=true,rss="Alchemist",rsslvl=50},
["C9A4ADEA0101010101"] = {akey="I1D4B524957967758,381A56C9EAC57667,,,,,,",de="Anleitung: Starker Flammen-Schutztrank",en="Recipe: Greater Flame Warding Potion",fr="Recette : Potion de protection supérieure des flammes",ru="Рецепт: крепкое зелье защиты от Огня",icon="scroll8b",val=0,q=1,bop=true,accBound=true,Consumable=true,rss="Alchemist",rsslvl=180,rf="Ember Scholars",rfl=1},
["93A9E7F50F01010101"] = {akey="IFEB9D4935359AB0B,C755E66BD7FB76B6,,,,,,",de="Anleitung: Empyreum-Verstärkung der Klugheit",en="Recipe: Empyrean Clever Augment",fr="Recette : Augmentation d'esprit empyréenne",ru="Рецепт: Эмпирейское усиление талантов",icon="scroll9",val=0,q=2,bop=true,Consumable=true,rss="Alchemist",rsslvl=340},
["E0F5A56B01010101"] = {akey="I0D697AE00D329B80,4C4DFB83321BB936,,,,,,",de="Anleitung: Verherrlichter Manatrank",en="Recipe: Glorified Mana Potion",fr="Recette : Potion de mana glorifiée",ru="Рецепт: знаменитое зелье маны",icon="scroll1",val=0,q=2,bop=true,accBound=true,Consumable=true,rss="Alchemist",rsslvl=300,rf="Kelari Expedition",rfl=3},
["A4F7FCFF0601010101"] = {akey="I6FFF3BA402848E9F,0654E1F0807D58CF,,,,,,",de="Anleitung: Phiole des Luftwiderstandes",en="Recipe: Vial of Air Resistance",fr="Recette : Fiole de résistance à l'Air",ru="Рецепт: флакон сопротивляемости Воздуху",icon="scroll9a",val=0,q=2,bop=true,accBound=true,Consumable=true,rss="Alchemist",rsslvl=280,rf="The Storm Inquisition",rfl=3},
["9987F0DA0F01010101"] = {akey="IFB5C03990D438D69,F7E856937956E975,,,,,,",de="Anleitung: Größere Verstärkung der Schändlichkeit",en="Recipe: Major Nefarious Augment",fr="Recette : Augmentation abominable majeure",ru="Чертеж: Большое нечестивое усиление",icon="scroll8b",val=0,q=2,bop=true,Consumable=true,rss="Alchemist",rsslvl=300},
["A490AF800201010101"] = {akey="I200BC8240F962B5E,149C8C21C740EF4F,,,,,,",de="Anleitung: Legendärer Zaubertrank der Kraft",en="Recipe: Legendary Philter of Power",fr="Recette : Philtre légendaire de puissance",ru="Рецепт: великолепное снадобье мощи",icon="scroll2",val=1,q=3,Consumable=true,rss="Alchemist",rsslvl=300},
["9AD8FBB00301010101"] = {akey="I361EEC1A7E98F968,30ADDB8DD5019EE8,,,,,,",de="Anleitung: Starker Kraftzaubertrank",en="Recipe: Greater Philter of Power",fr="Recette : Philtre supérieur de puissance",ru="Рецепт: крепкое снадобье мощи",icon="scroll8b",val=0,q=2,bop=true,Consumable=true,rss="Alchemist",rsslvl=210},
["CD8BBBF30F01010101"] = {akey="IFE6EC5CD716A49DF,66F5186A34F13FEE,,,,,,",de="Anleitung: Hervorragende Phiole des Erdwiderstandes",en="Recipe: Excellent Vial of Earth Resistance",fr="Recette : Fiole de résistance à la Terre excellente",ru="Рецепт: Отличный флакон сопротивляемости земле",icon="scroll9",val=0,q=1,bop=true,Consumable=true,rss="Alchemist",rsslvl=375},
["F7EBF2EB0101010101"] = {akey="I1D7CB5F76FCE0507,BD67A4F372D05ECE,,,,,,",de="Anleitung: Schafs-Gebräu",en="Recipe: Sheepish Concoction",fr="Recette : Concoction timorée",ru="Рецепт: овечий отвар",icon="scroll9a",val=4500,q=2,bop=true,accBound=true,Consumable=true,rss="Alchemist",rsslvl=250,rf="Arcane Hand",rfl=3},
["E7F6D9FE0601010101"] = {akey="I6FD67B6708F2EDE5,20AA867A46742F01,,,,,,",de="Anleitung: Stasisröhre",en="Recipe: Stasis Tube",fr="Plan : Tube de stase",ru="Чертеж: Стазисная трубка",icon="scroll4c",val=0,bop=true,Consumable=true,rss="Alchemist",rsslvl=360},
["9DF1FAFD0F01010101"] = {akey="IFFBEB89D16693ABD,7493C91D48E2D07E,,,,,,",de="Anleitung: Stellare Bewehrte Phiole",en="Recipe: Stellar Fortified Vial",fr="Recette : Fiole renforcée stellaire",ru="Рецепт: Звездный флакон укрепления",icon="sealed_parchment",val=0,q=2,bop=true,Consumable=true,rss="Alchemist",rsslvl=375},
["83ECF2EB0101010101"] = {akey="I1D7CB603601A30B5,E0873147AC10EADE,,,,,,",de="Anleitung: Heroische Herzzerreißende Phiole",en="Recipe: Heroic Heartshatter Vial",fr="Recette : Fiole de brisecœur héroïque",ru="Рецепт: превосходный флакон боевого настоя",icon="scroll2",val=1,q=3,Consumable=true,rss="Alchemist",rsslvl=280},
["C3EDF9820101010101"] = {akey="I105E76C3E8C4F1EC,5FE5526537279FFE,,,,,,",de="Anleitung: Hartnäckigkeit",en="Recipe: Tenacity",fr="Recette : Ténacité",ru="Рецепт: цепкость",icon="scroll9a",val=0,q=2,bop=true,Consumable=true,rss="Alchemist",rsslvl=280},
["D2F09D4B01010101"] = {akey="I096778523CEF21B3,2F6DC69358C76E7D,,,,,,",de="Anleitung: Einfacher Unheiliger Schutztrank",en="Recipe: Basic Unholy Warding Potion",fr="Recette : Potion de protection essentielle impie",ru="Рецепт: простое зелье защиты от Смерти",icon="scroll8b",val=0,q=1,bop=true,accBound=true,Consumable=true,rss="Alchemist",rsslvl=160,rf="Order of the Death Serpent",rfl=1},
["D8898DED0401010101"] = {akey="I4DA344D809A15B7E,44968D5906A90847,,,,,,",de="Anleitung: Einfacher Heilzaubertrank",en="Recipe: Basic Healing Philter",fr="Recette : Philtre de guérison essentiel",ru="Рецепт: простое снадобье исцеления",icon="scroll1a",val=0,q=2,bop=true,Consumable=true,rss="Alchemist",rsslvl=110},
["98FA880F01010101"] = {akey="I01E23D18391D4FDE,62C5F98AA1F2BC20,,,,,,",de="Anleitung: Stellare Quelle des Erdwiderstandes",en="Recipe: Stellar Wellspring of Earth Resistance",fr="Plan : Source-puits stellaire de résistance à la Terre",ru="Рецепт: Звездный источник сопротивления силе Земли",icon="sealed_parchment",val=0,q=3,bop=true,Consumable=true,rss="Alchemist",rsslvl=375},
["C1A4E1FB0501010101"] = {akey="I5F78524120718066,EA08AB28A9F4126E,,,,,,",de="Anleitung: Mächtiger Titanen-Schutztrank",en="Recipe: Mighty Titan Warding Potion",fr="Recette : Potion de protection puissante des titants",ru="Рецепт: могучее зелье защиты от Земли",icon="scroll9a",val=0,q=1,bop=true,accBound=true,Consumable=true,rss="Alchemist",rsslvl=240,rf="The Shale Collegiate",rfl=2},
["91AF8AA90301010101"] = {akey="I3522979160046508,33F5045E989E7995,,,,,,",de="Anleitung: Große Verstärkung der Wendigkeit",en="Recipe: Greater Nimble Augment",fr="Recette : Augmentation d'agilité supérieure",ru="Чертеж: Крепкое усиление гибкости",icon="scroll9a",val=0,q=3,bop=true,Consumable=true,rss="Alchemist",rsslvl=300},
["F4F2ACE60301010101"] = {akey="I3CCB3974315ABC3B,5EA84B9957B963AB,,,,,,",de="Anleitung: Mittlere Verstärkung der Klugheit",en="Recipe: Median Clever Augment",fr="Recette : Augmentation d'esprit moyenne",ru="Чертеж: Большое усиление ума",icon="scroll8b",val=0,q=1,bop=true,Consumable=true,rss="Alchemist",rsslvl=225},
["D1988DF80301010101"] = {akey="I3F034C515AE7848D,27CAB836B9EDDAF5,,,,,,",de="Anleitung: Geringe Verstärkung der Wendigkeit",en="Recipe: Minor Nimble Augment",fr="Recette : Augmentation d'agilité mineure",ru="Чертеж: Малое усиление гибкости",icon="scroll1a",val=0,q=1,bop=true,Consumable=true,rss="Alchemist",rsslvl=150},
["9BBA8FED0401010101"] = {akey="I4DA3DD1B38B139CB,223428574429D4DD,,,,,,",de="Anleitung: Schwache Verstärkung der Wendigkeit",en="Recipe: Lesser Nimble Augment",fr="Recette : Augmentation d'agilité inférieure",ru="Чертеж: Слабейшее усиление гибкости",icon="scroll4",val=0,q=1,bop=true,Consumable=true,rss="Alchemist",rsslvl=50},
["94A9E7F50F01010101"] = {akey="IFEB9D4944061B194,D9583D80E3583DDF,,,,,,",de="Anleitung: Empyreum-Verstärkung des Segens",en="Recipe: Empyrean Blessed Augment",fr="Recette : Augmentation de bénédiction empyréenne",ru="Рецепт: Благословенное эмпирейское усиление",icon="scroll9",val=0,q=2,bop=true,Consumable=true,rss="Alchemist",rsslvl=340},
["E1F5A56B01010101"] = {akey="I0D697AE1325C9201,EA0F17FBF3E4DAC4,,,,,,",de="Anleitung: Verherrlichter Manatrank",en="Recipe: Glorified Mana Potion",fr="Recette : Potion de mana glorifiée",ru="Рецепт: знаменитое зелье маны",icon="scroll1",val=0,q=2,bop=true,accBound=true,Consumable=true,rss="Alchemist",rsslvl=300,rf="The Farclan",rfl=3},
["A5F7FCFF0601010101"] = {akey="I6FFF3BA571ADEE51,CA224D8949BE0795,,,,,,",de="Anleitung: Phiole des Lebenswiderstandes",en="Recipe: Vial of Life Resistance",fr="Recette : Fiole de résistance à la Vie",ru="Рецепт: флакон сопротивляемости Жизни",icon="scroll9a",val=0,q=2,bop=true,accBound=true,Consumable=true,rss="Alchemist",rsslvl=280,rf="Order of Life Serene",rfl=3},
["9A87F0DA0F01010101"] = {akey="IFB5C039A311A4656,E9648966CF6DA7DB,,,,,,",de="Anleitung: Große Verstärkung der Schändlichkeit",en="Recipe: Greater Nefarious Augment",fr="Recette : Augmentation abominable supérieure",ru="Чертеж: Крепкое нечестивое усиление",icon="scroll9a",val=0,q=3,bop=true,Consumable=true,rss="Alchemist",rsslvl=300},
["B6B7F7B90201010101"] = {akey="I273DDBB63DD6CC74,0290AFEB0BD986DD,,,,,,",de="Anleitung: Einfacher Heiliger Schutztrank",en="Recipe: Basic Holy Warding Potion",fr="Recette : Potion de protection essentielle sacrée",ru="Рецепт: простое зелье защиты от Жизни",icon="scroll8b",val=0,q=1,bop=true,accBound=true,Consumable=true,rss="Alchemist",rsslvl=160,rf="Students of the Vale",rfl=1},
["F699F1880601010101"] = {akey="I611C4CF622DF259B,DEE6528F5163842A,,,,,,",de="Anleitung: Flasche des Lebensegels",en="Recipe: Bottle of Lifeleech",fr="Recette : Bouteille de drain de vie",ru="Рецепт: бутыль вытягивания жизни",icon="scroll4",val=0,q=1,bop=true,Consumable=true,rss="Alchemist",rsslvl=60},
["A590AF800201010101"] = {akey="I200BC8254A8338A0,EAFCA86812322F95,,,,,,",de="Anleitung: Allheilmittel",en="Recipe: Panacea",fr="Recette : Panacée",ru="Чертеж: панацея",icon="scroll2",val=0,q=3,bop=true,Consumable=true,rss="Alchemist",rsslvl=300},
["97ACF59C0701010101"] = {akey="I739D56176C92A842,078E94BDCF6FEA8A,,,,,,",de="Anleitung: Große Flasche der Tricks",en="Recipe: Greater Bottle of Tricks",fr="Recette : Bouteille de tromperie supérieure",ru="Рецепт: крепкая бутыль шуток",icon="scroll8b",val=10000,q=2,bop=true,accBound=true,Consumable=true,rss="Alchemist",rsslvl=150,rf="Gloamwood Waykeepers",rfl=3},
["CE8BBBF30F01010101"] = {akey="IFE6EC5CE528C1010,F8F76F80404E0717,,,,,,",de="Anleitung: Hervorragende Phiole des Feuerwiderstandes",en="Recipe: Excellent Vial of Fire Resistance",fr="Recette : Fiole de résistance au Feu excellente",ru="Рецепт: Отличный флакон сопротивляемости огню",icon="scroll9",val=0,q=1,bop=true,Consumable=true,rss="Alchemist",rsslvl=375},
["84ECF2EB0101010101"] = {akey="I1D7CB6040D380F51,3055E79B607A2CC3,,,,,,",de="Anleitung: Heroisches Manatonikum",en="Recipe: Heroic Mana Tonic",fr="Recette : Fortifiant de mana héroïque",ru="Рецепт: превосходная микстура маны",icon="scroll9a",val=0,q=1,bop=true,Consumable=true,rss="Alchemist",rsslvl=290},
["D3F09D4B01010101"] = {akey="I0967785341316114,D99B7FD503C6A1BB,,,,,,",de="Anleitung: Starker Flammen-Schutztrank",en="Recipe: Greater Flame Warding Potion",fr="Recette : Potion de protection supérieure des flammes",ru="Рецепт: крепкое зелье защиты от Огня",icon="scroll8b",val=0,q=1,bop=true,accBound=true,Consumable=true,rss="Alchemist",rsslvl=180,rf="Order of the Flame",rfl=1},
["C1869FD30F01010101"] = {akey="IFA67C34157908E08,2D8C52B1D26FB340,,,,,,",de="Anleitung: Hervorragender Sprengzaubertrank",en="Recipe: Excellent Explosive Philter",fr="Recette : Philtre explosif excellent",ru="Рецепт: Отличное снадобье взрыва",icon="scroll9",val=0,q=1,bop=true,Consumable=true,rss="Alchemist",rsslvl=325},
["D9898DED0401010101"] = {akey="I4DA344D9536AB547,1EAD6CF9E673D8BE,,,,,,",de="Anleitung: Gift-Elixier",en="Recipe: Poison Elixir",fr="Recette : Élixir anti-poison",ru="Рецепт: эликсир противоядия",icon="scroll1a",val=0,q=2,bop=true,Consumable=true,rss="Alchemist",rsslvl=130},
["99FA880F01010101"] = {akey="I01E23D197EBA5086,690A0E8BF6E328E4,,,,,,",de="Anleitung: Stellare Quelle des Feuerwiderstandes",en="Recipe: Stellar Wellspring of Fire Resistance",fr="Plan : Source-puits stellaire de résistance au Feu",ru="Рецепт: Звездный источник сопротивления силе Огня",icon="sealed_parchment",val=0,q=3,bop=true,Consumable=true,rss="Alchemist",rsslvl=375},
["C1D2AAF50601010101"] = {akey="I6EAAA9411C9A8651,E2386EE9B28CEDCB,,,,,,",de="Anleitung: Phiole des Erdwiderstandes",en="Recipe: Vial of Earth Resistance",fr="Recette : Fiole de résistance à la Terre",ru="Рецепт: флакон сопротивляемости Земле",icon="scroll9a",val=0,q=2,bop=true,accBound=true,Consumable=true,rss="Alchemist",rsslvl=280,rf="The Shale Collegiate",rfl=3},
["92AF8AA90301010101"] = {akey="I3522979228E46603,244A6243024DC43F,,,,,,",de="Anleitung: Größere Verstärkung des Segens",en="Recipe: Major Blessed Augment",fr="Recette : Augmentation de bénédiction majeure",ru="Чертеж: Большое усиление благословения",icon="scroll9a",val=0,q=2,bop=true,Consumable=true,rss="Alchemist",rsslvl=300},
["F5F2ACE60301010101"] = {akey="I3CCB397537DC5F47,70AAA2AE63162AD4,,,,,,",de="Anleitung: Mittlere Verstärkung der Robustheit",en="Recipe: Median Rugged Augment",fr="Recette : Augmentation d'endurance moyenne",ru="Чертеж: Большое усиление грубости",icon="scroll8b",val=0,q=1,bop=true,Consumable=true,rss="Alchemist",rsslvl=225},
["DCF2C7E80101010101"] = {akey="I1D11F95C1D783F78,0F487AC2F85E3369,,,,,,",de="Anleitung für Farbe: Helles Meergrün",en="Recipe: Light Seafoam Green Dye",fr="Recette : Teinture vert écume de mer clair",ru="Рецепт: светло-малахитовый краситель",icon="scroll1a",val=0,q=2,bop=true,Consumable=true,rss="Alchemist",rsslvl=110},
["95A9E7F50F01010101"] = {akey="IFEB9D495622C6445,1CBE5994015ABFA3,,,,,,",de="Anleitung: Empyreum-Verstärkung der Wendigkeit",en="Recipe: Empyrean Nimble Augment",fr="Recette : Augmentation d'agilité empyréenne",ru="Рецепт: Эмпирейское усиление проворности",icon="scroll9",val=0,q=2,bop=true,Consumable=true,rss="Alchemist",rsslvl=340},
["E2F5A56B01010101"] = {akey="I0D697AE27CD66B0B,582747812932DB74,,,,,,",de="Anleitung: Verherrlichter Heiltrank",en="Recipe: Glorified Healing Potion",fr="Recette : Potion de soins glorifiée",ru="Рецепт: знаменитое зелье исцеления",icon="scroll1",val=0,q=2,bop=true,accBound=true,Consumable=true,rss="Alchemist",rsslvl=300,rf="Kelari Expedition",rfl=3},
["A6F7FCFF0601010101"] = {akey="I6FFF3BA642D5A0C2,BF407434D9E39783,,,,,,",de="Anleitung: Phiole des Todeswiderstandes",en="Recipe: Vial of Death Resistance",fr="Recette : Fiole de résistance à la Mort",ru="Рецепт: флакон сопротивляемости Смерти",icon="scroll9a",val=0,q=2,bop=true,accBound=true,Consumable=true,rss="Alchemist",rsslvl=280,rf="Order of the Death Serpent",rfl=3},
["E78BDDD80601010101"] = {akey="I6B1745E7326F7A0E,C66ADD6EB5D97CAD,,,,,,",de="Anleitung für Farbe: Helles Magenta",en="Recipe: Light Magenta Dye",fr="Recette : Teinture magenta clair",ru="Рецепт: светло-сиреневый краситель",icon="scroll9a",val=0,q=2,bop=true,Consumable=true,rss="Alchemist",rsslvl=250},
["A690AF800201010101"] = {akey="I200BC8262522BE34,D00FBDADD1E1AA8A,,,,,,",de="Anleitung: Elixier der Straffreiheit",en="Recipe: Elixir of Impunity",fr="Recette : Élixir d'impunité",ru="Рецепт: эликсир безнаказанности",icon="scroll2",val=0,q=3,bop=true,Consumable=true,rss="Alchemist",rsslvl=300},
}

nkItemBase.db.recipe.armorsmith={
["BFF3C8E20F01010101"] = {akey="IFC5239BF58B705B8,2799D7A88D614105,,,,,,",de="Anleitung: Größere Verstärkung der Barbarei",en="Recipe: Major Barbaric Augment",fr="Recette : Augmentation de barbarie majeure",ru="Чертеж: Большое варварское усиление",icon="scroll8b",val=0,q=2,bop=true,Consumable=true,rss="Armorsmith",rsslvl=300},
["93D5C5E60401010101"] = {akey="I4CD16A937FDFEF28,0DBECB0CC91C3AD7,,,,,,",de="Anleitung: Panzerschuhe des Frommen",en="Recipe: Sabatons of the Devout",fr="Plan : Solerets du Dévot",ru="Чертеж: сабатоны последователя",icon="scroll2a",val=0,q=3,bop=true,Consumable=true,rss="Armorsmith",rsslvl=300},
["9FFBB6EB0601010101"] = {akey="I6D6DBD9F67DAEBDA,23452473794F8286,,,,,,",de="Anleitung: Zinn-Hüftreif",en="Recipe: Tin Fauld",fr="Plan : Braconnière en fer-blanc",ru="Чертеж: оловянная латная юбка",icon="scroll4",val=0,q=1,bop=true,Consumable=true,rss="Armorsmith",rsslvl=1},
["B3CAA5A50601010101"] = {akey="I64A96533555AD4AE,6CEAD53703053235,,,,,,",de="Anleitung: Eisenklauen-Stiefel",en="Recipe: Iron Claw Boots",fr="Plan : Bottes de Griffes de fer",ru="Чертеж: сапоги железного когтя",icon="scroll1",val=0,q=2,bop=true,accBound=true,Consumable=true,rss="Armorsmith",rsslvl=120,rf="Iron Claw Trappers",rfl=1},
["87F78D800601010101"] = {akey="I60037B87253F2E54,3FD4BA4A4A0D1AA0,,,,,,",de="Anleitung: Schwerer Schild des Getreuen",en="Recipe: Heavy Shield of the Stalwart",fr="Plan : Bouclier lourd du Fidèle",ru="Чертеж: тяжелый щит стойкости",icon="scroll8b",val=0,q=3,bop=true,Consumable=true,rss="Armorsmith",rsslvl=300},
["E9F6D9FE0601010101"] = {akey="I6FD67B691DEF3608,34F868D5EC34FBE9,,,,,,",de="Anleitung: Baustein: Steinwürfel",en="Recipe: Building Block: Stone Cube",fr="Plan : Bloc de construction : cube de pierre",ru="Чертеж: Стройматериал: Каменный куб",icon="scroll4c",val=0,bop=true,Consumable=true,rss="Armorsmith",rsslvl=120},
["ADCADA4E01010101"] = {akey="I09D6A52D5352B0E9,C2CDB44012938649,,,,,,",de="Anleitung: Stoßkragen des Getreuen",en="Recipe: Pauldrons of the Stalwart",fr="Plan : Espauliers du Fidèle",ru="Чертеж: наплечники стойкости",icon="scroll8b",val=0,q=3,bop=true,Consumable=true,rss="Armorsmith",rsslvl=300},
["E4C2FACB0601010101"] = {akey="I697EA16433F5811B,2C1DA8BC6E0B8CD5,,,,,,",de="Anleitung: Glaubensgeschmiedete Schulterplatten",en="Recipe: Faith-Forged Spaulders",fr="Plan : Spallières de Forgefoy",ru="Чертеж: кованные верой наплечи",icon="scroll2a",val=0,q=3,bop=true,Consumable=true,rss="Armorsmith",rsslvl=300},
["B6AAD0DD0F01010101"] = {akey="IFBB4153628F7B72C,3C1180BAB2439125,,,,,,",de="Anleitung: Verstärkter Rhenium-Schaller",en="Recipe: Reinforced Rhenium Sallet",fr="Plan : Heaume renforcé en rhénium",ru="Чертеж: Усиленный рениевый салет",icon="scroll8b",val=0,q=2,bop=true,Consumable=true,rss="Armorsmith",rsslvl=370},
["BC80FBD00F01010101"] = {akey="IFA1EC03C3272FC2E,E870D71125303FE0,,,,,,",de="Anleitung: Große Verstärkung der Unerschütterlichkeit",en="Recipe: Greater Stalwart Augment",fr="Recette : Augmentation de loyauté supérieure",ru="Чертеж: Крепкое усиление стойкости",icon="scroll8b",val=0,q=3,bop=true,Consumable=true,rss="Armorsmith",rsslvl=300},
["9EEBF5D80101010101"] = {akey="I1B1D759E6972044B,0350DD883198F217,,,,,,",de="Anleitung: Dunkelmetall-Kettenhemd",en="Recipe: Darkmetal Hauberk",fr="Plan : Haubert en sombracier",ru="Чертеж: хауберк темного металла",icon="scroll8b",val=0,q=2,bop=true,Consumable=true,rss="Armorsmith",rsslvl=225},
["909AA2FC0F01010101"] = {akey="IFF888D1029BB9073,B73068FB5B47D381,,,,,,",de="Anleitung: Verstärkte Tuthony-Bastion",en="Recipe: Reinforced Karthite Bastion",fr="Plan : Bastion renforcé en tuthonie",ru="Чертеж: Усиленный картитовый бастион",icon="scroll8b",val=1,q=2,Consumable=true,rss="Armorsmith",rsslvl=350},
["EAB7EFD50501010101"] = {akey="I5ABBDBEA40CECCD6,BD9F0937907221E5,,,,,,",de="Anleitung: Aufpolierte Mathosianische Beinschienen",en="Recipe: Refurbished Mathosian Greaves",fr="Plan : Grèves mathosiennes fourbies",ru="Чертеж: восстановленные матошийские поножи",icon="scroll8a",val=0,q=2,bop=true,accBound=true,Consumable=true,rss="Armorsmith",rsslvl=300,rf="Order of Mathos"},
["DCEF90EE0F01010101"] = {akey="IFDC437DC7FB16BCD,D4C08D92279F0983,,,,,,",de="Anleitung: Große Verstärkung der Brutalität",en="Recipe: Greater Brutal Augment",fr="Recette : Augmentation de brutalité supérieure",ru="Чертеж: Крепкое усиление брутальности",icon="scroll8b",val=0,q=3,bop=true,Consumable=true,rss="Armorsmith",rsslvl=300},
["C7DAB2E30101010101"] = {akey="I1C6CAD47012A80A7,6D1924C89CC6AEC2,,,,,,",de="Anleitung: Gehärtete Orichalcum-Kettenstiefel",en="Recipe: Tempered Orichalcum Chain Boots",fr="Patron : Bottes de mailles en orichalque durci",ru="Чертеж: закаленные орихалковые кольчужные сапоги",icon="scroll1",val=0,q=2,bop=true,accBound=true,Consumable=true,rss="Armorsmith",rsslvl=300,rf="The Keepers",rfl=3},
["E8EFFAC70501010101"] = {akey="I58FEB7E8B2F8AF7A,16FF078ACDF0066F,,,,,,",de="Anleitung: Verkohlte Kettenstiefel",en="Recipe: Charred Chain Boots",fr="Patron : Bottes de mailles calcinées",ru="Чертеж: опаленные кольчужные сапоги",icon="scroll8b",val=0,q=3,bop=true,Consumable=true,rss="Armorsmith",rsslvl=300},
["93FAB67901010101"] = {akey="I0F2DBD13099E59D2,4A4B25A83BE8FB95,,,,,,",de="Anleitung: Dunkeleisen-Panzerhandschuhe",en="Recipe: Dark Iron Gauntlets",fr="Plan : Gantelets en fer noir",ru="Чертеж: рукавицы из темного железа",icon="scroll8b",val=1,q=2,Consumable=true,rss="Armorsmith",rsslvl=300},
["D18AC2F40F01010101"] = {akey="IFE90855101EA2E02,7779281963064FB2,,,,,,",de="Anleitung: Empyreum-Verstärkung der Exaktheit",en="Recipe: Empyrean Accurate Augment",fr="Recette : Augmentation de précision empyréenne",ru="Рецепт: Эмпирейское усиление точности",icon="scroll8b",val=0,q=2,bop=true,Consumable=true,rss="Armorsmith",rsslvl=340},
["DACEC86601010101"] = {akey="I0CD2275A3704A4C5,6514540286E7A7FB,,,,,,",de="Anleitung: Unnachgiebige Beharrlichkeit",en="Recipe: Unyielding Perseverance",fr="Plan : Persévérance inébranlable",ru="Рецепт: решительная неколебимость",icon="scroll8b",val=0,q=3,bop=true,Consumable=true,rss="Armorsmith",rsslvl=300},
["969AADEE0F01010101"] = {akey="IFDCB4D1600D7190F,3CBC4E7CCE9FCE54,,,,,,",de="Anleitung: Gantimit-Unterarmschienen",en="Recipe: Gantimite Vambraces",fr="Plan : Protège-bras en gantimite",ru="Чертеж: Гантимитовые наручи",icon="scroll8b",val=0,q=1,bop=true,Consumable=true,rss="Armorsmith",rsslvl=290},
["E0A4EDEC0F01010101"] = {akey="IFD9B52601B9A4E51,E86B58AF8A1BC699,,,,,,",de="Anleitung: Verstärkter Gantimit-Schutz",en="Recipe: Reinforced Gantimite Ward",fr="Plan : Protection en gantimite renforcée",ru="Чертеж: Усиленный гантимитовый щит",icon="scroll8b",val=10000,q=2,bop=true,Consumable=true,rss="Armorsmith",rsslvl=330},
["C0F3C8E20F01010101"] = {akey="IFC5239C02E7BC34D,455AF41F4F2AE5E3,,,,,,",de="Anleitung: Große Verstärkung der Barbarei",en="Recipe: Greater Barbaric Augment",fr="Recette : Augmentation de barbarie supérieure",ru="Чертеж: Крепкое варварское усиление",icon="scroll8b",val=0,q=3,bop=true,Consumable=true,rss="Armorsmith",rsslvl=300},
["C9D0C6E90F01010101"] = {akey="IFD31A849037F141B,B66DC089AACCD192,,,,,,",de="Anleitung: Größere Verstärkung der Exaktheit",en="Recipe: Major Accurate Augment",fr="Recette : Augmentation de précision majeure",ru="Чертеж: Большое усиление точности",icon="scroll8b",val=0,q=2,bop=true,Consumable=true,rss="Armorsmith",rsslvl=300},
["EAF6D9FE0601010101"] = {akey="I6FD67B6A506D146D,3919D2F58FBD253F,,,,,,",de="Anleitung: Baustein: Steinpfosten",en="Recipe: Building Block: Stone Pole",fr="Plan : Bloc de construction : poteau de pierre",ru="Чертеж: Стройматериал: Каменный столб",icon="scroll4c",val=0,bop=true,Consumable=true,rss="Armorsmith",rsslvl=180},
["E9F794B10501010101"] = {akey="I56253BE965CC7CA1,6B18E8480F8D276B,,,,,,",de="Anleitung: Aufpolierter Mathosianischer Tappart",en="Recipe: Refurbished Mathosian Tabard",fr="Plan : Tabard mathosien fourbi",ru="Чертеж: восстановленный матошийский плащ",icon="scroll8a",val=0,q=2,bop=true,accBound=true,Consumable=true,rss="Armorsmith",rsslvl=300,rf="Order of Mathos"},
["ABAAD0DD0F01010101"] = {akey="IFBB4152B613CBAEB,CCA144AC260D48BD,,,,,,",de="Anleitung: Grausamer Rhenium-Kürass",en="Recipe: Vicious Rhenium Cuirass",fr="Patron : Cuirasse vicieuse en rhénium",ru="Чертеж: Рениевая кираса злобы",icon="scroll8b",val=1,q=2,Consumable=true,rss="Armorsmith",rsslvl=370},
["B697FD8E0101010101"] = {akey="I11DF4BB652F18E91,0CB9C9C8393E8B1C,,,,,,",de="Anleitung: Verteidigerhelm",en="Recipe: Defender's Helmet",fr="Plan : Casque de défenseur",ru="Чертеж: шлем заступника",icon="scroll9a",val=0,q=2,bop=true,accBound=true,Consumable=true,rss="Armorsmith",rsslvl=300,rf="Icewatch",rfl=3},
["B7AAD0DD0F01010101"] = {akey="IFBB415375FDF1ECC,EAE4FE4D6D173965,,,,,,",de="Anleitung: Unbarmherziger Rhenium-Beinschutz",en="Recipe: Callous Rhenium Chausses",fr="Patron : Chausses monstrueuses en rhénium",ru="Выкройка: Грубые рениевые гетры",icon="scroll8b",val=0,q=2,bop=true,accBound=true,Consumable=true,rss="Armorsmith",rsslvl=375,rf="Necropolis Caretakers",rfl=4},
["BD80FBD00F01010101"] = {akey="IFA1EC03D11C0BFDB,EF812FFDA531960A,,,,,,",de="Anleitung: Empyreum-Verstärkung der Unerschütterlichkeit",en="Recipe: Empyrean Stalwart Augment",fr="Recette : Augmentation de loyauté empyréenne",ru="Чертеж: Эмпирейская усиление стойкости",icon="scroll8b",val=0,q=2,bop=true,Consumable=true,rss="Armorsmith",rsslvl=340},
["FCC2D6F60101010101"] = {akey="I1ED5A17C733E33E2,CBC787DF7E00C939,,,,,,",de="Anleitung: Edler Hüftgürtel",en="Recipe: Noble Girdle",fr="Patron : Ceinturon de noble",ru="Чертеж: благородный пояс",icon="scroll1",val=0,q=2,bop=true,accBound=true,Consumable=true,rss="Armorsmith",rsslvl=190,rf="The Runeguard",rfl=1},
["9FEBF5D80101010101"] = {akey="I1B1D759F23FD6479,2F48F989DBB446F3,,,,,,",de="Anleitung: Orichalcum-Schenkelschutz",en="Recipe: Orichalcum Cuisses",fr="Plan : Cuissards en orichalque",ru="Чертеж: орихалковые поножи",icon="scroll9a",val=0,q=2,bop=true,Consumable=true,rss="Armorsmith",rsslvl=290},
["919AA2FC0F01010101"] = {akey="IFF888D1135BBED19,04D47790270F9E3F,,,,,,",de="Anleitung: Grausames Chiffoncape",en="Recipe: Vicious Chiffon Cape",fr="Patron : Cape vicieuse en mousseline",ru="Выкройка: Шифоновая накидка злобы",icon="scroll8b",val=1,q=2,Consumable=true,rss="Armorsmith",rsslvl=360},
["DDEF90EE0F01010101"] = {akey="IFDC437DD336315B2,E6C367F532FC53FC,,,,,,",de="Anleitung: Empyreum-Verstärkung der Brutalität",en="Recipe: Empyrean Brutal Augment",fr="Recette : Augmentation de brutalité empyréenne",ru="Рецепт: Жесткое эмпирейское усиление",icon="scroll8b",val=0,q=2,bop=true,Consumable=true,rss="Armorsmith",rsslvl=340},
["94FAB67901010101"] = {akey="I0F2DBD147FC71A3C,1B922EB2C1C01B2C,,,,,,",de="Anleitung: Unerbittliche Stahl-Panzerhandschuhe",en="Recipe: Implacable Steel Gauntlets",fr="Plan : Gantelets en acier implacable",ru="Чертеж: заклятые стальные рукавицы",icon="scroll8b",val=1,q=2,Consumable=true,rss="Armorsmith",rsslvl=300},
["D28AC2F40F01010101"] = {akey="IFE908552138B5FB6,2CFDD3EB9933B054,,,,,,",de="Anleitung: Stellare Verstärkung der Exaktheit",en="Recipe: Stellar Accurate Augment",fr="Recette : Augmentation de précision stellaire",ru="Рецепт: Звездная сила удара",icon="scroll8b",val=0,q=3,bop=true,Consumable=true,rss="Armorsmith",rsslvl=375},
["979AADEE0F01010101"] = {akey="IFDCB4D1767958665,2D122FAFB84F9C4D,,,,,,",de="Anleitung: Gantimit-Stoßkragen",en="Recipe: Gantimite Pauldrons",fr="Plan : Espauliers en gantimite",ru="Чертеж: Гантимитовые наплечники",icon="scroll8b",val=0,q=1,bop=true,Consumable=true,rss="Armorsmith",rsslvl=300},
["D8AFF16101010101"] = {akey="I0C3C57D844474714,0F485F51D69EDA85,,,,,,",de="Anleitung: Carmintium-Schaller",en="Recipe: Carmintium Sallet",fr="Plan : Heaume en carmintium",ru="Чертеж: карминтиевый салад",icon="scroll9a",val=0,q=1,bop=true,Consumable=true,rss="Armorsmith",rsslvl=270},
["9DCBE8B10701010101"] = {akey="I763A259D0DA29BEC,BF2DDE3AE35609F0,,,,,,",de="Anleitung: Stahl-Faustschild",en="Recipe: Steel Buckler",fr="Plan : Rondache en acier",ru="Чертеж: стальной кулачный щит",icon="scroll1",val=0,q=2,bop=true,accBound=true,Consumable=true,rss="Armorsmith",rsslvl=80,rf="Granite Falls",rfl=2},
["92A1C70601010101"] = {akey="I00D1D09220B51A2D,EF6B4C1F133C585A,,,,,,",de="Anleitung: Grausamer Rhenium-Großhelm",en="Recipe: Vicious Rhenium Greathelm",fr="Patron : Grand casque vicieux en rhénium",ru="Чертеж: Рениевый топфхелм злобы",icon="scroll8b",val=1,q=3,Consumable=true,rss="Armorsmith",rsslvl=375},
["A3CADA4E01010101"] = {akey="I09D6A5233370B1F9,2D7457D066280E58,,,,,,",de="Anleitung: Eidbruch-Schulterplatten",en="Recipe: Spaulders of the Broken Oath",fr="Plan : Spallières du Serment brisé",ru="Чертеж: наплечи нарушенного обета",icon="scroll8b",val=0,q=3,bop=true,Consumable=true,rss="Armorsmith",rsslvl=300},
["C1F3C8E20F01010101"] = {akey="IFC5239C109321417,485A07BF472513A6,,,,,,",de="Anleitung: Empyreum-Verstärkung der Barbarei",en="Recipe: Empyrean Barbaric Augment",fr="Recette : Augmentation de barbarie empyréenne",ru="Рецепт: Варварское эмпирейское усиление",icon="scroll8b",val=0,q=2,bop=true,Consumable=true,rss="Armorsmith",rsslvl=340},
["CAD0C6E90F01010101"] = {akey="IFD31A84A05C85C45,D4846C476D13889A,,,,,,",de="Anleitung: Große Verstärkung der Exaktheit",en="Recipe: Greater Accurate Augment",fr="Recette : Augmentation de précision supérieure",ru="Чертеж: Крепкое усиление точности",icon="scroll8b",val=0,q=3,bop=true,Consumable=true,rss="Armorsmith",rsslvl=300},
["EBF6D9FE0601010101"] = {akey="I6FD67B6B58C1D33E,C82D3B3F3EA142E1,,,,,,",de="Anleitung: Baustein: Steinrechteck",en="Recipe: Building Block: Stone Rectangle",fr="Plan : Bloc de construction : rectangle de pierre",ru="Чертеж: Стройматериал: Каменная плитка",icon="scroll4c",val=0,bop=true,Consumable=true,rss="Armorsmith",rsslvl=240},
["EAF794B10501010101"] = {akey="I56253BEA14FF79AF,1DA1E6EED02FF759,,,,,,",de="Anleitung: Aufpolierte Mathosianische Panzerhandschuhe",en="Recipe: Refurbished Mathosian Gauntlets",fr="Plan : Gantelets mathosiens fourbis",ru="Чертеж: восстановленные матошийские рукавицы",icon="scroll8a",val=0,q=2,bop=true,accBound=true,Consumable=true,rss="Armorsmith",rsslvl=300,rf="Order of Mathos"},
["ACAAD0DD0F01010101"] = {akey="IFBB4152C44FDC1DE,E77372570B5DC0C5,,,,,,",de="Anleitung: Grausamer Rhenium-Stoßkragen",en="Recipe: Vicious Rhenium Pauldrons",fr="Plan : Espauliers vicieux en rhénium",ru="Чертеж: Рениевые наплечники злобы",icon="scroll8b",val=0,q=2,bop=true,Consumable=true,rss="Armorsmith",rsslvl=375},
["BFA6FCDA0501010101"] = {akey="I5B5F133F5982F35C,339E307E179F8F88,,,,,,",de="Anleitung: Kupfer-Helm",en="Recipe: Copper Helmet",fr="Plan : Casque en cuivre",ru="Чертеж: медный шлем",icon="scroll4",val=0,q=1,bop=true,Consumable=true,rss="Armorsmith",rsslvl=60},
["E6C2FACB0601010101"] = {akey="I697EA1665381F18A,D8F22D7D5EB94F54,,,,,,",de="Anleitung: Die Mauer",en="Recipe: The Wall",fr="Plan : La Barrière",ru="Чертеж: стена",icon="scroll2a",val=0,q=3,bop=true,Consumable=true,rss="Armorsmith",rsslvl=300},
["B6C5CEA90201010101"] = {akey="I2533A2B601265948,DE309C6661E46C9F,,,,,,",de="Anleitung: Fährtenleser-Panzerschuhe",en="Recipe: Tracker's Sabatons",fr="Plan : Solerets de pisteur",ru="Чертеж: сабатоны следопыта",icon="scroll1",val=0,q=2,bop=true,accBound=true,Consumable=true,rss="Armorsmith",rsslvl=140,rf="Red Scar Trackers",rfl=1},
["B8AAD0DD0F01010101"] = {akey="IFBB415386B08A714,2BC37B1959DEBB55,,,,,,",de="Anleitung: Grausames Rhenium-Cape",en="Recipe: Vicious Rhenium Cape",fr="Patron : Cape vicieuse en rhénium",ru="Чертеж: Рениевый плащ злобы",icon="scroll8b",val=30000,q=2,bop=true,Consumable=true,rss="Armorsmith",rsslvl=375},
["869AA2FC0F01010101"] = {akey="IFF888D061A4CE775,0F2D56D020917877,,,,,,",de="Anleitung: Grausamer Gantimit-Brustpanzer",en="Recipe: Vicious Gantimite Breastplate",fr="Plan : Plastron vicieux en gantimite",ru="Чертеж: Гантимитовый нагрузник злобы",icon="scroll8b",val=0,q=2,bop=true,Consumable=true,rss="Armorsmith",rsslvl=330},
["BE80FBD00F01010101"] = {akey="IFA1EC03E1242C1FA,DD995F845A7F136B,,,,,,",de="Anleitung: Stellare Verstärkung der Unerschütterlichkeit",en="Recipe: Stellar Stalwart Augment",fr="Recette : Augmentation de loyauté stellaire",ru="Рецепт: Звездное усиление стойкости",icon="scroll8b",val=0,q=3,bop=true,Consumable=true,rss="Armorsmith",rsslvl=375},
["A0EBF5D80101010101"] = {akey="I1B1D75A05C1BCDE4,414B509E67108ACF,,,,,,",de="Anleitung: Orichalcum-Beinschutz",en="Recipe: Orichalcum Chausses",fr="Plan : Bas-de-chausses en orichalque",ru="Чертеж: орихалковые шоссы",icon="scroll9a",val=0,q=2,bop=true,Consumable=true,rss="Armorsmith",rsslvl=290},
["929AA2FC0F01010101"] = {akey="IFF888D12356D7489,F52A58C310BF6C38,,,,,,",de="Anleitung: Unbarmherziges Chiffoncape",en="Recipe: Callous Chiffon Cape",fr="Patron : Cape monstrueuse en mousseline",ru="Выкройка: Грубый шифоновый капюшон",icon="scroll8b",val=1,q=2,Consumable=true,rss="Armorsmith",rsslvl=360},
["DEEF90EE0F01010101"] = {akey="IFDC437DE1099AEEF,F8C5BF0ABE591B24,,,,,,",de="Anleitung: Stellare Verstärkung der Brutalität",en="Recipe: Stellar Brutal Augment",fr="Recette : Augmentation de brutalité stellaire",ru="Рецепт: Звездная сила и сила удара",icon="scroll8b",val=0,q=3,bop=true,Consumable=true,rss="Armorsmith",rsslvl=375},
["989AADEE0F01010101"] = {akey="IFDCB4D180673C035,0897AE886BEC882D,,,,,,",de="Anleitung: Gantimit-Schulterrüstung",en="Recipe: Gantimite Spaulders",fr="Plan : Spallières en gantimite",ru="Чертеж: Гантимитовые наплечи",icon="scroll8b",val=0,q=1,bop=true,Consumable=true,rss="Armorsmith",rsslvl=300},
["93A1C70601010101"] = {akey="I00D1D09369C2BCC6,016D1FE69E991F82,,,,,,",de="Anleitung: Gehärteter Rhenium-Großhelm",en="Recipe: Hardened Rhenium Greathelm",fr="Plan : Grand casque endurci en rhénium",ru="Чертеж: Крепкий рениевый топфхельм",icon="scroll8b",val=0,q=3,bop=true,Consumable=true,rss="Armorsmith",rsslvl=375},
["A4CADA4E01010101"] = {akey="I09D6A52467996486,DC5ADF50ECBB896C,,,,,,",de="Anleitung: Geistgehärtetes Kettenhemd",en="Recipe: Spirit-Tempered Hauberk",fr="Plan : Haubert lunatique",ru="Чертеж: закаленный духами хауберк",icon="scroll8b",val=0,q=3,bop=true,Consumable=true,rss="Armorsmith",rsslvl=300},
["8380C0E90501010101"] = {akey="I5D3000037E6BB4BC,F3F4DED3C94F1B4B,,,,,,",de="Anleitung: Vitalität",en="Recipe: Vitality",fr="Plan : Vitalité",ru="Рецепт: живучесть",icon="scroll8b",val=0,q=2,bop=true,Consumable=true,rss="Armorsmith",rsslvl=280},
["C2F3C8E20F01010101"] = {akey="IFC5239C246831E74,E670B37E096B4760,,,,,,",de="Anleitung: Stellare Verstärkung der Barbarei",en="Recipe: Stellar Barbaric Augment",fr="Recette : Augmentation de barbarie stellaire",ru="Рецепт: Звездная сила и сила критического удара",icon="scroll8b",val=0,q=3,bop=true,Consumable=true,rss="Armorsmith",rsslvl=375},
["ECF6D9FE0601010101"] = {akey="I6FD67B6C4E6A9FCC,DA2F925449FE0A0A,,,,,,",de="Anleitung: Rüstungsständer",en="Recipe: Armor Rack",fr="Plan : Présentoir à armure",ru="Чертеж: Стойка для доспехов",icon="scroll4c",val=0,bop=true,Consumable=true,rss="Armorsmith",rsslvl=300},
["EBF794B10501010101"] = {akey="I56253BEB53316E74,FE40FC52C8E703E7,,,,,,",de="Anleitung: Aufpolierte Mathosianische Barbuta",en="Recipe: Refurbished Mathosian Barbute",fr="Plan : Barbute mathosienne fourbie",ru="Чертеж: восстановленный матошийский барбют",icon="scroll8a",val=0,q=2,bop=true,accBound=true,Consumable=true,rss="Armorsmith",rsslvl=300,rf="Order of Mathos"},
["ADAAD0DD0F01010101"] = {akey="IFBB4152D1C55F9D4,D87A0D5C1D246AFB,,,,,,",de="Anleitung: Grausamer Rhenium-Bauchreifen",en="Recipe: Vicious Rhenium Tassets",fr="Plan : Tassettes vicieuses en rhénium",ru="Чертеж: Рениевые набедренные щитки злобы",icon="scroll8b",val=0,q=2,bop=true,Consumable=true,rss="Armorsmith",rsslvl=375},
["C0A6FCDA0501010101"] = {akey="I5B5F1340000E6C95,578905A6BE4E601E,,,,,,",de="Anleitung: Eisen-Helm",en="Recipe: Iron Helmet",fr="Plan : Casque en fer",ru="Чертеж: железный шлем",icon="scroll1a",val=0,q=1,bop=true,Consumable=true,rss="Armorsmith",rsslvl=100},
["9397A48E0101010101"] = {akey="I11C90B9376F23CE3,5A553403609C6CCE,,,,,,",de="Anleitung: Zinn-Helm",en="Recipe: Tin Helmet",fr="Plan : Casque en fer-blanc",ru="Чертеж: оловянный шлем",icon="scroll4",val=0,q=1,bop=true,Consumable=true,rss="Armorsmith",rsslvl=20},
["E7C2FACB0601010101"] = {akey="I697EA1672BC4EEED,EBA5C1B2122CF2BB,,,,,,",de="Anleitung: Gewicht der Welt",en="Recipe: Weight of the World",fr="Plan : Poids du Monde",ru="Чертеж: Вся тяжесть мира",icon="scroll2a",val=0,q=3,bop=true,Consumable=true,rss="Armorsmith",rsslvl=300},
["B9AAD0DD0F01010101"] = {akey="IFBB415391371EF4E,F21885FAD459E6A0,,,,,,",de="Anleitung: Unbarmherziges Rhenium-Cape",en="Recipe: Callous Rhenium Cape",fr="Patron : Cape monstrueuse en rhénium",ru="Выкройка: Грубый рениевый плащ",icon="scroll8b",val=30000,q=2,bop=true,Consumable=true,rss="Armorsmith",rsslvl=375},
["879AA2FC0F01010101"] = {akey="IFF888D07383D1879,D0BD940BB57059F3,,,,,,",de="Anleitung: Lebhaftigkeit",en="Recipe: Vivacity",fr="Plan : Vivacité",ru="Рецепт: Оживленность",icon="scroll8b",val=0,q=2,bop=true,Consumable=true,rss="Armorsmith",rsslvl=330},
["FA91BF820101010101"] = {akey="I104FC8FA7747AB52,C1489900BBC782F6,,,,,,",de="Anleitung: Zinn-Schaller",en="Recipe: Tin Sallet",fr="Plan : Heaume en fer-blanc",ru="Чертеж: оловянный салад",icon="scroll4",val=0,q=1,bop=true,Consumable=true,rss="Armorsmith",rsslvl=20},
["A1EBF5D80101010101"] = {akey="I1B1D75A160767C32,5CDABAD1FE80645A,,,,,,",de="Anleitung: Orichalcum-Faustschild",en="Recipe: Orichalcum Buckler",fr="Plan : Rondache en orichalque",ru="Чертеж: орихалковый кулачный щит",icon="scroll9a",val=0,q=2,bop=true,Consumable=true,rss="Armorsmith",rsslvl=290},
["939AA2FC0F01010101"] = {akey="IFF888D133F38E8EC,2D9E76AE2365F9AE,,,,,,",de="Anleitung: Verstärkte Gantimit-Beinplatten",en="Recipe: Reinforced Gantimite Legplates",fr="Patron : Cuissardes renforcées en gantimite",ru="Чертеж: Усиленные гантимитовые поножи",icon="scroll8b",val=10000,q=2,bop=true,Consumable=true,rss="Armorsmith",rsslvl=330},
["D48AC2F40F01010101"] = {akey="IFE90855445F1C7E0,3E5CC77A627BD3B4,,,,,,",de="Anleitung: Empyreum-Verstärkung der Unempfindlichkeit",en="Recipe: Empyrean Impervious Augment",fr="Recette : Augmentation insensible empyréenne",ru="Рецепт: Эмпирейское усиление непроницаемости",icon="scroll8b",val=0,q=2,bop=true,Consumable=true,rss="Armorsmith",rsslvl=340},
["999AADEE0F01010101"] = {akey="IFDCB4D194331D5EB,1F624B151DBF114D,,,,,,",de="Anleitung: Gantimit-Panzerschuhe",en="Recipe: Gantimite Sabatons",fr="Plan : Solerets en gantimite",ru="Чертеж: Гантимитовые сабатоны",icon="scroll8b",val=0,q=1,bop=true,Consumable=true,rss="Armorsmith",rsslvl=310},
["94A1C70601010101"] = {akey="I00D1D0940FE788BE,243F52BC6E43B155,,,,,,",de="Anleitung: Unbarmherzige Rhenium-Haube",en="Recipe: Callous Rhenium Coif",fr="Plan : Camail monstrueux en rhénium",ru="Чертеж: Грубый рениевый койф",icon="scroll8b",val=1,q=3,Consumable=true,rss="Armorsmith",rsslvl=375},
["96D3F4930201010101"] = {akey="I227D2996290AEC9B,E3AE51A97C592650,,,,,,",de="Anleitung: Transportierbare Lebensquelle",en="Recipe: Portable Lifespring",fr="Plan : Source de vie portable",ru="Чертеж: портативный источник Жизни",icon="scroll1a",val=0,q=3,bop=true,Consumable=true,rss="Armorsmith",rsslvl=260},
["EE8593E20501010101"] = {akey="I5C44C2EE50067C63,77ACB169900D74A5,,,,,,",de="Anleitung: Nachtfeuer-Zauberschild",en="Recipe: Nightfire Spellshield",fr="Plan : Bouclier ensorcelé de feu nocturne",ru="Чертеж: колдовской щит ночного Огня",icon="scroll1",val=0,q=2,bop=true,accBound=true,Consumable=true,rss="Armorsmith",rsslvl=90,rf="Gloamwood Waykeepers",rfl=2},
["EDF6D9FE0601010101"] = {akey="I6FD67B6D6A9FE666,E01D94C09E70E154,,,,,,",de="Anleitung: Rüstungswandständer",en="Recipe: Wall Armor Rack",fr="Plan : Présentoir à armure mural",ru="Чертеж: Вешалка для брони",icon="scroll4c",val=0,bop=true,Consumable=true,rss="Armorsmith",rsslvl=360},
["ECF794B10501010101"] = {akey="I56253BEC1498E0B5,2A3895057301D575,,,,,,",de="Anleitung: Aufpolierte Mathosianische Gamaschen",en="Recipe: Refurbished Mathosian Leggings",fr="Plan : Jambières mathosiennes fourbies",ru="Чертеж: восстановленные матошийские наголенники",icon="scroll8a",val=0,q=2,bop=true,accBound=true,Consumable=true,rss="Armorsmith",rsslvl=300,rf="Order of Mathos"},
["AEAAD0DD0F01010101"] = {akey="IFBB4152E7FB17934,19588A2809EBECEB,,,,,,",de="Anleitung: Gehärteter Rhenium-Schild",en="Recipe: Hardened Rhenium Shield",fr="Patron : Bouclier endurci en rhénium",ru="Чертеж: Крепкий рениевый щит",icon="scroll8b",val=0,q=2,bop=true,accBound=true,Consumable=true,rss="Armorsmith",rsslvl=375,rf="The Qaijiri",rfl=4},
["C1A6FCDA0501010101"] = {akey="I5B5F13416011C3BD,2DE921ED094023B2,,,,,,",de="Anleitung: Chromit-Helm",en="Recipe: Chromite Helmet",fr="Plan : Casque en chromite",ru="Чертеж: хромитовый шлем",icon="scroll8b",val=0,q=1,bop=true,Consumable=true,rss="Armorsmith",rsslvl=140},
["889AA2FC0F01010101"] = {akey="IFF888D0856C54AC7,C401E0BC7B98D172,,,,,,",de="Anleitung: Bestehen",en="Recipe: Subsistence",fr="Plan : Subsistance",ru="Рецепт: Живучесть",icon="scroll8b",val=0,q=2,bop=true,Consumable=true,rss="Armorsmith",rsslvl=370},
["A2EBF5D80101010101"] = {akey="I1B1D75A240FCF5F8,576F11D395F5FE9B,,,,,,",de="Anleitung: Orichalcum-Panzerhandschuhe",en="Recipe: Orichalcum Gauntlets",fr="Plan : Gantelets en orichalque",ru="Чертеж: орихалковые рукавицы",icon="scroll9a",val=0,q=2,bop=true,Consumable=true,rss="Armorsmith",rsslvl=290},
["8BC7E7B10601010101"] = {akey="I6639E38B09161C61,BBA831E9A664D5BF,,,,,,",de="Anleitung: Kettenhemd des Anbeters",en="Recipe: Worshipper's Chainmail",fr="Plan : Cotte de mailles d'infidèle",ru="Чертеж: кольчуга верующего",icon="scroll1",val=0,q=2,bop=true,accBound=true,Consumable=true,rss="Armorsmith",rsslvl=190,rf="The Runeguard",rfl=1},
["DB93CDCF0301010101"] = {akey="I39F349DB713A5DCB,3DA9C1221EDBC69B,,,,,,",de="Anleitung: Titan-Hüftreif",en="Recipe: Titanium Fauld",fr="Plan : Braconnière en titane",ru="Чертеж: титановый набрюшник",icon="scroll8b",val=0,q=1,bop=true,Consumable=true,rss="Armorsmith",rsslvl=190},
["D58AC2F40F01010101"] = {akey="IFE9085554DFA2207,505F1E8FEDD91E2C,,,,,,",de="Anleitung: Stellare Verstärkung der Unempfindlichkeit",en="Recipe: Stellar Impervious Augment",fr="Recette : Augmentation insensible stellaire",ru="Рецепт: Звездный блок",icon="scroll8b",val=0,q=3,bop=true,Consumable=true,rss="Armorsmith",rsslvl=375},
["9A9AADEE0F01010101"] = {akey="IFDCB4D1A3939D186,1EBB6FBD1AD178AC,,,,,,",de="Anleitung: Gantimit-Stiefel",en="Recipe: Gantimite Boots",fr="Plan : Bottes en gantimite",ru="Чертеж: Гантимитовые сапоги",icon="scroll8b",val=0,q=1,bop=true,Consumable=true,rss="Armorsmith",rsslvl=310},
["E4A4EDEC0F01010101"] = {akey="IFD9B52643C32294E,E5713DAD06A7AD1B,,,,,,",de="Anleitung: Unbarmherzige Gantimit-Beinplatten",en="Recipe: Callous Gantimite Legplates",fr="Patron : Cuissardes monstrueuses en gantimite",ru="Чертеж: Грубые гантимитовые поножи",icon="scroll8b",val=10000,q=2,bop=true,Consumable=true,rss="Armorsmith",rsslvl=330},
["95A1C70601010101"] = {akey="I00D1D0957328C8CF,D4FFB436BED444DA,,,,,,",de="Anleitung: Verstärkte Rhenium-Haube",en="Recipe: Reinforced Rhenium Coif",fr="Plan : Camail renforcé en rhénium",ru="Чертеж: Усиленный рениевый койф",icon="scroll8b",val=0,q=3,bop=true,Consumable=true,rss="Armorsmith",rsslvl=375},
["A6CADA4E01010101"] = {akey="I09D6A52622F1E983,1C2D66CCDD26D8AD,,,,,,",de="Anleitung: Geistgehärtete Schulterplatten",en="Recipe: Spirit-Tempered Spaulders",fr="Plan : Spallières lunatiques",ru="Чертеж: закаленные духами наплечи",icon="scroll8b",val=0,q=3,bop=true,Consumable=true,rss="Armorsmith",rsslvl=300},
["EDF794B10501010101"] = {akey="I56253BED61B4D176,3C3AEC1A7E5E9C9E,,,,,,",de="Anleitung: Aufpolierte Mathosianische Schulterplatten",en="Recipe: Refurbished Mathosian Pauldrons",fr="Plan : Espauliers mathosiens fourbis",ru="Чертеж: восстановленные матошийские наплечники",icon="scroll8a",val=0,q=2,bop=true,accBound=true,Consumable=true,rss="Armorsmith",rsslvl=300,rf="Order of Mathos"},
["AFAAD0DD0F01010101"] = {akey="IFBB4152F15573B3B,09AE6B5B739BBAE3,,,,,,",de="Anleitung: Notwendigkeit",en="Recipe: Necessity",fr="Plan : Nécessité",ru="Рецепт: Неизбежность",icon="scroll8b",val=0,q=2,bop=true,Consumable=true,rss="Armorsmith",rsslvl=375},
["C2A6FCDA0501010101"] = {akey="I5B5F13420BAA3A18,53B701EFCE754638,,,,,,",de="Anleitung: Kobalt-Helm",en="Recipe: Cobalt Helmet",fr="Plan : Casque en cobalt",ru="Чертеж: кобальтовый шлем",icon="scroll8b",val=0,q=1,bop=true,Consumable=true,rss="Armorsmith",rsslvl=170},
["97EBF5D80101010101"] = {akey="I1B1D75970EF73AFD,14F7CB1153084162,,,,,,",de="Anleitung: Stahl-Panzerschuhe",en="Recipe: Steel Sabatons",fr="Plan : Solerets en acier",ru="Чертеж: стальные сабатоны",icon="scroll1a",val=0,q=2,bop=true,Consumable=true,rss="Armorsmith",rsslvl=150},
["E9C2FACB0601010101"] = {akey="I697EA1690166FA1C,1CDA1FB168A442A3,,,,,,",de="Anleitung: Kettenhemd des Gläubigen",en="Recipe: Hauberk of the Devout",fr="Plan : Haubert du Dévot",ru="Чертеж: хауберк преданных",icon="scroll2a",val=0,q=3,bop=true,Consumable=true,rss="Armorsmith",rsslvl=300},
["899AA2FC0F01010101"] = {akey="IFF888D0920434812,B92007678BBE6161,,,,,,",de="Anleitung: Gehärteter Gantimit-Großhelm",en="Recipe: Hardened Gantimite Greathelm",fr="Patron : Grand casque endurci en gantimite",ru="Чертеж: Крепкий гантимитовый топфхельм",icon="scroll8b",val=0,q=2,bop=true,accBound=true,Consumable=true,rss="Armorsmith",rsslvl=310,rf="Eternal City Survivors",rfl=1},
["F0B6DA8C0701010101"] = {akey="I71969B7007A4DE30,DFFB884F0012AC13,,,,,,",de="Anleitung: Eklipse des Schlachtenmeisters",en="Recipe: Battlemaster's Eclipse",fr="Plan : Éclipse du maître de guerre",ru="Рецепт: Затмение мастера боя",icon="scroll8b",val=0,q=3,bop=true,Consumable=true,rss="Armorsmith",rsslvl=375},
["C586906A01010101"] = {akey="I0D44034529D2D4AA,E1B0B772F6A47A97,,,,,,",de="Anleitung: Kupfer-Hüftreif",en="Recipe: Copper Fauld",fr="Plan : Braconnière en cuivre",ru="Чертеж: медная юбка",icon="scroll4",val=0,q=1,bop=true,Consumable=true,rss="Armorsmith",rsslvl=40},
["BFD0B3FD0401010101"] = {akey="I4FACE83F3450ACA9,1B404507F27C084C,,,,,,",de="Anleitung: Kupfer-Bauchreifen",en="Recipe: Copper Tassets",fr="Plan : Tassettes en cuivre",ru="Чертеж: медные бедренные щитки",icon="scroll4",val=0,q=1,bop=true,Consumable=true,rss="Armorsmith",rsslvl=40},
["9B9AADEE0F01010101"] = {akey="IFDCB4D1B17084577,30BDC6D2A62E3FD4,,,,,,",de="Anleitung: Tuthony-Panzerhandschuhe",en="Recipe: Karthite Gauntlets",fr="Plan : Gantelets en tuthonie",ru="Чертеж: Картитовые перчатки",icon="scroll8b",val=0,q=1,bop=true,Consumable=true,rss="Armorsmith",rsslvl=330},
["E5A4EDEC0F01010101"] = {akey="IFD9B52650F0FE37B,0043EEA6EBF82523,,,,,,",de="Anleitung: Grausames Lanzancape",en="Recipe: Vicious Lanzan Cape",fr="Plan : Cape vicieuse en lanzane",ru="Выкройка: Ланзановый плащ злобы",icon="scroll8b",val=0,q=2,bop=true,Consumable=true,rss="Armorsmith",rsslvl=320},
["96A1C70601010101"] = {akey="I00D1D096587CBE74,DCC3957C9C6B3FBA,,,,,,",de="Anleitung: Grausame Rhenium-Bindungen",en="Recipe: Vicious Rhenium Bindings",fr="Plan : Liens vicieux en rhénium",ru="Чертеж: Рениевые обвязки злобы",icon="scroll8b",val=0,q=3,bop=true,Consumable=true,rss="Armorsmith",rsslvl=375},
["A7CADA4E01010101"] = {akey="I09D6A5277AD8F3E6,035EA11A7B6FC8D0,,,,,,",de="Anleitung: Hüter-Kettenhemd",en="Recipe: Hauberk of the Keeper",fr="Plan : Haubert du Garde",ru="Чертеж: хауберк хранителя",icon="scroll8b",val=0,q=3,bop=true,Consumable=true,rss="Armorsmith",rsslvl=300},
["9285EDA80101010101"] = {akey="I151B42927FBD4652,574BCB671F364ED6,,,,,,",de="Anleitung: Dunkeleisen-Kettenhemd",en="Recipe: Dark Iron Hauberk",fr="Plan : Haubert en fer noir",ru="Чертеж: хауберк из темного железа",icon="scroll8b",val=1,q=3,Consumable=true,rss="Armorsmith",rsslvl=300},
["CED0C6E90F01010101"] = {akey="IFD31A84E60F4CB0A,F6ECCB88911C9697,,,,,,",de="Anleitung: Größere Verstärkung der Unempfindlichkeit",en="Recipe: Major Impervious Augment",fr="Recette : Augmentation insensible majeure",ru="Чертеж: Большое усиление непроницаемости",icon="scroll8b",val=0,q=2,bop=true,Consumable=true,rss="Armorsmith",rsslvl=300},
["B0AAD0DD0F01010101"] = {akey="IFBB415300413649D,1BB0C2707EF8820C,,,,,,",de="Anleitung: Unbarmherziges Rhenium-Kettenhemd",en="Recipe: Callous Rhenium Hauberk",fr="Patron : Haubert monstrueux en rhénium",ru="Чертеж: Грубый рениевый хауберк",icon="scroll8b",val=1,q=2,Consumable=true,rss="Armorsmith",rsslvl=370},
["93E894980101010101"] = {akey="I130534130FB3BA53,42F3475F9B4357A6,,,,,,",de="Anleitung: Seelenwächter-Helm",en="Recipe: Soul Warden's Helm",fr="Plan : Casque de garde des âmes",ru="Чертеж: шлем смотрителя души",icon="scroll9a",val=0,q=2,bop=true,accBound=true,Consumable=true,rss="Armorsmith",rsslvl=300,rf="Icewatch",rfl=3},
["C3A6FCDA0501010101"] = {akey="I5B5F13434177366E,7FAF1DF078909B14,,,,,,",de="Anleitung: Titan-Helm",en="Recipe: Titanium Helmet",fr="Plan : Casque en titane",ru="Чертеж: титановый шлем",icon="scroll9a",val=0,q=1,bop=true,Consumable=true,rss="Armorsmith",rsslvl=210},
["98EBF5D80101010101"] = {akey="I1B1D75985CE7089C,06737A96291EFFC7,,,,,,",de="Anleitung: Stahl-Unterarmschienen",en="Recipe: Steel Vambraces",fr="Plan : Protège-bras en acier",ru="Чертеж: стальные наручи",icon="scroll1a",val=0,q=2,bop=true,Consumable=true,rss="Armorsmith",rsslvl=150},
["BCAAD0DD0F01010101"] = {akey="IFBB4153C06C32A67,1E9DF435F465AEFF,,,,,,",de="Anleitung: Gehärtete Rhenium-Panzerschuhe",en="Recipe: Hardened Rhenium Sabatons",fr="Patron : Solerets endurcis en rhénium",ru="Чертеж: Крепкие рениевые сабатоны",icon="scroll8b",val=1,q=2,Consumable=true,rss="Armorsmith",rsslvl=375},
["8A9AA2FC0F01010101"] = {akey="IFF888D0A1D93E32F,EEA53686C1EBC203,,,,,,",de="Anleitung: Verstärkte Gantimit-Bundhaube",en="Recipe: Reinforced Gantimite Coif",fr="Patron : Coiffe renforcée en gantimite",ru="Чертеж: Усиленный гантимитовый койф",icon="scroll8b",val=0,q=2,bop=true,accBound=true,Consumable=true,rss="Armorsmith",rsslvl=310,rf="Necropolis Caretakers",rfl=1},
["F1B6DA8C0701010101"] = {akey="I71969B717002687F,E41CF26F239A521A,,,,,,",de="Anleitung: Eklipse des Beichtvaters",en="Recipe: Confessor's Eclipse",fr="Plan : Éclipse de confesseur",ru="Рецепт: Затмение исповедника",icon="scroll8b",val=0,q=3,bop=true,Consumable=true,rss="Armorsmith",rsslvl=375},
["8DFAB67901010101"] = {akey="I0F2DBD0D14B6B356,EC1E081F5F90EE72,,,,,,",de="Anleitung: Nachteisen-Panzerschuhe",en="Recipe: Night Iron Sabatons",fr="Plan : Solerets en fer nocturnes",ru="Чертеж: сабатоны из ночного железа",icon="scroll8b",val=1,q=3,Consumable=true,rss="Armorsmith",rsslvl=300},
["C0D0B3FD0401010101"] = {akey="I4FACE840574E1605,F49115AE28F05A9C,,,,,,",de="Anleitung: Eisen-Bauchreifen",en="Recipe: Iron Tassets",fr="Plan : Tassettes en fer",ru="Чертеж: железные набедренные щитки",icon="scroll1a",val=0,q=1,bop=true,Consumable=true,rss="Armorsmith",rsslvl=80},
["9C9AADEE0F01010101"] = {akey="IFDCB4D1C2B04C49B,50A10ADC995FA4D1,,,,,,",de="Anleitung: Tuthony-Unterarmschienen",en="Recipe: Karthite Vambraces",fr="Plan : Protège-bras en tuthonie",ru="Чертеж: Картитовые наручи",icon="scroll8b",val=0,q=1,bop=true,Consumable=true,rss="Armorsmith",rsslvl=330},
["E6A4EDEC0F01010101"] = {akey="IFD9B52661BC9896D,1245C26DF754EC4C,,,,,,",de="Anleitung: Unbarmherziges Lanzancape",en="Recipe: Callous Lanzan Cape",fr="Plan : Cape monstrueuse en lanzane",ru="Выкройка: Грубый ланзановый плащ",icon="scroll8b",val=0,q=2,bop=true,Consumable=true,rss="Armorsmith",rsslvl=320},
["DA8F99920701010101"] = {akey="I724647DA3DF0B621,BE43654D4EDCEE1C,,,,,,",de="Anleitung: Kupfer-Schaller",en="Recipe: Copper Sallet",fr="Plan : Heaume en cuivre",ru="Чертеж: медный салад",icon="scroll4",val=0,q=1,bop=true,Consumable=true,rss="Armorsmith",rsslvl=60},
["97A1C70601010101"] = {akey="I00D1D0975B7D9AD7,23D57F27C2A22D7F,,,,,,",de="Anleitung: Gehärtete Rhenium-Bindungen",en="Recipe: Hardened Rhenium Bindings",fr="Patron : Liens endurcis en rhénium",ru="Выкройка: Крепкие рениевые обмотки",icon="scroll8b",val=1,q=3,Consumable=true,rss="Armorsmith",rsslvl=375},
["A8CADA4E01010101"] = {akey="I09D6A5280DE4CD9B,1560F82F86CC8FF9,,,,,,",de="Anleitung: Hüter-Schutz",en="Recipe: Ward of the Keeper",fr="Plan : Voile du Garde",ru="Чертеж: щит хранителя",icon="scroll8b",val=0,q=3,bop=true,Consumable=true,rss="Armorsmith",rsslvl=300},
["CFD0C6E90F01010101"] = {akey="IFD31A84F42924A39,AE901FB125E36C68,,,,,,",de="Anleitung: Große Verstärkung der Unempfindlichkeit",en="Recipe: Greater Impervious Augment",fr="Recette : Augmentation insensible supérieure",ru="Чертеж: Крепкое усиление непроницаемости",icon="scroll8b",val=0,q=3,bop=true,Consumable=true,rss="Armorsmith",rsslvl=300},
["A28FDFD80501010101"] = {akey="I5B17C7A20E12D3E7,13507A00E3D739EE,,,,,,",de="Anleitung: Faustschild des Gelehrten",en="Recipe: Buckler of the Scholar",fr="Plan : Rondache de l'Érudit",ru="Чертеж: кулачный щит ученого",icon="scroll1",val=0,q=2,bop=true,accBound=true,Consumable=true,rss="Armorsmith",rsslvl=60,rf="Freemarch Wardens",rfl=2},
["AFBFBBC10101010101"] = {akey="I182EDFAF5EAB38D2,42979515529974C2,,,,,,",de="Anleitung: Eidbruch-Kettenhemd",en="Recipe: Hauberk of the Broken Oath",fr="Plan : Haubert du Serment brisé",ru="Чертеж: хауберк нарушенной клятвы",icon="scroll8b",val=0,q=3,bop=true,Consumable=true,rss="Armorsmith",rsslvl=300},
["B1AAD0DD0F01010101"] = {akey="IFBB4153165C86087,2083ECFECA980AEE,,,,,,",de="Anleitung: Unbarmherzige Rhenium-Schulterrüstung",en="Recipe: Callous Rhenium Spaulders",fr="Plan : Spallières monstrueuses en rhénium",ru="Чертеж: Грубые рениевые наплечники",icon="scroll8b",val=0,q=2,bop=true,Consumable=true,rss="Armorsmith",rsslvl=375},
["C4A6FCDA0501010101"] = {akey="I5B5F1344785EA945,82AE3190708AC8D7,,,,,,",de="Anleitung: Carmintium-Helm",en="Recipe: Carmintium Helmet",fr="Plan : Casque en carmintium",ru="Чертеж: карминтиевый шлем",icon="scroll9a",val=0,q=1,bop=true,Consumable=true,rss="Armorsmith",rsslvl=260},
["99EBF5D80101010101"] = {akey="I1B1D75991ACC0E57,3A22478D5628C020,,,,,,",de="Anleitung: Dunkelmetall-Schaller",en="Recipe: Darkmetal Sallet",fr="Plan : Heaume en sombracier",ru="Чертеж: салад темного металла",icon="scroll8b",val=0,q=2,bop=true,Consumable=true,rss="Armorsmith",rsslvl=170},
["BDAAD0DD0F01010101"] = {akey="IFBB4153D5A263352,EF1E6AF8D0E6506F,,,,,,",de="Anleitung: Verstärkte Rhenium-Stiefel",en="Recipe: Reinforced Rhenium Boots",fr="Patron : Bottes renforcées en rhénium",ru="Чертеж: Усиленные рениевые сапоги",icon="scroll8b",val=1,q=2,Consumable=true,rss="Armorsmith",rsslvl=375},
["8B9AA2FC0F01010101"] = {akey="IFF888D0B60FB9CF3,E9390A3A59615C44,,,,,,",de="Anleitung: Gehärtetes Chiffoncape",en="Recipe: Hardened Chiffon Cape",fr="Patron : Cape endurcie en mousseline",ru="Выкройка: Крепкий шифоновый плащ",icon="scroll8b",val=0,q=2,bop=true,accBound=true,Consumable=true,rss="Armorsmith",rsslvl=360,rf="Necropolis Caretakers",rfl=4},
["DB8F91820301010101"] = {akey="I304447DB2CD636A1,CBB66FDCAF42E85A,,,,,,",de="Anleitung: Aigis des Aufsehers",en="Recipe: Overseer's Aegis",fr="Recette : Égide du superviseur",ru="Чертеж: щит надзирателя",icon="scroll1",val=0,q=2,bop=true,accBound=true,Consumable=true,rss="Armorsmith",rsslvl=60,rf="Quicksilver Scholars",rfl=2},
["F2B6DA8C0701010101"] = {akey="I71969B72206D585F,130379EEAA2E507C,,,,,,",de="Anleitung: Faustschild der Verdrehten Seelen",en="Recipe: Buckler of Twisted Souls",fr="Patron : Rondache des âmes tourmentées",ru="Чертеж: Баклер Искаженных душ",icon="scroll8b",val=0,q=3,bop=true,Consumable=true,rss="Armorsmith",rsslvl=375},
["DC8AF57701010101"] = {akey="I0EFD455C62F70692,002CCD9FA44DBD8C,,,,,,",de="Anleitung: Stahl-Schulterplatten",en="Recipe: Steel Spaulders",fr="Plan : Spallières en acier",ru="Чертеж: стальные наплечи",icon="scroll1a",val=0,q=2,bop=true,Consumable=true,rss="Armorsmith",rsslvl=150},
["8EFAB67901010101"] = {akey="I0F2DBD0E024E6200,E480ACDD4CAC3A13,,,,,,",de="Anleitung: Nachteisen-Panzerhandschuhe",en="Recipe: Night Iron Gauntlets",fr="Plan : Gantelets en fer nocturnes",ru="Чертеж: рукавицы из ночного железа",icon="scroll8b",val=1,q=2,Consumable=true,rss="Armorsmith",rsslvl=300},
["C1D0B3FD0401010101"] = {akey="I4FACE8414FD170BD,D8D21EEA5BB6BC04,,,,,,",de="Anleitung: Chromit-Bauchreifen",en="Recipe: Chromite Tassets",fr="Plan : Tassettes en chromite",ru="Чертеж: хромитовые бедренные щитки",icon="scroll1a",val=0,q=1,bop=true,Consumable=true,rss="Armorsmith",rsslvl=120},
["DBA4EDEC0F01010101"] = {akey="IFD9B525B3BDF7D73,DCFBE046BEA5A4E2,,,,,,",de="Anleitung: Bösartiger Gantimit-Großhelm",en="Recipe: Vicious Gantimite Greathelm",fr="Plan : Grand casque en gantimite brutal",ru="Чертеж: Гантимитовый топфхелм злобы",icon="scroll8b",val=1,q=2,Consumable=true,rss="Armorsmith",rsslvl=310},
["D5E09DFE0501010101"] = {akey="I5FC770551F7E909F,38AD5E8467BEA070,,,,,,",de="Anleitung: Gehärtete Orichalcum-Panzerhandschuhe",en="Recipe: Tempered Orichalcum Gauntlets",fr="Patron : Gantelets en orichalque durci",ru="Чертеж: закаленные орихалковые рукавицы",icon="scroll1",val=0,q=2,bop=true,accBound=true,Consumable=true,rss="Armorsmith",rsslvl=300,rf="The Farclan",rfl=3},
["9D9AADEE0F01010101"] = {akey="IFDCB4D1D3AD95345,62A2DEA324BBE8AB,,,,,,",de="Anleitung: Tuthony-Stoßkragen",en="Recipe: Karthite Pauldrons",fr="Plan : Espauliers en tuthonie",ru="Чертеж: Картитовые наплечники",icon="scroll8b",val=0,q=1,bop=true,Consumable=true,rss="Armorsmith",rsslvl=340},
["BBF3C8E20F01010101"] = {akey="IFC5239BB72362065,FC74ABBE5B255B9B,,,,,,",de="Anleitung: Größere Verstärkung der Wildheit",en="Recipe: Major Savage Augment",fr="Recette : Augmentation de sauvagerie majeure",ru="Чертеж: Большое усиление дикости",icon="scroll8b",val=0,q=2,bop=true,Consumable=true,rss="Armorsmith",rsslvl=300},
["98A1C70601010101"] = {akey="I00D1D0980D2BAD26,EC48AF111BB6CDFA,,,,,,",de="Anleitung: Unbarmherzige Rhenium-Schnürung",en="Recipe: Callous Rhenium Cord",fr="Plan : Corde monstrueuse en rhénium",ru="Выкройка: Грубый рениевый шнур",icon="scroll8b",val=0,q=3,bop=true,Consumable=true,rss="Armorsmith",rsslvl=375},
["A9CADA4E01010101"] = {akey="I09D6A5296DAE3852,2A523E10EEA200A9,,,,,,",de="Anleitung: Hüter-Schulterplatten",en="Recipe: Spaulders of the Keeper",fr="Plan : Spallières du Garde",ru="Чертеж: наплечи хранителя",icon="scroll8b",val=0,q=3,bop=true,Consumable=true,rss="Armorsmith",rsslvl=300},
["9AD3F4930201010101"] = {akey="I227D299A7B5FBD7A,D6347DC4256CED04,,,,,,",de="Anleitung: Transportierbares Geschütz",en="Recipe: Portable Turret",fr="Plan : Tourelle portable",ru="Чертеж: портативная огневая установка",icon="scroll1a",val=0,q=3,bop=true,Consumable=true,rss="Armorsmith",rsslvl=260},
["B2AAD0DD0F01010101"] = {akey="IFBB4153273635524,31D483A5ADDD728A,,,,,,",de="Anleitung: Verstärkter Rhenium-Hüftreif",en="Recipe: Reinforced Rhenium Fauld",fr="Plan : Braconnière renforcée en rhénium",ru="Чертеж: Усиленная рениевая латная юбка",icon="scroll8b",val=0,q=2,bop=true,Consumable=true,rss="Armorsmith",rsslvl=375},
["C5A6FCDA0501010101"] = {akey="I5B5F134519924F30,179EF424D8603987,,,,,,",de="Anleitung: Zinn-Bauchreifen",en="Recipe: Tin Tassets",fr="Plan : Tassettes en fer-blanc",ru="Чертеж: оловянные бедренные щитки",icon="scroll4",val=0,q=1,bop=true,Consumable=true,rss="Armorsmith",rsslvl=1},
["9AEBF5D80101010101"] = {akey="I1B1D759A4F0D1291,4C249EA261858749,,,,,,",de="Anleitung: Dunkelmetall-Bauchreifen",en="Recipe: Darkmetal Tassets",fr="Plan : Tassettes en sombracier",ru="Чертеж: набедренники темного металла",icon="scroll8b",val=0,q=2,bop=true,Consumable=true,rss="Armorsmith",rsslvl=170},
["8C9AA2FC0F01010101"] = {akey="IFF888D0C6F343D45,F26B8AB90ACA728F,,,,,,",de="Anleitung: Verstärktes Chiffoncape",en="Recipe: Reinforced Chiffon Cape",fr="Patron : Cape renforcée en mousseline",ru="Выкройка: Усиленный шифоновый плащ",icon="scroll8b",val=0,q=2,bop=true,accBound=true,Consumable=true,rss="Armorsmith",rsslvl=360,rf="Eternal City Survivors",rfl=4},
["F3B6DA8C0701010101"] = {akey="I71969B7314B2375F,E280A38630E9D1C3,,,,,,",de="Anleitung: Schild der Verdrehten Seelen",en="Recipe: Shield of Twisted Souls",fr="Patron : Bouclier des âmes tourmentées",ru="Чертеж: Щит Искаженных душ",icon="scroll8b",val=0,q=3,bop=true,Consumable=true,rss="Armorsmith",rsslvl=375},
["8FFAB67901010101"] = {akey="I0F2DBD0F5D57F531,F971F2BE34822E12,,,,,,",de="Anleitung: Dunkeleisen-Helm",en="Recipe: Dark Iron Helm",fr="Plan : Casque en fer noir",ru="Чертеж: шлем из черного железа",icon="scroll8b",val=1,q=3,Consumable=true,rss="Armorsmith",rsslvl=300},
["C2D0B3FD0401010101"] = {akey="I4FACE842418A480D,07B8A669E24A3718,,,,,,",de="Anleitung: Kobalt-Bauchreifen",en="Recipe: Cobalt Tassets",fr="Plan : Tassettes en cobalt",ru="Чертеж: кобальтовые набедренные щитки",icon="scroll8b",val=0,q=1,bop=true,Consumable=true,rss="Armorsmith",rsslvl=150},
["DCA4EDEC0F01010101"] = {akey="IFD9B525C45D781D8,2061FC5ADCA8A9F4,,,,,,",de="Anleitung: Unbarmherzige Gantimit-Haube",en="Recipe: Callous Gantimite Coif",fr="Patron : Coiffe monstrueuse en gantimite",ru="Чертеж: Грубый гантимитовый койф",icon="scroll8b",val=1,q=2,Consumable=true,rss="Armorsmith",rsslvl=310},
["D6D4D49C0201010101"] = {akey="I23952A56502A7C08,304D48B60D4BBA7A,,,,,,",de="Anleitung: Kobalt-Schaller",en="Recipe: Cobalt Sallet",fr="Plan : Heaume en cobalt",ru="Чертеж: кобальтовый салад",icon="scroll8b",val=0,q=1,bop=true,Consumable=true,rss="Armorsmith",rsslvl=170},
["9E9AADEE0F01010101"] = {akey="IFDCB4D1E5E294295,4CCF8A73A9868AEB,,,,,,",de="Anleitung: Tuthony-Schulterplatten",en="Recipe: Karthite Spaulders",fr="Plan : Spallières en tuthonie",ru="Чертеж: Картитовые наплечи",icon="scroll8b",val=0,q=1,bop=true,Consumable=true,rss="Armorsmith",rsslvl=340},
["BCF3C8E20F01010101"] = {akey="IFC5239BC5DFCB12E,0B3284C0898C6712,,,,,,",de="Anleitung: Große Verstärkung der Wildheit",en="Recipe: Greater Savage Augment",fr="Recette : Augmentation de sauvagerie supérieure",ru="Чертеж: Крепкое усиление дикости",icon="scroll8b",val=0,q=3,bop=true,Consumable=true,rss="Armorsmith",rsslvl=300},
["99A1C70601010101"] = {akey="I00D1D09971224A2C,F06A1931BF3EF74E,,,,,,",de="Anleitung: Verstärkte Rhenium-Schnürung",en="Recipe: Reinforced Rhenium Cord",fr="Patron : Corde renforcée en rhénium",ru="Чертеж: Усиленный рениевый пояс",icon="scroll8b",val=1,q=3,Consumable=true,rss="Armorsmith",rsslvl=375},
["AACADA4E01010101"] = {akey="I09D6A52A53D33366,C461DBFFFD6AC8CA,,,,,,",de="Anleitung: Blutgeschmiedeter Kürass",en="Recipe: Blood-Forged Cuirass",fr="Plan : Cuirasse forgée dans le sang",ru="Чертеж: кровавая кираса",icon="scroll8b",val=0,q=3,bop=true,Consumable=true,rss="Armorsmith",rsslvl=300},
["9BD3F4930201010101"] = {akey="I227D299B289C3124,D46B4BECF6F158D1,,,,,,",de="Anleitung: Außerweltliche Panzerung",en="Recipe: Otherworldly Plating",fr="Plan : Blindage surnaturel",ru="Чертеж: неземная обшивка",icon="scroll1a",val=0,q=3,bop=true,Consumable=true,rss="Armorsmith",rsslvl=210},
["86F2A3860601010101"] = {akey="I60C8F9064053FCC3,53D9092B2078CB5E,,,,,,",de="Anleitung: Chromit-Hüftreif",en="Recipe: Chromite Fauld",fr="Plan : Braconnière en chromite",ru="Чертеж: хромитовая латная юбка",icon="scroll1a",val=0,q=1,bop=true,Consumable=true,rss="Armorsmith",rsslvl=120},
["E1C2FACB0601010101"] = {akey="I697EA16110E32826,0FB655D4EA36B2E1,,,,,,",de="Anleitung: Großhelm der Erhabenheit",en="Recipe: Greathelm of Grandeur",fr="Plan : Heaume de grandeur",ru="Чертеж: большой шлем величия",icon="scroll2a",val=0,q=3,bop=true,Consumable=true,rss="Armorsmith",rsslvl=300},
["B3AAD0DD0F01010101"] = {akey="IFBB415331C121753,3B0704245F4688D5,,,,,,",de="Anleitung: Verstärkter Rhenium-Faustschild",en="Recipe: Reinforced Rhenium Buckler",fr="Patron : Rondache renforcée en rhénium",ru="Чертеж: Усиленный рениевый кулачный щит",icon="scroll8b",val=0,q=2,bop=true,accBound=true,Consumable=true,rss="Armorsmith",rsslvl=375,rf="The Qaijiri",rfl=4},
["8E87DBF40501010101"] = {akey="I5E96C38E4919CAD2,3A4FC4875F8C0B0C,,,,,,",de="Anleitung: Eisen-Hüftreif",en="Recipe: Iron Fauld",fr="Plan : Braconnière en fer",ru="Чертеж: железный набрюшник",icon="scroll1a",val=0,q=1,bop=true,Consumable=true,rss="Armorsmith",rsslvl=80},
["B3BD90AD0701010101"] = {akey="I75A41EB34ABEA374,F31A47B072ED0E19,,,,,,",de="Anleitung: Fährtenleser-Panzerschuhe",en="Recipe: Tracker's Sabatons",fr="Plan : Solerets de pisteur",ru="Чертеж: сабатоны следопыта",icon="scroll1",val=0,q=2,bop=true,accBound=true,Consumable=true,rss="Armorsmith",rsslvl=140,rf="Iron Claw Trappers",rfl=1},
["AE9AE39A0301010101"] = {akey="I3358CD2E27EF065F,176F8AFEFCD01FBD,,,,,,",de="Anleitung: Gehärtete Orichalcum-Panzerhandschuhe",en="Recipe: Tempered Orichalcum Gauntlets",fr="Patron : Gantelets en orichalque durci",ru="Чертеж: закаленные орихалковые рукавицы",icon="scroll1",val=0,q=2,bop=true,accBound=true,Consumable=true,rss="Armorsmith",rsslvl=300,rf="Kelari Expedition",rfl=3},
["9BEBF5D80101010101"] = {akey="I1B1D759B01F9D728,3F696EA1A7AE8217,,,,,,",de="Anleitung: Dunkelmetall-Stoßkragen",en="Recipe: Darkmetal Pauldrons",fr="Plan : Espauliers en sombracier",ru="Чертеж: наплечники темного металла",icon="scroll8b",val=0,q=2,bop=true,Consumable=true,rss="Armorsmith",rsslvl=180},
["8D9AA2FC0F01010101"] = {akey="IFF888D0D689558C6,0D3DB864F01AEA97,,,,,,",de="Anleitung: Gehärtetes Lanzancape",en="Recipe: Hardened Lanzan Cape",fr="Patron : Cape endurcie en lanzane",ru="Выкройка: Крепкий ланзановый плащ",icon="scroll8b",val=1,q=2,Consumable=true,rss="Armorsmith",rsslvl=320},
["F4B6DA8C0701010101"] = {akey="I71969B747E859E90,11542118EBBD7A05,,,,,,",de="Anleitung: Boshafte Wiederauferstehung",en="Recipe: Spiteful Resurgence",fr="Patron : Reprise malveillante",ru="Рецепт: Злобное возрождение",icon="scroll8b",val=0,q=3,bop=true,Consumable=true,rss="Armorsmith",rsslvl=375},
["90FAB67901010101"] = {akey="I0F2DBD1045965F39,53884F0F144C7B39,,,,,,",de="Anleitung: Unerbittlicher Stahlhelm",en="Recipe: Implacable Steel Helm",fr="Plan : Casque en acier implacable",ru="Чертеж: заклятый стальной шлем",icon="scroll8b",val=1,q=3,Consumable=true,rss="Armorsmith",rsslvl=300},
["C3D0B3FD0401010101"] = {akey="I4FACE8433AC461CE,BD3DD58998789E57,,,,,,",de="Anleitung: Titan-Bauchreifen",en="Recipe: Titanium Tassets",fr="Plan : Tassettes en titane",ru="Чертеж: титановые набедренные щитки",icon="scroll8b",val=0,q=1,bop=true,Consumable=true,rss="Armorsmith",rsslvl=190},
["DDA4EDEC0F01010101"] = {akey="IFD9B525D09196C22,F030B2AF1111EBDA,,,,,,",de="Anleitung: Gehärteter Gantimit-Brustpanzer",en="Recipe: Hardened Gantimite Breastplate",fr="Plan : Plastron en gantimite endurci",ru="Чертеж: Крепкий гантимитовый нагрудник",icon="scroll8b",val=0,q=2,bop=true,Consumable=true,rss="Armorsmith",rsslvl=330},
["9F9AADEE0F01010101"] = {akey="IFDCB4D1F763A94F5,78C7232653A15C79,,,,,,",de="Anleitung: Tuthony-Panzerschuhe",en="Recipe: Karthite Sabatons",fr="Plan : Solerets en tuthonie",ru="Чертеж: Картитовые сабатоны",icon="scroll8b",val=0,q=1,bop=true,Consumable=true,rss="Armorsmith",rsslvl=350},
["BDF3C8E20F01010101"] = {akey="IFC5239BD6B7571C4,0050AB6B19B1F702,,,,,,",de="Anleitung: Empyreum-Verstärkung der Wildheit",en="Recipe: Empyrean Savage Augment",fr="Recette : Augmentation de sauvagerie empyréenne",ru="Рецепт: Дикое эмпирейское усиление",icon="scroll8b",val=0,q=2,bop=true,Consumable=true,rss="Armorsmith",rsslvl=340},
["F6E6E6F40101010101"] = {akey="I1E99B376231D7167,14D034265B4A41CE,,,,,,",de="Anleitung: Stahl-Faustschild",en="Recipe: Steel Buckler",fr="Plan : Rondache en acier",ru="Чертеж: стальной кулачный щит",icon="scroll1",val=0,q=2,bop=true,accBound=true,Consumable=true,rss="Armorsmith",rsslvl=80,rf="Gloamwood Waykeepers",rfl=2},
["9AA1C70601010101"] = {akey="I00D1D09A386FB3BC,F99C99B0F0A80D98,,,,,,",de="Anleitung: Unerschütterlicher Trotz",en="Recipe: Unshakable Defiance",fr="Plan : Défi inébranlable",ru="Рецепт: Неколебимая решимость",icon="scroll8b",val=0,q=3,bop=true,Consumable=true,rss="Armorsmith",rsslvl=375},
["ABCADA4E01010101"] = {akey="I09D6A52B61D87AED,DF3409AA62BBC421,,,,,,",de="Anleitung: Blutgeschmiedeter Stoßkragen",en="Recipe: Blood-Forged Pauldrons",fr="Plan : Espauliers forgées dans le sang",ru="Чертеж: кровавые наплечи",icon="scroll8b",val=0,q=3,bop=true,Consumable=true,rss="Armorsmith",rsslvl=300},
["D99086DE0101010101"] = {akey="I1BC188594086A029,2E68589E8BAAA0FD,,,,,,",de="Anleitung: Rotnarben-Stiefel",en="Recipe: Red Scar Boots",fr="Plan : Bottes de Rouge-balafre",ru="Чертеж: сапоги Красного Шрама",icon="scroll1",val=0,q=2,bop=true,accBound=true,Consumable=true,rss="Armorsmith",rsslvl=120,rf="Red Scar Trackers",rfl=1},
["9382A93B01010101"] = {akey="I076A41134F4AE288,CCE744D8DF5A502A,,,,,,",de="Anleitung: Kobalt-Hüftreif",en="Recipe: Cobalt Fauld",fr="Plan : Braconnière en cobalt",ru="Чертеж: кобальтовый набрюшник",icon="scroll8b",val=0,q=1,bop=true,Consumable=true,rss="Armorsmith",rsslvl=150},
["B4AAD0DD0F01010101"] = {akey="IFBB4153470C04CDB,CD095B3A6AA34FFE,,,,,,",de="Anleitung: Grausamer Rhenium-Helm",en="Recipe: Vicious Rhenium Helmet",fr="Plan : Casque vicieux en rhénium",ru="Чертеж: Рениевый шлем злобы",icon="scroll8b",val=0,q=2,bop=true,Consumable=true,rss="Armorsmith",rsslvl=370},
["AFA6F58C0201010101"] = {akey="I219D532F14548C6C,BC5BD9CC3F1B7412,,,,,,",de="Anleitung: Steinschmetter-Zauberschild",en="Recipe: Stoneshatter Spellshield",fr="Plan : Bouclier ensorcelé brise-pierre",ru="Чертеж: камнеломный магический щит",icon="scroll1",val=0,q=2,bop=true,accBound=true,Consumable=true,rss="Armorsmith",rsslvl=90,rf="Granite Falls",rfl=2},
["9CEBF5D80101010101"] = {akey="I1B1D759C0528C85A,516BC5B6B30B4940,,,,,,",de="Anleitung: Dunkelmetall-Helm",en="Recipe: Darkmetal Helmet",fr="Plan : Casque en sombracier",ru="Чертеж: шлем темного металла",icon="scroll8b",val=0,q=2,bop=true,Consumable=true,rss="Armorsmith",rsslvl=225},
["8E9AA2FC0F01010101"] = {akey="IFF888D0E32E32574,1F400F79FB77B1C0,,,,,,",de="Anleitung: Verstärktes Lanzancape",en="Recipe: Reinforced Lanzan Cape",fr="Patron : Cape renforcée en lanzane",ru="Выкройка: Усиленный ланзановый плащ",icon="scroll8b",val=1,q=2,Consumable=true,rss="Armorsmith",rsslvl=320},
["F882ECFE0201010101"] = {akey="I2FDB01787BFC6E06,FF341CB4398CD92E,,,,,,",de="Anleitung: Eisen-Schaller",en="Recipe: Iron Sallet",fr="Plan : Heaume en fer",ru="Чертеж: железный салад",icon="scroll1a",val=0,q=1,bop=true,Consumable=true,rss="Armorsmith",rsslvl=100},
["F0D1F3A80201010101"] = {akey="I251CE8F07E1EBA3E,40B2F3D1123513F2,,,,,,",de="Anleitung: Beständigkeit",en="Recipe: Persistence",fr="Plan : Persistance",ru="Рецепт: упорство",icon="scroll8b",val=0,q=3,bop=true,Consumable=true,rss="Armorsmith",rsslvl=300},
["91FAB67901010101"] = {akey="I0F2DBD1112F66A49,235788B248B6406D,,,,,,",de="Anleitung: Unerbittliche Stahl-Beinschienen",en="Recipe: Implacable Steel Greaves",fr="Plan : Grèves en acier implacable",ru="Чертеж: заклятые стальные поножи",icon="scroll8b",val=1,q=3,Consumable=true,rss="Armorsmith",rsslvl=300},
["E3A9B3BF0701010101"] = {akey="I77ECD4E30AB986CF,08DCA772B02F1579,,,,,,",de="Anleitung: Chromit-Schaller",en="Recipe: Chromite Sallet",fr="Plan : Heaume en chromite",ru="Чертеж: хромитовый салад",icon="scroll8b",val=0,q=1,bop=true,Consumable=true,rss="Armorsmith",rsslvl=140},
["C4D0B3FD0401010101"] = {akey="I4FACE844470A0D9D,C0F9C7F4BC2D04A9,,,,,,",de="Anleitung: Carmintium-Bauchreifen",en="Recipe: Carmintium Tassets",fr="Plan : Tassettes en carmintium",ru="Чертеж: карминтиевые набедренные щитки",icon="scroll9a",val=0,q=1,bop=true,Consumable=true,rss="Armorsmith",rsslvl=230},
["A09AADEE0F01010101"] = {akey="IFDCB4D2063429B7E,4FD87C8DC6A978FC,,,,,,",de="Anleitung: Tuthony-Stiefel",en="Recipe: Karthite Boots",fr="Plan : Bottes en tuthonie",ru="Чертеж: Картитовые сапоги",icon="scroll8b",val=0,q=1,bop=true,Consumable=true,rss="Armorsmith",rsslvl=350},
["C8A0ADDB0201010101"] = {akey="I2B6B5048554EF9C5,ECC268E2CFC1019C,,,,,,",de="Anleitung: Titan-Schaller",en="Recipe: Titanium Sallet",fr="Plan : Heaume en titane",ru="Чертеж: титановый салад",icon="scroll9a",val=0,q=1,bop=true,Consumable=true,rss="Armorsmith",rsslvl=210},
["BEF3C8E20F01010101"] = {akey="IFC5239BE00242418,2C48C76CC3CCC890,,,,,,",de="Anleitung: Stellare Verstärkung der Wildheit",en="Recipe: Stellar Savage Augment",fr="Recette : Augmentation de sauvagerie stellaire",ru="Рецепт: Звездная сила и критический удар ближнего боя",icon="scroll8b",val=0,q=3,bop=true,Consumable=true,rss="Armorsmith",rsslvl=375},
["E8F6D9FE0601010101"] = {akey="I6FD67B68755BB3BB,CAD83FBC7173623E,,,,,,",de="Anleitung: Baustein: Steinplanke",en="Recipe: Building Block: Stone Plank",fr="Patron : Bloc de construction : plaque de pierre",ru="Чертеж: Стройматериал: Каменная планка",icon="scroll4c",val=0,bop=true,Consumable=true,rss="Armorsmith",rsslvl=60},
["ACCADA4E01010101"] = {akey="I09D6A52C12C30B6F,CF89678F4C6B0ECA,,,,,,",de="Anleitung: Kürass des Getreuen",en="Recipe: Cuirass of the Stalwart",fr="Plan : Cuirasse du Fidèle",ru="Чертеж: кираса стойкости",icon="scroll8b",val=0,q=3,bop=true,Consumable=true,rss="Armorsmith",rsslvl=300},
["9DD3F4930201010101"] = {akey="I227D299D527BA4A0,FB5E6594EA2390A9,,,,,,",de="Anleitung: Außerweltliche Ausdauer",en="Recipe: Otherworldly Endurance",fr="Recette : Endurance surnaturelle",ru="Чертеж: неземная выносливость",icon="scroll1a",val=0,q=3,bop=true,Consumable=true,rss="Armorsmith",rsslvl=210},
["B5AAD0DD0F01010101"] = {akey="IFBB4153529EA8380,086230750539D0CB,,,,,,",de="Anleitung: Grausamer Rhenium-Schenkelschutz",en="Recipe: Vicious Rhenium Cuisses",fr="Patron : Cuissards vicieux en rhénium",ru="Чертеж: Рениевые щитки злобы",icon="scroll8b",val=0,q=2,bop=true,accBound=true,Consumable=true,rss="Armorsmith",rsslvl=375,rf="Eternal City Survivors",rfl=4},
["92F288D50201010101"] = {akey="I2AA2391244C39BFA,15CA5DFAC0636A84,,,,,,",de="Anleitung: Carmintium-Hüftreif",en="Recipe: Carmintium Fauld",fr="Plan : Braconnière en carmintium",ru="Чертеж: карминтиевая кольчужная юбка",icon="scroll9a",val=0,q=1,bop=true,Consumable=true,rss="Armorsmith",rsslvl=240},
["BB80FBD00F01010101"] = {akey="IFA1EC03B068EC5F5,37B07597549F290C,,,,,,",de="Anleitung: Größere Verstärkung der Unerschütterlichkeit",en="Recipe: Major Stalwart Augment",fr="Recette : Augmentation de loyauté majeure",ru="Чертеж: Большое усиление стойкости",icon="scroll8b",val=0,q=2,bop=true,Consumable=true,rss="Armorsmith",rsslvl=300},
["9DEBF5D80101010101"] = {akey="I1B1D759D777CEC6D,0B444B5FC4FAB8A1,,,,,,",de="Anleitung: Dunkelmetall-Stiefel",en="Recipe: Darkmetal Boots",fr="Plan : Bottes en sombracier",ru="Чертеж: сапоги темного металла",icon="scroll8b",val=0,q=2,bop=true,Consumable=true,rss="Armorsmith",rsslvl=225},
["8F9AA2FC0F01010101"] = {akey="IFF888D0F1B70EC60,D1C90E1F3C1A81AD,,,,,,",de="Anleitung: Gehärtete Tuthony-Aigis",en="Recipe: Hardened Karthite Aegis",fr="Plan : Égide endurcie en tuthonie",ru="Чертеж: Крепкий картитовый щит",icon="scroll8b",val=1,q=2,Consumable=true,rss="Armorsmith",rsslvl=350},
["DBEF90EE0F01010101"] = {akey="IFDC437DB25165FDB,F7BB4274EB5B8F87,,,,,,",de="Anleitung: Größere Verstärkung der Brutalität",en="Recipe: Major Brutal Augment",fr="Recette : Augmentation de brutalité majeure",ru="Чертеж: Большое усиление брутальности",icon="scroll8b",val=0,q=2,bop=true,Consumable=true,rss="Armorsmith",rsslvl=300},
["E7EFFAC70501010101"] = {akey="I58FEB7E71E161109,56DDECD68CE3C3AB,,,,,,",de="Anleitung: Verkohlte Plattenstiefel",en="Recipe: Charred Plate Boots",fr="Plan : Bottes de plates calcinées",ru="Чертеж: опаленные латные сапоги",icon="scroll8b",val=0,q=3,bop=true,Consumable=true,rss="Armorsmith",rsslvl=300},
["92FAB67901010101"] = {akey="I0F2DBD123810C0BC,3559DFC7D4130797,,,,,,",de="Anleitung: Hochglanz-Stahlhelm",en="Recipe: Glossy Steel Helm",fr="Plan : Casque en acier luisant",ru="Чертеж: блестящий стальной шлем",icon="scroll8b",val=1,q=3,Consumable=true,rss="Armorsmith",rsslvl=300},
["959AADEE0F01010101"] = {akey="IFDCB4D156A7B2ACB,2AB9F767C343072B,,,,,,",de="Anleitung: Gantimit-Panzerhandschuhe",en="Recipe: Gantimite Gauntlets",fr="Plan : Gantelets en gantimite",ru="Чертеж: Гантимитовые перчатки",icon="scroll8b",val=0,q=1,bop=true,Consumable=true,rss="Armorsmith",rsslvl=290},
["DFA4EDEC0F01010101"] = {akey="IFD9B525F31F63C94,25053C9A6C1944D5,,,,,,",de="Anleitung: Gehärtetes Gantimit-Wappen",en="Recipe: Hardened Gantimite Crest",fr="Plan : Blason en gantimite endurci",ru="Эскиз: Крепкий гантимитовый герб",icon="scroll8b",val=10000,q=2,bop=true,Consumable=true,rss="Armorsmith",rsslvl=330},
["B8ABCDF10201010101"] = {akey="I2E3355B84CD3D1FF,263CD72AA1412F80,,,,,,",de="Anleitung: Glaubensgeschmie-deter Helm",en="Recipe: Faith-Forged Helm",fr="Plan : Casque de Forgefoy",ru="Чертеж: кованный верой шлем",icon="scroll2a",val=0,q=3,bop=true,Consumable=true,rss="Armorsmith",rsslvl=300},
}

nkItemBase.db.recipe.artificer={
["9686F4E00F01010101"] = {akey="IFC1D0316670D4F1A,BB0B755EE2A7ABFF,,,,,,",de="Anleitung: Erkenntnis",en="Recipe: Cognition",fr="Plan : Connaissance",ru="Рецепт: Познание",icon="scroll8b",val=0,q=2,bop=true,Consumable=true,rss="Artificer",rsslvl=375},
["B895C0E30301010101"] = {akey="I3C700AB871812942,F165B54A353B98F0,,,,,,",de="Anleitung: Zorniges Turmalin-Siegel",en="Recipe: Furious Tourmaline Sigil",fr="Plan : Sceau furieux en tourmaline",ru="Эскиз: Яростная турмалиновая печатка",icon="scroll8b",val=0,q=2,bop=true,Consumable=true,rss="Artificer",rsslvl=320},
["87D4A7C30101010101"] = {akey="I1869EA077B99EB31,FFC7F7BAC5868B50,,,,,,",de="Anleitung: Fest gebundener Foliant",en="Recipe: Well-Bound Tome",fr="Patron : Casque en peau de Scarn",ru="Инструкция: качественно переплетенный фолиант",icon="scroll1a",val=0,q=1,bop=true,Consumable=true,rss="Artificer",rsslvl=110},
["9ED3F4930201010101"] = {akey="I227D299E2D550757,E29B9F4A927482C5,,,,,,",de="Anleitung: Stein der Schnelligkeit",en="Recipe: Stone of Quickness",fr="Recette : Pierre de vivacité",ru="Эскиз: камень проворства",icon="scroll1a",val=0,q=3,bop=true,Consumable=true,rss="Artificer",rsslvl=210},
["DFE7E9800601010101"] = {akey="I601A73DF4FDBAAAA,2DE14E0E53F025E0,,,,,,",de="Anleitung: Talglasband",en="Recipe: Valeglass Band",fr="Plan : Anneau en verre-val",ru="Чертеж: стеклянное кольцо",icon="scroll8b",val=0,q=1,bop=true,Consumable=true,rss="Artificer",rsslvl=180},
["C495C0E30301010101"] = {akey="I3C700AC447C11518,FB365D0CEEDF082F,,,,,,",de="Anleitung: Grausame Sphalerit-Kette",en="Recipe: Vicious Sphalerite Chain",fr="Plan : Chaîne vicieuse en sphalérite",ru="Чертеж: Сфалеритовая цепь злобы",icon="scroll8b",val=1,q=2,Consumable=true,rss="Artificer",rsslvl=360},
["F0F0A5BD0401010101"] = {akey="I47A97870007EB8DB,D93AA220E9EB1C99,,,,,,",de="Anleitung: Abgenutztes Lexikon",en="Recipe: Worn Lexicon",fr="Plan : Vieux lexique",ru="Чертеж: потрепанный словарь",icon="scroll8b",val=0,q=2,bop=true,Consumable=true,rss="Artificer",rsslvl=170},
["E3A8B7E80F01010101"] = {akey="IFD0DD46317C55931,41AC6DABD6100642,,,,,,",de="Anleitung: Profaner Foliant",en="Recipe: Profane Tome",fr="Plan : Grimoire profane",ru="Эскиз: Богохульный фолиант",icon="scroll8b",val=0,q=1,bop=true,Consumable=true,rss="Artificer",rsslvl=310},
["AFA7A50B01010101"] = {akey="I016953AF7A1A46E6,64153605C67AC41F,,,,,,",de="Anleitung: Glänzender Saphirring",en="Recipe: Shining Sapphire Ring",fr="Plan : Anneau scintillant serti de saphirs",ru="Чертеж: блестящее сапфировое кольцо",icon="scroll8b",val=1,q=2,Consumable=true,rss="Artificer",rsslvl=300},
["90E7B7D20F01010101"] = {akey="IFA4DF3900D2E8C73,485F2BD5485321C9,,,,,,",de="Anleitung: Große Verstärkung des Eiferers",en="Recipe: Greater Zealous Augment",fr="Recette : Augmentation de zèle supérieure",ru="Чертеж: Крепкое усиление фанатизма",icon="scroll8b",val=0,q=3,bop=true,Consumable=true,rss="Artificer",rsslvl=300},
["D59FA9F30501010101"] = {akey="I5E6A4FD54745E1B9,4ABB48DE88B20994,,,,,,",de="Anleitung: Wertvoller Foliant",en="Recipe: Valuable Tome",fr="Plan : Grimoire précieux",ru="Инструкция: ценный фолиант",icon="scroll8b",val=0,q=1,bop=true,Consumable=true,rss="Artificer",rsslvl=180},
["E286E4AC0201010101"] = {akey="I2599036274A1A4B3,BEB4401EED7B0CF2,,,,,,",de="Anleitung: Celestitsiegel",en="Recipe: Celestite Signet",fr="Plan : Chevalière en celestite",ru="Чертеж: селеститовая печатка",icon="scroll1a",val=0,q=1,bop=true,Consumable=true,rss="Artificer",rsslvl=110},
["C990C9E80101010101"] = {akey="I1D12484939066BF8,0B9B3CA5E0321198,,,,,,",de="Anleitung: Verwitterter Foliant",en="Recipe: Weathered Tome",fr="Plan : Grimoire patiné",ru="Инструкция: потрепанный фолиант",icon="scroll4",val=0,q=1,bop=true,Consumable=true,rss="Artificer",rsslvl=30},
["8B86F4E00F01010101"] = {akey="IFC1D030B2F85E783,19E2AB6AE44DD21D,,,,,,",de="Anleitung: Leuchtender Madrosa-Zauberstab",en="Recipe: Luminous Madrosa Wand",fr="Plan : Baguette lumineuse en madrosa",ru="Чертеж: Искристый жезл Мадрозы",icon="scroll8b",val=1,q=2,Consumable=true,rss="Artificer",rsslvl=375},
["ACA389F70F01010101"] = {akey="IFEE251AC7C386D67,5A3FF4ED3D1538A6,,,,,,",de="Anleitung: Große Verstärkung der Flüchtigkeit",en="Recipe: Greater Elusive Augment",fr="Recette : Augmentation insaisissable supérieure",ru="Чертеж: Крепкое усиление неуловимости",icon="scroll8b",val=0,q=3,bop=true,Consumable=true,rss="Artificer",rsslvl=300},
["FCF68D800601010101"] = {akey="I60037B7C17CF18B5,079BE957B4E529AF,,,,,,",de="Anleitung: Siegel des Getreuen",en="Recipe: Signet of the Stalwart",fr="Plan : Chevalière du Fidèle",ru="Чертеж: печатка стойкости",icon="scroll8b",val=0,q=3,bop=true,Consumable=true,rss="Artificer",rsslvl=300},
["CF89FACB0401010101"] = {akey="I497E84CF6A4C7D06,F06E1AB9DD96D9BC,,,,,,",de="Anleitung: Rubinsiegel",en="Recipe: Ruby Signet",fr="Plan : Chevalière sertie de rubis",ru="Чертеж: рубиновая печатка",icon="scroll8b",val=0,q=1,bop=true,Consumable=true,rss="Artificer",rsslvl=220},
["93D3F4930201010101"] = {akey="I227D2993291F34C6,AA6351A5FD4D1524,,,,,,",de="Anleitung: Stein der Wut",en="Recipe: Stone of Rage",fr="Recette : Pierre de rage",ru="Эскиз: камень ярости",icon="scroll1a",val=0,q=3,bop=true,Consumable=true,rss="Artificer",rsslvl=210},
["9591D0880401010101"] = {akey="I41140895910CD085,0FB8001082353BF8,,,,,,",de="Anleitung: Einblick",en="Recipe: Insight",fr="Plan : Perspicacité",ru="Рецепт: прозрение",icon="scroll8",val=0,q=2,bop=true,Consumable=true,rss="Artificer",rsslvl=280},
["B995C0E30301010101"] = {akey="I3C700AB946084C66,FE9F43999A229E22,,,,,,",de="Anleitung: Unbarmherziger Turmalin-Anhänger",en="Recipe: Callous Tourmaline Pendant",fr="Plan : Pendentif monstrueux en tourmaline",ru="Эскиз: Грубый турмалиновый кулон",icon="scroll8b",val=0,q=2,bop=true,Consumable=true,rss="Artificer",rsslvl=320},
["AECADA4E01010101"] = {akey="I09D6A52E7EFA0DD3,27E0C9845243848D,,,,,,",de="Anleitung: Eidbruch-Siegel",en="Recipe: Signet of the Broken Oath",fr="Plan : Chevalière du Serment brisé",ru="Чертеж: печатка нарушенного обета",icon="scroll8b",val=0,q=3,bop=true,Consumable=true,rss="Artificer",rsslvl=300},
["E0E7E9800601010101"] = {akey="I601A73E05218B1A9,C094E24407644C95,,,,,,",de="Anleitung: Himmelssteinband",en="Recipe: Skystone Band",fr="Plan : Anneau en pierre-ciel",ru="Чертеж: кольцо с небесным камнем",icon="scroll8b",val=0,q=1,bop=true,Consumable=true,rss="Artificer",rsslvl=180},
["C595C0E30301010101"] = {akey="I3C700AC552028438,2BF63B373F701F02,,,,,,",de="Anleitung: Bewehrtes Sphalerit-Siegel",en="Recipe: Fortified Sphalerite Sigil",fr="Plan : Sceau fortifié en sphalérite",ru="Эскиз: Усиленная сфалеритовая печатка",icon="scroll8b",val=0,q=2,bop=true,accBound=true,Consumable=true,rss="Artificer",rsslvl=360,rf="Eternal City Survivors",rfl=4},
["9EE7A9FC0401010101"] = {akey="I4F8A739E925DEAC5,4D24A42B58D9B67A,,,,,,",de="Anleitung: Ewiger Weiser",en="Recipe: Eternal Sage",fr="Plan : Sagesse éternelle",ru="Рецепт: вечный мудрец",icon="scroll8",val=0,q=3,bop=true,Consumable=true,rss="Artificer",rsslvl=300},
["F1F0A5BD0401010101"] = {akey="I47A978716228DFDA,10DDF6487EB1F26A,,,,,,",de="Anleitung: Polierter Runenbirken-Zeremonienstab",en="Recipe: Polished Runebirch Virge",fr="Plan : Baguette en rune-bouleau poli",ru="Чертеж: полированный жезл из рунной березы",icon="scroll8b",val=0,q=2,bop=true,Consumable=true,rss="Artificer",rsslvl=180},
["86E2ECD70301010101"] = {akey="I3AFB31061E425CD1,5634A7AC6DF6B638,,,,,,",de="Anleitung: Einfacher Foliant",en="Recipe: Plain Tome",fr="Plan : Grimoire ordinaire",ru="Инструкция: простой фолиант",icon="scroll4",val=0,q=1,bop=true,Consumable=true,rss="Artificer",rsslvl=70},
["E4A8B7E80F01010101"] = {akey="IFD0DD46422F10EC2,50C0594204F3A097,,,,,,",de="Anleitung: Gantimit-Totem",en="Recipe: Gantimite Totem",fr="Plan : Totem en gantimite",ru="Эскиз: Гантимитовый тотем",icon="scroll8b",val=0,q=1,bop=true,Consumable=true,rss="Artificer",rsslvl=310},
["829CFBC90501010101"] = {akey="I593ECE0221D5C625,3AAA33CD2985BD4F,,,,,,",de="Anleitung: Smaragdsiegel",en="Recipe: Emerald Signet",fr="Plan : Chevalière en émeraude",ru="Чертеж: изумрудная печатка",icon="scroll1a",val=0,q=1,bop=true,Consumable=true,rss="Artificer",rsslvl=150},
["B0A7A50B01010101"] = {akey="I016953B0318935DD,389D3DE656795478,,,,,,",de="Anleitung: Geflochtener Cinerium-Ring",en="Recipe: Plaited Cinerium Ring",fr="Plan : Anneau en cinerium tressé",ru="Чертеж: плетеное серебряное кольцо",icon="scroll8b",val=1,q=2,Consumable=true,rss="Artificer",rsslvl=300},
["91E7B7D20F01010101"] = {akey="IFA4DF39177F12931,0BC547EA6655A38D,,,,,,",de="Anleitung: Empyreum-Verstärkung des Eiferers",en="Recipe: Empyrean Zealous Augment",fr="Recette : Augmentation de zèle empyréenne",ru="Рецепт: Фанатичное эмпирейское усиление",icon="scroll8b",val=0,q=2,bop=true,Consumable=true,rss="Artificer",rsslvl=340},
["E6D7A6DE0201010101"] = {akey="I2BC9ABE63F25C3C7,D6AEB7163A849635,,,,,,",de="Anleitung: Blutberylitband",en="Recipe: Blood Berylite Band",fr="Plan : Anneau en bérylite de sang",ru="Чертеж: кольцо из кровавого бериллита",icon="scroll1a",val=0,q=1,bop=true,Consumable=true,rss="Artificer",rsslvl=150},
["8C86F4E00F01010101"] = {akey="IFC1D030C7AE912E2,23D7BBA66C3F1B9D,,,,,,",de="Anleitung: Grausames Chrysopras-Siegel",en="Recipe: Vicious Chrysoprase Signet",fr="Plan : Chevalière vicieuse en chrysoprase",ru="Эскиз: Хрисопразовая печатка злобы",icon="scroll8b",val=1,q=2,Consumable=true,rss="Artificer",rsslvl=370},
["E5B5D7F00401010101"] = {akey="I4E15DAE5019DEC41,FCB34797468557D8,,,,,,",de="Anleitung: Grausamer Chrysopras-Schlagring",en="Recipe: Vicious Chrysoprase Knuckle",fr="Plan : Coup-de-poing vicieux en chrysoprase",ru="Чертеж: Хрисопразовый кастет злобы",icon="scroll8b",val=1,q=3,Consumable=true,rss="Artificer",rsslvl=375},
["FEE3C1E90301010101"] = {akey="I3D3071FE67A37CB6,3193C4AD50FE8FBC,,,,,,",de="Anleitung: Herzsteinband",en="Recipe: Heartstone Band",fr="Plan : Anneau de pierre-de-cœur",ru="Чертеж: полоска камнесердца",icon="scroll1a",val=0,q=1,bop=true,Consumable=true,rss="Artificer",rsslvl=110},
["BA95C0E30301010101"] = {akey="I3C700ABA1EAE04EE,F3BD6A44AA47AAC3,,,,,,",de="Anleitung: Unbarmherzige profane Abhandlung",en="Recipe: Callous Profane Treatise",fr="Compendium : Traité monstrueux profane",ru="Эскиз: Грубый богохульный трактат",icon="scroll8b",val=10000,q=2,bop=true,Consumable=true,rss="Artificer",rsslvl=320},
["AFCADA4E01010101"] = {akey="I09D6A52F24240455,C7C40D8FC574663B,,,,,,",de="Anleitung: Geistgehärtetes Siegel",en="Recipe: Spirit-Tempered Signet",fr="Plan : Chevalière lunatique",ru="Чертеж: закаленная духами печатка",icon="scroll8b",val=0,q=3,bop=true,Consumable=true,rss="Artificer",rsslvl=300},
["E1E7E9800601010101"] = {akey="I601A73E17271FD53,E2B5D7FAAEF77EDB,,,,,,",de="Anleitung: Talglassiegel",en="Recipe: Valeglass Signet",fr="Plan : Chevalière en verre-val",ru="Чертеж: печатка валегласса",icon="scroll8b",val=0,q=1,bop=true,Consumable=true,rss="Artificer",rsslvl=180},
["C695C0E30301010101"] = {akey="I3C700AC64D7E447D,D6D5B4E712862E7D,,,,,,",de="Anleitung: Verstärkter Sphalerit-Anhänger",en="Recipe: Reinforced Sphalerite Pendant",fr="Plan : Pendentif renforcé en sphalérite",ru="Эскиз: Усиленная сфалеритовая подвеска",icon="scroll8b",val=0,q=2,bop=true,accBound=true,Consumable=true,rss="Artificer",rsslvl=360,rf="Necropolis Caretakers",rfl=4},
["F2F0A5BD0401010101"] = {akey="I47A97872159A10A8,08EB8F0DEB51327E,,,,,,",de="Anleitung: Polierte Runenbirken-Rute",en="Recipe: Polished Runebirch Rod",fr="Plan : Bâtonnet en rune-bouleau poli",ru="Чертеж: полированный скипетр из рунной березы",icon="scroll8b",val=0,q=2,bop=true,Consumable=true,rss="Artificer",rsslvl=210},
["9BECFEF50301010101"] = {akey="I3EBFB61B54FC47A3,655E7CC91EF05A4E,,,,,,",de="Anleitung: Stoischer Anhänger",en="Recipe: Stoic Pendant",fr="Plan : Pendentif du stoïque",ru="Чертеж: подвеска стоика",icon="scroll1",val=0,q=2,bop=true,accBound=true,Consumable=true,rss="Artificer",rsslvl=170,rf="Arcane Hand",rfl=1},
["E5A8B7E80F01010101"] = {akey="IFD0DD465321059EA,62C22D09105067C0,,,,,,",de="Anleitung: Sphalerit-Ring",en="Recipe: Sphalerite Ring",fr="Plan : Anneau en sphalérite",ru="Эскиз: Сфалеритовый перстень",icon="scroll8b",val=0,q=1,bop=true,Consumable=true,rss="Artificer",rsslvl=330},
["B1A7A50B01010101"] = {akey="I016953B11C2F7A44,2DBB6491669EE467,,,,,,",de="Anleitung: Herzloser Ring",en="Recipe: Heartless Ring",fr="Plan : Anneau cruel",ru="Чертеж: бездушное кольцо",icon="scroll8b",val=1,q=2,Consumable=true,rss="Artificer",rsslvl=300},
["92E7B7D20F01010101"] = {akey="IFA4DF3924565F6C3,FD40F76FBC6C61F1,,,,,,",de="Anleitung: Stellare Verstärkung des Eiferers",en="Recipe: Stellar Zealous Augment",fr="Recette : Augmentation de zèle stellaire",ru="Рецепт: Звездная мудрость и критический урон заклинаний",icon="scroll8b",val=0,q=3,bop=true,Consumable=true,rss="Artificer",rsslvl=375},
["B3C5C04C01010101"] = {akey="I099022B373226809,CC6DA8FF5B31D817,,,,,,",de="Anleitung: Raufbold-Siegel",en="Recipe: Pugilist's Signet",fr="Plan : Chevalière du pugiliste",ru="Чертеж: печатка бойца",icon="scroll9a",val=0,q=2,bop=true,accBound=true,Consumable=true,rss="Artificer",rsslvl=300,rf="Dragonslayer Covenant",rfl=3},
["E7D7A6DE0201010101"] = {akey="I2BC9ABE70E9CB46B,C25E50AA945FEF29,,,,,,",de="Anleitung: Smaragdband",en="Recipe: Emerald Band",fr="Plan : Anneau en émeraude",ru="Чертеж: кольцо с изумрудом",icon="scroll1a",val=0,q=1,bop=true,Consumable=true,rss="Artificer",rsslvl=150},
["8FBD84E90601010101"] = {akey="I6D211E8F0D428B0D,3D92B6F4DD917C9F,,,,,,",de="Anleitung: Schlüssel zur Bibliothek",en="Recipe: Keys to the Library",fr="Modèle : Clés de la bibliothèque",ru="Чертеж: ключи от библиотеки",icon="scroll1",val=0,q=2,bop=true,accBound=true,Consumable=true,rss="Artificer",rsslvl=50,rf="Quicksilver Scholars",rfl=2},
["E6B5D7F00401010101"] = {akey="I4E15DAE667DF5E95,2F3CC98A872827C7,,,,,,",de="Anleitung: Gehärteter Chrysopras-Schlagring",en="Recipe: Hardened Chrysoprase Knuckle",fr="Plan : Coup-de-poing endurci en chrysoprase",ru="Чертеж: Крепкий хризофразовый кастет",icon="scroll8b",val=0,q=3,bop=true,Consumable=true,rss="Artificer",rsslvl=375},
["FFE3C1E90301010101"] = {akey="I3D3071FF03D2CE8E,21E92292BAADDA66,,,,,,",de="Anleitung: Celestitband",en="Recipe: Celestite Band",fr="Plan : Anneau en celestite",ru="Чертеж: селеститовое кольцо",icon="scroll1a",val=0,q=1,bop=true,Consumable=true,rss="Artificer",rsslvl=110},
["BB95C0E30301010101"] = {akey="I3C700ABB6E9C5775,22A3F1C330DBA925,,,,,,",de="Anleitung: Grausamer Turmalin-Schlagring",en="Recipe: Vicious Tourmaline Knuckle",fr="Plan : Coup-de-poing vicieux en tourmaline",ru="Чертеж: Турмалиновый кастет злобы",icon="scroll8b",val=0,q=2,bop=true,accBound=true,Consumable=true,rss="Artificer",rsslvl=330,rf="Necropolis Caretakers",rfl=1},
["B0CADA4E01010101"] = {akey="I09D6A53074F10747,38196B732F243433,,,,,,",de="Anleitung: Hüter-Zeichen",en="Recipe: Sign of the Keeper",fr="Plan : Emblème du Garde",ru="Чертеж: знак Блюстителя",icon="scroll8b",val=0,q=3,bop=true,Consumable=true,rss="Artificer",rsslvl=300},
["C795C0E30301010101"] = {akey="I3C700AC771C81794,C72B12CC7C35FC75,,,,,,",de="Anleitung: Leuchtendes Sphalerit-Amulett",en="Recipe: Luminous Sphalerite Amulet",fr="Plan : Amulette lumineuse en sphalérite",ru="Эскиз: Искристый сфалеритовый амулет",icon="scroll8b",val=0,q=2,bop=true,Consumable=true,rss="Artificer",rsslvl=360},
["F3F0A5BD0401010101"] = {akey="I47A9787370DCC903,1AED62D476AD7658,,,,,,",de="Anleitung: Goldkette",en="Recipe: Gold Chain",fr="Plan : Chaîne en or",ru="Чертеж: золотая цепочка",icon="scroll8b",val=0,q=2,bop=true,Consumable=true,rss="Artificer",rsslvl=210},
["E6A8B7E80F01010101"] = {akey="IFD0DD46631C1E15A,36F824DF72A0B42D,,,,,,",de="Anleitung: Sphalerit-Band",en="Recipe: Sphalerite Band",fr="Plan : Jonc en sphalérite",ru="Эскиз: Сфалеритовое кольцо",icon="scroll8b",val=0,q=1,bop=true,Consumable=true,rss="Artificer",rsslvl=330},
["B2A7A50B01010101"] = {akey="I016953B21784E873,5CA1EC106D32E2CA,,,,,,",de="Anleitung: Drachen-Rubinring",en="Recipe: Dragon Ruby Ring",fr="Plan : Anneau serti de rubis draconiques",ru="Чертеж: кольцо с драконьим рубином",icon="scroll8b",val=1,q=2,Consumable=true,rss="Artificer",rsslvl=300},
["86B6ABE80401010101"] = {akey="I4D0ADB0637D2C306,1C7B1B4DBAE65962,,,,,,",de="Anleitung: Heiliger Fetisch",en="Recipe: Sacred Fetish",fr="Plan : Fétiche sacré",ru="Чертеж: священный фетиш",icon="scroll9a",val=0,q=1,bop=true,Consumable=true,rss="Artificer",rsslvl=280},
["A7ED935501010101"] = {akey="I0AA4F6A76F13626E,C7EBAB4F8829E548,,,,,,",de="Anleitung: Schlüssel zum Waffenarsenal",en="Recipe: Keys to the Armory",fr="Modèle : Clés de l'Armurerie",ru="Чертеж: ключи от арсенала",icon="scroll1",val=0,q=2,bop=true,accBound=true,Consumable=true,rss="Artificer",rsslvl=50,rf="Freemarch Wardens",rfl=2},
["B4D0FFFC0601010101"] = {akey="I6F9FE8345F855D28,D3BC709939F11EA1,,,,,,",de="Anleitung: Weghüter-Band",en="Recipe: Waykeeper's Band",fr="Plan : Anneau de Garde-voie",ru="Чертеж: кольцо смотрителя",icon="scroll1",val=0,q=2,bop=true,accBound=true,Consumable=true,rss="Artificer",rsslvl=90,rf="Gloamwood Waykeepers",rfl=2},
["E8D7A6DE0201010101"] = {akey="I2BC9ABE83407D172,12DEC76CF0E00D4C,,,,,,",de="Anleitung: Blutberylitsiegel",en="Recipe: Blood Berylite Signet",fr="Plan : Chevalière en bérylite de sang",ru="Чертеж: печатка из кровавого бериллита",icon="scroll1a",val=0,q=1,bop=true,Consumable=true,rss="Artificer",rsslvl=150},
["CA8DC9AF0501010101"] = {akey="I55F246CA0103C984,5E9A9140397BF6CB,,,,,,",de="Anleitung: Lichtfluch-Diamantsiegel",en="Recipe: Lightsbane Diamond Signet",fr="Plan : Chevalière sertie de diamants Fléau-de-lumière",ru="Чертеж: ослепительная алмазная печатка",icon="scroll9a",val=0,q=1,bop=true,Consumable=true,rss="Artificer",rsslvl=260},
["B8D2CCBF0201010101"] = {akey="I27F3293801DA260E,EDE4BBCC88EB16C3,,,,,,",de="Anleitung: Verstärktes Gehärtetes Orichalcum-Band",en="Recipe: Reinforced Tempered Orichalcum Band",fr="Patron : Anneau en orichalque durci renforcé",ru="Чертеж: укрепленный закаленный орихалковый перстень",icon="scroll1",val=0,q=2,bop=true,accBound=true,Consumable=true,rss="Artificer",rsslvl=300,rf="The Farclan",rfl=3},
["8E86F4E00F01010101"] = {akey="IFC1D030E38F3F565,C4ED7B05267F7D1A,,,,,,",de="Anleitung: Unbarmherziger Madrosa-Kampfstab",en="Recipe: Callous Madrosa Quarterstaff",fr="Plan : Bâton de combat monstrueux en madrosa",ru="Чертеж: Грубый посох Мадрозы",icon="scroll8b",val=0,q=2,bop=true,Consumable=true,rss="Artificer",rsslvl=375},
["86C0A2A00201010101"] = {akey="I2408A00631C50E05,6A0BB0B04222CEFF,,,,,,",de="Anleitung: Ungewöhnlicher Fetisch",en="Recipe: Strange Fetish",fr="Plan : Fétiche étrange",ru="Чертеж: странный фетиш",icon="scroll4",val=0,q=1,bop=true,Consumable=true,rss="Artificer",rsslvl=70},
["E7B5D7F00401010101"] = {akey="I4E15DAE7283001E9,1F92276F70D7F5BE,,,,,,",de="Anleitung: Unbarmherziger Chrysopras-Zirkel",en="Recipe: Callous Chrysoprase Circle",fr="Plan : Petit anneau monstrueux en chrysoprase",ru="Эскиз: Грубый хиропразовый круг",icon="scroll8b",val=1,q=3,Consumable=true,rss="Artificer",rsslvl=375},
["EAE2C9C50501010101"] = {akey="I58B2716A48CBA4E3,2453B1D243B654B3,,,,,,",de="Anleitung: Knöchelring der Carcera",en="Recipe: Carceran Knuckle Ring",fr="Plan : Anneau coup-de-poing de Carcera",ru="Эскиз: карцерское массивное кольцо",icon="scroll8b",val=0,q=3,bop=true,Consumable=true,rss="Artificer",rsslvl=300},
["CE90C3D10601010101"] = {akey="I6A30C84E3C230576,13A0360BC7685C7C,,,,,,",de="Anleitung: Eisenklauen-Fährtenleserhandbuch",en="Recipe: Iron Claw Tracking Manual",fr="Compendium : Manuel de pistage de Griffes de fer",ru="Чертеж: охотничье руководство железного когтя",icon="scroll1",val=0,q=2,bop=true,accBound=true,Consumable=true,rss="Artificer",rsslvl=110,rf="Iron Claw Trappers",rfl=1},
["80E4C1E90301010101"] = {akey="I3D307200409FDB30,3E29EF76F3D06DD8,,,,,,",de="Anleitung: Herzsteinsiegel",en="Recipe: Heartstone Signet",fr="Plan : Chevalière de Pierre-de-cœur",ru="Чертеж: печатка из сердцевика",icon="scroll1a",val=0,q=1,bop=true,Consumable=true,rss="Artificer",rsslvl=110},
["BC95C0E30301010101"] = {akey="I3C700ABC59D5F0C0,EBD4E183BC0FAB24,,,,,,",de="Anleitung: Bewehrtes Turmalin-Auge",en="Recipe: Fortified Tourmaline Eye",fr="Plan : Œil fortifié en tourmaline",ru="Эскиз: Усиленный турмалиновый глаз",icon="scroll8b",val=1,q=2,Consumable=true,rss="Artificer",rsslvl=330},
["B1CADA4E01010101"] = {akey="I09D6A5314940ED7D,1D80C64F4E518607,,,,,,",de="Anleitung: Peiniger-Band",en="Recipe: Tormentor's Band",fr="Plan : Anneau du Tourmenteur",ru="Эскиз: перстень мучителя",icon="scroll8b",val=0,q=3,bop=true,Consumable=true,rss="Artificer",rsslvl=300},
["C895C0E30301010101"] = {akey="I3C700AC848E3FEBA,E1FD40776186747D,,,,,,",de="Anleitung: Gehärteter Sphalerit-Schlagring",en="Recipe: Hardened Sphalerite Knuckle",fr="Plan : Coup-de-poing endurci en sphalérite",ru="Чертеж: Крепкий сфалеритовый кастет",icon="scroll8b",val=20000,q=2,bop=true,Consumable=true,rss="Artificer",rsslvl=370},
["F4F0A5BD0401010101"] = {akey="I47A978746BEE7F58,C6E4FB8820C8CB34,,,,,,",de="Anleitung: Polierter Runenbirken-Kampfstab",en="Recipe: Polished Runebirch Quarterstaff",fr="Plan : Bâton de combat en rune-bouleau poli",ru="Чертеж: полированный волшебный посох из рунной березы",icon="scroll8b",val=0,q=2,bop=true,Consumable=true,rss="Artificer",rsslvl=210},
["909BABF60401010101"] = {akey="I4ECACD900D9B08F6,32CB13687F641C1A,,,,,,",de="Anleitung: Orichalcum-Zauberstab",en="Recipe: Orichalcum Wand",fr="Plan : Baguette en orichalque",ru="Чертеж: орихалковый жезл",icon="scroll2",val=0,q=3,bop=true,Consumable=true,rss="Artificer",rsslvl=300},
["E7A8B7E80F01010101"] = {akey="IFD0DD4673B8D55BD,14A7C8290EDE93E6,,,,,,",de="Anleitung: Sphalerit-Siegel",en="Recipe: Sphalerite Signet",fr="Plan : Sceau en sphalérite",ru="Эскиз: Сфалеритовая печатка",icon="scroll8b",val=0,q=1,bop=true,Consumable=true,rss="Artificer",rsslvl=340},
["B3A7A50B01010101"] = {akey="I016953B35531CE93,51C012BBFD5872BA,,,,,,",de="Anleitung: Leuchtender Krummstab",en="Recipe: Luminous Crook",fr="Plan : Crosse lumineuse",ru="Чертеж: светящийся посох",icon="scroll8b",val=1,q=2,Consumable=true,rss="Artificer",rsslvl=300},
["87B6ABE80401010101"] = {akey="I4D0ADB0771418C24,FA2ABE975724BC69,,,,,,",de="Anleitung: Antiker Fetisch",en="Recipe: Ancient Fetish",fr="Plan : Fétiche ancien",ru="Чертеж: древний фетиш",icon="scroll8b",val=0,q=1,bop=true,Consumable=true,rss="Artificer",rsslvl=220},
["858C85D10101010101"] = {akey="I1A214605266143A4,37DD095F97575060,,,,,,",de="Anleitung: Strahlendes Diamantband",en="Recipe: Brilliant Diamond Band",fr="Plan : Anneau serti de diamants brillants",ru="Эскиз: сверкающее кольцо с бриллиантами",icon="scroll9a",val=0,q=1,bop=true,Consumable=true,rss="Artificer",rsslvl=260},
["8F86F4E00F01010101"] = {akey="IFC1D030F16D90899,C90EE5254A07A66F,,,,,,",de="Anleitung: Leuchtender Madrosa-Stab",en="Recipe: Luminous Madrosa Staff",fr="Plan : Bâton lumineux en madrosa",ru="Чертеж: Искристый посох Мадрозы",icon="scroll8b",val=0,q=2,bop=true,Consumable=true,rss="Artificer",rsslvl=375},
["E8B5D7F00401010101"] = {akey="I4E15DAE8731AB62F,21DDB2B50B3BFB7D,,,,,,",de="Anleitung: Verstärkter Chrysopras-Zirkel",en="Recipe: Reinforced Chrysoprase Circle",fr="Plan : Petit anneau renforcé en chrysoprase",ru="Эскиз: Усиленный хрисопразовый круг",icon="scroll8b",val=0,q=3,bop=true,Consumable=true,rss="Artificer",rsslvl=375},
["EBE2C9C50501010101"] = {akey="I58B2716B5FF8C30F,1971D87D53DC67F0,,,,,,",de="Anleitung: Messingschlagring der Carcera",en="Recipe: Carceran Brass Knuckles",fr="Plan : Coup-de-poing en laiton de Carcera",ru="Чертеж: карцерский кастет",icon="scroll8b",val=0,q=3,bop=true,Consumable=true,rss="Artificer",rsslvl=300},
["F0E0F5EF0501010101"] = {akey="I5DFD707016190103,70B1D62323D1D5BC,,,,,,",de="Anleitung: Rotnarben-Fährtenleserhandbuch",en="Recipe: Red Scar Tracking Manual",fr="Compendium : Guide de pistage de Rouge-balafre",ru="Инструкция: пособие по выслеживанию от Красного Шрама",icon="scroll1",val=0,q=2,bop=true,accBound=true,Consumable=true,rss="Artificer",rsslvl=110,rf="Red Scar Trackers",rfl=1},
["BD95C0E30301010101"] = {akey="I3C700ABD0269730D,16029AC4E70EDE61,,,,,,",de="Anleitung: Verstärkter Turmalin-Zirkel",en="Recipe: Reinforced Tourmaline Circle",fr="Plan : Cercle renforcé en tourmaline",ru="Эскиз: Усиленное турмалиновое кольцо",icon="scroll8b",val=0,q=2,bop=true,accBound=true,Consumable=true,rss="Artificer",rsslvl=330,rf="Eternal City Survivors",rfl=1},
["AF89AE890301010101"] = {akey="I312B84AF7BBF9785,0B914CA913D51432,,,,,,",de="Anleitung: Totem der Verdrehten Seelen",en="Recipe: Totem of Twisted Souls",fr="Plan : Totem des âmes tourmentées",ru="Эскиз: Тотем Искаженных душ",icon="scroll8b",val=0,q=3,bop=true,Consumable=true,rss="Artificer",rsslvl=375},
["EEF6D9FE0601010101"] = {akey="I6FD67B6E495212A5,0F0398F12504DFB6,,,,,,",de="Anleitung: Baustein: Holzwürfel",en="Recipe: Building Block: Wood Cube",fr="Plan : Bloc de construction : cube de bois",ru="Чертеж: Стройматериал: Деревянный куб",icon="scroll4c",val=0,bop=true,Consumable=true,rss="Artificer",rsslvl=60},
["B2CADA4E01010101"] = {akey="I09D6A532617721A1,32C79B77B6A408E1,,,,,,",de="Anleitung: Stab der Folter",en="Recipe: Staff of Torment",fr="Plan : Bâton du tourment",ru="Чертеж: посох мучений",icon="scroll8b",val=0,q=3,bop=true,Consumable=true,rss="Artificer",rsslvl=300},
["DBC0DB2D01010101"] = {akey="I05B6E05B63AAE088,115B57FFF02262EC,,,,,,",de="Anleitung: Verstärktes Gehärtetes Orichalcum-Band",en="Recipe: Reinforced Tempered Orichalcum Band",fr="Patron : Anneau en orichalque durci renforcé",ru="Чертеж: укрепленный закаленный орихалковый перстень",icon="scroll1",val=0,q=2,bop=true,accBound=true,Consumable=true,rss="Artificer",rsslvl=300,rf="Kelari Expedition",rfl=3},
["C995C0E30301010101"] = {akey="I3C700AC96328DC8E,B633384D43D6C0EB,,,,,,",de="Anleitung: Zorniges Sphalerit-Auge",en="Recipe: Furious Sphalerite Eye",fr="Plan : Œil furieux en sphalérite",ru="Эскиз: Яростное сфалеритовое око",icon="scroll8b",val=20000,q=2,bop=true,Consumable=true,rss="Artificer",rsslvl=370},
["F5F0A5BD0401010101"] = {akey="I47A97875026B3EC1,B7EC19DB328F756A,,,,,,",de="Anleitung: Schattendorn-Zeremonienstab",en="Recipe: Shadethorn Virge",fr="Plan : Baguette en ombrépine",ru="Чертеж: жезл теневого терна",icon="scroll9a",val=0,q=2,bop=true,Consumable=true,rss="Artificer",rsslvl=290},
["E8A8B7E80F01010101"] = {akey="IFD0DD46817B69CD0,07EC14DA55070B64,,,,,,",de="Anleitung: Sphalerit-Locke",en="Recipe: Sphalerite Ringlet",fr="Plan : Petit anneau en sphalérite",ru="Эскиз: Сфалеритовое колечко",icon="scroll8b",val=0,q=1,bop=true,Consumable=true,rss="Artificer",rsslvl=340},
["88B6ABE80401010101"] = {akey="I4D0ADB087A776FD6,58AB2BA3714253C9,,,,,,",de="Anleitung: Exquisiter Fetisch",en="Recipe: Exquisite Fetish",fr="Plan : Fétiche exquis",ru="Чертеж: изящный фетиш",icon="scroll8b",val=0,q=1,bop=true,Consumable=true,rss="Artificer",rsslvl=180},
["868C85D10101010101"] = {akey="I1A21460619C87F69,1181A3B93F3ECFA5,,,,,,",de="Anleitung: Lichtfluch-Diamantband",en="Recipe: Lightsbane Diamond Band",fr="Plan : Anneau serti de diamants Fléau-de-lumière",ru="Чертеж: кольцо из светопоглощающих бриллиантов",icon="scroll9a",val=0,q=1,bop=true,Consumable=true,rss="Artificer",rsslvl=260},
["C6EFE79B0701010101"] = {akey="I7379F7C63D8C9BEC,03126A3A83811700,,,,,,",de="Anleitung: Dreifach geknotete Binde",en="Recipe: Triple-Knotted Band",fr="Plan : Anneau à triple sertissage",ru="Чертеж: кольцо с тремя камнями",icon="scroll1",val=0,q=2,bop=true,accBound=true,Consumable=true,rss="Artificer",rsslvl=100,rf="Granite Falls",rfl=2},
["9086F4E00F01010101"] = {akey="IFC1D03104901A971,EBE117FB99B23841,,,,,,",de="Anleitung: Grausamer Chrysopras-Ringkragen",en="Recipe: Vicious Chrysoprase Gorget",fr="Plan : Gorgerin vicieux en chrysoprase",ru="Эскиз: Хрисопразовое ожерелье злобы",icon="scroll8b",val=0,q=2,bop=true,Consumable=true,rss="Artificer",rsslvl=375},
["C7B896A60401010101"] = {akey="I44C59C471B2DFA31,F0509216CF9E54A7,,,,,,",de="Anleitung: Silberanhänger",en="Recipe: Silver Pendant",fr="Plan : Pendentif en argent",ru="Чертеж: серебряный кулон",icon="scroll1a",val=0,q=2,bop=true,Consumable=true,rss="Artificer",rsslvl=100},
["E9B5D7F00401010101"] = {akey="I4E15DAE90ABD2BE0,DBC237C62733F025,,,,,,",de="Anleitung: Zorniges Chrysopras-Auge",en="Recipe: Furious Chrysoprase Eye",fr="Plan : Œil furieux en chrysoprase",ru="Эскиз: Яростное хризопразовое око",icon="scroll8b",val=1,q=3,Consumable=true,rss="Artificer",rsslvl=375},
["ECE2C9C50501010101"] = {akey="I58B2716C72E4C340,2E631E5EBBB1D8A0,,,,,,",de="Anleitung: Ritterfingerschutz der Carcera",en="Recipe: Carceran Crusader's Fingerguard",fr="Plan : Protège-doigt du croisé de Carcera",ru="Чертеж: перстень карцерского рыцаря",icon="scroll8b",val=0,q=3,bop=true,Consumable=true,rss="Artificer",rsslvl=300},
["E6CD80D60F01010101"] = {akey="IFAC026E62CC638D4,F7077CC84A402085,,,,,,",de="Anleitung: Größere Verstärkung der Erleuchtung",en="Recipe: Major Enlightened Augment",fr="Recette : Augmentation de la lumière majeure",ru="Чертеж: Большое усиление просветления",icon="scroll8b",val=0,q=2,bop=true,Consumable=true,rss="Artificer",rsslvl=300},
["98D3F4930201010101"] = {akey="I227D299829BF6364,B22FCF9A0EB35EB2,,,,,,",de="Anleitung: Transportierbare Lebensquelle",en="Recipe: Portable Lifespring",fr="Plan : Source de vie portable",ru="Чертеж: портативный источник Жизни",icon="scroll1a",val=0,q=3,bop=true,Consumable=true,rss="Artificer",rsslvl=260},
["BE95C0E30301010101"] = {akey="I3C700ABE151E0784,CACA0A0EEB1D60CD,,,,,,",de="Anleitung: Leuchtender Turmalin-Schatz",en="Recipe: Luminous Tourmaline Treasure",fr="Plan : Trésor lumineux en tourmaline",ru="Эскиз: Искристое турмалиновое сокровище",icon="scroll8b",val=10000,q=2,bop=true,Consumable=true,rss="Artificer",rsslvl=330},
["848BB2DD0F01010101"] = {akey="IFBAC85844ED4E0AD,F3926E2DB8F09C2C,,,,,,",de="Anleitung: Größere Verstärkung der Undurchdringlichkeit",en="Recipe: Major Impenetrable Augment",fr="Recette : Augmentation d'impénétrabilité majeure",ru="Чертеж: Большое усиление неприступности",icon="scroll8b",val=0,q=2,bop=true,Consumable=true,rss="Artificer",rsslvl=300},
["B089AE890301010101"] = {akey="I312B84B030F0CE6B,6E0640E615B04457,,,,,,",de="Anleitung: Fetisch der Verdrehten Seelen",en="Recipe: Fetish of Twisted Souls",fr="Recette : Fétiche des âmes tourmentées",ru="Эскиз: Фетиш Искаженных душ",icon="scroll8b",val=0,q=3,bop=true,Consumable=true,rss="Artificer",rsslvl=375},
["EFF6D9FE0601010101"] = {akey="I6FD67B6F1C60EDA0,D26A3854C307617B,,,,,,",de="Anleitung: Baustein: Holzplatte",en="Recipe: Building Block: Wood Tile",fr="Plan : Bloc de construction : carreau de bois",ru="Чертеж: Стройматериал: Деревянная черепица",icon="scroll4c",val=0,bop=true,Consumable=true,rss="Artificer",rsslvl=120},
["B3CADA4E01010101"] = {akey="I09D6A533283BAF80,C185747A650B1459,,,,,,",de="Anleitung: Todbringer-Band",en="Recipe: Deathbringer Band",fr="Plan : Anneau mortuaire",ru="Эскиз: кольцо вестника смерти",icon="scroll8b",val=0,q=3,bop=true,Consumable=true,rss="Artificer",rsslvl=300},
["90D796A90601010101"] = {akey="I6525AB903B624DB0,5DE60BD79B58CD46,,,,,,",de="Anleitung: Unbarmherziger Sphalerit-Zirkel",en="Recipe: Callous Sphalerite Circle",fr="Plan : Petit anneau monstrueux en sphalérite",ru="Эскиз: Грубый сфалеритовый круг",icon="scroll8b",val=0,q=2,bop=true,Consumable=true,rss="Artificer",rsslvl=370},
["F6F0A5BD0401010101"] = {akey="I47A978763DD52370,F8CA96A79F56740B,,,,,,",de="Anleitung: Schattendorn-Zauberstab",en="Recipe: Shadethorn Spellstaff",fr="Plan : Hampesort en ombrépine",ru="Чертеж: колдовской посох из теневого терна",icon="scroll9a",val=0,q=2,bop=true,Consumable=true,rss="Artificer",rsslvl=290},
["B58F98A30301010101"] = {akey="I346607B5760D0638,08EC56AD84408487,,,,,,",de="Anleitung: Erleuchtung",en="Recipe: Enlightenment",fr="Plan : Illumination",ru="Рецепт: просветление",icon="scroll8",val=0,q=3,bop=true,Consumable=true,rss="Artificer",rsslvl=300},
["E9A8B7E80F01010101"] = {akey="IFD0DD46905EA2C1E,3B9B651F82114F0D,,,,,,",de="Anleitung: Foliant der Sättigung",en="Recipe: Replete Tome",fr="Plan : Grimoire épais",ru="Эскиз: Фолиант насыщенности",icon="scroll8b",val=0,q=1,bop=true,Consumable=true,rss="Artificer",rsslvl=350},
["89B6ABE80401010101"] = {akey="I4D0ADB09017769FC,1E2F6CC16DDDC76D,,,,,,",de="Anleitung: Verzauberter Fetisch",en="Recipe: Spellstruck Fetish",fr="Plan : Fétiche envoûté",ru="Чертеж: очарованный фетиш",icon="scroll1a",val=0,q=1,bop=true,Consumable=true,rss="Artificer",rsslvl=150},
["C18182EC0201010101"] = {akey="I2D8080C1300613C9,E0994B5F4F25668A,,,,,,",de="Anleitung: Band der Zauber",en="Recipe: Band of Spells",fr="Plan : Anneau de sorts",ru="Чертеж: кольцо заклинаний",icon="scroll9a",val=0,q=2,bop=true,accBound=true,Consumable=true,rss="Artificer",rsslvl=300,rf="Dragonslayer Covenant",rfl=3},
["A6A389F70F01010101"] = {akey="IFEE251A62E0B8EF3,8EB891FE2E2E9674,,,,,,",de="Anleitung: Größere Verstärkung der Besonnenheit",en="Recipe: Major Canny Augment",fr="Recette : Augmentation de ruse majeure",ru="Чертеж: Большое усиление коварства",icon="scroll8b",val=0,q=2,bop=true,Consumable=true,rss="Artificer",rsslvl=300},
["878C85D10101010101"] = {akey="I1A2146073D825A49,2F42C0300107F133,,,,,,",de="Anleitung: Strahlendes Diamantsiegel",en="Recipe: Brilliant Diamond Signet",fr="Plan : Chevalière sertie de diamants brillants",ru="Эскиз: сверкающая алмазная печатка",icon="scroll9a",val=0,q=1,bop=true,Consumable=true,rss="Artificer",rsslvl=270},
["9186F4E00F01010101"] = {akey="IFC1D0311120FE9CB,AF47341037B436B6,,,,,,",de="Anleitung: Unbarmherziger Chrysopras-Halsreif",en="Recipe: Callous Chrysoprase Choker",fr="Plan : Sautoir monstrueux en chrysoprase",ru="Эскиз: Грубый хиропразовый ошейник",icon="scroll8b",val=0,q=2,bop=true,Consumable=true,rss="Artificer",rsslvl=375},
["B8A3B2D20F01010101"] = {akey="IFA4C91B813246DB7,88EC878D2F9AE41D,,,,,,",de="Anleitung: Empyreum-Verstärkung der Besonnenheit",en="Recipe: Empyrean Canny Augment",fr="Recette : Augmentation de ruse empyréenne",ru="Рецепт: Эмпирейское усиление осторожности",icon="scroll8b",val=0,q=2,bop=true,Consumable=true,rss="Artificer",rsslvl=340},
["EAB5D7F00401010101"] = {akey="I4E15DAEA46443E4E,45E1DD9121F589CF,,,,,,",de="Anleitung: Bewehrtes Chrysopras-Auge",en="Recipe: Fortified Chrysoprase Eye",fr="Plan : Œil fortifié en chrysoprase",ru="Эскиз: Усиленный хрисопразовый глаз",icon="scroll8b",val=0,q=3,bop=true,Consumable=true,rss="Artificer",rsslvl=375},
["EDE2C9C50501010101"] = {akey="I58B2716D26EE5109,3284887E5F3A8544,,,,,,",de="Anleitung: Mystikerabzeichen der Carcera",en="Recipe: Carceran Mystic's Insignia",fr="Plan : Insigne du mystique de Carcera",ru="Чертеж: герб карцерского Мистика",icon="scroll8b",val=0,q=3,bop=true,Consumable=true,rss="Artificer",rsslvl=300},
["DDBEB3DF0401010101"] = {akey="I4BECDF5D6AFB30DD,49A105D277FE121A,,,,,,",de="Anleitung: Steingefallene Binde",en="Recipe: Stonefallen Band",fr="Plan : Anneau de Chutepierre",ru="Чертеж: лента падшего камня",icon="scroll1",val=0,q=2,bop=true,accBound=true,Consumable=true,rss="Artificer",rsslvl=90,rf="Granite Falls",rfl=2},
["E7CD80D60F01010101"] = {akey="IFAC026E753DC77D9,25EE0447D0D41EE7,,,,,,",de="Anleitung: Große Verstärkung der Erleuchtung",en="Recipe: Greater Enlightened Augment",fr="Recette : Augmentation de la lumière supérieure",ru="Чертеж: Крепкое усиление просветления",icon="scroll8b",val=0,q=3,bop=true,Consumable=true,rss="Artificer",rsslvl=300},
["BF95C0E30301010101"] = {akey="I3C700ABF107A3BB9,BFE830B97B43740B,,,,,,",de="Anleitung: Wachsamkeit",en="Recipe: Vigilance",fr="Plan : Vigilance",ru="Рецепт: Бдительность",icon="scroll8b",val=0,q=2,bop=true,Consumable=true,rss="Artificer",rsslvl=330},
["858BB2DD0F01010101"] = {akey="IFBAC85850ED066BD,E3E7CC12229FE6D6,,,,,,",de="Anleitung: Große Verstärkung der Undurchdringlichkeit",en="Recipe: Greater Impenetrable Augment",fr="Recette : Augmentation d'impénétrabilité supérieure",ru="Чертеж: Крепкое усиление неприступности",icon="scroll8b",val=0,q=3,bop=true,Consumable=true,rss="Artificer",rsslvl=300},
["B189AE890301010101"] = {akey="I312B84B154F08361,10D873BD655AD629,,,,,,",de="Anleitung: Gehobenes Bewusstsein",en="Recipe: Elevated Consciousness",fr="Recette : Conscience élevée",ru="Рецепт: Повышенная сознательность",icon="scroll8b",val=0,q=3,bop=true,Consumable=true,rss="Artificer",rsslvl=375},
["F0F6D9FE0601010101"] = {akey="I6FD67B7060B02E0A,C3E5E7D9991E1FE0,,,,,,",de="Anleitung: Baustein: Holzpfosten",en="Recipe: Building Block: Wood Pole",fr="Plan : Bloc de construction : poteau de bois",ru="Чертеж: Стройматериал: Деревянный столб",icon="scroll4c",val=0,bop=true,Consumable=true,rss="Artificer",rsslvl=180},
["B4CADA4E01010101"] = {akey="I09D6A5342EE8B4CE,01491968C8FE4144,,,,,,",de="Anleitung: Jenseitsgeschmiedetes Band",en="Recipe: Netherforged Band",fr="Plan : Anneau forgé par le néant",ru="Чертеж: кольцо теневой ковки",icon="scroll8b",val=0,q=3,bop=true,Consumable=true,rss="Artificer",rsslvl=300},
["91D796A90601010101"] = {akey="I6525AB915E20E5EF,ECA3E4DAC9BFD8BD,,,,,,",de="Anleitung: Leuchtender Sphalerit-Schatz",en="Recipe: Luminous Sphalerite Treasure",fr="Plan : Trésor lumineux en sphalérite",ru="Эскиз: Искристое сфалеритовое сокровище",icon="scroll8b",val=0,q=2,bop=true,Consumable=true,rss="Artificer",rsslvl=370},
["F7F0A5BD0401010101"] = {akey="I47A978774ABD0155,0ACD710A2AB3BE83,,,,,,",de="Anleitung: Schöne Platinkette",en="Recipe: Fine Platinum Chain",fr="Plan : Fine chaîne en platine",ru="Чертеж: добротная платиновая цепочка",icon="scroll9a",val=0,q=2,bop=true,Consumable=true,rss="Artificer",rsslvl=290},
["AAA7A50B01010101"] = {akey="I016953AA7D25A2B6,26DB2C67BD21C16A,,,,,,",de="Anleitung: Drachenjäger-Eisenring",en="Recipe: Dragon Hunter's Iron Ring",fr="Plan : Anneau en fer de chasseur de dragons",ru="Чертеж: железное кольцо охотника за драконами",icon="scroll8b",val=1,q=2,Consumable=true,rss="Artificer",rsslvl=300},
["B986D9F40F01010101"] = {akey="IFE96433908E70B79,5141A48F30AF9EBA,,,,,,",de="Anleitung: Größere Verstärkung des Fanatismus",en="Recipe: Major Fanatical Augment",fr="Recette : Augmentation fanatique majeure",ru="Чертеж: Большое фанатическое усиление ",icon="scroll8b",val=0,q=2,bop=true,Consumable=true,rss="Artificer",rsslvl=300},
["E9FE98B90601010101"] = {akey="I67263F697FC5294F,524A50BA8B37A92D,,,,,,",de="Anleitung: Seltsamer Fetisch",en="Recipe: Odd Fetish",fr="Plan : Fétiche bizarre",ru="Чертеж: странный фетиш",icon="scroll4",val=0,q=1,bop=true,Consumable=true,rss="Artificer",rsslvl=30},
["EBC2FACB0601010101"] = {akey="I697EA16B7885918A,40DECDDB7F5D4DA7,,,,,,",de="Anleitung: Band aus kristallisiertem Mana",en="Recipe: Band of Crystallized Mana",fr="Plan : Anneau de mana cristallisé",ru="Чертеж: кольцо кристаллизованной маны",icon="scroll2a",val=0,q=3,bop=true,Consumable=true,rss="Artificer",rsslvl=300},
["EAA8B7E80F01010101"] = {akey="IFD0DD46A5105EF93,FF018134A013D0D1,,,,,,",de="Anleitung: Tuthony-Totem",en="Recipe: Karthite Totem",fr="Plan : Totem en tuthonie",ru="Эскиз: Картитовый тотем",icon="scroll8b",val=0,q=1,bop=true,Consumable=true,rss="Artificer",rsslvl=350},
["FE8FBAE00701010101"] = {akey="I7C0E87FE0CD93F7F,56BA2F03E0987F27,,,,,,",de="Anleitung: Heiliger Foliant",en="Recipe: Sacred Tome",fr="Plan : Grimoire sacré",ru="Инструкция: священный фолиант",icon="scroll9a",val=0,q=1,bop=true,Consumable=true,rss="Artificer",rsslvl=280},
["8AB6ABE80401010101"] = {akey="I4D0ADB0A7EEAECBD,085B9543F2A869AD,,,,,,",de="Anleitung: Verhexter Fetisch",en="Recipe: Bewitched Fetish",fr="Plan : Fétiche enchanté",ru="Чертеж: околдованный амулет",icon="scroll1a",val=0,q=1,bop=true,Consumable=true,rss="Artificer",rsslvl=110},
["8AB4D5FB0501010101"] = {akey="I5F755A0A5F1998F8,E79D6DB0B71D9288,,,,,,",de="Anleitung: Himmelssteinsiegel",en="Recipe: Skystone Signet",fr="Plan : Chevalière en pierre-ciel",ru="Чертеж: печатка с небесным камнем",icon="scroll8b",val=0,q=1,bop=true,Consumable=true,rss="Artificer",rsslvl=180},
["A7A389F70F01010101"] = {akey="IFEE251A747669568,894CE900C5A430B5,,,,,,",de="Anleitung: Große Verstärkung der Besonnenheit",en="Recipe: Greater Canny Augment",fr="Recette : Augmentation de ruse supérieure",ru="Чертеж: Крепкое усиление коварства",icon="scroll8b",val=0,q=3,bop=true,Consumable=true,rss="Artificer",rsslvl=300},
["9286F4E00F01010101"] = {akey="IFC1D03126EBFFA7A,FF166DB2EC1DFBEB,,,,,,",de="Anleitung: Unbarmherziger Foliant der Ausschüttung",en="Recipe: Callous Teeming Tome",fr="Compendium : Grimoire débordant monstrueux",ru="Эскиз: Грубая многословная книга",icon="scroll8b",val=0,q=2,bop=true,accBound=true,Consumable=true,rss="Artificer",rsslvl=375,rf="The Qaijiri",rfl=4},
["B9A3B2D20F01010101"] = {akey="IFA4C91B97BA0B96C,7E0AAE383FC0740C,,,,,,",de="Anleitung: Stellare Verstärkung der Besonnenheit",en="Recipe: Stellar Canny Augment",fr="Recette : Augmentation de ruse stellaire",ru="Рецепт: Звездный критический урон заклинаний",icon="scroll8b",val=0,q=3,bop=true,Consumable=true,rss="Artificer",rsslvl=375},
["EBB5D7F00401010101"] = {akey="I4E15DAEB2385A60F,D9BA96CF3676748F,,,,,,",de="Anleitung: Leuchtender Chrysopras-Schatz",en="Recipe: Luminous Chrysoprase Treasure",fr="Plan : Trésor lumineux en chrysoprase",ru="Эскиз: Искристое хиропразовое сокровище",icon="scroll8b",val=1,q=3,Consumable=true,rss="Artificer",rsslvl=375},
["EEE2C9C50501010101"] = {akey="I58B2716E1C4F8089,55AC4A9BAF6122A4,,,,,,",de="Anleitung: Zehenring der Carcera",en="Recipe: Carceran Pinky Ring",fr="Plan : Petit anneau de Carcera",ru="Эскиз: карцерское кольцо на мизинец",icon="scroll8b",val=0,q=3,bop=true,Consumable=true,rss="Artificer",rsslvl=300},
["E8CD80D60F01010101"] = {akey="IFAC026E8428A1BC4,DFD28958ECCB9041,,,,,,",de="Anleitung: Empyreum-Verstärkung der Erleuchtung",en="Recipe: Empyrean Enlightened Augment",fr="Recette : Augmentation de la lumière empyréenne",ru="Рецепт: Просветленное эмпирейское усиление",icon="scroll8b",val=0,q=2,bop=true,Consumable=true,rss="Artificer",rsslvl=340},
["C095C0E30301010101"] = {akey="I3C700AC0046BA6E0,141DA540DD933D2A,,,,,,",de="Anleitung: Unbarmherzige Abhandlung der Sättigung",en="Recipe: Callous Replete Treatise",fr="Plan : Traité épais monstrueux",ru="Эскиз: Грубый словообильный трактат",icon="scroll8b",val=0,q=2,bop=true,Consumable=true,rss="Artificer",rsslvl=350},
["868BB2DD0F01010101"] = {akey="IFBAC8586034646F9,EAF824FEA2A13D00,,,,,,",de="Anleitung: Empyreum-Verstärkung der Undurchdringlichkeit",en="Recipe: Empyrean Impenetrable Augment",fr="Recette : Augmentation d'impénétrabilité empyréenne",ru="Рецепт: Непробиваемое эмпирейское усиление",icon="scroll8b",val=0,q=2,bop=true,Consumable=true,rss="Artificer",rsslvl=340},
["ECF0A5BD0401010101"] = {akey="I47A9786C5E4430B2,DFCD80CCA9D2455A,,,,,,",de="Anleitung: Polierter Mahagoni-Stab",en="Recipe: Polished Mahogany Crasier",fr="Plan : Démence en acajou poli",ru="Чертеж: полированный посох из красного дерева",icon="scroll1a",val=0,q=2,bop=true,Consumable=true,rss="Artificer",rsslvl=100},
["F1F6D9FE0601010101"] = {akey="I6FD67B712280F7BF,C50B217FC71B3532,,,,,,",de="Anleitung: Baustein: Holzrechteck",en="Recipe: Building Block: Wood Rectangle",fr="Plan : Bloc de construction : rectangle de bois",ru="Чертеж: Стройматериал: Деревянная плитка",icon="scroll4c",val=0,bop=true,Consumable=true,rss="Artificer",rsslvl=240},
["B5CADA4E01010101"] = {akey="I09D6A5355412AB4F,F19E774DB2AE0F3B,,,,,,",de="Anleitung: Blutgeschmiedetes Siegel",en="Recipe: Blood-Forged Signet",fr="Plan : Chevalière forgée dans le sang",ru="Чертеж: печатка кровавой ковки",icon="scroll8b",val=0,q=3,bop=true,Consumable=true,rss="Artificer",rsslvl=300},
["DFA8B7E80F01010101"] = {akey="IFD0DD45F5D5009C4,38E7C34BA317420D,,,,,,",de="Anleitung: Turmalin-Ring",en="Recipe: Tourmaline Ring",fr="Plan : Bague en tourmaline",ru="Эскиз: Турмалиновое кольцо",icon="scroll8b",val=0,q=1,bop=true,Consumable=true,rss="Artificer",rsslvl=290},
["92D796A90601010101"] = {akey="I6525AB927480007B,300A00EE67C25A82,,,,,,",de="Anleitung: Fanatismus",en="Recipe: Zealotry",fr="Plan : Zèle",ru="Рецепт: Фанатизм",icon="scroll8b",val=0,q=2,bop=true,Consumable=true,rss="Artificer",rsslvl=370},
["F8F0A5BD0401010101"] = {akey="I47A9787865872281,061E81467447B3AB,,,,,,",de="Anleitung: Verzierter Platin-Halsreif",en="Recipe: Ornate Platinum Choker",fr="Plan : Ras-du-cou de platine orné",ru="Чертеж: богато украшенное колье",icon="scroll9a",val=0,q=2,bop=true,Consumable=true,rss="Artificer",rsslvl=290},
["ABA7A50B01010101"] = {akey="I016953AB7E037256,55C1B3E6C3B5BFCB,,,,,,",de="Anleitung: Ring der Gebundenen Flamme",en="Recipe: Bound-Flame Ring",fr="Plan : Anneau de flamme-liée",ru="Чертеж: кольцо привязанного огня",icon="scroll8b",val=1,q=3,Consumable=true,rss="Artificer",rsslvl=300},
["BA86D9F40F01010101"] = {akey="IFE96433A7AD1D6DF,494E36B89D4DD830,,,,,,",de="Anleitung: Große Verstärkung des Fanatismus",en="Recipe: Greater Fanatical Augment",fr="Recette : Augmentation fanatique supérieure",ru="Чертеж: Крепкое фанатическое усиление ",icon="scroll8b",val=0,q=3,bop=true,Consumable=true,rss="Artificer",rsslvl=300},
["ECC2FACB0601010101"] = {akey="I697EA16C5A446140,0733D8BC79D8FC41,,,,,,",de="Anleitung: Titanensiegel",en="Recipe: Titan's Signet",fr="Plan : Chevalière du Titan",ru="Чертеж: печатка титана",icon="scroll2a",val=0,q=3,bop=true,Consumable=true,rss="Artificer",rsslvl=300},
["E5A6DEC70101010101"] = {akey="I18F7936508C338F9,2F95154BA7011B42,,,,,,",de="Anleitung: Saphirsiegel",en="Recipe: Sapphire Signet",fr="Plan : Chevalière sertie de saphirs",ru="Чертеж: сапфировая печатка",icon="scroll8b",val=0,q=1,bop=true,Consumable=true,rss="Artificer",rsslvl=220},
["9386F4E00F01010101"] = {akey="IFC1D03137FA7F70E,B2C53AAA99283F93,,,,,,",de="Anleitung: Leuchtendes Rhenium-Totem",en="Recipe: Luminous Rhenium Totem",fr="Plan : Totem lumineux en rhénium",ru="Эскиз: Искристый рениевый тотем",icon="scroll8b",val=0,q=2,bop=true,accBound=true,Consumable=true,rss="Artificer",rsslvl=375,rf="The Qaijiri",rfl=4},
["83E6C1CB0601010101"] = {akey="I697073030D28827C,E78F6F6158EE0E58,,,,,,",de="Anleitung: Dreifach geknotete Binde",en="Recipe: Triple-Knotted Band",fr="Plan : Anneau à triple sertissage",ru="Чертеж: кольцо с тремя камнями",icon="scroll1",val=0,q=2,bop=true,accBound=true,Consumable=true,rss="Artificer",rsslvl=100,rf="Gloamwood Waykeepers",rfl=2},
["ECB5D7F00401010101"] = {akey="I4E15DAEC73B05C25,0D6963C6E38034E9,,,,,,",de="Anleitung: Ungetrübte Vorausschau",en="Recipe: Unclouded Foresight",fr="Plan : Prévoyance limpide",ru="Рецепт: Незамутненное прозрение",icon="scroll8b",val=0,q=3,bop=true,Consumable=true,rss="Artificer",rsslvl=375},
["EFE2C9C50501010101"] = {akey="I58B2716F69713B48,4DB960129BFFDF69,,,,,,",de="Anleitung: Schleicherabzeichen der Carcera",en="Recipe: Carceran Slinker's Insignia",fr="Plan : Insigne de l'errant de Carcera",ru="Чертеж: карцерский герб Слизня",icon="scroll8b",val=0,q=3,bop=true,Consumable=true,rss="Artificer",rsslvl=300},
["E9CD80D60F01010101"] = {akey="IFAC026E951334E8D,FB5677717A3367D5,,,,,,",de="Anleitung: Stellare Verstärkung der Erleuchtung",en="Recipe: Stellar Enlightened Augment",fr="Recette : Augmentation de la lumière stellaire",ru="Рецепт: Звездная мудрость и сила заклинаний",icon="scroll8b",val=0,q=3,bop=true,Consumable=true,rss="Artificer",rsslvl=375},
["C195C0E30301010101"] = {akey="I3C700AC14F1A236B,261FFC55E8F00453,,,,,,",de="Anleitung: Leuchtender Tuthony-Kristall",en="Recipe: Luminous Karthite Crystal",fr="Plan : Cristal de tuthonie lumineux",ru="Эскиз: Искристый кристалл картита",icon="scroll8b",val=0,q=2,bop=true,Consumable=true,rss="Artificer",rsslvl=350},
["878BB2DD0F01010101"] = {akey="IFBAC858778B2D7FC,0CB147E21EF64245,,,,,,",de="Anleitung: Stellare Verstärkung der Undurchdringlichkeit",en="Recipe: Stellar Impenetrable Augment",fr="Recette : Augmentation d'impénétrabilité stellaire",ru="Рецепт: Звездная выносливость и блок",icon="scroll8b",val=0,q=3,bop=true,Consumable=true,rss="Artificer",rsslvl=375},
["EDF0A5BD0401010101"] = {akey="I47A9786D3FE2C96A,F8628019DAC0F019,,,,,,",de="Anleitung: Polierte Mahagoni-Rute",en="Recipe: Polished Mahogany Rod",fr="Plan : Bâtonnet en acajou poli",ru="Чертеж: полированный скипетр из красного дерева",icon="scroll1a",val=0,q=2,bop=true,Consumable=true,rss="Artificer",rsslvl=135},
["F2F6D9FE0601010101"] = {akey="I6FD67B7208C26A14,F5CB82F817AC4C05,,,,,,",de="Anleitung: Offenes Buch",en="Recipe: Open Book",fr="Patron : Livre ouvert",ru="Эскиз: Открытая книга",icon="scroll4c",val=0,bop=true,Consumable=true,rss="Artificer",rsslvl=300},
["8897C51001010101"] = {akey="I02114B8873B8056D,5A6B63C8E321BA2A,,,,,,",de="Anleitung: Schwerer Foliant",en="Recipe: Heavy Tome",fr="Plan : Grimoire lourd",ru="Инструкция: тяжелый фолиант",icon="scroll1a",val=0,q=1,bop=true,Consumable=true,rss="Artificer",rsslvl=150},
["C7FCF9A20301010101"] = {akey="I345E7E477ADC23F8,7006C4FA5F00BF9F,,,,,,",de="Anleitung: Unseliges Relikt",en="Recipe: Ill-Fated Relic",fr="Plan : Relique du malheur",ru="Чертеж: злополучная реликвия",icon="scroll1",val=0,q=2,bop=true,accBound=true,Consumable=true,rss="Artificer",rsslvl=200,rf="Arcane Hand",rfl=1},
["E0A8B7E80F01010101"] = {akey="IFD0DD4606B88AA16,337B96FF3A8C5900,,,,,,",de="Anleitung: Turmalin-Band",en="Recipe: Tourmaline Band",fr="Plan : Anneau en tourmaline",ru="Эскиз: Турмалиновая лента",icon="scroll8b",val=0,q=1,bop=true,Consumable=true,rss="Artificer",rsslvl=290},
["F9F0A5BD0401010101"] = {akey="I47A978790020F9DB,101414D0FC38FD2B,,,,,,",de="Anleitung: Platin-Halskette",en="Recipe: Platinum Necklace",fr="Plan : Collier en platine",ru="Чертеж: платиновое ожерелье",icon="scroll9a",val=0,q=2,bop=true,Consumable=true,rss="Artificer",rsslvl=290},
["ACA7A50B01010101"] = {akey="I016953AC51CF85EB,15E2CE9A04C2028F,,,,,,",de="Anleitung: Brausender Zauberstab",en="Recipe: Effervescent Wand",fr="Plan : Baguette effervescente",ru="Чертеж: искрометный жезл",icon="scroll8b",val=1,q=2,Consumable=true,rss="Artificer",rsslvl=300},
["BB86D9F40F01010101"] = {akey="IFE96433B53CCDFC1,41B15EC48A69A71F,,,,,,",de="Anleitung: Empyreum-Verstärkung des Fanatismus",en="Recipe: Empyrean Fanatical Augment",fr="Recette : Augmentation fanatique empyréenne",ru="Рецепт: Эмпирейское усиление фанатизма",icon="scroll8b",val=0,q=2,bop=true,Consumable=true,rss="Artificer",rsslvl=340},
["EDC2FACB0601010101"] = {akey="I697EA16D7A14C694,343D76DC35910631,,,,,,",de="Anleitung: Tysumis Abhandlung über arkanes Reisen",en="Recipe: Tysumi's Treatise on Arcane Travel",fr="Plan : Traité de Tysumi sur le Voyage arcanique",ru="Чертеж: трактат Тисуми о тайном путешествии",icon="scroll2a",val=0,q=3,bop=true,Consumable=true,rss="Artificer",rsslvl=300},
["9486F4E00F01010101"] = {akey="IFC1D0314517BB901,170643E54BEE1DAC,,,,,,",de="Anleitung: Zorniges Chrysopras-Lariat",en="Recipe: Furious Chrysoprase Lariat",fr="Plan : Ras-du-cou furieux en chrysoprase",ru="Чертеж: Яростное хризопразовое лассо",icon="scroll8b",val=30000,q=2,bop=true,Consumable=true,rss="Artificer",rsslvl=375},
["B695C0E30301010101"] = {akey="I3C700AB628EBF38C,03DDDF5C7641E5E7,,,,,,",de="Anleitung: Verstärkter Linden-Hexerstab",en="Recipe: Reinforced Linden Hexer",fr="Plan : Envoûteur renforcé en tilleul",ru="Чертеж: Усиленный липовый проклинатель",icon="scroll8b",val=1,q=2,Consumable=true,rss="Artificer",rsslvl=310},
["BBA3B2D20F01010101"] = {akey="IFA4C91BB0DC0EE4C,23352AB542E0F2CA,,,,,,",de="Anleitung: Empyreum-Verstärkung der Flüchtigkeit",en="Recipe: Empyrean Elusive Augment",fr="Recette : Augmentation insaisissable empyréenne",ru="Рецепт: Ускользающее эмпирейское усиление",icon="scroll8b",val=0,q=2,bop=true,Consumable=true,rss="Artificer",rsslvl=340},
["F0E2C9C50501010101"] = {akey="I58B27170338B0C61,688B0A6F01505770,,,,,,",de="Anleitung: Zaubererring der Carcera",en="Recipe: Carceran Wizard's Ring",fr="Plan : Anneau du magicien de Carcera",ru="Эскиз: кольцо карцерского колдуна",icon="scroll8b",val=0,q=3,bop=true,Consumable=true,rss="Artificer",rsslvl=300},
["9CD3F4930201010101"] = {akey="I227D299C3E46C935,CC77DE1563901595,,,,,,",de="Anleitung: Transportierbares Geschütz",en="Recipe: Portable Turret",fr="Plan : Tourelle portable",ru="Чертеж: портативная огневая установка",icon="scroll1a",val=0,q=3,bop=true,Consumable=true,rss="Artificer",rsslvl=260},
["C295C0E30301010101"] = {akey="I3C700AC257F46241,03D0A63B052E675B,,,,,,",de="Anleitung: Verstärkter Sphalerit-Hexerstab",en="Recipe: Reinforced Sphalerite Hexer",fr="Plan : Envoûteur renforcé en sphalérite",ru="Чертеж: Усиленный сфалеритовый проклинатель",icon="scroll8b",val=0,q=2,bop=true,Consumable=true,rss="Artificer",rsslvl=350},
["EEF0A5BD0401010101"] = {akey="I47A9786E21F150F4,FB5E1BE711E22902,,,,,,",de="Anleitung: Polierter Runenbirken-Stab",en="Recipe: Polished Runebirch Staff",fr="Plan : Bâton en rune-bouleau poli",ru="Чертеж: полированный посох из рунной березы",icon="scroll8b",val=0,q=2,bop=true,Consumable=true,rss="Artificer",rsslvl=170},
["F3F6D9FE0601010101"] = {akey="I6FD67B7349130D67,F9EC69CA3B34755A,,,,,,",de="Anleitung: Kelarilampe",en="Recipe: Kelari Lamp",fr="Plan : Lampe kelari",ru="Эскиз: Лампа келари",icon="scroll4c",val=0,bop=true,Consumable=true,rss="Artificer",rsslvl=360},
["E1A8B7E80F01010101"] = {akey="IFD0DD46164E9C597,1DA7BF81BF5677F0,,,,,,",de="Anleitung: Turmalin-Siegel",en="Recipe: Tourmaline Signet",fr="Plan : Chevalière en tourmaline",ru="Эскиз: Турмалиновая печатка",icon="scroll8b",val=0,q=1,bop=true,Consumable=true,rss="Artificer",rsslvl=300},
["FAF0A5BD0401010101"] = {akey="I47A9787A404E1BFA,CBD028A12CAEBE7C,,,,,,",de="Anleitung: Platin-Ringkragen",en="Recipe: Platinum Gorget",fr="Plan : Sautoir en platine",ru="Чертеж: платиновое ожерелье",icon="scroll9a",val=0,q=2,bop=true,Consumable=true,rss="Artificer",rsslvl=290},
["ADA7A50B01010101"] = {akey="I016953AD7FDA52A8,231CE03769A907C1,,,,,,",de="Anleitung: Verzauberter Rubinanhänger",en="Recipe: Enchanted Ruby Pendant",fr="Plan : Pendentif enchanté serti de rubis",ru="Чертеж: кулон с зачарованным рубином",icon="scroll8b",val=1,q=2,Consumable=true,rss="Artificer",rsslvl=300},
["BC86D9F40F01010101"] = {akey="IFE96433C10EF65A0,1EB6A9E2C6AD211D,,,,,,",de="Anleitung: Stellare Verstärkung des Fanatismus",en="Recipe: Stellar Fanatical Augment",fr="Recette : Augmentation fanatique stellaire",ru="Рецепт: Звездная мудрость и сила критического удара",icon="scroll8b",val=0,q=3,bop=true,Consumable=true,rss="Artificer",rsslvl=375},
["EEC2FACB0601010101"] = {akey="I697EA16E66CBF83D,EBF3D4F296183224,,,,,,",de="Anleitung: Talisman der empathischen Verteidigung",en="Recipe: Talisman of Emphatic Defense",fr="Plan : Talisman de défense empathique",ru="Чертеж: талисман эмпатической защиты",icon="scroll2a",val=0,q=3,bop=true,Consumable=true,rss="Artificer",rsslvl=300},
["A0F098A70601010101"] = {akey="I64E638207CAED490,ED793C6F50EA1812,,,,,,",de="Anleitung: Orichalcum-Amulett",en="Recipe: Orichalcum Amulet",fr="Plan : Amulette en orichalque",ru="Чертеж: орихалковый амулет",icon="scroll2",val=0,q=3,bop=true,Consumable=true,rss="Artificer",rsslvl=300},
["8986F4E00F01010101"] = {akey="IFC1D03096D70524C,1F347B66DCCE80BC,,,,,,",de="Anleitung: Leuchtendes Chrysopras-Band",en="Recipe: Luminous Chrysoprase Band",fr="Plan : Bague lumineuse en chrysoprase",ru="Эскиз: Искристое кольцо с хиропразом",icon="scroll8b",val=0,q=2,bop=true,Consumable=true,rss="Artificer",rsslvl=370},
["CD89FACB0401010101"] = {akey="I497E84CD53BC9D28,F1B85997A2999975,,,,,,",de="Anleitung: Rubinband",en="Recipe: Ruby Band",fr="Plan : Anneau serti de rubis",ru="Чертеж: рубиновое кольцо",icon="scroll8b",val=0,q=1,bop=true,Consumable=true,rss="Artificer",rsslvl=220},
["8095CCF80501010101"] = {akey="I5F130A804610029B,2A01D40267843E32,,,,,,",de="Anleitung: Verziertes Peridot-Amulett",en="Recipe: Ornate Peridot Amulet",fr="Plan : Amulette ornée de péridot",ru="Чертеж: богато украшенный амулет из перидота",icon="scroll8b",val=1,q=2,Consumable=true,rss="Artificer",rsslvl=300},
["9586F4E00F01010101"] = {akey="IFC1D0315277D47FA,C2FDDC997608EF39,,,,,,",de="Anleitung: Leuchtende Chrysopras-Halskette",en="Recipe: Luminous Chrysoprase Necklace",fr="Plan : Collier lumineux en chrysoprase",ru="Эскиз: Искристое ожерелье с хиропразом",icon="scroll8b",val=30000,q=2,bop=true,Consumable=true,rss="Artificer",rsslvl=375},
["B795C0E30301010101"] = {akey="I3C700AB70C2D339E,2FD5780F205D3AC3,,,,,,",de="Anleitung: Leuchtender Linden-Hexenstab",en="Recipe: Luminous Linden Spellstaff",fr="Plan : Hampesort lumineux en tilleul",ru="Чертеж: Искристый липовый колдовской посох",icon="scroll8b",val=0,q=2,bop=true,Consumable=true,rss="Artificer",rsslvl=310},
["BCA3B2D20F01010101"] = {akey="IFA4C91BC613A4AD0,3411B37861D6C987,,,,,,",de="Anleitung: Stellare Verstärkung der Flüchtigkeit",en="Recipe: Stellar Elusive Augment",fr="Recette : Augmentation insaisissable stellaire",ru="Рецепт: Звездное уклонение",icon="scroll8b",val=0,q=3,bop=true,Consumable=true,rss="Artificer",rsslvl=375},
["C395C0E30301010101"] = {akey="I3C700AC33D3C1043,15D27A02908B2E83,,,,,,",de="Anleitung: Leuchtender Sphalerit-Sprenger",en="Recipe: Luminous Sphalerite Blaster",fr="Plan : Destructeur lumineux en sphalérite",ru="Чертеж: Искристый сфалеритовый бластер",icon="scroll8b",val=1,q=2,Consumable=true,rss="Artificer",rsslvl=350},
["EFF0A5BD0401010101"] = {akey="I47A9786F74B612F0,0D6072FC1D3EF02B,,,,,,",de="Anleitung: Gold-Ringkragen",en="Recipe: Gold Gorget",fr="Plan : Ras-du-cou en or",ru="Чертеж: золотой горжет",icon="scroll8b",val=0,q=2,bop=true,Consumable=true,rss="Artificer",rsslvl=170},
["E2A8B7E80F01010101"] = {akey="IFD0DD4622C18A3C3,EEEEC88BC52D143A,,,,,,",de="Anleitung: Turmalin-Locke",en="Recipe: Tourmaline Ringlet",fr="Plan : Petit anneau en tourmaline",ru="Эскиз: Турмалиновое колечко",icon="scroll8b",val=0,q=1,bop=true,Consumable=true,rss="Artificer",rsslvl=300},
["AEA7A50B01010101"] = {akey="I016953AE4C246FFD,39E800129B7C1430,,,,,,",de="Anleitung: Verzierter Stahl-Halsreif",en="Recipe: Ornate Steel Choker",fr="Plan : Ras-du-cou en acier travaillé",ru="Чертеж: богатое стальное ожерелье",icon="scroll8b",val=1,q=2,Consumable=true,rss="Artificer",rsslvl=300},
["8FE7B7D20F01010101"] = {akey="IFA4DF38F6A18BD04,365CD4C03CF65AA0,,,,,,",de="Anleitung: Größere Verstärkung des Eiferers",en="Recipe: Major Zealous Augment",fr="Recette : Augmentation de zèle majeure",ru="Чертеж: Большое усиление фанатизма",icon="scroll8b",val=0,q=2,bop=true,Consumable=true,rss="Artificer",rsslvl=300},
["EFC2FACB0601010101"] = {akey="I697EA16F3A285E5A,3D3ADDFB9BEF51BC,,,,,,",de="Anleitung: Zauberstab der Wütenden Blitze",en="Recipe: Spellstaff of Raging Lightning",fr="Plan : Hampesort de Foudre rageuse",ru="Чертеж: колдовской посох яростной молнии",icon="scroll2a",val=0,q=3,bop=true,Consumable=true,rss="Artificer",rsslvl=300},
["DE8FFB5D01010101"] = {akey="I0BBEC7DE19D0DE79,35D6C469F0019772,,,,,,",de="Anleitung: Alter Foliant",en="Recipe: Ancient Tome",fr="Plan : Grimoire ancien",ru="Инструкция: древний фолиант",icon="scroll8b",val=0,q=1,bop=true,Consumable=true,rss="Artificer",rsslvl=220},
["BAA8E4CD0701010101"] = {akey="I79B9143A701467EF,F3914B9510B3140B,,,,,,",de="Anleitung: Glühendes Gehärtetes Orichalcum-Amulett",en="Recipe: Glowing Tempered Orichalcum Amulet",fr="Plan : Amulette en orichalque durci luminescent",ru="Чертеж: мерцающий закаленный орихалковый амулет",icon="scroll1",val=0,q=2,bop=true,accBound=true,Consumable=true,rss="Artificer",rsslvl=300,rf="The Keepers",rfl=3},
["8A86F4E00F01010101"] = {akey="IFC1D030A50115B69,0BE762258C6EF9DB,,,,,,",de="Anleitung: Unbarmherzige Madrosa-Rute",en="Recipe: Callous Madrosa Rod",fr="Plan : Bâtonnet monstrueux en madrosa",ru="Чертеж: Грубый жезл Мадрозы",icon="scroll8b",val=1,q=2,Consumable=true,rss="Artificer",rsslvl=375},
["ABA389F70F01010101"] = {akey="IFEE251AB5F96218A,483D9DD831B8717D,,,,,,",de="Anleitung: Größere Verstärkung der Flüchtigkeit",en="Recipe: Major Elusive Augment",fr="Recette : Augmentation insaisissable majeure",ru="Чертеж: Большое усиление неуловимости",icon="scroll8b",val=0,q=2,bop=true,Consumable=true,rss="Artificer",rsslvl=300},
["CE89FACB0401010101"] = {akey="I497E84CE6718838D,EC4CB099BA0EB067,,,,,,",de="Anleitung: Saphirband",en="Recipe: Sapphire Band",fr="Plan : Anneau serti de saphirs",ru="Чертеж: кольцо с сапфиром",icon="scroll8b",val=0,q=1,bop=true,Consumable=true,rss="Artificer",rsslvl=220},
}

nkItemBase.db.recipe.butchering={
["B992E8CE0301010101"] = {akey="I39DA093963DE9267,388901B5EF648FEF,,,,,,",de="Anleitung: Feines Leder",en="Recipe: Fine Leather",fr="Patron : Cuir de qualité",ru="Выкройка: выделанная кожа",icon="scroll1",val=10000,q=1,bop=true,Consumable=true,rss="Butchering",rsslvl=115},
["9ECEB2BC0401010101"] = {akey="I478CA71E085DA0EE,CAB387834886DB8D,,,,,,",de="Anleitung: Schafsbrustkorb",en="Recipe: Sheep Rib Cage",fr="Recette : Cage thoracique de mouton",ru="Рецепт: Ребра овцы",icon="scroll4c",val=0,bop=true,Consumable=true,rss="Butchering",rsslvl=60},
["BA92E8CE0301010101"] = {akey="I39DA093A15A70F0E,535B2F6054B507F6,,,,,,",de="Anleitung: Gehärtetes Leder",en="Recipe: Reinforced Leather",fr="Patron : Cuir durci",ru="Выкройка: укрепленная кожа",icon="scroll1",val=10000,q=1,bop=true,Consumable=true,rss="Butchering",rsslvl=185},
["9FCEB2BC0401010101"] = {akey="I478CA71F6E18C319,DFA4CD64305CCF8C,,,,,,",de="Anleitung: Bärenfell-Teppich",en="Recipe: Bearskin Rug",fr="Plan : Tapis en peau d'ours",ru="Выкройка: Ковер из шкуры медведя",icon="scroll4c",val=0,bop=true,Consumable=true,rss="Butchering",rsslvl=120},
["A0CEB2BC0401010101"] = {akey="I478CA720578EAEF3,CDBD8039E5AA4CED,,,,,,",de="Anleitung: Fuchsfellhaufen",en="Recipe: Pile of Fox Furs",fr="Patron : Tas de fourrures de renard",ru="Эскиз: Куча лисьих шкурок",icon="scroll4c",val=0,bop=true,Consumable=true,rss="Butchering",rsslvl=180},
["A1CEB2BC0401010101"] = {akey="I478CA7216007D668,DFBF5400710690C7,,,,,,",de="Anleitung: Bett mit Fellen",en="Recipe: Bed with Furs",fr="Plan : Lit avec fourrures",ru="Эскиз: Меховое ложе",icon="scroll4c",val=0,bop=true,Consumable=true,rss="Butchering",rsslvl=240},
["A2CEB2BC0401010101"] = {akey="I478CA722045CD96C,2B9A0671BDB34084,,,,,,",de="Anleitung: Knochenfackel",en="Recipe: Bone Torch",fr="Plan : Torche en os",ru="Эскиз: Факел из кости",icon="scroll4c",val=0,bop=true,Consumable=true,rss="Butchering",rsslvl=300},
["CCD7D6970701010101"] = {akey="I72F5ABCC6E08E5BD,E72F775FCFABA233,,,,,,",de="Anleitung: Durchwirktes Leder",en="Recipe: Imbued Leather",fr="Patron : Cuir imprégné",ru="Рецепт: пропитанная кожа",icon="scroll1",val=10000,q=1,bop=true,Consumable=true,rss="Butchering",rsslvl=280},
}

nkItemBase.db.recipe.fishing={
["DFEFEF900501010101"] = {akey="I521BF7DF7D7BF65D,2EC947892DC40111,,,,,,",de="Anleitung: Amphibische Qualle-Köder",en="Recipe: Amphibious Jelly Lure",fr="Recette : Appât pour Méduse",ru="Рецепт: Приманка для земноводной медузы",icon="scroll4d",val=0,q=1,bop=true,Consumable=true,rss="Fishing",rsslvl=290},
["CBADDFF80301010101"] = {akey="I3F17D6CB245F4FB5,22CDD7511F6B325E,,,,,,",de="Anleitung: Zwielicht-Aal-Köder",en="Recipe: Gloam Eel Lure",fr="Recette : Appât pour Anguille du Crépuscule",ru="Рецепт: Приманка для сумеречного угря",icon="scroll4d",val=0,q=1,bop=true,Consumable=true,rss="Fishing",rsslvl=50},
["91A89EE80F01010101"] = {akey="IFD07941168C913C5,EA88D1703D6B8796,,,,,,",de="Anleitung: Schneidflossenköder",en="Recipe: Sharpfin Lure",fr="Recette : Appât pour Vive coupante",ru="Рецепт: Приманка на острошкура",icon="scroll4d",val=0,q=1,bop=true,Consumable=true,rss="Fishing",rsslvl=325},
["D7ADDFF80301010101"] = {akey="I3F17D6D7460CB3AF,47497C3F60BD83B7,,,,,,",de="Anleitung: Übersommernder Nautilus-Köder",en="Recipe: Aestivating Nautilus Lure",fr="Recette : Appât pour Nautile estivant",ru="Рецепт: Приманка для наутилуса в спячке",icon="scroll4d",val=0,q=1,bop=true,Consumable=true,rss="Fishing",rsslvl=160},
["D4EFEF900501010101"] = {akey="I521BF7D402AA5C03,68AF89A030C7724D,,,,,,",de="Anleitung: Kaltwasser-Meereskäfer-Köder",en="Recipe: Coldwater Seabug Lure",fr="Recette : Appât pour Isopode des eaux froides",ru="Рецепт: Приманка для холодноводного морского жука",icon="scroll4d",val=0,q=1,bop=true,Consumable=true,rss="Fishing",rsslvl=160},
["E0EFEF900501010101"] = {akey="I521BF7E04B0F4661,6152462E6E66D0FE,,,,,,",de="Anleitung: Tiefenrochen-Köder",en="Recipe: Deep Ray Lure",fr="Recette : Appât pour Raie des profondeurs",ru="Рецепт: Приманка для глубоководного ската",icon="scroll4d",val=0,q=1,bop=true,Consumable=true,rss="Fishing",rsslvl=260},
["CCADDFF80301010101"] = {akey="I3F17D6CC6C55F1D7,149257BD5CED1BC1,,,,,,",de="Anleitung: Indigoby-Köder",en="Recipe: Indigoby Lure",fr="Recette : Appât pour Indigobie",ru="Рецепт: Приманка для индиговой рыбы",icon="scroll4d",val=0,q=1,bop=true,Consumable=true,rss="Fishing",rsslvl=70},
["D8ADDFF80301010101"] = {akey="I3F17D6D84607348A,6969EEA7885032AE,,,,,,",de="Anleitung: Ödland-Kugelfisch-Köder",en="Recipe: Droughtlands Puffer Lure",fr="Recette : Appât pour Poisson-globe des Plaines Arides",ru="Рецепт: Приманка для рыбы-собаки Сухих Земель",icon="scroll4d",val=0,q=1,bop=true,Consumable=true,rss="Fishing",rsslvl=190},
["D5EFEF900501010101"] = {akey="I521BF7D57C5A226C,7F7A262DE299FB6D,,,,,,",de="Anleitung: Gletscher-Oktopus-Köder",en="Recipe: Glacier Octopus Lure",fr="Recette : Appât pour Pieuvre de glacier",ru="Рецепт: Приманка для ледникового осьминога",icon="scroll4d",val=0,q=1,bop=true,Consumable=true,rss="Fishing",rsslvl=190},
["E1EFEF900501010101"] = {akey="I521BF7E10C259167,781D6609A0395A1F,,,,,,",de="Anleitung: Asche-Hai-Köder",en="Recipe: Ash Shark Lure",fr="Recette : Appât pour Requin cendré",ru="Рецепт: Приманка для пепельной акулы",icon="scroll4d",val=0,q=1,bop=true,Consumable=true,rss="Fishing",rsslvl=290},
["CDADDFF80301010101"] = {akey="I3F17D6CD15C957CF,342D4E2E68B3D90F,,,,,,",de="Anleitung: Zackenbarsch-Köder",en="Recipe: Grouper Lure",fr="Recette : Appât pour Mérou",ru="Рецепт: Приманка для групера",icon="scroll4d",val=0,q=1,bop=true,Consumable=true,rss="Fishing",rsslvl=100},
["93A89EE80F01010101"] = {akey="IFD0794134F0A6BAF,FDBEAA750FD7CE8F,,,,,,",de="Anleitung: Kaltfackel-Oktopusköder",en="Recipe: Coldflare Octopus Lure",fr="Recette : Appât pour Pieuvre frigorifère",ru="Рецепт: Приманка на осьминога хладного пламени",icon="scroll4d",val=0,q=1,bop=true,Consumable=true,rss="Fishing",rsslvl=355},
["D6EFEF900501010101"] = {akey="I521BF7D609229D9E,72BEF62C28C2F63B,,,,,,",de="Anleitung: Klarwasser-Oktopus-Köder",en="Recipe: Brightwater Octopus Lure",fr="Recette : Appât pour Pieuvre d'eau claire",ru="Рецепт: Приманка для мелководного осьминога",icon="scroll4d",val=0,q=1,bop=true,Consumable=true,rss="Fishing",rsslvl=225},
["CEADDFF80301010101"] = {akey="I3F17D6CE29742901,4166DC7D4D9A5AF2,,,,,,",de="Anleitung: Wundwald-Kristallfisch-Köder",en="Recipe: Scarwood Crystalfish Lure",fr="Recette : Appât pour Poisson-cristal des Bois Meurtris",ru="Рецепт: Приманка для кристальной рыбы Шрамолесья",icon="scroll4d",val=0,q=1,bop=true,Consumable=true,rss="Fishing",rsslvl=130},
["94A89EE80F01010101"] = {akey="IFD0794141A1BF531,316CF41EBCE18EE9,,,,,,",de="Anleitung: Riesenteichhüpfer-Köder",en="Recipe: Giant Pondleaper Lure",fr="Recette : Appât pour Carpe géante",ru="Рецепт: Приманка на гигантского прудовика-прыгуна",icon="scroll4d",val=0,q=1,bop=true,Consumable=true,rss="Fishing",rsslvl=315},
["D7EFEF900501010101"] = {akey="I521BF7D779315853,04C14D42341F3A16,,,,,,",de="Anleitung: Pudernasenkrabbe-Köder",en="Recipe: Powdernose Crab Lure",fr="Recette : Appât pour Crabe poudreux",ru="Рецепт: Приманка для песконосого краба",icon="scroll4d",val=0,q=1,bop=true,Consumable=true,rss="Fishing",rsslvl=250},
["CFADDFF80301010101"] = {akey="I3F17D6CF07E883E8,78B8A3E8B4B2ECD7,,,,,,",de="Anleitung: Binnen-Oktopus-Köder",en="Recipe: Inland Octopus Lure",fr="Recette : Appât pour Pieuvre de rivière",ru="Рецепт: Приманка для озерных осьминогов",icon="scroll4d",val=0,q=1,bop=true,Consumable=true,rss="Fishing",rsslvl=100},
["D8EFEF900501010101"] = {akey="I521BF7D842AF559E,3E99D2EA460F2CC5,,,,,,",de="Anleitung: Wüsten-Meereskäfer-Köder",en="Recipe: Desert Seabug Lure",fr="Recette : Appât pour Isopode du désert",ru="Рецепт: Приманка для пустынного морского жука",icon="scroll4d",val=0,q=1,bop=true,Consumable=true,rss="Fishing",rsslvl=225},
["D0ADDFF80301010101"] = {akey="I3F17D6D05EDF0E21,85F232379999F208,,,,,,",de="Anleitung: Eisenschalen-Krabbe-Köder",en="Recipe: Ironshell Crab Lure",fr="Recette : Appât pour Crabe ferré",ru="Рецепт: Приманка для железнопанцирного краба",icon="scroll4d",val=0,q=1,bop=true,Consumable=true,rss="Fishing",rsslvl=130},
["96A89EE80F01010101"] = {akey="IFD07941668D75C21,33C52C66B1EE2409,,,,,,",de="Anleitung: Dämmeraalköder",en="Recipe: Dusken Eel Lure",fr="Recette : Appât pour Anguille de Brunante",ru="Рецепт: Приманка на даскенского угря",icon="scroll4d",val=0,q=1,bop=true,Consumable=true,rss="Fishing",rsslvl=365},
["D9EFEF900501010101"] = {akey="I521BF7D979E5CF1C,509C29FF516BF3EE,,,,,,",de="Anleitung: Sandnautilus-Köder",en="Recipe: Sand Nautilus Lure",fr="Recette : Appât pour Nautile des sables",ru="Рецепт: Приманка для песчаного наутилуса",icon="scroll4d",val=0,q=1,bop=true,Consumable=true,rss="Fishing",rsslvl=250},
["A3E1FAEF0F01010101"] = {akey="IFDFEB0A31FF59ADF,F3DC20752A49DF04,,,,,,",de="Anleitung: Verdrehter Köder",en="Recipe: Twisted Lure",fr="Recette : Appât altéré",ru="Рецепт: Приманка для искаженных",icon="scroll4d",val=0,q=3,Consumable=true,rss="Fishing",rsslvl=375},
["C5ADDFF80301010101"] = {akey="I3F17D6C53A17B8AF,1F51CCBF67575A80,,,,,,",de="Anleitung: Guppy mit normalen Augen-Köder",en="Recipe: Normal-Eyed Guppy Lure",fr="Recette : Appât pour Guppy",ru="Рецепт: Приманка для глазастой гуппи",icon="scroll4d",val=0,q=1,bop=true,Consumable=true,rss="Fishing",rsslvl=10},
["ADBEA0A10501010101"] = {akey="I54281F2D12F98F23,2C14806D4FBC6B77,,,,,,",de="Anleitung: Attraktor für Seltene Brevanische Artefakte",en="Recipe: Rare Brevanic Artifact Attractor",fr="Plan : Attracteur d'artefacts tynandrais rares",ru="Чертеж: Притягиватель редких бревайнских артефактов",icon="scroll4d",val=0,q=2,Consumable=true,rss="Fishing",rsslvl=375},
["D1ADDFF80301010101"] = {akey="I3F17D6D177944AD8,6B5909C5B8C6C08E,,,,,,",de="Anleitung: Roter Mangler-Köder",en="Recipe: Red Mangler Lure",fr="Recette : Appât pour Broyeur rouge",ru="Рецепт: Приманка для красного человеколова",icon="scroll4d",val=0,q=1,bop=true,Consumable=true,rss="Fishing",rsslvl=100},
["97A89EE80F01010101"] = {akey="IFD0794172ACD02FE,E773F95EDEF7E464,,,,,,",de="Anleitung: Verschleierter-Oktopusköder",en="Recipe: Veiled Octopus Lure",fr="Recette : Appât pour Pieuvre voilée",ru="Рецепт: Приманка на бахромчатого осьминога",icon="scroll4d",val=0,q=1,bop=true,Consumable=true,rss="Fishing",rsslvl=325},
["A3CEB2BC0401010101"] = {akey="I478CA7232B6B10DC,1BEF645627630E7C,,,,,,",de="Anleitung: Holzkiste",en="Recipe: Wood Crate",fr="Plan : Caisse en bois",ru="Чертеж: Деревянный ящик",icon="scroll4c",val=0,bop=true,Consumable=true,rss="Fishing",rsslvl=60},
["CEEFEF900501010101"] = {akey="I521BF7CE31B273E0,5FBD4EB77163901C,,,,,,",de="Anleitung: Mondpferd-Köder",en="Recipe: Moonhorse Lure",fr="Recette : Appât pour Hippocampe",ru="Рецепт: Приманка для лунного конька",icon="scroll4d",val=0,q=1,bop=true,Consumable=true,rss="Fishing",rsslvl=160},
["DAEFEF900501010101"] = {akey="I521BF7DA78C3202A,45BA50AA6191008F,,,,,,",de="Anleitung: Feuerbauch-Schnapper-Köder",en="Recipe: Firebelly Snapper Lure",fr="Recette : Appât pour Vivaneau ventre-rouge",ru="Рецепт: Приманка для огнебрюхого люциана",icon="scroll4d",val=0,q=1,bop=true,Consumable=true,rss="Fishing",rsslvl=225},
["C6ADDFF80301010101"] = {akey="I3F17D6C6247997FF,3153A086F2B39E5A,,,,,,",de="Anleitung: Tiefenmark-Aal-Köder",en="Recipe: Deep March Eel Lure",fr="Recette : Appât pour Anguille de la Marche des profondeurs",ru="Рецепт: Приманка для глубоководного шустрого угря",icon="scroll4d",val=0,q=1,bop=true,Consumable=true,rss="Fishing",rsslvl=30},
["D2ADDFF80301010101"] = {akey="I3F17D6D272B4F79E,7D5B60DAC42387B7,,,,,,",de="Anleitung: Stahlschuppen-Drescher-Köder",en="Recipe: Steelscale Thrasher Lure",fr="Recette : Appât pour Requin des gorges",ru="Рецепт: Приманка для стальношкурого молотильщика",icon="scroll4d",val=0,q=1,bop=true,Consumable=true,rss="Fishing",rsslvl=130},
["C0BCFEE50301010101"] = {akey="I3CBF9E407CFE2407,BA2AB658FA900214,,,,,,",de="Anleitung: Attraktor für seltene Artefakte",en="Recipe: Rare Artifact Attractor",fr="Recette : Attracteur d'artefacts rares",ru="Чертеж: притягиватель редких артефактов",icon="scroll4d",val=15000,q=3,bop=true,accBound=true,Consumable=true,rss="Fishing",rsslvl=300},
["A4CEB2BC0401010101"] = {akey="I478CA7246FCB3428,C4A27EF774882457,,,,,,",de="Anleitung: Alabaster-Amphore",en="Recipe: Alabaster Amphora",fr="Plan : Amphore d'albâtre",ru="Эскиз: Алебастровая амфора",icon="scroll4c",val=0,bop=true,Consumable=true,rss="Fishing",rsslvl=120},
["CFEFEF900501010101"] = {akey="I521BF7CF6880EBF0,4755DFF34CE00358,,,,,,",de="Anleitung: Grasland-Teichhüpfer-Köder",en="Recipe: Grassland Pondleaper Lure",fr="Recette : Appât pour Carpe des prairies",ru="Рецепт: Приманка для степного прудовика",icon="scroll4d",val=0,q=1,bop=true,Consumable=true,rss="Fishing",rsslvl=190},
["DBEFEF900501010101"] = {akey="I521BF7DB4B862933,74A0D8296824FEF2,,,,,,",de="Anleitung: Moorhüpfer-Köder",en="Recipe: Moorleaper Lure",fr="Recette : Appât pour Carpe de la lande",ru="Рецепт: Приманка для болотного прыгуна",icon="scroll4d",val=0,q=1,bop=true,Consumable=true,rss="Fishing",rsslvl=250},
["C7ADDFF80301010101"] = {akey="I3F17D6C745CC0006,68A567F1D9CCB38E,,,,,,",de="Anleitung: Silberwald-Engel-Köder",en="Recipe: Silverwood Angel Lure",fr="Recette : Appât pour Ange de Bois d'Argent",ru="Рецепт: Приманка для Ангела Серебристого Леса",icon="scroll4d",val=0,q=1,bop=true,Consumable=true,rss="Fishing",rsslvl=10},
["D3ADDFF80301010101"] = {akey="I3F17D6D31E6DB827,0C6F4C72F307A55A,,,,,,",de="Anleitung: Grünes Breitmaul-Köder",en="Recipe: Green Widemouth Lure",fr="Recette : Appât pour Perche truitée verte",ru="Рецепт: Приманка для зеленого широкопаста",icon="scroll4d",val=0,q=1,bop=true,Consumable=true,rss="Fishing",rsslvl=100},
["99A89EE80F01010101"] = {akey="IFD0794193B983BE8,FA9C0D679852442E,,,,,,",de="Anleitung: Smaragdfliegenfänger-Köder",en="Recipe: Emerald Flycatcher Lure",fr="Recette : Appât pour Attrape-mouches émeraude",ru="Рецепт: Приманка на изумрудного мухолова",icon="scroll4d",val=0,q=1,bop=true,Consumable=true,rss="Fishing",rsslvl=355},
["A5CEB2BC0401010101"] = {akey="I478CA72531FDFB48,D993C4D8DC5D9507,,,,,,",de="Anleitung: Fisch und Fass",en="Recipe: Fish and Barrel",fr="Plan : Poisson et tonneau",ru="Рецепт: Рыба в бочке",icon="scroll4c",val=0,bop=true,Consumable=true,rss="Fishing",rsslvl=180},
["D0EFEF900501010101"] = {akey="I521BF7D0051A4920,1491D8A34C6A65CA,,,,,,",de="Anleitung: Hochland-Aal-Köder",en="Recipe: Highlands Eel Lure",fr="Recette : Appât pour Anguille des Hautes-Terres",ru="Рецепт: Приманка для горного угря",icon="scroll4d",val=0,q=1,bop=true,Consumable=true,rss="Fishing",rsslvl=160},
["DCEFEF900501010101"] = {akey="I521BF7DC22A21059,1030425DFF94D87D,,,,,,",de="Anleitung: Bullen-Chamäleonfischköder",en="Recipe: Bull Chameleonfish Lure",fr="Recette : Appât pour Poisson-caméléon mâle",ru="Рецепт: Приманка для бычьей рыбы-хамелеона",icon="scroll4d",val=0,q=1,bop=true,Consumable=true,rss="Fishing",rsslvl=225},
["C8ADDFF80301010101"] = {akey="I3F17D6C8766059C6,7AA7BF06E5297AB7,,,,,,",de="Anleitung: Silberwald-Teufel-Köder",en="Recipe: Silverwood Devil Lure",fr="Recette : Appât pour Démon de Bois d'Argent",ru="Рецепт: Приманка для дьявола Серебристого Леса",icon="scroll4d",val=0,q=1,bop=true,Consumable=true,rss="Fishing",rsslvl=30},
["C49E82BF0501010101"] = {akey="I57E08F447E093304,241295B130879F4D,,,,,,",de="Anleitung: Zeitgesteuerter Trophäen-Köder",en="Recipe: Timed Trophy Lure",fr="Recette : Appât temporaire pour trophée de pêche",ru="Рецепт: испытанная трофейная приманка",icon="scroll4d",val=356,q=2,Consumable=true,rss="Fishing",rsslvl=180},
["D4ADDFF80301010101"] = {akey="I3F17D6D41864A45D,2D74E6FC11C705E9,,,,,,",de="Anleitung: Elektrischer Drachenfisch-Köder",en="Recipe: Electric Dragonfish Lure",fr="Recette : Appât pour Dragon-amphibie électrique",ru="Рецепт: Приманка для электрической рыбы-дракона",icon="scroll4d",val=0,q=1,bop=true,Consumable=true,rss="Fishing",rsslvl=130},
["9AA89EE80F01010101"] = {akey="IFD07941A40F47349,09AF75B0C735DE81,,,,,,",de="Anleitung: Sonnenpferdköder",en="Recipe: Sunhorse Lure",fr="Recette : Appât pour Destrier du soleil",ru="Рецепт: Приманка на солнечного конька",icon="scroll4d",val=0,q=1,bop=true,Consumable=true,rss="Fishing",rsslvl=315},
["A6CEB2BC0401010101"] = {akey="I478CA72637FDC861,E8A7B06F0B41B2AA,,,,,,",de="Anleitung: Seelandschaft-Amphore",en="Recipe: Seascape Amphora",fr="Plan : Amphore à décor marin",ru="Эскиз: Амфора с морским пейзажем",icon="scroll4c",val=0,bop=true,Consumable=true,rss="Fishing",rsslvl=240},
["D1EFEF900501010101"] = {akey="I521BF7D12DAE4EBA,26942FB857C72CF3,,,,,,",de="Anleitung: Walfisch-Köder",en="Recipe: Whalefish Lure",fr="Recette : Appât pour Poisson-baleine",ru="Рецепт: Приманка для китовой рыбы",icon="scroll4d",val=0,q=1,bop=true,Consumable=true,rss="Fishing",rsslvl=190},
["DDEFEF900501010101"] = {akey="I521BF7DD0E6D34EE,0AC4995F9709EF70,,,,,,",de="Anleitung: Stillmoor-Teufel-Köder",en="Recipe: Stillmoor Devil Lure",fr="Recette : Appât pour Démon de Mornelande",ru="Рецепт: Приманка для дьявола Тихих Топей",icon="scroll4d",val=0,q=1,bop=true,Consumable=true,rss="Fishing",rsslvl=250},
["C9ADDFF80301010101"] = {akey="I3F17D6C93709EE62,753C16087C9F14F8,,,,,,",de="Anleitung: Fächerschweif-Köder",en="Recipe: Fantail Lure",fr="Recette : Appât pour Queue d'éventail",ru="Рецепт: Приманка для веерохвоста",icon="scroll4d",val=0,q=1,bop=true,Consumable=true,rss="Fishing",rsslvl=50},
["D5ADDFF80301010101"] = {akey="I3F17D6D52C8717A1,19C33711C7F8E4FA,,,,,,",de="Anleitung: Wühlkrabben-Köder",en="Recipe: Burrowing Crab Lure",fr="Recette : Appât pour Crabe fouisseur",ru="Рецепт: Приманка для норного краба",icon="scroll4d",val=0,q=1,bop=true,Consumable=true,rss="Fishing",rsslvl=160},
["A7CEB2BC0401010101"] = {akey="I478CA72758F72F87,ECC897412EC9DBFF,,,,,,",de="Anleitung: Dory",en="Recipe: Dory",fr="Plan : Saint-pierre",ru="Рецепт: Солнечник",icon="scroll4c",val=0,bop=true,Consumable=true,rss="Fishing",rsslvl=300},
["D2EFEF900501010101"] = {akey="I521BF7D26EDC1922,69FA4BCC75C9AEB7,,,,,,",de="Anleitung: Ruhiger Plattfisch-Köder",en="Recipe: Serene Flatfish Lure",fr="Recette : Appât pour Poisson plat serein",ru="Рецепт: Приманка для спокойной камбалы",icon="scroll4d",val=0,q=1,bop=true,Consumable=true,rss="Fishing",rsslvl=160},
["DEEFEF900501010101"] = {akey="I521BF7DE10907B34,1CC6F074226739E8,,,,,,",de="Anleitung: Glut-Steinhaut-Köder",en="Recipe: Ember Stoneskin Lure",fr="Recette : Appât pour Peau de pierre embrasée",ru="Рецепт: Приманка для угольного камнекожа",icon="scroll4d",val=0,q=1,bop=true,Consumable=true,rss="Fishing",rsslvl=260},
["CAADDFF80301010101"] = {akey="I3F17D6CA111A6119,6D48A831E93D4E6E,,,,,,",de="Anleitung: Kaskadenfisch-Köder",en="Recipe: Cascadefish Lure",fr="Recette : Appât pour Poisson d'eau douce",ru="Рецепт: Приманка для каскадной рыбы",icon="scroll4d",val=0,q=1,bop=true,Consumable=true,rss="Fishing",rsslvl=70},
["90A89EE80F01010101"] = {akey="IFD079410478A688D,3EE74B5113CDC835,,,,,,",de="Anleitung: Krakenjungeköder",en="Recipe: Kraken Hatchling Lure",fr="Recette : Appât pour Jeune kraken",ru="Рецепт: Приманка на детеныша кракена",icon="scroll4d",val=0,q=1,bop=true,Consumable=true,rss="Fishing",rsslvl=365},
["D6ADDFF80301010101"] = {akey="I3F17D6D658406F3E,0EF3E45BA3DECB0B,,,,,,",de="Anleitung: Wüsten-Grünling-Köder",en="Recipe: Desert Greenling Lure",fr="Recette : Appât pour Rascasse verte du désert",ru="Рецепт: Приманка для пустынного терпуга",icon="scroll4d",val=0,q=1,bop=true,Consumable=true,rss="Fishing",rsslvl=190},
["B6A2E8870201010101"] = {akey="I20FA11361D22A033,DF4DED9F92063A7E,,,,,,",de="Anleitung: Beständiger Trophäenköder",en="Recipe: Enduring Trophy Lure",fr="Recette : Leurre de Trophée de pêche durable",ru="Рецепт: Приманка на выносливую добычу",icon="scroll4d",val=0,q=2,Consumable=true,rss="Fishing",rsslvl=350},
["D3EFEF900501010101"] = {akey="I521BF7D36A384D57,5B757803CBE06D1B,,,,,,",de="Anleitung: Eisbeißer-Köder",en="Recipe: Icebiter Lure",fr="Recette : Appât pour Morglace",ru="Рецепт: Приманка для ледового кусаки",icon="scroll4d",val=0,q=1,bop=true,Consumable=true,rss="Fishing",rsslvl=190},
}

nkItemBase.db.recipe.foraging={
["B892E8CE0301010101"] = {akey="I39DA093862E073FA,1098FA2078C7AD49,,,,,,",de="Anleitung: Kristallklares Destillat",en="Recipe: Pristine Distillate",fr="Recette : Distillat immaculé",ru="Рецепт: чистейший дистиллят",icon="scroll1",val=10000,q=1,bop=true,Consumable=true,rss="Foraging",rsslvl=260},
["9DCEB2BC0401010101"] = {akey="I478CA71D0A80E734,E83E934546ABAB68,,,,,,",de="Anleitung: Enokialgen",en="Recipe: Enoki Algae",fr="Recette : Algues d'Enoki",ru="Рецепт: Водоросли эноки",icon="scroll4c",val=0,bop=true,Consumable=true,rss="Foraging",rsslvl=300},
["C9D7D6970701010101"] = {akey="I72F5ABC90471947E,178943160F54547F,,,,,,",de="Anleitung: Poliertes Mahagoni-Nutzholz",en="Recipe: Polished Mahogany Lumber",fr="Plan : Planche d'acajou polie",ru="Чертеж: отполированные доски красного дерева",icon="scroll1",val=10000,q=1,bop=true,Consumable=true,rss="Foraging",rsslvl=115},
["CAD7D6970701010101"] = {akey="I72F5ABCA30B051FC,298B16DD9AB09859,,,,,,",de="Anleitung: Poliertes Runenbirken-Nutzholz",en="Recipe: Polished Runebirch Lumber",fr="Plan : Planche de rune-bouleau polie",ru="Чертеж: полированная древесина рунной березы",icon="scroll1",val=10000,q=1,bop=true,Consumable=true,rss="Foraging",rsslvl=185},
["CBD7D6970701010101"] = {akey="I72F5ABCB492E2FAE,0690E54956F495A6,,,,,,",de="Anleitung: Poliertes Schattendorn-Nutzholz",en="Recipe: Polished Shadethorn Lumber",fr="Plan : Planche d'ombrépine polie",ru="Чертеж: полированная древесина теневого терна",icon="scroll1",val=10000,q=1,bop=true,Consumable=true,rss="Foraging",rsslvl=280},
["99CEB2BC0401010101"] = {akey="I478CA7190A12DF59,E4937F7058CD8B2F,,,,,,",de="Anleitung: Gebüschskelett",en="Recipe: Dry Scrub",fr="Recette : Broussaille sèche",ru="Чертеж: Сухая щетка",icon="scroll4c",val=0,bop=true,Consumable=true,rss="Foraging",rsslvl=60},
["9ACEB2BC0401010101"] = {akey="I478CA71A40670BFD,FCC943649D98B791,,,,,,",de="Anleitung: Kleine Kiefer",en="Recipe: Little Pine",fr="Recette : Petit pin",ru="Эскиз: Маленькая сосна",icon="scroll4c",val=0,bop=true,Consumable=true,rss="Foraging",rsslvl=120},
["B692E8CE0301010101"] = {akey="I39DA0936255BA72E,FA7538EBC9E2397C,,,,,,",de="Anleitung: Mächtiges Destillat",en="Recipe: Potent Distillate",fr="Recette : Distillat puissant",ru="Рецепт: сильный дистиллят",icon="scroll1",val=10000,q=1,bop=true,Consumable=true,rss="Foraging",rsslvl=115},
["9BCEB2BC0401010101"] = {akey="I478CA71B3E92F4B6,ED1EA14907488589,,,,,,",de="Anleitung: Blaue Dschungelblumen",en="Recipe: Blue Jungle Flowers",fr="Recette : Fleurs bleues de la jungle",ru="Рецепт: Синие цветы джунглей",icon="scroll4c",val=0,bop=true,Consumable=true,rss="Foraging",rsslvl=180},
["B792E8CE0301010101"] = {akey="I39DA09371989F744,FBA7B43F10F1B94B,,,,,,",de="Anleitung: Reines Destillat",en="Recipe: Pure Distillate",fr="Recette : Distillat pur",ru="Рецепт: чистый дистиллят",icon="scroll1",val=10000,q=1,bop=true,Consumable=true,rss="Foraging",rsslvl=185},
["9CCEB2BC0401010101"] = {akey="I478CA71C776BDF0F,E8E27A1908C04F30,,,,,,",de="Anleitung: Rosa Bodenabdeckung",en="Recipe: Pink Ground Cover",fr="Recette : Couverture de sol rose",ru="Эскиз: Розовый газон",icon="scroll4c",val=0,bop=true,Consumable=true,rss="Foraging",rsslvl=240},
}

nkItemBase.db.recipe.weaponsmith={
["EB92E9FF0501010101"] = {akey="I5FFA496B198AF77E,58C10295D7D01DF6,,,,,,",de="Anleitung: Titan-Hellebarde",en="Recipe: Titanium Halberd",fr="Plan : Hallebarde en titane",ru="Чертеж: титановая алебарда",icon="scroll8b",val=0,q=1,bop=true,Consumable=true,rss="Light Weaponsmith",rsslvl=220},
["D0D7FFE50F01010101"] = {akey="IFCBFEBD016567DEF,41E39D0E5A833F7B,,,,,,",de="Anleitung: Große Verstärkung der Tücke",en="Recipe: Greater Treacherous Augment",fr="Recette : Augmentation de traîtrise supérieure",ru="Чертеж: Крепкое усиление предательства",icon="scroll8b",val=0,q=3,bop=true,Consumable=true,rss="Light Weaponsmith",rsslvl=300},
["B1A4FFEC0401010101"] = {akey="I4D9FD2316BB34CC5,721A7CF81A7EE2A8,,,,,,",de="Anleitung: Transportierbare Lebensquelle",en="Recipe: Portable Lifespring",fr="Plan : Source de vie portable",ru="Чертеж: портативный источник Жизни",icon="scroll1a",val=0,q=3,bop=true,Consumable=true,rss="Light Weaponsmith",rsslvl=260},
["9BF9AEAB0701010101"] = {akey="I756BBC9B71238EB6,48DF6159C994314C,,,,,,",de="Anleitung: Faust des Märtyrers",en="Recipe: Martyr's Fist",fr="Plan : Poing du martyr",ru="Чертеж: Кулак мученика",icon="scroll2a",val=0,q=3,bop=true,Consumable=true,rss="Light Weaponsmith",rsslvl=300},
["F2959FCB0401010101"] = {akey="I4967CAF24815D4EC,14E3F288EC588AA2,,,,,,",de="Anleitung: Schwindel",en="Recipe: Trickery",fr="Plan : Tromperie",ru="Рецепт: Хитрость",icon="scroll8b",val=0,q=2,bop=true,Consumable=true,rss="Light Weaponsmith",rsslvl=330},
["CC91DAFC0F01010101"] = {akey="IFF9688CC15657775,37602E835B281FC8,,,,,,",de="Anleitung: Tuthony-Kriegshammer",en="Recipe: Karthite Warhammer",fr="Plan : Marteau de guerre en tuthonie",ru="Чертеж: Картитовый боевой молот",icon="scroll8b",val=0,q=1,bop=true,Consumable=true,rss="Light Weaponsmith",rsslvl=330},
["D7B0FFAB0401010101"] = {akey="I457FD8570F8E5239,1D74C4DA6C2086A5,,,,,,",de="Anleitung: Verzauberter Schattendorn-Bogen",en="Recipe: Enchanted Shadethorn Bow",fr="Plan : Arc en ombrépine enchantée",ru="Чертеж: зачарованный лук теневого терна",icon="scroll1",val=0,q=2,bop=true,accBound=true,Consumable=true,rss="Light Weaponsmith",rsslvl=300,rf="The Keepers",rfl=3},
["FDD18BF70501010101"] = {akey="I5EE2E8FD3B7EA95E,4811333F3D96B310,,,,,,",de="Anleitung: Wegewachen-Langschwert",en="Recipe: Wayward Longsword",fr="Plan : Épée longue imprévisible",ru="Чертеж: своенравный меч",icon="scroll1",val=0,q=2,bop=true,accBound=true,Consumable=true,rss="Light Weaponsmith",rsslvl=100,rf="Gloamwood Waykeepers",rfl=2},
["E8B8F6F30F01010101"] = {akey="IFE7D9C685A039944,E104898DAD1DA238,,,,,,",de="Anleitung: Stellare Verstärkung der Abwendung",en="Recipe: Stellar Averting Augment",fr="Recette : Augmentation d'évitement stellaire",ru="Рецепт: Звездная выносливость и отражение",icon="scroll8b",val=0,q=3,bop=true,Consumable=true,rss="Light Weaponsmith",rsslvl=375},
["A7DDA6D50701010101"] = {akey="I7AA9AEA77B60210D,326E6099DB14234E,,,,,,",de="Anleitung: Rituelle Orichalcum-Klinge",en="Recipe: Orichalcum Ritual Blade",fr="Plan : Lame rituelle en orichalque",ru="Чертеж: ритуальный клинок из орихалка",icon="scroll9a",val=0,q=2,bop=true,Consumable=true,rss="Light Weaponsmith",rsslvl=290},
["82D589E30301010101"] = {akey="I3C626A825BDC4A71,F1DE2D2D33020CAE,,,,,,",de="Anleitung: Verbannungsklinge",en="Recipe: Banishing Blade",fr="Plan : Lame de bannissement",ru="Чертеж: изгоняющий клинок",icon="scroll1",val=0,q=2,bop=true,accBound=true,Consumable=true,rss="Light Weaponsmith",rsslvl=100,rf="Gloamwood Waykeepers",rfl=2},
["D38281E10601010101"] = {akey="I6C2041530950205D,84AACE25118C2A85,,,,,,",de="Anleitung: Stahlberührtes Langschwert",en="Recipe: Steeltouched Longsword",fr="Plan : Épée longue touchée par l'acier",ru="Чертеж: обработанный сталью меч",icon="scroll1",val=0,q=2,bop=true,accBound=true,Consumable=true,rss="Light Weaponsmith",rsslvl=100,rf="Granite Falls",rfl=2},
["F3C6BFFE0F01010101"] = {akey="IFFCFE3736DFCD2CD,3B1A5DF7A2AD2AB7,,,,,,",de="Anleitung: Zornige Rhenium-Axt",en="Recipe: Furious Rhenium Axe",fr="Plan : Hache furieuse en rhénium",ru="Чертеж: Яростный рениевый топор",icon="scroll8b",val=0,q=2,bop=true,accBound=true,Consumable=true,rss="Light Weaponsmith",rsslvl=370,rf="The Qaijiri",rfl=4},
["C8CCD8EE0701010101"] = {akey="I7DD626483F708D92,D370377CD7559245,,,,,,",de="Anleitung: Weghüter-Axt",en="Recipe: Waykeeper's Axe",fr="Plan : Hache de Garde-voie",ru="Чертеж: топор привратника",icon="scroll1",val=0,q=2,bop=true,accBound=true,Consumable=true,rss="Light Weaponsmith",rsslvl=90,rf="Gloamwood Waykeepers",rfl=2},
["F982F58E0101010101"] = {akey="I11DD41794DBD038F,DAED786BB45C54CA,,,,,,",de="Anleitung: Eisen-Klinge",en="Recipe: Iron Blade",fr="Plan : Lame en fer",ru="Чертеж: железный клинок",icon="scroll1",val=0,q=1,bop=true,Consumable=true,rss="Light Weaponsmith",rsslvl=90},
["91D4E8880701010101"] = {akey="I711A2A1108E6518D,CDD078F32FCBB16C,,,,,,",de="Anleitung: Kupfer-Hellebarde",en="Recipe: Copper Halberd",fr="Plan : Hallebarde en cuivre",ru="Чертеж: медная алебарда",icon="scroll4",val=0,q=1,bop=true,Consumable=true,rss="Light Weaponsmith",rsslvl=70},
["D1D7FFE50F01010101"] = {akey="IFCBFEBD12C24AEBC,2920D6C402D43197,,,,,,",de="Anleitung: Empyreum-Verstärkung der Tücke",en="Recipe: Empyrean Treacherous Augment",fr="Recette : Augmentation de traîtrise empyréenne",ru="Рецепт: Вероломное эмпирейское усиление",icon="scroll8b",val=0,q=2,bop=true,Consumable=true,rss="Light Weaponsmith",rsslvl=340},
["B6C4C1F60101010101"] = {akey="I1ED062360922CB6A,2AF18ABDF74330B7,,,,,,",de="Anleitung: Dunkelholz-Spalter",en="Recipe: Blackwood Cleaver",fr="Plan : Fendoir de Noir-bois",ru="Чертеж: колун черного дерева",icon="scroll1",val=0,q=2,bop=true,accBound=true,Consumable=true,rss="Light Weaponsmith",rsslvl=90,rf="Gloamwood Waykeepers",rfl=2},
["BBF58CD70F01010101"] = {akey="IFAE33ABB2DB630E2,1368C45892C16A53,,,,,,",de="Anleitung: Empyreum-Verstärkung der Gnadenlosigkeit",en="Recipe: Empyrean Ruthless Augment",fr="Recette : Augmentation de férocité empyréenne",ru="Рецепт: Беспощадное эмпирейское усиление",icon="scroll8b",val=0,q=2,bop=true,Consumable=true,rss="Light Weaponsmith",rsslvl=340},
["D59FFC9F0301010101"] = {akey="I33FF0FD559A6EBE9,808DAB7BEA3A8CA0,,,,,,",de="Anleitung: Eisen-Streitkolben",en="Recipe: Iron Mace",fr="Plan : Masse en fer",ru="Чертеж: железная булава",icon="scroll1",val=0,q=1,bop=true,Consumable=true,rss="Light Weaponsmith",rsslvl=80},
["E28B88940301010101"] = {akey="I328205E25CF3909B,F69B086F1F0F3AB5,,,,,,",de="Anleitung: Schuppenschneider",en="Recipe: Scalecutter",fr="Plan : Coupe-écailles",ru="Чертеж: рассекатель",icon="scroll9a",val=0,q=2,bop=true,accBound=true,Consumable=true,rss="Light Weaponsmith",rsslvl=300,rf="Dragonslayer Covenant",rfl=3},
["B2A4FFEC0401010101"] = {akey="I4D9FD2320D90A0A0,29D0DB0E7B0691E9,,,,,,",de="Anleitung: Transportierbares Geschütz",en="Recipe: Portable Turret",fr="Plan : Tourelle portable",ru="Чертеж: портативная огневая установка",icon="scroll1a",val=0,q=3,bop=true,Consumable=true,rss="Light Weaponsmith",rsslvl=260},
["F3959FCB0401010101"] = {akey="I4967CAF335E57642,6EFAD227CC235B19,,,,,,",de="Anleitung: Zorniges Tuthony-Messer",en="Recipe: Furious Karthite Shiv",fr="Plan : Surin furieux en tuthonie",ru="Чертеж: Яростный картитовый стилет",icon="scroll8b",val=0,q=2,bop=true,Consumable=true,rss="Light Weaponsmith",rsslvl=340},
["CD91DAFC0F01010101"] = {akey="IFF9688CD7426CC3C,2C7E552EEB4DAFB8,,,,,,",de="Anleitung: Tuthony-Streitaxt",en="Recipe: Karthite Battleaxe",fr="Plan : Hache de bataille en tuthonie",ru="Чертеж: Картитовый боевой топор",icon="scroll8b",val=0,q=1,bop=true,Consumable=true,rss="Light Weaponsmith",rsslvl=340},
["E7F09EC80501010101"] = {akey="I5907B8671E4E9733,F43A094FCFBBA727,,,,,,",de="Anleitung: Zauberjäger-Prügel",en="Recipe: Spellhunter Cudgel",fr="Plan : Gourdin chasse-sort",ru="Чертеж: дубинка колдуна-охотника",icon="scroll1",val=0,q=2,bop=true,accBound=true,Consumable=true,rss="Light Weaponsmith",rsslvl=120,rf="Red Scar Trackers",rfl=1},
["BDC8A7D60301010101"] = {akey="I3AC9E43D4BE53D2A,51D5A5569E11F927,,,,,,",de="Anleitung: Gewandtheit",en="Recipe: Finesse",fr="Plan : Finesse",ru="Рецепт: искусность",icon="scroll8b",val=0,q=2,bop=true,Consumable=true,rss="Light Weaponsmith",rsslvl=280},
["C2AE817701010101"] = {akey="I0EE05742251DFCEC,56FDE797518DDAC2,,,,,,",de="Anleitung: Schattenpiekser",en="Recipe: Shadepiercer",fr="Plan : Perce-ombre",ru="Чертеж: тенекол",icon="scroll9a",val=0,q=2,bop=true,accBound=true,Consumable=true,rss="Light Weaponsmith",rsslvl=300,rf="Dragonslayer Covenant",rfl=3},
["DCCD8C1C01010101"] = {akey="I038326DC50CEDF53,5B1FEC9474607F18,,,,,,",de="Anleitung: Zinn-Klinge",en="Recipe: Tin Blade",fr="Plan : Lame en fer-blanc",ru="Чертеж: оловянный кинжал",icon="scroll4",val=0,q=1,bop=true,Consumable=true,rss="Light Weaponsmith",rsslvl=10},
["ECF39EAF0401010101"] = {akey="I45E7B9EC4E9CA9A8,CAD1C851D47240E4,,,,,,",de="Anleitung: Jagdbogen",en="Recipe: Hunting Bow",fr="Plan : Arc de chasse",ru="Чертеж: охотничий лук",icon="scroll1",val=0,q=2,bop=true,accBound=true,Consumable=true,rss="Light Weaponsmith",rsslvl=50,rf="Quicksilver Scholars",rfl=2},
["80C7BFFE0F01010101"] = {akey="IFFCFE3806711BE6C,1757DD154E8EA9FA,,,,,,",de="Anleitung: Gehärtetes Rhenium-Langschwert",en="Recipe: Hardened Rhenium Longsword",fr="Plan : Épée longue endurcie en rhénium",ru="Чертеж: Крепкий рениевый длинный меч",icon="scroll8b",val=0,q=2,bop=true,Consumable=true,rss="Light Weaponsmith",rsslvl=375},
["B5D88CCC0701010101"] = {akey="I79832C3534A35F29,5D4BC6C09CA31D20,,,,,,",de="Anleitung: Schwert der Verdrehten Seelen",en="Recipe: Sword of Twisted Souls",fr="Plan : Épée des âmes tourmentées",ru="Чертеж: Меч Искаженных душ",icon="scroll8b",val=0,q=3,bop=true,Consumable=true,rss="Light Weaponsmith",rsslvl=375},
["958FA79F0301010101"] = {akey="I33E9C795363631AF,2DF536E97E3094C6,,,,,,",de="Anleitung: Carmintium-Hellebarde",en="Recipe: Carmintium Halberd",fr="Plan : Hallebarde en carmintium",ru="Чертеж: карминтиевая алебарда",icon="scroll9a",val=0,q=1,bop=true,Consumable=true,rss="Light Weaponsmith",rsslvl=260},
["D2D7FFE50F01010101"] = {akey="IFCBFEBD22BA2AC9D,58075E4389682FF9,,,,,,",de="Anleitung: Stellare Verstärkung der Tücke",en="Recipe: Stellar Treacherous Augment",fr="Recette : Augmentation de traîtrise stellaire",ru="Рецепт: Звездная ловкость и критический удар ближнего боя",icon="scroll8b",val=0,q=3,bop=true,Consumable=true,rss="Light Weaponsmith",rsslvl=375},
["BCF58CD70F01010101"] = {akey="IFAE33ABC0BC4C9D3,261CDBDBC6359109,,,,,,",de="Anleitung: Stellare Verstärkung der Gnadenlosigkeit",en="Recipe: Stellar Ruthless Augment",fr="Recette : Augmentation de férocité stellaire",ru="Рецепт: Звездный критический удар ближнего боя",icon="scroll8b",val=0,q=3,bop=true,Consumable=true,rss="Light Weaponsmith",rsslvl=375},
["A1E2B3D90501010101"] = {akey="I5B2CF1213573413C,2FB873D19F05B4AA,,,,,,",de="Anleitung: Kobalt-Streitkolben",en="Recipe: Cobalt Mace",fr="Plan : Masse en cobalt",ru="Чертеж: кобальтовая булава",icon="scroll8b",val=0,q=1,bop=true,Consumable=true,rss="Light Weaponsmith",rsslvl=150},
["F4959FCB0401010101"] = {akey="I4967CAF463E46C30,607681ACA23A197E,,,,,,",de="Anleitung: Verstärktes Tuthony-Zepter",en="Recipe: Reinforced Karthite Scepter",fr="Plan : Sceptre renforcé en tuthonie",ru="Чертеж: Усиленный картитовый скипетр",icon="scroll8b",val=10000,q=2,bop=true,Consumable=true,rss="Light Weaponsmith",rsslvl=340},
["AEDA801B01010101"] = {akey="I03602D2E2B9E0A62,70D78055F738FC71,,,,,,",de="Anleitung: Zauberzerberster",en="Recipe: Spellsmasher",fr="Plan : Brise-sorts",ru="Чертеж: сокрушитель заклинаний",icon="scroll9a",val=0,q=2,bop=true,accBound=true,Consumable=true,rss="Light Weaponsmith",rsslvl=300,rf="Icewatch",rfl=3},
["CE91DAFC0F01010101"] = {akey="IFF9688CE57824B9D,E945C9A3D9B5C89F,,,,,,",de="Anleitung: Tuthony-Schlagstock",en="Recipe: Karthite Truncheon",fr="Plan : Casse-tête en tuthonie",ru="Чертеж: Картитовая дубинка",icon="scroll8b",val=0,q=1,bop=true,Consumable=true,rss="Light Weaponsmith",rsslvl=350},
["BD9C918A0101010101"] = {akey="I11444E3D66C7480C,142F62BC3F960B78,,,,,,",de="Anleitung: Fallbewohner-Axt",en="Recipe: Fallsdweller Axe",fr="Plan : Hache de l'habitant des chutes",ru="Чертеж: топор жителя глубин",icon="scroll1",val=0,q=2,bop=true,accBound=true,Consumable=true,rss="Light Weaponsmith",rsslvl=90,rf="Granite Falls",rfl=2},
["CCBBA0BC0301010101"] = {akey="I37881DCC224DBE3A,AFA116CE17E367C1,,,,,,",de="Anleitung: Gehärteter Madrosa-Angriffsbogen",en="Recipe: Hardened Madrosa Striker",fr="Plan : Frappeur endurci en madrosa",ru="Чертеж: Крепкий меч Мадрозы",icon="scroll8b",val=0,q=3,bop=true,Consumable=true,rss="Light Weaponsmith",rsslvl=375},
["FF97ACC80501010101"] = {akey="I590B0BFF5DD25B4B,DA7349FD2B6E1326,,,,,,",de="Anleitung: Runengarde-Donnerbüchse",en="Recipe: Runeguard Blunderbuss",fr="Plan : Tromblon de la Garde runique",ru="Чертеж: мушкетон Рунной стражи",icon="scroll1",val=0,q=2,bop=true,accBound=true,Consumable=true,rss="Light Weaponsmith",rsslvl=180,rf="The Runeguard",rfl=1},
["F0A39B3301010101"] = {akey="I0666D1F05FF5AB19,08E1DB740F3C2CA4,,,,,,",de="Anleitung: Holzfäller-Axt",en="Recipe: Logger's Axe",fr="Plan : Hache de bûcheron",ru="Чертеж: топор дровосека",icon="scroll1",val=0,q=2,bop=true,accBound=true,Consumable=true,rss="Light Weaponsmith",rsslvl=120,rf="Iron Claw Trappers",rfl=1},
["D7BEC2FD0401010101"] = {akey="I4FB09F5709A1C8FE,AEB085B59D2B65BD,,,,,,",de="Anleitung: Zaubererdolch der Carcera",en="Recipe: Carceran Wizard's Dagger",fr="Plan : Dague du magicien de Carcera",ru="Чертеж: кинжал карцерского колдуна",icon="scroll8b",val=0,q=3,bop=true,Consumable=true,rss="Light Weaponsmith",rsslvl=300},
["C5C8FEF10F01010101"] = {akey="IFE3FA445408EB436,DA383CFE92CAC2CF,,,,,,",de="Anleitung: Größere Verstärkung der Gewandtheit",en="Recipe: Major Deft Augment",fr="Recette : Augmentation d'adresse majeure",ru="Чертеж: Большое усиление коварства",icon="scroll8b",val=0,q=2,bop=true,Consumable=true,rss="Light Weaponsmith",rsslvl=300},
["81C7BFFE0F01010101"] = {akey="IFFCFE3814ED45EC7,295A342A59EB7123,,,,,,",de="Anleitung: Verrat",en="Recipe: Deceit",fr="Plan : Fourberie",ru="Рецепт: Лживость",icon="scroll8b",val=0,q=2,bop=true,Consumable=true,rss="Light Weaponsmith",rsslvl=375},
["A0DCF6C50501010101"] = {akey="I58BDAE2028570C41,08BA2789E81E8498,,,,,,",de="Anleitung: Eisen-Hellebarde",en="Recipe: Iron Halberd",fr="Plan : Hallebarde en fer",ru="Чертеж: железная алебарда",icon="scroll1",val=0,q=1,bop=true,Consumable=true,rss="Light Weaponsmith",rsslvl=110},
["B6D88CCC0701010101"] = {akey="I79832C365EA0AE30,2E92CFCAA27A3CB8,,,,,,",de="Anleitung: Bogen der Verdrehten Seelen",en="Recipe: Bow of Twisted Souls",fr="Patron : Arc des âmes tourmentées",ru="Чертеж: Лук Искаженных душ",icon="scroll8b",val=0,q=3,bop=true,Consumable=true,rss="Light Weaponsmith",rsslvl=375},
["AFA6AC820201010101"] = {akey="I204B132F70EE8B62,499133069447E151,,,,,,",de="Anleitung: Lichtschmetterer",en="Recipe: Lightsmasher",fr="Plan : Écrase-lumière",ru="Чертеж: уничтожитель света",icon="scroll8b",val=1,q=3,Consumable=true,rss="Light Weaponsmith",rsslvl=300},
["E9959FCB0401010101"] = {akey="I4967CAE909514FD9,15947E4CFEC7C8C3,,,,,,",de="Anleitung: Zorniger Linden-Bogen",en="Recipe: Furious Linden Archbow",fr="Plan : Arc furieux en tilleul",ru="Чертеж: Яростный липовый кривой лук",icon="scroll8b",val=10000,q=2,bop=true,Consumable=true,rss="Light Weaponsmith",rsslvl=310},
["AABBD2800401010101"] = {akey="I40149DAA7D1579C4,E8E2F176BB8D7339,,,,,,",de="Anleitung: Steinspalter",en="Recipe: Stonecleaver",fr="Plan : Tranchepierre",ru="Чертеж: камнекол",icon="scroll1",val=0,q=2,bop=true,accBound=true,Consumable=true,rss="Light Weaponsmith",rsslvl=90,rf="Granite Falls",rfl=2},
["F5959FCB0401010101"] = {akey="I4967CAF5222647A3,50CC62DF8BE9E775,,,,,,",de="Anleitung: Bewehrter Ulmen-Bogen",en="Recipe: Fortified Elm Archbow",fr="Plan : Arc fortifié en orme",ru="Чертеж: Усиленный кривой лук из вяза",icon="scroll8b",val=0,q=2,bop=true,Consumable=true,rss="Light Weaponsmith",rsslvl=350},
["CF91DAFC0F01010101"] = {akey="IFF9688CF417CB4BD,EB2A0565C8DC24AC,,,,,,",de="Anleitung: Tuthony-Streitkolben",en="Recipe: Karthite Mace",fr="Plan : Masse en tuthonie",ru="Чертеж: Картитовая булава",icon="scroll8b",val=0,q=1,bop=true,Consumable=true,rss="Light Weaponsmith",rsslvl=350},
["E5B5CB5601010101"] = {akey="I0AD2DAE5198EA194,15F217DB2BF979AC,,,,,,",de="Anleitung: Damast-Kriegshammer",en="Recipe: Damascus Warhammer",fr="Plan : Marteau de guerre en acier damassé",ru="Чертеж: дамасский боевой молот",icon="scroll1",val=0,q=2,bop=true,Consumable=true,rss="Light Weaponsmith",rsslvl=150},
["B8AEFFB70501010101"] = {akey="I56FFD738726207FD,15A4E8171820B3BC,,,,,,",de="Anleitung: Chromit-Muskete",en="Recipe: Chromite Musket",fr="Plan : Mousquet en chromite",ru="Чертеж: хромитовый мушкет",icon="scroll1",val=0,q=1,bop=true,Consumable=true,rss="Light Weaponsmith",rsslvl=150},
["C7ABF58C0301010101"] = {akey="I319D55C7754FBCEA,C4AE86D2C92B9F8B,,,,,,",de="Anleitung: Orichalcum-Claymore",en="Recipe: Orichalcum Claymore",fr="Plan : Claymore en orichalque",ru="Чертеж: орихалковый клеймор",icon="scroll9a",val=0,q=2,bop=true,Consumable=true,rss="Light Weaponsmith",rsslvl=290},
["94FBF48F0701010101"] = {akey="I71FD3D94580BD3BB,4A2A35BB98A4204C,,,,,,",de="Anleitung: Heiligen-Zepter",en="Recipe: Saint's Scepter",fr="Plan : Sceptre de saint",ru="Чертеж: скипетр святого",icon="scroll2a",val=0,q=3,bop=true,Consumable=true,rss="Light Weaponsmith",rsslvl=300},
["F6C6BFFE0F01010101"] = {akey="IFFCFE3765863C69B,71216336C4C38032,,,,,,",de="Anleitung: Grausame Rhenium-Hellebarde",en="Recipe: Vicious Rhenium Halberd",fr="Plan : Hallebarde vicieuse en rhénium",ru="Чертеж: Рениевая алебарда злобы",icon="scroll8b",val=1,q=2,Consumable=true,rss="Light Weaponsmith",rsslvl=375},
["D8BEC2FD0401010101"] = {akey="I4FB09F584E492770,C27CBC3C27A44E85,,,,,,",de="Anleitung: Berserkeraxt der Carcera",en="Recipe: Carceran Berzerker Axe",fr="Plan : Hache du berserker de Carcera",ru="Чертеж: карцерский топор берсерка",icon="scroll8b",val=0,q=3,bop=true,Consumable=true,rss="Light Weaponsmith",rsslvl=300},
["C6C8FEF10F01010101"] = {akey="IFE3FA4464EC75488,DE59A71EB65268D6,,,,,,",de="Anleitung: Große Verstärkung der Gewandtheit",en="Recipe: Greater Deft Augment",fr="Recette : Augmentation d'adresse supérieure",ru="Чертеж: Крепкое усиление проворства",icon="scroll8b",val=0,q=3,bop=true,Consumable=true,rss="Light Weaponsmith",rsslvl=300},
["ABA6AEF90101010101"] = {akey="I1F2B932B69C272B1,C741D8BE2263C625,,,,,,",de="Anleitung: Gehärteter Orichalcum-Streitkolben",en="Recipe: Tempered Orichalcum Mace",fr="Plan : Massue en orichalque durci",ru="Чертеж: закаленная орихалковая булава",icon="scroll1",val=0,q=2,bop=true,accBound=true,Consumable=true,rss="Light Weaponsmith",rsslvl=300,rf="The Farclan",rfl=3},
["A5CADA4E01010101"] = {akey="I09D6A52543C7CFEC,C8A92F65A2EDEBCB,,,,,,",de="Anleitung: Geist-Signalfeuer",en="Recipe: Spirit Beacon",fr="Plan : Balise spirituelle",ru="Чертеж: маяк для духов",icon="scroll8b",val=0,q=3,bop=true,Consumable=true,rss="Light Weaponsmith",rsslvl=300},
["B495C6D40101010101"] = {akey="I1A918AB448AEED0E,B1F7037CBACFB2DA,,,,,,",de="Anleitung: Carmintium-Streitkolben",en="Recipe: Carmintium Mace",fr="Plan : Masse en carmintium",ru="Чертеж: карминтиевая булава",icon="scroll9a",val=0,q=1,bop=true,Consumable=true,rss="Light Weaponsmith",rsslvl=230},
["B7D88CCC0701010101"] = {akey="I79832C3715D727AF,32B439EAC602660D,,,,,,",de="Anleitung: Stilett der Verdrehten Seelen",en="Recipe: Stiletto of Twisted Souls",fr="Patron : Stylet des âmes tourmentées",ru="Чертеж: Стилет Искаженных душ",icon="scroll8b",val=0,q=3,bop=true,Consumable=true,rss="Light Weaponsmith",rsslvl=375},
["B0A6AC820201010101"] = {akey="I204B1330676F828E,6D8B7F6805D8AF56,,,,,,",de="Anleitung: Funkenschläger",en="Recipe: Spark Smiter",fr="Plan : Provocateur d'étincelle",ru="Чертеж: сокрушитель искр",icon="scroll8b",val=1,q=2,Consumable=true,rss="Light Weaponsmith",rsslvl=300},
["EA959FCB0401010101"] = {akey="I4967CAEA22250029,8AB2A4F68EED58B1,,,,,,",de="Anleitung: Bewehrte Gantimit-Donnerbüchse",en="Recipe: Fortified Gantimite Blunderbuss",fr="Plan : Tromblon fortifié en gantimite",ru="Чертеж: Усиленный гантимитовый мушкетон",icon="scroll8b",val=1,q=2,Consumable=true,rss="Light Weaponsmith",rsslvl=310},
["C3E4B5FC0701010101"] = {akey="I7F8D724320EBD6B7,007F8ECA311BD969,,,,,,",de="Anleitung: Baustein: Metallplanke",en="Recipe: Building Block: Metal Plank",fr="Plan : Bloc de construction : planche métallique",ru="Чертеж: Стройматериал: Металлическая планка",icon="scroll4c",val=0,bop=true,Consumable=true,rss="Light Weaponsmith",rsslvl=60},
["BEF58CD70F01010101"] = {akey="IFAE33ABE218846F6,C09FF3025AE40EF0,,,,,,",de="Anleitung: Empyreum-Verstärkung der Gewandtheit",en="Recipe: Empyrean Deft Augment",fr="Recette : Augmentation d'adresse empyréenne",ru="Рецепт: Эмпирейское усиление парирования",icon="scroll8b",val=0,q=2,bop=true,Consumable=true,rss="Light Weaponsmith",rsslvl=340},
["A9968F810501010101"] = {akey="I5023CB290A8866D6,2DD7C0226A6A675D,,,,,,",de="Anleitung: Blutmond-Scharfschütze",en="Recipe: Bloodmoon Sniper",fr="Plan : Arc de précision de Lune de sang",ru="Чертеж: лук кровавой луны",icon="scroll1",val=0,q=2,bop=true,accBound=true,Consumable=true,rss="Light Weaponsmith",rsslvl=90,rf="Gloamwood Waykeepers",rfl=2},
["F6959FCB0401010101"] = {akey="I4967CAF6554E744A,4410AF9052125EF4,,,,,,",de="Anleitung: Grausamer Ulmen-Angriffsbogen",en="Recipe: Vicious Elm Striker",fr="Plan : Frappeur vicieux en orme",ru="Чертеж: Злобный вязовый кусач",icon="scroll8b",val=1,q=2,Consumable=true,rss="Light Weaponsmith",rsslvl=350},
["B7C687E00F01010101"] = {akey="IFC01E33722A31B59,2D2FFC685E20DA45,,,,,,",de="Anleitung: Größere Verstärkung der Scharfsinnigkeit",en="Recipe: Major Keen Augment",fr="Recette : Augmentation d'intensité majeure",ru="Чертеж: Большое усиление резкости",icon="scroll8b",val=0,q=2,bop=true,Consumable=true,rss="Light Weaponsmith",rsslvl=300},
["CFB4E8CB0401010101"] = {akey="I497A1A4F21852CE8,F52B382A52ED8218,,,,,,",de="Anleitung: Kobalt-Muskete",en="Recipe: Cobalt Musket",fr="Plan : Mousquet en cobalt",ru="Чертеж: кобальтовый мушкет",icon="scroll8b",val=0,q=1,bop=true,Consumable=true,rss="Light Weaponsmith",rsslvl=180},
["CEBBA0BC0301010101"] = {akey="I37881DCE1D489300,C8AA12A14EB84B95,,,,,,",de="Anleitung: Geübte Täuschung",en="Recipe: Practiced Deception",fr="Plan : Tromperie chevronnée",ru="Рецепт: Мастерский обман",icon="scroll8b",val=0,q=3,bop=true,Consumable=true,rss="Light Weaponsmith",rsslvl=375},
["F7C6BFFE0F01010101"] = {akey="IFFCFE37778DF17FC,0323BA4C5020475C,,,,,,",de="Anleitung: Grausames Rhenium-Beil",en="Recipe: Vicious Rhenium Hatchet",fr="Plan : Hachette vicieuse en rhénium",ru="Чертеж: Рениевый топорик злобы",icon="scroll8b",val=0,q=2,bop=true,Consumable=true,rss="Light Weaponsmith",rsslvl=370},
["D9BEC2FD0401010101"] = {akey="I4FB09F593DE558C4,D47F1351330115AE,,,,,,",de="Anleitung: Parierklinge der Carcera",en="Recipe: Carceran Parrying Blade",fr="Plan : Lame de parade de Carcera",ru="Чертеж: карцерский клинок фехтовальщика",icon="scroll8b",val=0,q=3,bop=true,Consumable=true,rss="Light Weaponsmith",rsslvl=300},
["E6DFCC1A01010101"] = {akey="I03532FE655AAE3BA,D33F3F98ADC5A28A,,,,,,",de="Anleitung: Chromit-Streitkolben",en="Recipe: Chromite Mace",fr="Plan : Masse en chromite",ru="Чертеж: хромитовая булава",icon="scroll1",val=0,q=1,bop=true,Consumable=true,rss="Light Weaponsmith",rsslvl=120},
["B2A2EDEB0701010101"] = {akey="I7D7B513234B83B40,5906743D48E240CA,,,,,,",de="Anleitung: Steinbewahrer-Jagdbogen",en="Recipe: Stonewarden Hunting Bow",fr="Plan : Arc de chasse de Garde de pierre",ru="Чертеж: охотничий лук каменного смотрителя",icon="scroll1",val=0,q=2,bop=true,accBound=true,Consumable=true,rss="Light Weaponsmith",rsslvl=90,rf="Granite Falls",rfl=2},
["8DC09FDD0401010101"] = {akey="I4BA7E00D5D576278,328A2F1899B35B08,,,,,,",de="Anleitung: Damast-Säbel",en="Recipe: Damascus Saber",fr="Plan : Sabre en acier damassé",ru="Чертеж: дамасская сабля",icon="scroll1",val=0,q=2,bop=true,Consumable=true,rss="Light Weaponsmith",rsslvl=150},
["B8D88CCC0701010101"] = {akey="I79832C382513F630,395F1B21C6307C83,,,,,,",de="Anleitung: Taktischer Vorteil",en="Recipe: Tactical Advantage",fr="Plan : Avantage tactique",ru="Схема: Тактическое превосходство",icon="scroll8b",val=0,q=3,bop=true,Consumable=true,rss="Light Weaponsmith",rsslvl=375},
["B1A6AC820201010101"] = {akey="I204B13310D3F49DF,1C7206E88C6CADB8,,,,,,",de="Anleitung: Gleichgültige Klinge",en="Recipe: Callous Blade",fr="Plan : Lame monstrueuse",ru="Чертеж: жестокий клинок",icon="scroll8b",val=1,q=2,Consumable=true,rss="Light Weaponsmith",rsslvl=300},
["EB959FCB0401010101"] = {akey="I4967CAEB32957F32,2D84D7CD5E97EA84,,,,,,",de="Anleitung: Grausame Gantimit-Pike",en="Recipe: Vicious Gantimite Pike",fr="Plan : Pique vicieuse en gantimite",ru="Чертеж: Гантимитовая пика злобы",icon="scroll8b",val=0,q=2,bop=true,Consumable=true,rss="Light Weaponsmith",rsslvl=320},
["C4E4B5FC0701010101"] = {akey="I7F8D724466911511,1CC05BAE6A3E6CDB,,,,,,",de="Anleitung: Baustein: Metallwürfel",en="Recipe: Building Block: Metal Cube",fr="Plan : Bloc de construction : cube métallique",ru="Чертеж: Стройматериал: Металлический куб",icon="scroll4c",val=0,bop=true,Consumable=true,rss="Light Weaponsmith",rsslvl=120},
["D584F07C01010101"] = {akey="I0F9C0255130CDB2E,A812BD2EEC329537,,,,,,",de="Anleitung: Fleischreißer",en="Recipe: Fleshreaper",fr="Plan : Décharneuse",ru="Чертеж: жнец плоти",icon="scroll2a",val=0,q=3,bop=true,Consumable=true,rss="Light Weaponsmith",rsslvl=300},
["BFF58CD70F01010101"] = {akey="IFAE33ABF39B55846,D2A24A176640D619,,,,,,",de="Anleitung: Stellare Verstärkung der Gewandtheit",en="Recipe: Stellar Deft Augment",fr="Recette : Augmentation d'adresse stellaire",ru="Рецепт: Звездное парирование",icon="scroll8b",val=0,q=3,bop=true,Consumable=true,rss="Light Weaponsmith",rsslvl=375},
["F7959FCB0401010101"] = {akey="I4967CAF72BDB0E53,6C013A7348AFC4E9,,,,,,",de="Anleitung: Zornige Tuthony-Donnerbüchse",en="Recipe: Furious Karthite Blunderbuss",fr="Plan : Tromblon furieux en tuthonie",ru="Чертеж: Яростный картитовый мушкетон",icon="scroll8b",val=0,q=2,bop=true,Consumable=true,rss="Light Weaponsmith",rsslvl=350},
["B8C687E00F01010101"] = {akey="IFC01E3384AE9918C,3151668881A9039A,,,,,,",de="Anleitung: Große Verstärkung der Scharfsinnigkeit",en="Recipe: Greater Keen Augment",fr="Recette : Augmentation d'intensité supérieure",ru="Чертеж: Крепкое усиление резкости",icon="scroll8b",val=0,q=3,bop=true,Consumable=true,rss="Light Weaponsmith",rsslvl=300},
["E8FBB8DC0101010101"] = {akey="I1B8E3DE805E08F77,F37BBE9F5A192A9A,,,,,,",de="Anleitung: Kobalt-Klinge",en="Recipe: Cobalt Blade",fr="Plan : Lame en cobalt",ru="Чертеж: кобальтовый клинок",icon="scroll8b",val=0,q=1,bop=true,Consumable=true,rss="Light Weaponsmith",rsslvl=160},
["BDF8D3CC0201010101"] = {akey="I2994FC3D017C6C79,1B3ADC2EDAB9491C,,,,,,",de="Anleitung: Dunkelmetall-Streitaxt",en="Recipe: Darkmetal Battleaxe",fr="Plan : Hache de bataille en sombracier",ru="Чертеж: боевой топор темного металла",icon="scroll8b",val=0,q=2,bop=true,Consumable=true,rss="Light Weaponsmith",rsslvl=185},
["F8C6BFFE0F01010101"] = {akey="IFFCFE378040ACD8E,1D32D4ECDEE88C2E,,,,,,",de="Anleitung: Zorniger Rhenium-Dolch",en="Recipe: Furious Rhenium Dagger",fr="Plan : Dague furieuse en rhénium",ru="Чертеж: Яростный рениевый кинжал",icon="scroll8b",val=30000,q=2,bop=true,Consumable=true,rss="Light Weaponsmith",rsslvl=375},
["DABEC2FD0401010101"] = {akey="I4FB09F5A043E4993,C7C3E350F9298D2D,,,,,,",de="Anleitung: Kriegsgurt der Carcera",en="Recipe: Carceran War Flange",fr="Plan : Masse d'arme de Carcera",ru="Чертеж: карцерская боевая чесалка",icon="scroll8b",val=0,q=3,bop=true,Consumable=true,rss="Light Weaponsmith",rsslvl=300},
["C1C4F3D90501010101"] = {akey="I5B3CE241A8670751,DBD3126966517900,,,,,,",de="Anleitung: Wahrnehmung",en="Recipe: Perception",fr="Plan : Perception",ru="Рецепт: восприятие",icon="scroll8b",val=0,q=3,bop=true,Consumable=true,rss="Light Weaponsmith",rsslvl=300},
["D0E6EA0E01010101"] = {akey="I01DAB35069B8AAF1,2EC427EDA8C30B18,,,,,,",de="Anleitung: Gelehrtendolch",en="Recipe: Scholar's Dagger",fr="Plan : Dague de l'Érudit",ru="Чертеж: кинжал ученого",icon="scroll1",val=0,q=2,bop=true,accBound=true,Consumable=true,rss="Light Weaponsmith",rsslvl=60,rf="Quicksilver Scholars",rfl=2},
["B2A6AC820201010101"] = {akey="I204B13327E6CD7D5,11902D931C923DA8,,,,,,",de="Anleitung: Stacheliger Kompositbogen",en="Recipe: Spined Compound Bow",fr="Plan : Arc composite renforcé",ru="Чертеж: упрочненный блочный лук",icon="scroll8b",val=1,q=2,Consumable=true,rss="Light Weaponsmith",rsslvl=300},
["EC959FCB0401010101"] = {akey="I4967CAEC4B239F39,3F872EE2E9F42E5E,,,,,,",de="Anleitung: Unbarmherziger Gantimit-Spalthammer",en="Recipe: Callous Gantimite Maul",fr="Plan : Merlin monstrueux en gantimite",ru="Чертеж: Грубая гантимитовая булава",icon="scroll8b",val=1,q=2,Consumable=true,rss="Light Weaponsmith",rsslvl=320},
["C5E4B5FC0701010101"] = {akey="I7F8D724576F4E3BD,24843CF447D567BB,,,,,,",de="Anleitung: Baustein: Metallplatte",en="Recipe: Building Block: Metal Tile",fr="Plan : Bloc de construction : carreau métallique",ru="Чертеж: Стройматериал: Металлическая черепица",icon="scroll4c",val=0,bop=true,Consumable=true,rss="Light Weaponsmith",rsslvl=180},
["C0F0A78B0701010101"] = {akey="I7169F8400DC949B6,0A768D9B90CDBFB3,,,,,,",de="Anleitung: Eisen-Muskete",en="Recipe: Iron Musket",fr="Plan : Mousquet en fer",ru="Чертеж: железный мушкет",icon="scroll1",val=0,q=1,bop=true,Consumable=true,rss="Light Weaponsmith",rsslvl=110},
["BAA08FDA0301010101"] = {akey="I3B43D03A00F1FE52,DE10E00D929E259F,,,,,,",de="Anleitung: Chromit-Klinge",en="Recipe: Chromite Blade",fr="Plan : Lame en chromite",ru="Чертеж: хромитовый меч",icon="scroll1",val=0,q=1,bop=true,Consumable=true,rss="Light Weaponsmith",rsslvl=130},
["F8959FCB0401010101"] = {akey="I4967CAF818F46A72,17A343E0724D844C,,,,,,",de="Anleitung: Gehärtete Tuthony-Kanone",en="Recipe: Hardened Karthite Cannon",fr="Plan : Canon endurci en karthite",ru="Чертеж: Крепкая картитовая пушка",icon="scroll8b",val=10000,q=2,bop=true,Consumable=true,rss="Light Weaponsmith",rsslvl=350},
["B9C687E00F01010101"] = {akey="IFC01E33923BD78CD,C353BD9E8D05CAC3,,,,,,",de="Anleitung: Empyreum-Verstärkung der Scharfsinnigkeit",en="Recipe: Empyrean Keen Augment",fr="Recette : Augmentation d'intensité empyréenne",ru="Рецепт: Острое эмпирейское усиление",icon="scroll8b",val=0,q=2,bop=true,Consumable=true,rss="Light Weaponsmith",rsslvl=340},
["F9C6BFFE0F01010101"] = {akey="IFFCFE3795EE86DAD,4F0A967177747FDD,,,,,,",de="Anleitung: Leuchtendes Rhenium-Stilett",en="Recipe: Luminous Rhenium Stiletto",fr="Plan : Stylet lumineux en rhénium",ru="Чертеж: Искристый рениевый стилет",icon="scroll8b",val=30000,q=2,bop=true,Consumable=true,rss="Light Weaponsmith",rsslvl=375},
["C3899FCB0201010101"] = {akey="I2967C4C34199CBFC,1CBB3AEDE0C182A3,,,,,,",de="Anleitung: Chromit-Hellebarde",en="Recipe: Chromite Halberd",fr="Plan : Hallebarde en chromite",ru="Чертеж: хромитовая алебарда",icon="scroll1",val=0,q=1,bop=true,Consumable=true,rss="Light Weaponsmith",rsslvl=150},
["86CCA0DA0601010101"] = {akey="I6B482606691A9354,E49375310D0692BE,,,,,,",de="Anleitung: Carmintium-Klinge",en="Recipe: Carmintium Blade",fr="Plan : Lame en carmintium",ru="Чертеж: карминтиевый клинок",icon="scroll9a",val=0,q=1,bop=true,Consumable=true,rss="Light Weaponsmith",rsslvl=240},
["B3A6AC820201010101"] = {akey="I204B13330A45B88C,3295C81D3B519E37,,,,,,",de="Anleitung: Gnadenlose Klinge",en="Recipe: Merciless Blade",fr="Plan : Machette impitoyable",ru="Чертеж: беспощадный клинок",icon="scroll8b",val=1,q=2,Consumable=true,rss="Light Weaponsmith",rsslvl=300},
["ED959FCB0401010101"] = {akey="I4967CAED2E64DF4B,750BDAB3A022124F,,,,,,",de="Anleitung: Grausames Gantimit-Beil",en="Recipe: Vicious Gantimite Hatchet",fr="Plan : Hachette vicieuse en gantimite",ru="Чертеж: Гантимитовый топорик злобы",icon="scroll8b",val=1,q=2,Consumable=true,rss="Light Weaponsmith",rsslvl=330},
["C6E4B5FC0701010101"] = {akey="I7F8D7246324D854B,2EDD0F13E5A56E72,,,,,,",de="Anleitung: Baustein: Metallrechteck",en="Recipe: Building Block: Metal Rectangle",fr="Plan : Bloc de construction : rectangle métallique",ru="Чертеж: Стройматериал: Металлическая плитка",icon="scroll4c",val=0,bop=true,Consumable=true,rss="Light Weaponsmith",rsslvl=240},
["8BACB7CB0201010101"] = {akey="I296DD60B41D1D80B,EA9CF6897265BD5A,,,,,,",de="Anleitung: Titan-Muskete",en="Recipe: Titanium Musket",fr="Plan : Mousquet en titane",ru="Чертеж: титановый мушкет",icon="scroll8b",val=0,q=1,bop=true,Consumable=true,rss="Light Weaponsmith",rsslvl=220},
["AAA8C2850401010101"] = {akey="I40B0942A3E4BF3D0,41DCA24905864CC3,,,,,,",de="Anleitung: Holzfäller-Axt",en="Recipe: Logger's Axe",fr="Plan : Hache de bûcheron",ru="Чертеж: топор дровосека",icon="scroll1",val=0,q=2,bop=true,accBound=true,Consumable=true,rss="Light Weaponsmith",rsslvl=120,rf="Red Scar Trackers",rfl=1},
["BAEEFD4301010101"] = {akey="I087F773A1A4F9229,F4E4BCB9BE9A204C,,,,,,",de="Anleitung: Ebenholz-Spalthammer",en="Recipe: Ebony Maul",fr="Plan : Merlin en ébène",ru="Чертеж: черный молот",icon="scroll8b",val=0,q=2,bop=true,Consumable=true,rss="Light Weaponsmith",rsslvl=225},
["C7B5C7E40701010101"] = {akey="I7C91DAC77517A2F2,1AB95FB4E4C111A1,,,,,,",de="Anleitung: Zauberjäger-Prügel",en="Recipe: Spellhunter Cudgel",fr="Plan : Gourdin chasse-sort",ru="Чертеж: дубинка колдуна-охотника",icon="scroll1",val=0,q=2,bop=true,accBound=true,Consumable=true,rss="Light Weaponsmith",rsslvl=120,rf="Iron Claw Trappers",rfl=1},
["F6EED35801010101"] = {akey="I0B14F776706283DE,012DF2C6F65F4BCB,,,,,,",de="Anleitung: Schattendorn-Bogen",en="Recipe: Shadethorn Bow",fr="Plan : Arc en ombrépine",ru="Чертеж: лук теневого терна",icon="scroll9a",val=0,q=2,bop=true,Consumable=true,rss="Light Weaponsmith",rsslvl=270},
["F9959FCB0401010101"] = {akey="I4967CAF968F9457C,5B095FF490500610,,,,,,",de="Anleitung: Leuchtender Tuthony-Zauberbrecher",en="Recipe: Luminous Karthite Spellcutter",fr="Plan : Coupe-sort lumineux en tuthonie",ru="Чертеж: Искристый картитовый чароруб",icon="scroll8b",val=1,q=2,Consumable=true,rss="Light Weaponsmith",rsslvl=360},
["BAC687E00F01010101"] = {akey="IFC01E33A15FBCBA0,D55614B3986291EC,,,,,,",de="Anleitung: Stellare Verstärkung der Scharfsinnigkeit",en="Recipe: Stellar Keen Augment",fr="Recette : Augmentation d'intensité stellaire",ru="Рецепт: Звездная ловкость и сила удара",icon="scroll8b",val=0,q=3,bop=true,Consumable=true,rss="Light Weaponsmith",rsslvl=375},
["D1FA903A01010101"] = {akey="I07443D5132672418,363D2CC7799243EA,,,,,,",de="Anleitung: Tuthony-Stilett",en="Recipe: Karthite Stiletto",fr="Plan : Stylet en tuthonie",ru="Чертеж: Картитовый стилет",icon="scroll8b",val=0,q=1,bop=true,Consumable=true,rss="Light Weaponsmith",rsslvl=340},
["CC8E82A20401010101"] = {akey="I4440874C0AAF44BE,19B9F2CA44E2E578,,,,,,",de="Anleitung: Schwarzeisen-Beil",en="Recipe: Black Iron Hatchet",fr="Plan : Hachette en fer noir",ru="Чертеж: топор черного железа",icon="scroll2a",val=0,q=3,bop=true,Consumable=true,rss="Light Weaponsmith",rsslvl=300},
["D3CCE1DB0301010101"] = {akey="I3B7866536509EE16,E3EFC8F76ED73115,,,,,,",de="Anleitung: Quecksilberbogen",en="Recipe: Quicksilver Bow",fr="Plan : Arc de Vif-argent",ru="Чертеж: лук живого серебра",icon="scroll1",val=0,q=2,bop=true,accBound=true,Consumable=true,rss="Light Weaponsmith",rsslvl=50,rf="Freemarch Wardens",rfl=2},
["FAC6BFFE0F01010101"] = {akey="IFFCFE37A59DE4837,48E18B5A632EDAF2,,,,,,",de="Anleitung: Grausamer Rhenium-Zweihänder",en="Recipe: Vicious Rhenium Greatsword",fr="Plan : Grande épée vicieuse en rhénium",ru="Чертеж: Рениевый двуручный меч злобы",icon="scroll8b",val=1,q=2,Consumable=true,rss="Light Weaponsmith",rsslvl=375},
["83F78D800601010101"] = {akey="I60037B83715F5C1B,EC0C9894E62DA396,,,,,,",de="Anleitung: Eidbrecher",en="Recipe: Oathsmasher",fr="Plan : Brisserment",ru="Чертеж: клятвобоец",icon="scroll8b",val=0,q=3,bop=true,Consumable=true,rss="Light Weaponsmith",rsslvl=300},
["EE959FCB0401010101"] = {akey="I4967CAEE70ABC420,6B98A0978419BDA9,,,,,,",de="Anleitung: Leuchtender Gantimit-Zauberbrecher",en="Recipe: Luminous Gantimite Spellcutter",fr="Plan : Coupe-sort lumineux en gantimite",ru="Чертеж: Искристый гантимитовый чароруб",icon="scroll8b",val=0,q=2,bop=true,Consumable=true,rss="Light Weaponsmith",rsslvl=330},
["C7E4B5FC0701010101"] = {akey="I7F8D72477D839275,52C6DD9F0C543F07,,,,,,",de="Anleitung: Bogenständer",en="Recipe: Bow Rack",fr="Plan : Présentoir à arcs",ru="Чертеж: Стойка для луков",icon="scroll4c",val=0,bop=true,Consumable=true,rss="Light Weaponsmith",rsslvl=300},
["C891DAFC0F01010101"] = {akey="IFF9688C869F68A45,FA48D05839107422,,,,,,",de="Anleitung: Gantimit-Kriegshammer",en="Recipe: Gantimite Warhammer",fr="Plan : Marteau de guerre en gantimite",ru="Чертеж: Гантимитовый боевой молот",icon="scroll8b",val=0,q=1,bop=true,Consumable=true,rss="Light Weaponsmith",rsslvl=290},
["EC81D1890701010101"] = {akey="I713440EC2553BDBC,710057BFA4F57F64,,,,,,",de="Anleitung: Orichalcum-Streitkolben",en="Recipe: Orichalcum Mace",fr="Plan : Masse en orichalque",ru="Чертеж: булава из орихалка",icon="scroll9a",val=0,q=2,bop=true,Consumable=true,rss="Light Weaponsmith",rsslvl=290},
["FA959FCB0401010101"] = {akey="I4967CAFA3719EAA2,559D33A827C5A051,,,,,,",de="Anleitung: Grausamer Tuthony-Säbel",en="Recipe: Vicious Karthite Saber",fr="Plan : Sabre vicieux en tuthonie",ru="Чертеж: Картитовая сабля злобы",icon="scroll8b",val=0,q=2,bop=true,Consumable=true,rss="Light Weaponsmith",rsslvl=360},
["8893ACD60F01010101"] = {akey="IFACB09881683666E,604AFECCE14CBE66,,,,,,",de="Anleitung: Größere Verstärkung der Hinterlist",en="Recipe: Major Insidious Augment",fr="Recette : Augmentation insidieuse majeure",ru="Чертеж: Большое усиление тайной деятельности",icon="scroll8b",val=0,q=2,bop=true,Consumable=true,rss="Light Weaponsmith",rsslvl=300},
["AC939B7801010101"] = {akey="I0F06C9AC77087DB4,0D63E0D88F022227,,,,,,",de="Anleitung: Carmintium-Muskete",en="Recipe: Carmintium Musket",fr="Plan : Mousquet en carmintium",ru="Чертеж: карминтиевый мушкет",icon="scroll9a",val=0,q=1,bop=true,Consumable=true,rss="Light Weaponsmith",rsslvl=260},
["E09F98DD0201010101"] = {akey="I2BA60FE0424A1EF4,041D00232CE5B4A3,,,,,,",de="Anleitung: Falkenkralle",en="Recipe: Hawk's Talon",fr="Plan : Serre du Faucon",ru="Чертеж: Коготь ястреба",icon="scroll2a",val=0,q=3,bop=true,Consumable=true,rss="Light Weaponsmith",rsslvl=300},
["E59BB6DC0401010101"] = {akey="I4B8D8DE52AF54A09,56367A701826B45C,,,,,,",de="Anleitung: Orichalcum-Zauberbrecher",en="Recipe: Orichalcum Spellcutter",fr="Plan : Coupe-sort en orichalque",ru="Чертеж: орихалковый магорез",icon="scroll9a",val=0,q=2,bop=true,accBound=true,Consumable=true,rss="Light Weaponsmith",rsslvl=300,rf="Order of Mathos",rfl=3},
["A3F7C6E30301010101"] = {akey="I3C71BBA33077E37A,BCF16C5529FA2AFD,,,,,,",de="Anleitung: Ebenholz-Beil",en="Recipe: Ebony Hatchet",fr="Plan : Hachette en ébène",ru="Чертеж: черный топор",icon="scroll8b",val=0,q=2,bop=true,Consumable=true,rss="Light Weaponsmith",rsslvl=225},
["B3ECFEF20601010101"] = {akey="I6E5FB633238D1F98,B7CF0973C84D529E,,,,,,",de="Anleitung: Kobalt-Hellebarde",en="Recipe: Cobalt Halberd",fr="Plan : Hallebarde en cobalt",ru="Чертеж: кобальтовая алебарда",icon="scroll8b",val=0,q=1,bop=true,Consumable=true,rss="Light Weaponsmith",rsslvl=180},
["84F78D800601010101"] = {akey="I60037B847E0CA684,17AEA2000FCBE647,,,,,,",de="Anleitung: Todbringer",en="Recipe: Deathbringer",fr="Plan : Lame fatale",ru="Чертеж: вестник Смерти",icon="scroll8b",val=0,q=3,bop=true,Consumable=true,rss="Light Weaponsmith",rsslvl=300},
["DAB4E0D30701010101"] = {akey="I7A781A5A64E3B3FE,FC2E6CE26F7A8690,,,,,,",de="Anleitung: Zinn-Muskete",en="Recipe: Tin Musket",fr="Plan : Mousquet en fer-blanc",ru="Чертеж: оловянный мушкет",icon="scroll4",val=0,q=1,bop=true,Consumable=true,rss="Light Weaponsmith",rsslvl=30},
["EF959FCB0401010101"] = {akey="I4967CAEF4532E744,8544FFF0FD034544,,,,,,",de="Anleitung: Gehärteter Gantimit-Knüppel",en="Recipe: Hardened Gantimite Bludgeon",fr="Plan : Gourdin endurci en gantimite",ru="Чертеж: Крепкая гантимитовая дубинка",icon="scroll8b",val=0,q=2,bop=true,accBound=true,Consumable=true,rss="Light Weaponsmith",rsslvl=330,rf="Eternal City Survivors",rfl=1},
["C8E4B5FC0701010101"] = {akey="I7F8D724808B3D152,4AD3F316F8F2FBCC,,,,,,",de="Anleitung: Axt- und Schwertständer",en="Recipe: Axe and Sword Stand",fr="Plan : Présentoir à haches et épées",ru="Чертеж: Стойка для мечей и топоров",icon="scroll4c",val=0,bop=true,Consumable=true,rss="Light Weaponsmith",rsslvl=360},
["C991DAFC0F01010101"] = {akey="IFF9688C90C00CCD6,17475D12A4526918,,,,,,",de="Anleitung: Gantimit-Streitaxt",en="Recipe: Gantimite Battleaxe",fr="Plan : Hache de bataille en gantimite",ru="Чертеж: Гантимитовый боевой топор",icon="scroll8b",val=0,q=1,bop=true,Consumable=true,rss="Light Weaponsmith",rsslvl=300},
["FB959FCB0401010101"] = {akey="I4967CAFB1E642A9D,59BE9DC84B4DC9A6,,,,,,",de="Anleitung: Verschlagenheit",en="Recipe: Deviousness",fr="Plan : Sournoiserie",ru="Рецепт: Нерешительность",icon="scroll8b",val=0,q=2,bop=true,Consumable=true,rss="Light Weaponsmith",rsslvl=370},
["8580DB950601010101"] = {akey="I62B6C0056A19709F,C73E7E1A3E0DB836,,,,,,",de="Anleitung: Titan-Streitkolben",en="Recipe: Titanium Mace",fr="Plan : Masse en titane",ru="Чертеж: титановая булава",icon="scroll8b",val=0,q=1,bop=true,Consumable=true,rss="Light Weaponsmith",rsslvl=190},
["CBD7ECC10501010101"] = {akey="I583B2BCB73FF9713,1CF0F000DEE3FB37,,,,,,",de="Anleitung: Heimtückische Zweihandaxt",en="Recipe: Malevolent Greataxe",fr="Plan : Grande hache malfaisante",ru="Чертеж: двуручный топор злобы",icon="scroll8b",val=1,q=2,Consumable=true,rss="Light Weaponsmith",rsslvl=300},
["D6C487D00401010101"] = {akey="I4A01E256579DCDB4,66FF104E61B98FBF,,,,,,",de="Anleitung: Ausweider",en="Recipe: Eviscerator",fr="Plan : Éviscérateur",ru="Чертеж: Потрошитель",icon="scroll2a",val=0,q=3,bop=true,Consumable=true,rss="Light Weaponsmith",rsslvl=300},
["E5B8F6F30F01010101"] = {akey="IFE7D9C6570093024,05497D4D35DC64A5,,,,,,",de="Anleitung: Größere Verstärkung der Abwendung",en="Recipe: Major Averting Augment",fr="Recette : Augmentation d'évitement majeure",ru="Чертеж: Большое усиление предотвращения",icon="scroll8b",val=0,q=2,bop=true,Consumable=true,rss="Light Weaponsmith",rsslvl=300},
["8993ACD60F01010101"] = {akey="IFACB098951A10CFB,13FA4F128E57020E,,,,,,",de="Anleitung: Große Verstärkung der Hinterlist",en="Recipe: Greater Insidious Augment",fr="Recette : Augmentation insidieuse supérieure",ru="Чертеж: Крепкое усиление тайной деятельности",icon="scroll8b",val=0,q=3,bop=true,Consumable=true,rss="Light Weaponsmith",rsslvl=300},
["D8C3966201010101"] = {akey="I0C45A1D87846E5F6,84E44652FD8AFC75,,,,,,",de="Anleitung: Gehärteter Orichalcum-Streitkolben",en="Recipe: Tempered Orichalcum Mace",fr="Plan : Massue en orichalque durci",ru="Чертеж: закаленная орихалковая булава",icon="scroll1",val=0,q=2,bop=true,accBound=true,Consumable=true,rss="Light Weaponsmith",rsslvl=300,rf="Kelari Expedition",rfl=3},
["C0C8FEF10F01010101"] = {akey="IFE3FA4407D26FA71,0839D06DDD665CAB,,,,,,",de="Anleitung: Größere Verstärkung der Gnadenlosigkeit",en="Recipe: Major Ruthless Augment",fr="Recette : Augmentation de férocité majeure",ru="Чертеж: Большое усиление жестокости",icon="scroll8b",val=0,q=2,bop=true,Consumable=true,rss="Light Weaponsmith",rsslvl=300},
["C0D5A9D60401010101"] = {akey="I4ACA6AC06773AE65,08C8B8EED94D0E19,,,,,,",de="Anleitung: Dunkelmetall-Zepter",en="Recipe: Darkmetal Scepter",fr="Plan : Sceptre en sombracier",ru="Чертеж: скипетр темного металла",icon="scroll8b",val=0,q=2,bop=true,Consumable=true,rss="Light Weaponsmith",rsslvl=185},
["AFC1BFCC0401010101"] = {akey="I498FE0AF336A4700,08883F125834333E,,,,,,",de="Anleitung: Königsholz-Kompositbogen",en="Recipe: Composite Kingswood Bow",fr="Plan : Arc composite en bois royal",ru="Чертеж: составной лук из королевского дерева",icon="scroll8b",val=0,q=2,bop=true,Consumable=true,rss="Light Weaponsmith",rsslvl=185},
["FCC6BFFE0F01010101"] = {akey="IFFCFE37C34337664,6CE63984F9E86945,,,,,,",de="Anleitung: Verstärkter Rhenium-Schlagstock",en="Recipe: Reinforced Rhenium Truncheon",fr="Plan : Casse-tête renforcé en rhénium",ru="Чертеж: Усиленная рениевая дубинка",icon="scroll8b",val=0,q=2,bop=true,accBound=true,Consumable=true,rss="Light Weaponsmith",rsslvl=375,rf="The Qaijiri",rfl=4},
["DFA4ABA10301010101"] = {akey="I342AD25F1046DEA3,FBD5076697CBD466,,,,,,",de="Anleitung: Kupfer-Klinge",en="Recipe: Copper Blade",fr="Plan : Lame en cuivre",ru="Чертеж: медный клинок",icon="scroll4",val=0,q=1,bop=true,Consumable=true,rss="Light Weaponsmith",rsslvl=50},
["FEBA81FD0701010101"] = {akey="I7FA05D7E68C83EF1,DCBFC53F8A3B4F60,,,,,,",de="Anleitung: Zinn-Streitkolben",en="Recipe: Tin Mace",fr="Plan : Masse en fer-blanc",ru="Чертеж: оловянная булава",icon="scroll4",val=0,q=1,bop=true,Consumable=true,rss="Light Weaponsmith",rsslvl=1},
["A5EB8E9F0601010101"] = {akey="I63E3B5A515972DE9,E3A23806CB186D71,,,,,,",de="Anleitung: Damast-Messer",en="Recipe: Damascus Shiv",fr="Plan : Surin en acier damassé",ru="Чертеж: дамасский кинжал",icon="scroll1",val=0,q=2,bop=true,Consumable=true,rss="Light Weaponsmith",rsslvl=150},
["85F78D800601010101"] = {akey="I60037B85607AC59C,DB14BE152DCE680B,,,,,,",de="Anleitung: Jenseitsgeschmiedeter Schlitzer",en="Recipe: Netherforged Slicer",fr="Plan : Trancheur forgé par le néant",ru="Чертеж: тесак теневой ковки",icon="scroll8b",val=0,q=3,bop=true,Consumable=true,rss="Light Weaponsmith",rsslvl=300},
["AFA4FFEC0401010101"] = {akey="I4D9FD22F2E363705,81AAC2C3C0C456F3,,,,,,",de="Anleitung: Schlagstock der Wut",en="Recipe: Baton of Rage",fr="Plan : Matraque de la rage",ru="Чертеж: палочка ярости",icon="scroll1a",val=0,q=3,bop=true,Consumable=true,rss="Light Weaponsmith",rsslvl=210},
["F0959FCB0401010101"] = {akey="I4967CAF040E5B09B,879007E897674B03,,,,,,",de="Anleitung: Zorniger Gantimit-Rapier",en="Recipe: Furious Gantimite Rapier",fr="Plan : Rapière furieuse en gantimite",ru="Чертеж: Яростная гантимитовая рапира",icon="scroll8b",val=10000,q=2,bop=true,Consumable=true,rss="Light Weaponsmith",rsslvl=330},
["CA91DAFC0F01010101"] = {akey="IFF9688CA1CBAAFF5,1E4D7E824FCA0274,,,,,,",de="Anleitung: Gantimit-Schlagstock",en="Recipe: Gantimite Truncheon",fr="Plan : Casse-tête en gantimite",ru="Чертеж: Гантимитовая дубинка",icon="scroll8b",val=0,q=1,bop=true,Consumable=true,rss="Light Weaponsmith",rsslvl=310},
["AB8CAC3801010101"] = {akey="I070B062B3B92C763,240B10A3AF0AB533,,,,,,",de="Anleitung: Schwert des Ordens",en="Recipe: Sword of the Order",fr="Plan : Épée de l'Ordre",ru="Чертеж: меч порядка",icon="scroll9a",val=0,q=2,bop=true,accBound=true,Consumable=true,rss="Light Weaponsmith",rsslvl=300,rf="Order of Mathos",rfl=3},
["E6B8F6F30F01010101"] = {akey="IFE7D9C660CADB0C4,3CFFDB62966413E6,,,,,,",de="Anleitung: Große Verstärkung der Abwendung",en="Recipe: Greater Averting Augment",fr="Recette : Augmentation d'évitement supérieure",ru="Чертеж: Крепкое усиление предотвращения",icon="scroll8b",val=0,q=3,bop=true,Consumable=true,rss="Light Weaponsmith",rsslvl=300},
["8A93ACD60F01010101"] = {akey="IFACB098A41B1ADF6,044FACF7F8064CB8,,,,,,",de="Anleitung: Empyreum-Verstärkung der Hinterlist",en="Recipe: Empyrean Insidious Augment",fr="Recette : Augmentation insidieuse empyréenne",ru="Рецепт: Тайное эмпирейское усиление",icon="scroll8b",val=0,q=2,bop=true,Consumable=true,rss="Light Weaponsmith",rsslvl=340},
["C1C8FEF10F01010101"] = {akey="IFE3FA44117D02FBC,1E4335529C4112BB,,,,,,",de="Anleitung: Große Verstärkung der Gnadenlosigkeit",en="Recipe: Greater Ruthless Augment",fr="Recette : Augmentation de férocité supérieure",ru="Чертеж: Крепкое усиление жестокости",icon="scroll8b",val=0,q=3,bop=true,Consumable=true,rss="Light Weaponsmith",rsslvl=300},
["90A785960401010101"] = {akey="I42C153904AA5F23E,5D29ED29C3AC8929,,,,,,",de="Anleitung: Zinn-Hellebarde",en="Recipe: Tin Halberd",fr="Plan : Hallebarde en fer-blanc",ru="Чертеж: оловянная алебарда",icon="scroll4",val=0,q=1,bop=true,Consumable=true,rss="Light Weaponsmith",rsslvl=30},
["FDC6BFFE0F01010101"] = {akey="IFFCFE37D6602FDFD,6150D7D5AC78547E,,,,,,",de="Anleitung: Bewehrter Madrosa-Langbogen",en="Recipe: Fortified Madrosa Longbow",fr="Plan : Arc long fortifié en madrosa",ru="Чертеж: Усиленный длинный лук Мадрозы",icon="scroll8b",val=0,q=2,bop=true,Consumable=true,rss="Light Weaponsmith",rsslvl=375},
["B99ABEE90401010101"] = {akey="I4D2F8D390B57B7AC,E458F14B4CF3CB8E,,,,,,",de="Anleitung: Titan-Klinge",en="Recipe: Titanium Blade",fr="Plan : Lame en titane",ru="Чертеж: титановый клинок",icon="scroll8b",val=0,q=1,bop=true,Consumable=true,rss="Light Weaponsmith",rsslvl=200},
["B3F5B64501010101"] = {akey="I08ADBAB31510A0DE,A7F12C61E184AE11,,,,,,",de="Anleitung: Dunkelmetall-Schwert",en="Recipe: Darkmetal Sword",fr="Plan : Épée en sombracier",ru="Чертеж: меч темного металла",icon="scroll8b",val=0,q=2,bop=true,Consumable=true,rss="Light Weaponsmith",rsslvl=185},
["EAF6B28C0201010101"] = {akey="I218CBB6A566A148E,3FAA3280928F710F,,,,,,",de="Anleitung: Kupfer-Streitkolben",en="Recipe: Copper Mace",fr="Plan : Masse en cuivre",ru="Чертеж: медная булава",icon="scroll4",val=0,q=1,bop=true,Consumable=true,rss="Light Weaponsmith",rsslvl=40},
["FED8AA900601010101"] = {akey="I620AAC7EA84ECDAB,441CEA8170C8B1EF,,,,,,",de="Anleitung: Übermäßige Genialität",en="Recipe: Exuberant Ingenuity",fr="Plan : Ingéniosité exubérante",ru="Рецепт: буйное воображение",icon="scroll8b",val=0,q=3,bop=true,Consumable=true,rss="Light Weaponsmith",rsslvl=300},
["86F78D800601010101"] = {akey="I60037B867EA44A23,2AE37469E237A9F0,,,,,,",de="Anleitung: Blutgeschmiedetes Claymore",en="Recipe: Blood-Forged Claymore",fr="Plan : Claymore forgée dans le sang",ru="Чертеж: кровавый клеймор",icon="scroll8b",val=0,q=3,bop=true,Consumable=true,rss="Light Weaponsmith",rsslvl=300},
["D19C9EB40401010101"] = {akey="I46878E5178E733EF,E10B063BCC2403DD,,,,,,",de="Anleitung: Gantimit-Stilett",en="Recipe: Gantimite Stiletto",fr="Plan : Stylet en gantimite",ru="Чертеж: Гантимитовый стилет",icon="scroll8b",val=0,q=1,bop=true,Consumable=true,rss="Light Weaponsmith",rsslvl=300},
["CFD7FFE50F01010101"] = {akey="IFCBFEBCF56450817,474F460CC30DA53A,,,,,,",de="Anleitung: Größere Verstärkung der Tücke",en="Recipe: Major Treacherous Augment",fr="Recette : Augmentation de traîtrise majeure",ru="Чертеж: Большое усиление предательства",icon="scroll8b",val=0,q=2,bop=true,Consumable=true,rss="Light Weaponsmith",rsslvl=300},
["DAD4BBC60701010101"] = {akey="I78CEEA5A7FB3B14D,1692D0D996627608,,,,,,",de="Anleitung: Kupfer-Muskete",en="Recipe: Copper Musket",fr="Plan : Mousquet en cuivre",ru="Чертеж: медный мушкет",icon="scroll4",val=0,q=1,bop=true,Consumable=true,rss="Light Weaponsmith",rsslvl=70},
["B0A4FFEC0401010101"] = {akey="I4D9FD23037A93BAF,2B1B9D3AC008CE53,,,,,,",de="Anleitung: Schlagstock der Schnelligkeit",en="Recipe: Baton of Swiftness",fr="Plan : Matraque de la rapidité",ru="Чертеж: палочка стремительности",icon="scroll1a",val=0,q=3,bop=true,Consumable=true,rss="Light Weaponsmith",rsslvl=210},
["E08C998A0401010101"] = {akey="I414646607D150E3F,3DAF02F323371276,,,,,,",de="Anleitung: Bewahrerdolch",en="Recipe: Warden's Dagger",fr="Plan : Dague de protecteur",ru="Чертеж: кинжал смотрителя",icon="scroll1",val=0,q=2,bop=true,accBound=true,Consumable=true,rss="Light Weaponsmith",rsslvl=60,rf="Freemarch Wardens",rfl=3},
["F1959FCB0401010101"] = {akey="I4967CAF16DC6F253,4AF623FDB569CCC7,,,,,,",de="Anleitung: Bewehrter Gantimit-Entersäbel",en="Recipe: Fortified Gantimite Cutlass",fr="Plan : Coutelas fortifié en gantimite",ru="Чертеж: Усиленная гантимитовая сабля",icon="scroll8b",val=0,q=2,bop=true,accBound=true,Consumable=true,rss="Light Weaponsmith",rsslvl=330,rf="Necropolis Caretakers",rfl=1},
["CB91DAFC0F01010101"] = {akey="IFF9688CB0400E078,304FD597DB26464E,,,,,,",de="Anleitung: Gantimit-Streitkolben",en="Recipe: Gantimite Mace",fr="Plan : Masse en gantimite",ru="Чертеж: Гантимитовая булава",icon="scroll8b",val=0,q=1,bop=true,Consumable=true,rss="Light Weaponsmith",rsslvl=310},
["C9BBA0BC0301010101"] = {akey="I37881DC92F7A4C74,EE9E5F3715E867C8,,,,,,",de="Anleitung: Unbarmherziger Rhenium-Spalthammer",en="Recipe: Callous Rhenium Maul",fr="Plan : Merlin monstrueux en rhénium",ru="Чертеж: Грубая рениевая булава",icon="scroll8b",val=0,q=3,bop=true,Consumable=true,rss="Light Weaponsmith",rsslvl=375},
["B3A5FF820701010101"] = {akey="I705FD2B340E8DE4F,2DE1118030053151,,,,,,",de="Anleitung: Ebenholz-Gewehr",en="Recipe: Ebony Rifle",fr="Plan : Fusil en ébène",ru="Чертеж: черная винтовка",icon="scroll8b",val=0,q=2,bop=true,Consumable=true,rss="Light Weaponsmith",rsslvl=225},
["E7B8F6F30F01010101"] = {akey="IFE7D9C6719CF6A02,321E020D2689A3D6,,,,,,",de="Anleitung: Empyreum-Verstärkung der Abwendung",en="Recipe: Empyrean Averting Augment",fr="Recette : Augmentation d'évitement empyréenne",ru="Рецепт: Предотвращающее эмпирейское усиление",icon="scroll8b",val=0,q=2,bop=true,Consumable=true,rss="Light Weaponsmith",rsslvl=340},
["8B93ACD60F01010101"] = {akey="IFACB098B7F36D240,33363476FE9A4B1B,,,,,,",de="Anleitung: Stellare Verstärkung der Hinterlist",en="Recipe: Stellar Insidious Augment",fr="Recette : Augmentation insidieuse stellaire",ru="Рецепт: Звездная ловкость и сила критического удара",icon="scroll8b",val=0,q=3,bop=true,Consumable=true,rss="Light Weaponsmith",rsslvl=375},
["DFACC3DD0401010101"] = {akey="I4BB0D65F78B9E5FD,FF58D3BD0F0E193E,,,,,,",de="Anleitung: Steinschlitzer",en="Recipe: Stoneslasher",fr="Plan : Taillepierre",ru="Чертеж: сокрушитель скал",icon="scroll1",val=0,q=2,bop=true,accBound=true,Consumable=true,rss="Light Weaponsmith",rsslvl=100,rf="Granite Falls",rfl=2},
["F2C6BFFE0F01010101"] = {akey="IFFCFE372321FAE5F,29178394174FE03F,,,,,,",de="Anleitung: Unbarmherziger Rhenium-Kriegshammer",en="Recipe: Callous Rhenium Warhammer",fr="Plan : Marteau de guerre monstrueux en rhénium",ru="Чертеж: Грубый рениевый боевой молот",icon="scroll8b",val=0,q=2,bop=true,Consumable=true,rss="Light Weaponsmith",rsslvl=375},
["FEC6BFFE0F01010101"] = {akey="IFFCFE37E749C248F,32975D91B24EF0C8,,,,,,",de="Anleitung: Grausamer Madrosa-Kurzbogen",en="Recipe: Vicious Madrosa Shortbow",fr="Plan : Arc court vicieux en madrosa",ru="Чертеж: Короткий лук злобы Мадрозы",icon="scroll8b",val=0,q=2,bop=true,Consumable=true,rss="Light Weaponsmith",rsslvl=375},
["8BD0C8DE0301010101"] = {akey="I3BD2280B52951BE1,2B4C222559D6D31F,,,,,,",de="Anleitung: Göttlicher Verteidiger",en="Recipe: Divine Defender",fr="Plan : Défenseur divin",ru="Чертеж: Небесный защитник",icon="scroll2a",val=0,q=3,bop=true,Consumable=true,rss="Light Weaponsmith",rsslvl=300},
}

nkItemBase.db.recipe.mining={
["C6D7D6970701010101"] = {akey="I72F5ABC670596D28,FB216CE00B7EF73C,,,,,,",de="Anleitung: Stahlbarren",en="Recipe: Steel Bar",fr="Recette : Barre d'acier",ru="Рецепт: слиток стали",icon="scroll1",val=10000,q=1,bop=true,Consumable=true,rss="Mining",rsslvl=115},
["C7D7D6970701010101"] = {akey="I72F5ABC7439FFDC3,2BE14B0B5C100E0F,,,,,,",de="Anleitung: Dunkel-metallbarren",en="Recipe: Darkmetal Bar",fr="Recette : Barre de sombracier",ru="Рецепт: слиток темного металла",icon="scroll1",val=10000,q=1,bop=true,Consumable=true,rss="Mining",rsslvl=185},
["C8D7D6970701010101"] = {akey="I72F5ABC86CB4FB5B,D089E00AB4DE402A,,,,,,",de="Anleitung: Cineriumbarren",en="Recipe: Cinerium Bar",fr="Recette : Barre de cinerium",ru="Рецепт: слиток цинерия",icon="scroll1",val=10000,q=1,bop=true,Consumable=true,rss="Mining",rsslvl=280},
["94CEB2BC0401010101"] = {akey="I478CA7141CD95ABB,247D0DA43EBBB1C6,,,,,,",de="Anleitung: Flechtenbedeckter Felsbrocken",en="Recipe: Lichen-covered Boulder",fr="Plan : Rocher couvert de lichen",ru="Эскиз: Заросший лишайником валун",icon="scroll4c",val=0,bop=true,Consumable=true,rss="Mining",rsslvl=60},
["95CEB2BC0401010101"] = {akey="I478CA7153B9D13A0,2B8D6690BEBC84A2,,,,,,",de="Anleitung: Spitzhackenständer",en="Recipe: Pickaxe Rack",fr="Plan : Râtelier de pioches",ru="Чертеж: Стойка для кирок",icon="scroll4c",val=0,bop=true,Consumable=true,rss="Mining",rsslvl=120},
["96CEB2BC0401010101"] = {akey="I478CA7166EFF867A,D20F523B6188527B,,,,,,",de="Anleitung: Großer Felsbrocken",en="Recipe: Tall Boulder",fr="Plan : Grand rocher",ru="Эскиз: Высокий валун",icon="scroll4c",val=0,bop=true,Consumable=true,rss="Mining",rsslvl=180},
["97CEB2BC0401010101"] = {akey="I478CA7175F9EC51B,CCA325EF78FCE61F,,,,,,",de="Anleitung: Bergbaulore mit Erz",en="Recipe: Mining Cart with Ore",fr="Plan : Wagonnet de mine avec minerai",ru="Чертеж: Шахтерская вагонетка",icon="scroll4c",val=0,bop=true,Consumable=true,rss="Mining",rsslvl=240},
["98CEB2BC0401010101"] = {akey="I478CA7181A9363EC,EF7558C5C8A777F1,,,,,,",de="Anleitung: Kristallmasse",en="Recipe: Crystal Mass",fr="Plan : Masse cristalline",ru="Рецепт: Кристаллическая масса",icon="scroll4c",val=0,bop=true,Consumable=true,rss="Mining",rsslvl=300},
["C5D7D6970701010101"] = {akey="I72F5ABC540048763,F5336A74B70B9CA4,,,,,,",de="Anleitung: Bronzebarren",en="Recipe: Bronze Bar",fr="Recette : Barre de bronze",ru="Рецепт: слиток бронзы",icon="scroll1",val=10000,q=1,bop=true,Consumable=true,rss="Mining",rsslvl=50},
}

nkItemBase.db.recipe.outfitter={
["84DCB2E80601010101"] = {akey="I6D0CAE04209247EC,C4EE63338B1CBA15,,,,,,",de="Anleitung: Jutegurt",en="Recipe: Burlap Waistband",fr="Patron : Ceinturon en toile de jute",ru="Выкройка: джутовый пояс",icon="scroll4",val=0,q=1,bop=true,Consumable=true,rss="Outfitter",rsslvl=1},
["BFE4B5FC0701010101"] = {akey="I7F8D723F59C40011,28BEE35812AFFB5A,,,,,,",de="Anleitung: Runendruck-Stoff",en="Recipe: Rune Print Cloth",fr="Patron : Tissu à imprimé runique",ru="Выкройка: Ткань с рунным рисунком",icon="scroll4c",val=0,bop=true,Consumable=true,rss="Outfitter",rsslvl=180},
["9A95D5D10F01010101"] = {akey="IFA354A9A7C6E9DC1,6EE06B6CDF39522E,,,,,,",de="Anleitung: Größere Verstärkung der Listigkeit",en="Recipe: Major Wily Augment",fr="Recette : Augmentation de roublardise majeure",ru="Чертеж: Большое усиление лукавства",icon="scroll8b",val=0,q=2,bop=true,Consumable=true,rss="Outfitter",rsslvl=300},
["B1F19B6201010101"] = {akey="I0C46F8B150FD4B11,5230C182DE0536FD,,,,,,",de="Anleitung: Exotische Lederkapuze",en="Recipe: Exotic Leather Hood",fr="Patron : Capuchon en cuir exotique",ru="Выкройка: капюшон из экзотической кожи",icon="scroll8b",val=0,q=1,bop=true,Consumable=true,rss="Outfitter",rsslvl=210},
["A695D5D10F01010101"] = {akey="IFA354AA6706216C5,2FF6EC90B4572C73,,,,,,",de="Anleitung: Größere Verstärkung der Genialität",en="Recipe: Major Brilliant Augment",fr="Recette : Augmentation éclatante majeure",ru="Чертеж: Большое сверкающее усиление",icon="scroll8b",val=0,q=2,bop=true,Consumable=true,rss="Outfitter",rsslvl=300},
["B4C19AD60F01010101"] = {akey="IFAC6A0B44947D8F8,516AD7F58DF6994A,,,,,,",de="Anleitung: Leuchtende Empyreum-Schärpe",en="Recipe: Luminous Empyrean Sash",fr="Patron : Écharpe empyréenne lumineuse",ru="Выкройка: Искристый эмпирейский кушак",icon="scroll8b",val=0,q=2,bop=true,Consumable=true,rss="Outfitter",rsslvl=375},
["BDF19B6201010101"] = {akey="I0C46F8BD6D26A2D0,4AD4015E9BA518FD,,,,,,",de="Anleitung: Mittlere Lederkapuze",en="Recipe: Medium Leather Hood",fr="Patron : Capuchon en cuir moyen",ru="Выкройка: капюшон из средней кожи",icon="scroll1a",val=0,q=1,bop=true,Consumable=true,rss="Outfitter",rsslvl=100},
["A7D79EF40601010101"] = {akey="I6E87ABA750E558EA,1077D2A85035EB01,,,,,,",de="Anleitung: Aufbereiteter Leder-Schulterschutz",en="Recipe: Conditioned Leather Shoulder Guard",fr="Patron : Protection d'épaule en cuir apprêté",ru="Чертеж: наплечники из выделанной кожи",icon="scroll8b",val=1,q=3,Consumable=true,rss="Outfitter",rsslvl=300},
["A6B1B9F10401010101"] = {akey="I4E2E58A61A865B79,A355EA0E9025286D,,,,,,",de="Anleitung: Intuition",en="Recipe: Intuition",fr="Patron : Intuition",ru="Рецепт: интуиция",icon="scroll8",val=0,q=3,bop=true,Consumable=true,rss="Outfitter",rsslvl=300},
["F3EBA8FD0701010101"] = {akey="I7FAA35F3540BA660,0769FA1F65DD5152,,,,,,",de="Anleitung: Schiefergespinst-Gewand",en="Recipe: Shaleweave Robe",fr="Patron: Chasuble en tisse-roc",ru="Выкройка: мантия из сланцевины",icon="scroll8b",val=0,q=2,bop=true,Consumable=true,rss="Outfitter",rsslvl=160},
["A09B8FC80301010101"] = {akey="I3903CDA01BB6BBA6,658D22CD0562ABC2,,,,,,",de="Anleitung: Geschick",en="Recipe: Aptitude",fr="Patron : Aptitude",ru="Рецепт: одаренность",icon="scroll8",val=0,q=2,bop=true,Consumable=true,rss="Outfitter",rsslvl=280},
["F4D0E2E20F01010101"] = {akey="IFC58A87454F5B2EC,08CA863ABCC53969,,,,,,",de="Anleitung: Zornige Echthaut-Kniehose",en="Recipe: Furious Truehide Breeches",fr="Patron : Braies furieuses en peau authentique",ru="Выкройка: Яростные бриджи чистой кожи",icon="scroll8b",val=0,q=2,bop=true,accBound=true,Consumable=true,rss="Outfitter",rsslvl=375,rf="The Qaijiri",rfl=4},
["8ABECCFF0F01010101"] = {akey="IFFF31F0A357491A8,6FF45F6A1DBC5457,,,,,,",de="Anleitung: Kompakte Lederstiefel",en="Recipe: Dense Leather Boots",fr="Patron : Bottes en cuir dense",ru="Выкройка: Плотные кожаные ботинки",icon="scroll8b",val=0,q=1,bop=true,Consumable=true,rss="Outfitter",rsslvl=310},
["BBD387960201010101"] = {akey="I22C1E9BB59547DE3,0B6F23BF98AB73A6,,,,,,",de="Anleitung: Gestählte Ledergamaschen",en="Recipe: Steeled Leather Leggings",fr="Patron : Jambières en cuir renforcé d'acier",ru="Выкройка: поножи из закаленной кожи",icon="scroll9a",val=0,q=2,bop=true,Consumable=true,rss="Outfitter",rsslvl=290},
["96BECCFF0F01010101"] = {akey="IFFF31F164DD15341,55F1615D8DEA4817,,,,,,",de="Anleitung: Gestreifte Lederstiefel",en="Recipe: Striped Leather Boots",fr="Patron : Bottes en cuir rayé",ru="Выкройка: Ботинки плетеной кожи",icon="scroll8b",val=0,q=1,bop=true,Consumable=true,rss="Outfitter",rsslvl=350},
["8DCC971501010101"] = {akey="I02A5E60D05CE2D35,23507269A03429EA,,,,,,",de="Anleitung: Nachtschatten-Gürtel",en="Recipe: Nightshade Belt",fr="Plan : Ceinture d'ombrenuit",ru="Чертеж: ремень ночной тени",icon="scroll1",val=0,q=2,bop=true,accBound=true,Consumable=true,rss="Outfitter",rsslvl=90,rf="Granite Falls",rfl=2},
["C0E4B5FC0701010101"] = {akey="I7F8D72402142C92A,2CE0D0C6B63824B0,,,,,,",de="Anleitung: Kelaribett",en="Recipe: Kelari Bed",fr="Patron : Lit kelari",ru="Эскиз: Постель келари",icon="scroll4c",val=0,bop=true,Consumable=true,rss="Outfitter",rsslvl=240},
["9B95D5D10F01010101"] = {akey="IFA354A9B69A09247,59009486D9FB6F26,,,,,,",de="Anleitung: Große Verstärkung der Listigkeit",en="Recipe: Greater Wily Augment",fr="Recette : Augmentation de roublardise supérieure",ru="Чертеж: Крепкое усиление лукавства",icon="scroll8b",val=0,q=3,bop=true,Consumable=true,rss="Outfitter",rsslvl=300},
["B2F19B6201010101"] = {akey="I0C46F8B21987A747,45750E33242DAE7B,,,,,,",de="Anleitung: Verbundkutte",en="Recipe: Composite Cowl",fr="Patron : Capuche en tissu composite",ru="Выкройка: капюшон из смешанной ткани",icon="scroll8b",val=0,q=1,bop=true,Consumable=true,rss="Outfitter",rsslvl=210},
["A795D5D10F01010101"] = {akey="IFA354AA70701CC08,8F6FB05340A74894,,,,,,",de="Anleitung: Große Verstärkung der Genialität",en="Recipe: Greater Brilliant Augment",fr="Recette : Augmentation éclatante supérieure",ru="Чертеж: Крепкое сверкающее усиление",icon="scroll8b",val=0,q=3,bop=true,Consumable=true,rss="Outfitter",rsslvl=300},
["B5C19AD60F01010101"] = {akey="IFAC6A0B532B47AF3,E36CABBD1952DD24,,,,,,",de="Anleitung: Bewehrtes Empyreum-Cape",en="Recipe: Fortified Empyrean Cape",fr="Patron : Cape empyréenne fortifiée",ru="Выкройка: Усиленный эмпирейский плащ",icon="scroll8b",val=1,q=2,Consumable=true,rss="Outfitter",rsslvl=375},
["BEF19B6201010101"] = {akey="I0C46F8BE23BDE949,4567D512B319ACA1,,,,,,",de="Anleitung: Wollkutte",en="Recipe: Wool Cowl",fr="Patron : Capuche en laine",ru="Выкройка: шерстяной капюшон",icon="scroll1a",val=0,q=1,bop=true,Consumable=true,rss="Outfitter",rsslvl=100},
["A8D79EF40601010101"] = {akey="I6E87ABA867B2FA94,1F35ABAA7E9CF678,,,,,,",de="Anleitung: Dunkelstoff-Gürtel",en="Recipe: Darkcloth Belt",fr="Patron : Ceinture en tissombre",ru="Чертеж: пояс из темной ткани",icon="scroll8b",val=1,q=2,Consumable=true,rss="Outfitter",rsslvl=300},
["E5C2FACB0601010101"] = {akey="I697EA16514E04652,E89CCF98F509815C,,,,,,",de="Anleitung: Gewand der fließenden Dunkelheit",en="Recipe: Robes of the Flowing Dark",fr="Patron : Chasuble des Ténèbres ondulantes",ru="Выкройка: мантия струящейся тьмы",icon="scroll2a",val=0,q=3,bop=true,Consumable=true,rss="Outfitter",rsslvl=300},
["E9EFFAC70501010101"] = {akey="I58FEB7E906DB087F,779E1CEDC6A712FD,,,,,,",de="Anleitung: Verkohlte Lederstiefel",en="Recipe: Charred Leather Boots",fr="Patron : Bottes en cuir calcinées",ru="Выкройка: опаленные кожаные сапоги",icon="scroll8b",val=0,q=3,bop=true,Consumable=true,rss="Outfitter",rsslvl=300},
["A9F8F6E30F01010101"] = {akey="IFC7DBC29087DC689,76D8C332D4DFF3DB,,,,,,",de="Anleitung: Zornige Gestreifte Lederkapuze",en="Recipe: Furious Striped Leather Hood",fr="Patron : Capuchon furieux en cuir rayé",ru="Выкройка: Яростный плетеный кожаный капюшон",icon="scroll8b",val=0,q=2,bop=true,Consumable=true,rss="Outfitter",rsslvl=350},
["F5D0E2E20F01010101"] = {akey="IFC58A8751E69974B,34C2A23B66E08E45,,,,,,",de="Anleitung: Leuchtende Empyreum-Hose",en="Recipe: Luminous Empyrean Trousers",fr="Patron : Chausses empyréennes lumineuses",ru="Выкройка: Искристые эмпирейские штаны",icon="scroll8b",val=0,q=2,bop=true,accBound=true,Consumable=true,rss="Outfitter",rsslvl=375,rf="The Qaijiri",rfl=4},
["8BBECCFF0F01010101"] = {akey="IFFF31F0B7394FB55,47C31AEABC7FB005,,,,,,",de="Anleitung: Lanzan-Schuhe",en="Recipe: Lanzan Shoes",fr="Patron : Chaussures en lanzane",ru="Выкройка: Ланзановые туфли",icon="scroll8b",val=0,q=1,bop=true,Consumable=true,rss="Outfitter",rsslvl=310},
["FDF68D800601010101"] = {akey="I60037B7D517D66FE,08CE64AB7BF4262F,,,,,,",de="Anleitung: Peiniger-Gewand",en="Recipe: Tormentor's Robe",fr="Patron : Chasuble du Tourmenteur",ru="Выкройка: мантия мучителя",icon="scroll8b",val=0,q=3,bop=true,Consumable=true,rss="Outfitter",rsslvl=300},
["BCD387960201010101"] = {akey="I22C1E9BC1BE3C3D6,FEB37070DED3EB24,,,,,,",de="Anleitung: Hexengespinst-Kniehose",en="Recipe: Witchweave Breeches",fr="Patron : Braies en toile de sorcière",ru="Выкройка: штаны из ведьмина полотна",icon="scroll9a",val=0,q=2,bop=true,Consumable=true,rss="Outfitter",rsslvl=290},
["A7A4FFEC0401010101"] = {akey="I4D9FD2272FEB4347,57A2C87C47209695,,,,,,",de="Anleitung: Ätherische Einlagen",en="Recipe: Ethereal Insoles",fr="Plan : Semelles éthérées",ru="Выкройка: эфирные стельки",icon="scroll1a",val=0,q=3,bop=true,Consumable=true,rss="Outfitter",rsslvl=210},
["97BECCFF0F01010101"] = {akey="IFFF31F171C7E71D6,67F3B87299470F40,,,,,,",de="Anleitung: Chiffonschuhe",en="Recipe: Chiffon Shoes",fr="Patron : Chaussures en mousseline",ru="Выкройка: Шифоновые туфли",icon="scroll8b",val=0,q=1,bop=true,Consumable=true,rss="Outfitter",rsslvl=350},
["C1E4B5FC0701010101"] = {akey="I7F8D72414EB185CD,3612CDF7E7A13AFA,,,,,,",de="Anleitung: Knotendruckstoff",en="Recipe: Knotwork Print Cloth",fr="Patron : Tissu à imprimé cordages",ru="Выкройка: Вязаный трикотаж",icon="scroll4c",val=0,bop=true,Consumable=true,rss="Outfitter",rsslvl=300},
["9C95D5D10F01010101"] = {akey="IFA354A9C5B4A6E39,89C072B1AA8C02AC,,,,,,",de="Anleitung: Empyreum-Verstärkung der Listigkeit",en="Recipe: Empyrean Wily Augment",fr="Recette : Augmentation de roublardise empyréenne",ru="Рецепт: Коварное эмпирейское усиление",icon="scroll8b",val=0,q=2,bop=true,Consumable=true,rss="Outfitter",rsslvl=340},
["B3F19B6201010101"] = {akey="I0C46F8B33B899F1C,5488F9CA5311CC1E,,,,,,",de="Anleitung: Exotischer Ledergürtel",en="Recipe: Exotic Leather Belt",fr="Patron : Ceinture en cuir exotique",ru="Выкройка: пояс из экзотической кожи",icon="scroll8b",val=0,q=1,bop=true,Consumable=true,rss="Outfitter",rsslvl=190},
["A895D5D10F01010101"] = {akey="IFA354AA804526725,52D5CC68DEA9CA59,,,,,,",de="Anleitung: Empyreum-Verstärkung der Genialität",en="Recipe: Empyrean Brilliant Augment",fr="Recette : Augmentation éclatante empyréenne",ru="Рецепт: Блистательное эмпирейское усиление",icon="scroll8b",val=0,q=2,bop=true,Consumable=true,rss="Outfitter",rsslvl=340},
["B6C19AD60F01010101"] = {akey="IFAC6A0B65AFAF126,EC5761F1E351CF0E,,,,,,",de="Anleitung: Leuchtendes Empyreum-Cape",en="Recipe: Luminous Empyrean Cape",fr="Patron : Cape empyréenne lumineuse",ru="Выкройка: Искристый эмпирейский плащ",icon="scroll8b",val=1,q=2,Consumable=true,rss="Outfitter",rsslvl=375},
["BFF19B6201010101"] = {akey="I0C46F8BF01C7A0D7,1BC874A7FE0B7035,,,,,,",de="Anleitung: Mittlerer Ledergürtel",en="Recipe: Medium Leather Belt",fr="Patron : Ceinture en cuir moyen",ru="Выкройка: ремень из средней кожи",icon="scroll1a",val=0,q=1,bop=true,Consumable=true,rss="Outfitter",rsslvl=80},
["A9D79EF40601010101"] = {akey="I6E87ABA92C58275C,313802BF89F9BDA1,,,,,,",de="Anleitung: Aufbereitete Lederstiefel",en="Recipe: Conditioned Leather Boots",fr="Patron : Bottes en cuir apprêté",ru="Выкройка: сапоги из выделанной кожи",icon="scroll8b",val=1,q=2,Consumable=true,rss="Outfitter",rsslvl=300},
["DCCEDB800401010101"] = {akey="I4016E75C589AA02C,34DC8F8ED7BB67C8,,,,,,",de="Anleitung: Gamaschen des Jägers",en="Recipe: Leggings of the Hunter",fr="Patron : Jambières du Chasseur",ru="Выкройка: наголенники охотника",icon="scroll2a",val=0,q=3,bop=true,Consumable=true,rss="Outfitter",rsslvl=300},
["EAEFFAC70501010101"] = {akey="I58FEB7EA1179D8FF,89A0740252045D75,,,,,,",de="Anleitung: Verkohlte Stoffpantoffeln",en="Recipe: Charred Cloth Slippers",fr="Patron : Mules en tissu calcinées",ru="Выкройка: опаленные матерчатые башмаки",icon="scroll8b",val=0,q=3,bop=true,Consumable=true,rss="Outfitter",rsslvl=300},
["AAF8F6E30F01010101"] = {akey="IFC7DBC2A2A3D982F,0B18CBF4949F0B9B,,,,,,",de="Anleitung: Bewehrte Gestreifte Lederkapuze",en="Recipe: Fortified Striped Leather Hood",fr="Patron : Capuchon fortifié en cuir rayé",ru="Выкройка: Усиленный плетеный кожаный капюшон",icon="scroll8b",val=1,q=2,Consumable=true,rss="Outfitter",rsslvl=350},
["DA92D3E80F01010101"] = {akey="IFD14C95A6C5E92E6,F54E5E77CD327EBD,,,,,,",de="Anleitung: Chiffonbeutel",en="Recipe: Chiffon Bag",fr="Patron : Sac en mousseline",ru="Выкройка: Шифоновая сумка",icon="scroll8b",val=0,q=1,bop=true,Consumable=true,rss="Outfitter",rsslvl=340},
["F6D0E2E20F01010101"] = {akey="IFC58A876190D5FEA,4B8D3EC818B31765,,,,,,",de="Anleitung: Zornige Echthaut-Schulterpolster",en="Recipe: Furious Truehide Shoulderpads",fr="Patron : Protège-épaules furieux en peau authentique",ru="Выкройка: Яростные наплечники чистой кожи",icon="scroll8b",val=0,q=2,bop=true,Consumable=true,rss="Outfitter",rsslvl=375},
["8CBECCFF0F01010101"] = {akey="IFFF31F0C7651C56A,7C8A8A33408E3272,,,,,,",de="Anleitung: Leuchtende Lanzan-Kutte",en="Recipe: Luminous Lanzan Cowl",fr="Patron : Capuche lumineuse en lanzane",ru="Выкройка: Искристый ланзановый капюшон",icon="scroll8b",val=10000,q=2,bop=true,Consumable=true,rss="Outfitter",rsslvl=310},
["FEF68D800601010101"] = {akey="I60037B7E26232184,37B4EC2A82882492,,,,,,",de="Anleitung: Peiniger-Schulterpolster",en="Recipe: Tormentor's Shoulderpads",fr="Patron : Protège-épaules du Tourmenteur",ru="Выкройка: наплечники мучителя",icon="scroll8b",val=0,q=3,bop=true,Consumable=true,rss="Outfitter",rsslvl=300},
["BDD387960201010101"] = {akey="I22C1E9BD545C0901,2E4E0397C2FE118C,,,,,,",de="Anleitung: Hexengespinst-Tasche",en="Recipe: Witchweave Bag",fr="Patron : Sac en toile de sorcière",ru="Выкройка: сумка из ведьмина полотна",icon="scroll9a",val=0,q=2,bop=true,Consumable=true,rss="Outfitter",rsslvl=290},
["A8A4FFEC0401010101"] = {akey="I4D9FD2280645E92D,69A51F91527D5DBE,,,,,,",de="Anleitung: Ätherische Polsterung",en="Recipe: Ethereal Padding",fr="Recette : Rembourrage éthéré",ru="Выкройка: эфирная подбивка",icon="scroll1a",val=0,q=3,bop=true,Consumable=true,rss="Outfitter",rsslvl=210},
["98BECCFF0F01010101"] = {akey="IFFF31F180B19DAD9,4891C73A91FD9880,,,,,,",de="Anleitung: Einfallsreichtum",en="Recipe: Resourcefulness",fr="Patron : Ingéniosité",ru="Рецепт: Находчивость",icon="scroll8b",val=0,q=2,bop=true,Consumable=true,rss="Outfitter",rsslvl=370},
["C2E4B5FC0701010101"] = {akey="I7F8D724231C888DC,4815A85A72FE0224,,,,,,",de="Anleitung: Ockerfarbener Teppich",en="Recipe: Ochre Rug",fr="Patron : Tapis ocre",ru="Выкройка: Желто-коричневый коврик",icon="scroll4c",val=0,bop=true,Consumable=true,rss="Outfitter",rsslvl=360},
["9D95D5D10F01010101"] = {akey="IFA354A9D6D9F3E57,6F23D26D08DFDC56,,,,,,",de="Anleitung: Stellare Verstärkung der Listigkeit",en="Recipe: Stellar Wily Augment",fr="Recette : Augmentation de roublardise stellaire",ru="Рецепт: Звездная выносливость и уклонение",icon="scroll8b",val=0,q=3,bop=true,Consumable=true,rss="Outfitter",rsslvl=375},
["B4F19B6201010101"] = {akey="I0C46F8B459F35CE1,FF67F02C2627DB99,,,,,,",de="Anleitung: Verbundgurt",en="Recipe: Composite Waistband",fr="Patron : Ceinturon en tissu composite",ru="Выкройка: ремень из смешанной ткани",icon="scroll8b",val=0,q=1,bop=true,Consumable=true,rss="Outfitter",rsslvl=190},
["85BBB2AC0401010101"] = {akey="I458C9D856D71C0A6,58C59000AD333670,,,,,,",de="Anleitung: Feine Lederhandschuhe",en="Recipe: Fine Leather Gloves",fr="Patron : Gants en cuir de qualité",ru="Выкройка: перчатки из выделанной кожи",icon="scroll1a",val=0,q=2,bop=true,Consumable=true,rss="Outfitter",rsslvl=120},
["A995D5D10F01010101"] = {akey="IFA354AA91EFB9C6F,6135AC572FF7BFF7,,,,,,",de="Anleitung: Stellare Verstärkung der Genialität",en="Recipe: Stellar Brilliant Augment",fr="Recette : Augmentation éclatante stellaire",ru="Рецепт: Звездный интеллект и сила критического удара",icon="scroll8b",val=0,q=3,bop=true,Consumable=true,rss="Outfitter",rsslvl=375},
["B7C19AD60F01010101"] = {akey="IFAC6A0B75397B893,DF9BAEA2A97A468D,,,,,,",de="Anleitung: Holzwolle",en="Recipe: Excelsior",fr="Patron : Excelsior",ru="Рецепт: Эксцельсиор",icon="scroll8b",val=0,q=2,bop=true,Consumable=true,rss="Outfitter",rsslvl=375},
["C0F19B6201010101"] = {akey="I0C46F8C072DB942B,38C67E13E94CE1DC,,,,,,",de="Anleitung: Wollgurt",en="Recipe: Wool Waistband",fr="Patron : Ceinturon en laine",ru="Выкройка: шерстяной пояс",icon="scroll1a",val=0,q=1,bop=true,Consumable=true,rss="Outfitter",rsslvl=80},
["D9D99DE10F01010101"] = {akey="IFC276CD94111929D,DE619E947300B742,,,,,,",de="Anleitung: Größere Verstärkung der Standhaftigkeit",en="Recipe: Major Unwavering Augment",fr="Recette : Augmentation de détermination majeure",ru="Чертеж: Большое усиление непоколебимости",icon="scroll8b",val=0,q=2,bop=true,Consumable=true,rss="Outfitter",rsslvl=300},
["ABF8F6E30F01010101"] = {akey="IFC7DBC2B3424CD7B,1D1B23099FFBD2C4,,,,,,",de="Anleitung: Leuchtende Chiffonkutte",en="Recipe: Luminous Chiffon Cowl",fr="Patron : Capuche lumineuse en mousseline",ru="Выкройка: Искристый шифоновый капюшон",icon="scroll8b",val=0,q=2,bop=true,Consumable=true,rss="Outfitter",rsslvl=350},
["85D1B2BB0401010101"] = {akey="I476CA88534657D97,29572592527F4EFA,,,,,,",de="Anleitung: Wegewachen-Brigantine",en="Recipe: Wayward Brigandine",fr="Patron : Brigandine incontrôlable",ru="Чертеж: бригандина своенравия",icon="scroll9a",val=0,q=2,bop=true,accBound=true,Consumable=true,rss="Outfitter",rsslvl=300,rf="Icewatch",rfl=3},
["DB92D3E80F01010101"] = {akey="IFD14C95B1C6B6E21,0750B58CD88F45E6,,,,,,",de="Anleitung: Empyreum-Beutel",en="Recipe: Empyrean Bag",fr="Patron : Sac empyréen",ru="Выкройка: Эмпирейская сумка",icon="scroll8b",val=0,q=2,bop=true,Consumable=true,rss="Outfitter",rsslvl=375},
["F7D0E2E20F01010101"] = {akey="IFC58A87750C7E29C,4FAF2C363C3BC40A,,,,,,",de="Anleitung: Leuchtender Empyreum-Mantel",en="Recipe: Luminous Empyrean Mantle",fr="Patron : Houppelande empyréenne lumineuse",ru="Выкройка: Искристая эмпирейская мантия",icon="scroll8b",val=0,q=2,bop=true,Consumable=true,rss="Outfitter",rsslvl=375},
["8DBECCFF0F01010101"] = {akey="IFFF31F0D2B35ECFB,2F1388D98131025F,,,,,,",de="Anleitung: Leuchtendes Lanzancape",en="Recipe: Luminous Lanzan Cape",fr="Patron : Braies lumineuses en lanzane",ru="Выкройка: Искристый ланзановый плащ",icon="scroll8b",val=0,q=2,bop=true,Consumable=true,rss="Outfitter",rsslvl=320},
["FFF68D800601010101"] = {akey="I60037B7F2E7C2D56,2CD312D512AE37D0,,,,,,",de="Anleitung: Todbringer-Brigantine",en="Recipe: Deathbringer Brigandine",fr="Patron : Brigandine mortuaire",ru="Выкройка: бригандина вестника смерти",icon="scroll8b",val=0,q=3,bop=true,Consumable=true,rss="Outfitter",rsslvl=300},
["C4ADFD940501010101"] = {akey="I529F56C428D64116,2A97871A1BFFF03E,,,,,,",de="Anleitung: Marodeur-Kniehose",en="Recipe: Marauder's Breeches",fr="Patron : Braies du maraudeur",ru="Чертеж: штаны мародера",icon="scroll1",val=0,q=2,bop=true,accBound=true,Consumable=true,rss="Outfitter",rsslvl=190,rf="The Runeguard",rfl=1},
["A9A4FFEC0401010101"] = {akey="I4D9FD2295E65CCA4,87BBCB4F14C39178,,,,,,",de="Anleitung: Transportierbare Lebensquelle",en="Recipe: Portable Lifespring",fr="Plan : Source de vie portable",ru="Чертеж: портативный источник Жизни",icon="scroll1a",val=0,q=3,bop=true,Consumable=true,rss="Outfitter",rsslvl=260},
["9E95D5D10F01010101"] = {akey="IFA354A9E03FB2C9B,81262982143CA37F,,,,,,",de="Anleitung: Größere Verstärkung der Gerissenheit",en="Recipe: Major Cunning Augment",fr="Recette : Augmentation d'astuce majeure",ru="Чертеж: Большое сверкающее усиление",icon="scroll8b",val=0,q=2,bop=true,Consumable=true,rss="Outfitter",rsslvl=300},
["CE80BAA10401010101"] = {akey="I442E804E46ED542E,A4914830130F09D2,,,,,,",de="Anleitung: Strahlende Brillanz",en="Recipe: Radiant Brilliance",fr="Patron : Brillance rayonnante",ru="Рецепт: ослепительный блеск",icon="scroll8",val=0,q=3,bop=true,Consumable=true,rss="Outfitter",rsslvl=300},
["B5F19B6201010101"] = {akey="I0C46F8B55AC5226E,095D83B6AE192519,,,,,,",de="Anleitung: Dicke Lederkapuze",en="Recipe: Thick Leather Hood",fr="Patron : Capuchon en cuir épais",ru="Чертеж: капюшон из толстой кожи",icon="scroll8b",val=0,q=1,bop=true,Consumable=true,rss="Outfitter",rsslvl=170},
["D8A1ECF60F01010101"] = {akey="IFEDB10D860617971,D74A1C680EA8E95E,,,,,,",de="Anleitung: Empyreum-Verstärkung der Standhaftigkeit",en="Recipe: Empyrean Unwavering Augment",fr="Recette : Augmentation inébranlable empyréenne",ru="Рецепт: Стойкое эмпирейское усиление",icon="scroll8b",val=0,q=2,bop=true,Consumable=true,rss="Outfitter",rsslvl=340},
["89D4EAB90401010101"] = {akey="I473AAA09074503D5,E9F2C56BCB230825,,,,,,",de="Anleitung: Eisenklauen-Kopfschutz",en="Recipe: Iron Claw Headwrap",fr="Patron : Coiffe de Griffes de fer",ru="Чертеж: косынка железного когтя",icon="scroll1",val=0,q=2,bop=true,accBound=true,Consumable=true,rss="Outfitter",rsslvl=130,rf="Iron Claw Trappers",rfl=1},
["CEFCEC3601010101"] = {akey="I06DB3E4E014CCA9E,4AE176C08468C56A,,,,,,",de="Anleitung: Dunkelstoff-Pantoffeln",en="Recipe: Darkcloth Slippers",fr="Patron : Mules en tissombre",ru="Чертеж: башмаки из темной ткани",icon="scroll8b",val=1,q=2,Consumable=true,rss="Outfitter",rsslvl=300},
["E8C2FACB0601010101"] = {akey="I697EA168344691A5,0AD7C89C5D477B7A,,,,,,",de="Anleitung: Kapuze der fließenden Dunkelheit",en="Recipe: Hood of the Flowing Dark",fr="Patron : Capuchon des Ténèbres ondulantes",ru="Выкройка: капюшон струящейся тьмы",icon="scroll2a",val=0,q=3,bop=true,Consumable=true,rss="Outfitter",rsslvl=300},
["F48785DD0701010101"] = {akey="I7BA143F436DFBD9A,0976163F1C51AE35,,,,,,",de="Anleitung: Schiefergespinst-Gurt",en="Recipe: Shaleweave Waistband",fr="Patron : Ceinturon en tisse-roc",ru="Выкройка: ремень из сланцевины",icon="scroll8b",val=0,q=2,bop=true,Consumable=true,rss="Outfitter",rsslvl=170},
["D0BCD0AD0101010101"] = {akey="I15B41E503603F36A,08D37362F20C139D,,,,,,",de="Anleitung: Nachtschatten-Gürtel",en="Recipe: Nightshade Belt",fr="Plan : Ceinture d'ombrenuit",ru="Чертеж: ремень ночной тени",icon="scroll1",val=0,q=2,bop=true,accBound=true,Consumable=true,rss="Outfitter",rsslvl=90,rf="Gloamwood Waykeepers",rfl=2},
["DED3E0E30601010101"] = {akey="I6C7829DE7DC5F9C6,E6264C72852888F3,,,,,,",de="Anleitung: Zornige Echthaut-Kapuze",en="Recipe: Furious Truehide Hood",fr="Patron : Capuchon furieux en peau authentique",ru="Выкройка: Яростный капюшон чистой кожи",icon="scroll8b",val=0,q=3,bop=true,Consumable=true,rss="Outfitter",rsslvl=375},
["DAD99DE10F01010101"] = {akey="IFC276CDA00D0402A,2FA8A79D78D7D6DA,,,,,,",de="Anleitung: Große Verstärkung der Standhaftigkeit",en="Recipe: Greater Unwavering Augment",fr="Recette : Augmentation de détermination supérieure",ru="Чертеж: Крепкое усиление непоколебимости",icon="scroll8b",val=0,q=3,bop=true,Consumable=true,rss="Outfitter",rsslvl=300},
["F8D0E2E20F01010101"] = {akey="IFC58A8784007FD7D,42F378E782643B88,,,,,,",de="Anleitung: Zornige Echthaut-Schleicher",en="Recipe: Furious Truehide Slinkers",fr="Patron : Bottillons furieux en peau authentique",ru="Выкройка: Яростные сандалии чистой кожи",icon="scroll8b",val=30000,q=2,bop=true,Consumable=true,rss="Outfitter",rsslvl=375},
["8EBECCFF0F01010101"] = {akey="IFFF31F0E408689D6,7F93FF9B5DB1A3D1,,,,,,",de="Anleitung: Gestreifte Lederhandschuhe",en="Recipe: Striped Leather Gloves",fr="Patron : Gants en cuir rayé",ru="Выкройка: Перчатки плетеной кожи",icon="scroll8b",val=0,q=1,bop=true,Consumable=true,rss="Outfitter",rsslvl=330},
["80F78D800601010101"] = {akey="I60037B805B6E286C,3F86A70AC621DB37,,,,,,",de="Anleitung: Todbringer-Schulterschutz",en="Recipe: Deathbringer Shoulders",fr="Patron : Couvre-épaules mortuaire",ru="Выкройка: наплечи вестника смерти",icon="scroll8b",val=0,q=3,bop=true,Consumable=true,rss="Outfitter",rsslvl=300},
["AAA4FFEC0401010101"] = {akey="I4D9FD22A30A4635A,740A1B64CAF57089,,,,,,",de="Anleitung: Transportierbares Geschütz",en="Recipe: Portable Turret",fr="Plan : Tourelle portable",ru="Чертеж: портативная огневая установка",icon="scroll1a",val=0,q=3,bop=true,Consumable=true,rss="Outfitter",rsslvl=260},
["9F95D5D10F01010101"] = {akey="IFA354A9F6AB999F1,8C230CC144C1DB69,,,,,,",de="Anleitung: Große Verstärkung der Gerissenheit",en="Recipe: Greater Cunning Augment",fr="Recette : Augmentation d'astuce supérieure",ru="Чертеж: Крепкое усиление хитрости",icon="scroll8b",val=0,q=3,bop=true,Consumable=true,rss="Outfitter",rsslvl=300},
["D1CDD2FF0F01010101"] = {akey="IFFF4A6D1102ABD21,6B58D77BB32336C5,,,,,,",de="Anleitung: Vorstellungskraft",en="Recipe: Imagination",fr="Patron : Imagination",ru="Рецепт: Воображение",icon="scroll8b",val=0,q=2,bop=true,Consumable=true,rss="Outfitter",rsslvl=330},
["B6F19B6201010101"] = {akey="I0C46F8B61A3F24B5,FE7BAA61BE3EB508,,,,,,",de="Anleitung: Seidenkutte",en="Recipe: Silk Cowl",fr="Patron : Capuche en soie",ru="Выкройка: шелковый капюшон",icon="scroll8b",val=0,q=1,bop=true,Consumable=true,rss="Outfitter",rsslvl=170},
["978D8E4A01010101"] = {akey="I094386977D982A4A,2D5B36E8A8C24F6D,,,,,,",de="Anleitung: Eklipse des Schwindlers",en="Recipe: Trickster's Eclipse",fr="Recette : Éclipse d'entourloupeur",ru="Рецепт: Затмение ловкача",icon="scroll8b",val=0,q=3,bop=true,Consumable=true,rss="Outfitter",rsslvl=375},
["D9A1ECF60F01010101"] = {akey="IFEDB10D93DCA7A70,1D9EA3FA092497F8,,,,,,",de="Anleitung: Stellare Verstärkung der Standhaftigkeit",en="Recipe: Stellar Unwavering Augment",fr="Recette : Augmentation inébranlable stellaire",ru="Рецепт: Звездная сила заклинаний",icon="scroll8b",val=0,q=3,bop=true,Consumable=true,rss="Outfitter",rsslvl=375},
["F8E5F6A10601010101"] = {akey="I643DB2F8281FADE8,EAC31FB807080F6F,,,,,,",de="Anleitung: Dünnleder-Kapuze",en="Recipe: Thin Leather Hood",fr="Plan : Capuchon en cuir fin",ru="Выкройка: капюшон из тонкой кожи",icon="scroll4",val=0,q=1,bop=true,Consumable=true,rss="Outfitter",rsslvl=60},
["F58785DD0701010101"] = {akey="I7BA143F55818ACCD,19AE8DE2A89253BF,,,,,,",de="Anleitung: Feiner Leder-Schulterschutz",en="Recipe: Fine Leather Shoulders",fr="Patron : Couvre-épaules en cuir de qualité",ru="Выкройка: наплечники из выделанной кожи",icon="scroll8b",val=0,q=2,bop=true,Consumable=true,rss="Outfitter",rsslvl=180},
["EBF596DE0F01010101"] = {akey="IFBC5BAEB6640C802,F73D9FDD900DAC55,,,,,,",de="Anleitung: Zorniges Lanzancape",en="Recipe: Furious Lanzan Cape",fr="Patron : Cape furieuse en lanzane",ru="Выкройка: Яростный ланзановый плащ",icon="scroll8b",val=0,q=2,bop=true,Consumable=true,rss="Outfitter",rsslvl=320},
["DFD3E0E30601010101"] = {akey="I6C7829DF63811BF2,FB179253ECFE7CF1,,,,,,",de="Anleitung: Bewehrte Echthaut-Kapuze",en="Recipe: Fortified Truehide Hood",fr="Patron : Capuchon fortifié en peau authentique",ru="Выкройка: Усиленный капюшон из чистой кожи",icon="scroll8b",val=1,q=3,Consumable=true,rss="Outfitter",rsslvl=375},
["F9D0E2E20F01010101"] = {akey="IFC58A87977CA9598,5FE7CE25191C73B0,,,,,,",de="Anleitung: Leuchtende Empyreum-Schuhe",en="Recipe: Luminous Empyrean Slippers",fr="Patron : Pantoufles empyréennes lumineuses",ru="Выкройка: Искристые эмпирейские сандалии",icon="scroll8b",val=30000,q=2,bop=true,Consumable=true,rss="Outfitter",rsslvl=375},
["8FBECCFF0F01010101"] = {akey="IFFF31F0F61E45C3D,238E4BFE4F41EE87,,,,,,",de="Anleitung: Chiffonhandwickel",en="Recipe: Chiffon Handwraps",fr="Patron : Protège-mains en mousseline",ru="Выкройка: Шифоновые обмотки",icon="scroll8b",val=0,q=1,bop=true,Consumable=true,rss="Outfitter",rsslvl=330},
["81F78D800601010101"] = {akey="I60037B810E8F5471,130B61C0805AC818,,,,,,",de="Anleitung: Jenseitsgenähte Brigantine",en="Recipe: Netherstitched Brigandine",fr="Patron : Brigandine suture-néant",ru="Выкройка: бригандина теневого шитья",icon="scroll8b",val=0,q=3,bop=true,Consumable=true,rss="Outfitter",rsslvl=300},
["A095D5D10F01010101"] = {akey="IFA354AA00997D3C1,646F89A1A5710D8F,,,,,,",de="Anleitung: Empyreum-Verstärkung der Gerissenheit",en="Recipe: Empyrean Cunning Augment",fr="Recette : Augmentation d'astuce empyréenne",ru="Рецепт: Эмпирейское усиление хитрости",icon="scroll8b",val=0,q=2,bop=true,Consumable=true,rss="Outfitter",rsslvl=340},
["D2CDD2FF0F01010101"] = {akey="IFFF4A6D27FFEEE32,00FDA5B7788ECF79,,,,,,",de="Anleitung: Zorniges Chiffoncape",en="Recipe: Furious Chiffon Cape",fr="Patron : Cape furieuse en mousseline",ru="Выкройка: Яростный шифоновый плащ",icon="scroll8b",val=0,q=2,bop=true,Consumable=true,rss="Outfitter",rsslvl=360},
["B7F19B6201010101"] = {akey="I0C46F8B77B51AF9E,2D6231E0C4D2B36B,,,,,,",de="Anleitung: Dicker Ledergürtel",en="Recipe: Thick Leather Belt",fr="Patron : Ceinture en cuir épais",ru="Чертеж: плотный кожаный пояс",icon="scroll8b",val=0,q=1,bop=true,Consumable=true,rss="Outfitter",rsslvl=150},
["988D8E4A01010101"] = {akey="I0943869859267201,610A03DFD5CC0FC8,,,,,,",de="Anleitung: Eklipse des Magiers",en="Recipe: Magician's Eclipse",fr="Plan : Éclipse de magicien",ru="Рецепт: Затмение фокусника",icon="scroll8b",val=0,q=3,bop=true,Consumable=true,rss="Outfitter",rsslvl=375},
["F9E5F6A10601010101"] = {akey="I643DB2F97BB7B2F0,E6142FF4D09C0496,,,,,,",de="Anleitung: Baumwollkutte",en="Recipe: Cotton Cowl",fr="Patron : Capuche en coton",ru="Выкройка: хлопковый капюшон",icon="scroll4",val=0,q=1,bop=true,Consumable=true,rss="Outfitter",rsslvl=60},
["EAC2FACB0601010101"] = {akey="I697EA16A393889E9,182BB33B3238BB1A,,,,,,",de="Anleitung: Geistgespinst-Tasche",en="Recipe: Spiritweave Bag",fr="Patron : Sac en tisse-mâne",ru="Выкройка: духотканая сумка",icon="scroll2a",val=0,q=3,bop=true,Consumable=true,rss="Outfitter",rsslvl=300},
["F68785DD0701010101"] = {akey="I7BA143F626216570,233C4E9A0545703E,,,,,,",de="Anleitung: Schiefergespinst-Handbandagen",en="Recipe: Shaleweave Handwraps",fr="Patron : Protège-mains en tisse-roc",ru="Выкройка: обмотки из сланцевины",icon="scroll8b",val=0,q=2,bop=true,Consumable=true,rss="Outfitter",rsslvl=190},
["AB8AF38C0501010101"] = {akey="I519CC52B0FBBA2C5,509035590D55BBCF,,,,,,",de="Anleitung: Mantel der fließenden Dunkelheit",en="Recipe: Mantle of the Flowing Dark",fr="Patron : Cape des Ténèbres ondulantes",ru="Выкройка: оплечье струящейся тьмы",icon="scroll2a",val=0,q=3,bop=true,Consumable=true,rss="Outfitter",rsslvl=300},
["ECF596DE0F01010101"] = {akey="IFBC5BAEC60E490A1,22DFA949B9AB6BB8,,,,,,",de="Anleitung: Bewehrtes Lanzancape",en="Recipe: Fortified Lanzan Cape",fr="Patron : Cape fortifiée en lanzane",ru="Выкройка: Усиленный ланзановый плащ",icon="scroll8b",val=0,q=2,bop=true,accBound=true,Consumable=true,rss="Outfitter",rsslvl=320,rf="Eternal City Survivors",rfl=1},
["EED0E2E20F01010101"] = {akey="IFC58A86E0F14CD7D,0EDC121490C3F09F,,,,,,",de="Anleitung: Bewehrte Kompakte Ledergamaschen",en="Recipe: Fortified Dense Leather Leggings",fr="Patron : Jambières fortifiées en cuir dense",ru="Выкройка: Усиленные наголенники из плотной кожи",icon="scroll8b",val=1,q=2,Consumable=true,rss="Outfitter",rsslvl=330},
["E0D3E0E30601010101"] = {akey="I6C7829E06CD437E8,E489FD891278089D,,,,,,",de="Anleitung: Leuchtende Empyreum-Kapuze",en="Recipe: Luminous Empyrean Cowl",fr="Patron : Capuche empyréenne lumineuse",ru="Выкройка: Искристый эмпирейский капюшон",icon="scroll8b",val=1,q=3,Consumable=true,rss="Outfitter",rsslvl=375},
["90BECCFF0F01010101"] = {akey="IFFF31F105FF18820,5274D37D55D5ECEA,,,,,,",de="Anleitung: Leuchtendes Lanzan-Gewand",en="Recipe: Luminous Lanzan Robe",fr="Patron : Ceinturon lumineux en lanzane",ru="Выкройка: Искристая ланзановая мантия",icon="scroll8b",val=0,q=2,bop=true,accBound=true,Consumable=true,rss="Outfitter",rsslvl=330,rf="Necropolis Caretakers",rfl=1},
["82F78D800601010101"] = {akey="I60037B82343F35D1,F6EE71E956079058,,,,,,",de="Anleitung: Jenseitsgenähter Schulterschutz",en="Recipe: Netherstitched Shoulders",fr="Patron : Couvre-épaules suture-néant",ru="Выкройка: наплечники теневого шитья",icon="scroll8b",val=0,q=3,bop=true,Consumable=true,rss="Outfitter",rsslvl=300},
["A195D5D10F01010101"] = {akey="IFA354AA117DC71DF,2B6EECAE7FE69E95,,,,,,",de="Anleitung: Stellare Verstärkung der Gerissenheit",en="Recipe: Stellar Cunning Augment",fr="Recette : Augmentation d'astuce stellaire",ru="Рецепт: Звездный интеллект и сила заклинаний",icon="scroll8b",val=0,q=3,bop=true,Consumable=true,rss="Outfitter",rsslvl=375},
["B8F19B6201010101"] = {akey="I0C46F8B813C8A18B,4F1B54C44127B8B0,,,,,,",de="Anleitung: Seidengurt",en="Recipe: Silk Waistband",fr="Patron : Ceinturon en soie",ru="Выкройка: шелковый пояс",icon="scroll8b",val=0,q=1,bop=true,Consumable=true,rss="Outfitter",rsslvl=150},
["998D8E4A01010101"] = {akey="I094386990329258D,4DBD6DEC056D0C36,,,,,,",de="Anleitung: Empyreum-Blitzen",en="Recipe: Empyrean Coruscation",fr="Recette : Coruscation empyréenne",ru="Рецепт: Эмпирейское сияние",icon="scroll8b",val=0,q=3,bop=true,Consumable=true,rss="Outfitter",rsslvl=375},
["DBA1ECF60F01010101"] = {akey="IFEDB10DB7A971C9C,1B320E9C18945FFD,,,,,,",de="Anleitung: Empyreum-Verstärkung der Abwehr",en="Recipe: Empyrean Deflecting Augment",fr="Recette : Augmentation de déviation empyréenne",ru="Рецепт: Эмпирейское усиление отражения",icon="scroll8b",val=0,q=2,bop=true,Consumable=true,rss="Outfitter",rsslvl=340},
["FAE5F6A10601010101"] = {akey="I643DB2FA460A6151,3E613021314B36BC,,,,,,",de="Anleitung: Dünnleder-Gürtel",en="Recipe: Thin Leather Belt",fr="Patron : Ceinture en cuir fin",ru="Выкройка: пояс из тонкой кожи",icon="scroll4",val=0,q=1,bop=true,Consumable=true,rss="Outfitter",rsslvl=40},
["F78785DD0701010101"] = {akey="I7BA143F713DD79BD,2587D9E09FA975FD,,,,,,",de="Anleitung: Gehärtete Lederkapuze",en="Recipe: Reinforced Leather Hood",fr="Patron : Capuchon en cuir durci",ru="Выкройка: капюшон из укрепленной кожи",icon="scroll8b",val=0,q=2,bop=true,Consumable=true,rss="Outfitter",rsslvl=190},
["CDD7D6970701010101"] = {akey="I72F5ABCD034BC5AA,EB50E17FF333CB88,,,,,,",de="Anleitung: Schiefergespinst-Ballen",en="Recipe: Bolt of Shaleweave",fr="Patron : Rouleau de tisse-roc",ru="Выкройка: рулон сланцевины",icon="scroll1",val=10000,q=1,bop=true,Consumable=true,rss="Outfitter",rsslvl=185},
["CA9CAFBE0101010101"] = {akey="I17CBCE4A488E04C7,A9BD5F7876C0B97D,,,,,,",de="Anleitung: Rotnarben-Kopfschutz",en="Recipe: Red Scar Headwrap",fr="Patron : Coiffe de Rouge-balafre",ru="Чертеж: повязка Красного Шрама",icon="scroll1",val=0,q=2,bop=true,accBound=true,Consumable=true,rss="Outfitter",rsslvl=130,rf="Red Scar Trackers",rfl=1},
["8BACE2F50401010101"] = {akey="I4EB8960B1827EFEF,7540A8399D5007B2,,,,,,",de="Anleitung: Stahlvernähte Lederstiefel",en="Recipe: Steel-Stitched Leather Boots",fr="Patron : Bottes en cuir cousu d'acier",ru="Чертеж: прошитые сталью кожаные сапоги",icon="scroll1",val=0,q=2,bop=true,accBound=true,Consumable=true,rss="Outfitter",rsslvl=300,rf="The Farclan",rfl=3},
["EFD0E2E20F01010101"] = {akey="IFC58A86F30889D33,20DE69291C213B17,,,,,,",de="Anleitung: Geharnischte Kompakte Ledergamaschen",en="Recipe: Furious Dense Leather Leggings",fr="Patron : Jambières furieuses en cuir dense",ru="Выкройка: Яростные наголенники из плотной кожи",icon="scroll8b",val=1,q=2,Consumable=true,rss="Outfitter",rsslvl=330},
["E1D3E0E30601010101"] = {akey="I6C7829E17FE9400C,DE60F2727E3263B3,,,,,,",de="Anleitung: Zorniger Echthaut-Gürtel",en="Recipe: Furious Truehide Belt",fr="Patron : Ceinture furieuse en peau authentique",ru="Выкройка: Яростный ремень чистой кожи",icon="scroll8b",val=1,q=3,Consumable=true,rss="Outfitter",rsslvl=375},
["91BECCFF0F01010101"] = {akey="IFFF31F115423DA0C,4A81E8F44274A9AF,,,,,,",de="Anleitung: Bewehrtes Chiffoncape",en="Recipe: Fortified Chiffon Cape",fr="Patron : Cape fortifiée en mousseline",ru="Выкройка: Усиленный шифоновый плащ",icon="scroll8b",val=1,q=2,Consumable=true,rss="Outfitter",rsslvl=360},
["ADF19B6201010101"] = {akey="I0C46F8AD1B505785,2AAE900C65D8A66C,,,,,,",de="Anleitung: Seelengebundene Lederkapuze",en="Recipe: Soulbind Leather Hood",fr="Patron : Capuchon en cuir robuste",ru="Выкройка: капюшон из кожи духовных уз",icon="scroll9a",val=0,q=1,bop=true,Consumable=true,rss="Outfitter",rsslvl=250},
["8AA4F0AC0701010101"] = {akey="I759C120A1E0EE3F3,20DB6B474150E6B8,,,,,,",de="Anleitung: Zeremonien-Schulterpolster",en="Recipe: Ceremonial Shoulderpads",fr="Patron : Protège-épaules de cérémonie",ru="Чертеж: церемониальные наплечники",icon="scroll9a",val=0,q=2,bop=true,accBound=true,Consumable=true,rss="Outfitter",rsslvl=300,rf="Order of Mathos",rfl=3},
["A295D5D10F01010101"] = {akey="IFA354AA23C5DE512,3D7143C30B4365BF,,,,,,",de="Anleitung: Größere Verstärkung der Verschlagenheit",en="Recipe: Major Devious Augment",fr="Recette : Augmentation de sournoiserie majeure",ru="Чертеж: Большое усиление ума",icon="scroll8b",val=0,q=2,bop=true,Consumable=true,rss="Outfitter",rsslvl=300},
["D4CDD2FF0F01010101"] = {akey="IFFF4A6D4058BB1F1,FBABD5BB800EA428,,,,,,",de="Anleitung: Zornige Echthaut-Kappe",en="Recipe: Furious Truehide Cap",fr="Patron : Coiffe furieuse en peau authentique",ru="Выкройка: Яростная шапка чистой кожи",icon="scroll8b",val=1,q=2,Consumable=true,rss="Outfitter",rsslvl=370},
["B9F19B6201010101"] = {akey="I0C46F8B93EE26AD8,4385F31573B7A3EA,,,,,,",de="Anleitung: Schwere Lederkapuze",en="Recipe: Heavy Leather Hood",fr="Patron : Capuchon en cuir lourd",ru="Выкройка: тяжелый кожаный капюшон",icon="scroll1a",val=0,q=1,bop=true,Consumable=true,rss="Outfitter",rsslvl=140},
["A3D79EF40601010101"] = {akey="I6E87ABA3150E496F,E3E802A58B016255,,,,,,",de="Anleitung: Dunkelstoff-Mütze",en="Recipe: Darkcloth Cap",fr="Patron : Capuchon en tissombre",ru="Чертеж: темная шапка",icon="scroll8b",val=1,q=2,Consumable=true,rss="Outfitter",rsslvl=300},
["B492E8CE0301010101"] = {akey="I39DA09340E80EE09,567007723328AB29,,,,,,",de="Anleitung: Lockengespinst-Ballen",en="Recipe: Bolt of Lockweave",fr="Patron : Rouleau de tisse-boucle",ru="Выкройка: рулон жесткой ткани",icon="scroll1",val=10000,q=1,bop=true,Consumable=true,rss="Outfitter",rsslvl=115},
["DCA1ECF60F01010101"] = {akey="IFEDB10DC54FCD6B3,BFDA204DF1629217,,,,,,",de="Anleitung: Stellare Verstärkung der Abwehr",en="Recipe: Stellar Deflecting Augment",fr="Recette : Augmentation de déviation stellaire",ru="Рецепт: Звездное отражение",icon="scroll8b",val=0,q=3,bop=true,Consumable=true,rss="Outfitter",rsslvl=375},
["FBE5F6A10601010101"] = {akey="I643DB2FB261E91AD,03E677DBADE72DB1,,,,,,",de="Anleitung: Baumwollgurt",en="Recipe: Cotton Waistband",fr="Patron : Ceinturon en coton",ru="Выкройка: хлопковый пояс",icon="scroll4",val=0,q=1,bop=true,Consumable=true,rss="Outfitter",rsslvl=40},
["F88785DD0701010101"] = {akey="I7BA143F871E416C3,26BA553466B8727D,,,,,,",de="Anleitung: Gehärteter Ledergürtel",en="Recipe: Reinforced Leather Belt",fr="Patron : Ceinture en cuir durci",ru="Выкройка: ремень из укрепленной кожи",icon="scroll8b",val=0,q=2,bop=true,Consumable=true,rss="Outfitter",rsslvl=210},
["F0D0E2E20F01010101"] = {akey="IFC58A87008422700,40C1AD338F52A013,,,,,,",de="Anleitung: Leuchtendes Chiffoncape",en="Recipe: Luminous Chiffon Cape",fr="Patron : Cape lumineuse en mousseline",ru="Выкройка: Искристый шифоновый плащ",icon="scroll8b",val=0,q=2,bop=true,Consumable=true,rss="Outfitter",rsslvl=360},
["86BECCFF0F01010101"] = {akey="IFFF31F0613105A68,232635708AAC6A95,,,,,,",de="Anleitung: Kompakte Lederhandschuhe",en="Recipe: Dense Leather Gloves",fr="Patron : Gants en cuir dense",ru="Выкройка: Плотные кожаные перчатки",icon="scroll8b",val=0,q=1,bop=true,Consumable=true,rss="Outfitter",rsslvl=290},
["E2D3E0E30601010101"] = {akey="I6C7829E268CD258E,A21B541E7BB23907,,,,,,",de="Anleitung: Intellektuelle Hellsicht",en="Recipe: Intellectual Lucidity",fr="Patron : Lucidité intellectuelle",ru="Рецепт: Ясность ума",icon="scroll8b",val=0,q=3,bop=true,Consumable=true,rss="Outfitter",rsslvl=375},
["DED99DE10F01010101"] = {akey="IFC276CDE797018F7,435F5026372C0C0E,,,,,,",de="Anleitung: Größere Verstärkung der Abwehr",en="Recipe: Major Deflecting Augment",fr="Recette : Augmentation de déviation majeure",ru="Чертеж: Большое усиление брутальности",icon="scroll8b",val=0,q=2,bop=true,Consumable=true,rss="Outfitter",rsslvl=300},
["92BECCFF0F01010101"] = {akey="IFFF31F1231D78103,689894B204BADD69,,,,,,",de="Anleitung: Gestreifter Lederschulterschutz",en="Recipe: Striped Leather Shoulders",fr="Patron : Couvre-épaules en cuir rayé",ru="Выкройка: Наплечники плетеной кожи",icon="scroll8b",val=0,q=1,bop=true,Consumable=true,rss="Outfitter",rsslvl=340},
["AEF19B6201010101"] = {akey="I0C46F8AE5293B430,37E81E5B4ABF284F,,,,,,",de="Anleitung: Zaubergesponnene Kutte",en="Recipe: Spellspun Cowl",fr="Patron : Capuche ensorcelée",ru="Выкройка: чаропряжный капюшон",icon="scroll9a",val=0,q=1,bop=true,Consumable=true,rss="Outfitter",rsslvl=260},
["A395D5D10F01010101"] = {akey="IFA354AA33A1A7B50,6912C9E1B4E12521,,,,,,",de="Anleitung: Große Verstärkung der Verschlagenheit",en="Recipe: Greater Devious Augment",fr="Recette : Augmentation de sournoiserie supérieure",ru="Чертеж: Крепкое усиление изворотливости",icon="scroll8b",val=0,q=3,bop=true,Consumable=true,rss="Outfitter",rsslvl=300},
["B1C19AD60F01010101"] = {akey="IFAC6A0B1267F3BD3,11255CE73E1A7786,,,,,,",de="Anleitung: Bewehrter Echthaut-Waffenrock",en="Recipe: Fortified Truehide Tunic",fr="Patron : Tunique fortifiée en peau authentique",ru="Выкройка: Усиленная туника из чистой кожи",icon="scroll8b",val=0,q=2,bop=true,Consumable=true,rss="Outfitter",rsslvl=370},
["D5CDD2FF0F01010101"] = {akey="IFFF4A6D505953DC3,2F5B2600AD18E7D1,,,,,,",de="Anleitung: Leuchtender Empyreum-Kopfschutz",en="Recipe: Luminous Empyrean Headwrap",fr="Patron : Coiffe empyréenne lumineuse",ru="Выкройка: Искристая эмпирейская косынка",icon="scroll8b",val=1,q=2,Consumable=true,rss="Outfitter",rsslvl=370},
["BAF19B6201010101"] = {akey="I0C46F8BA347E2FA2,55884A2AFF13E7C4,,,,,,",de="Anleitung: Leinenkutte",en="Recipe: Linen Cowl",fr="Patron : Capuche en lin",ru="Выкройка: льняной капюшон",icon="scroll1a",val=0,q=1,bop=true,Consumable=true,rss="Outfitter",rsslvl=140},
["A4D79EF40601010101"] = {akey="I6E87ABA44EFFE841,572C4F555129D9D4,,,,,,",de="Anleitung: Dunkelstoff-Gamaschen",en="Recipe: Darkcloth Leggings",fr="Patron : Jambières en tissombre",ru="Чертеж: штаны из темной ткани",icon="scroll8b",val=1,q=3,Consumable=true,rss="Outfitter",rsslvl=300},
["B592E8CE0301010101"] = {akey="I39DA09356C9C3BBF,6872E1D53E85F5A2,,,,,,",de="Anleitung: Geistergespinst-Ballen",en="Recipe: Bolt of Spiritweave",fr="Patron : Rouleau de tisse-mâne",ru="Выкройка: рулон духоткани",icon="scroll1",val=10000,q=1,bop=true,Consumable=true,rss="Outfitter",rsslvl=280},
["FCE5F6A10601010101"] = {akey="I643DB2FC04F814C1,08075EADD16F5706,,,,,,",de="Anleitung: Weichleder-Kapuze",en="Recipe: Soft Leather Hood",fr="Patron : Capuchon en cuir souple",ru="Выкройка: капюшон из мягкой кожи",icon="scroll4",val=0,q=1,bop=true,Consumable=true,rss="Outfitter",rsslvl=20},
["F2C2C1900301010101"] = {akey="I3210617221398BF0,1962296296D551B3,,,,,,",de="Anleitung: Stahlvernähte Lederstiefel",en="Recipe: Steel-Stitched Leather Boots",fr="Patron : Bottes en cuir cousu d'acier",ru="Чертеж: прошитые сталью кожаные сапоги",icon="scroll1",val=0,q=2,bop=true,accBound=true,Consumable=true,rss="Outfitter",rsslvl=300,rf="Kelari Expedition",rfl=3},
["A4C5B2D70F01010101"] = {akey="IFAECA2A41481DC7B,18D8F71CF40C0C29,,,,,,",de="Anleitung: Geharnischte Kompakte Lederkapuze",en="Recipe: Furious Dense Leather Hood",fr="Patron : Capuchon furieux en cuir dense",ru="Выкройка: Яростный капюшон из плотной кожи",icon="scroll8b",val=10000,q=2,bop=true,Consumable=true,rss="Outfitter",rsslvl=310},
["AAAAEDB60401010101"] = {akey="I46DB552A10358AA4,3E1CCB7B29FA1C91,,,,,,",de="Anleitung: Scarnfell-Helm",en="Recipe: Scarn Hide Helmet",fr="Patron : Casque en peau de Scarn",ru="Выкройка: шлем из шкуры Скарна",icon="scroll6a",val=0,q=3,bop=true,Consumable=true,rss="Outfitter",rsslvl=300},
["87BECCFF0F01010101"] = {akey="IFFF31F071648378C,305FC3BF6F92EC78,,,,,,",de="Anleitung: Lanzan-Handwickel",en="Recipe: Lanzan Handwraps",fr="Patron : Protège-mains en lanzane",ru="Выкройка: Ланзановые обмотки",icon="scroll8b",val=0,q=1,bop=true,Consumable=true,rss="Outfitter",rsslvl=290},
["E3D3E0E30601010101"] = {akey="I6C7829E357978221,C032832A3DF8F00F,,,,,,",de="Anleitung: Bewehrter Echthaut-Gürtel",en="Recipe: Fortified Truehide Belt",fr="Patron : Ceinture fortifiée en peau authentique",ru="Выкройка: Усиленный ремень из чистой кожи",icon="scroll8b",val=0,q=3,bop=true,Consumable=true,rss="Outfitter",rsslvl=375},
["DFD99DE10F01010101"] = {akey="IFC276CDF4F741C23,E92DB377FC612E94,,,,,,",de="Anleitung: Große Verstärkung der Abwehr",en="Recipe: Greater Deflecting Augment",fr="Recette : Augmentation de déviation supérieure",ru="Чертеж: Крепкое усиление отражения",icon="scroll8b",val=0,q=3,bop=true,Consumable=true,rss="Outfitter",rsslvl=300},
["B8D387960201010101"] = {akey="I22C1E9B83C490A20,27A6D0A69DFEB868,,,,,,",de="Anleitung: Hexengespinst-Kutte",en="Recipe: Witchweave Cowl",fr="Patron : Capuche en toile de sorcière",ru="Выкройка: капюшон из ведьмина полотна",icon="scroll9a",val=0,q=2,bop=true,Consumable=true,rss="Outfitter",rsslvl=280},
["93BECCFF0F01010101"] = {akey="IFFF31F136555078B,7A9A68799017A491,,,,,,",de="Anleitung: Chiffonschulterpolster",en="Recipe: Chiffon Shoulderpads",fr="Patron : Protège-épaules en mousseline",ru="Выкройка: Шифоновые наплечники",icon="scroll8b",val=0,q=1,bop=true,Consumable=true,rss="Outfitter",rsslvl=340},
["BDE4B5FC0701010101"] = {akey="I7F8D723D02743010,361DFA2D8E9C27A4,,,,,,",de="Anleitung: Sonnendruckstoff",en="Recipe: Sun Print Cloth",fr="Patron : Tissu à imprimé soleil",ru="Выкройка: Ткань с рисунком солнца",icon="scroll4c",val=0,bop=true,Consumable=true,rss="Outfitter",rsslvl=60},
["AFF19B6201010101"] = {akey="I0C46F8AF4A7D57C2,1A608A6B8D734D4D,,,,,,",de="Anleitung: Seelengebundener Ledergürtel",en="Recipe: Soulbind Leather Belt",fr="Patron : Ceinture en cuir robuste",ru="Выкройка: пояс из кожи духовных уз",icon="scroll9a",val=0,q=1,bop=true,Consumable=true,rss="Outfitter",rsslvl=230},
["A495D5D10F01010101"] = {akey="IFA354AA42E28D827,8ACC70133136ADB4,,,,,,",de="Anleitung: Empyreum-Verstärkung der Verschlagenheit",en="Recipe: Empyrean Devious Augment",fr="Recette : Augmentation de sournoiserie empyréenne",ru="Рецепт: Удаленное эмпирейское усиление",icon="scroll8b",val=0,q=2,bop=true,Consumable=true,rss="Outfitter",rsslvl=340},
["B2C19AD60F01010101"] = {akey="IFAC6A0B218E44736,2D6629CB773D0AF8,,,,,,",de="Anleitung: Leuchtende Empyreum-Gewänder",en="Recipe: Luminous Empyrean Vestments",fr="Patron : Habits empyréens lumineux",ru="Выкройка: Искристое эмпирейское одеяние",icon="scroll8b",val=0,q=2,bop=true,Consumable=true,rss="Outfitter",rsslvl=370},
["BBF19B6201010101"] = {akey="I0C46F8BB47769945,E78AA1408A71323C,,,,,,",de="Anleitung: Schwerer Ledergürtel",en="Recipe: Heavy Leather Belt",fr="Patron : Ceinture en cuir lourd",ru="Выкройка: тяжелый кожаный пояс",icon="scroll1a",val=0,q=1,bop=true,Consumable=true,rss="Outfitter",rsslvl=120},
["A5D79EF40601010101"] = {akey="I6E87ABA51CC8E7AA,585ECAA99838D653,,,,,,",de="Anleitung: Dunkelstoff-Schleier",en="Recipe: Darkcloth Shroud",fr="Patron : Épaulières en tissombre",ru="Чертеж: темнотканный саван",icon="scroll8b",val=1,q=3,Consumable=true,rss="Outfitter",rsslvl=300},
["E2C2FACB0601010101"] = {akey="I697EA1627C88976E,499ADAE4862EA788,,,,,,",de="Anleitung: Brustschutz der wilden Verteidigung",en="Recipe: Chestguard of Furious Defense",fr="Patron : Plastron de défense enragée",ru="Выкройка: нагрудник яростной защиты",icon="scroll2a",val=0,q=3,bop=true,Consumable=true,rss="Outfitter",rsslvl=300},
["FDE5F6A10601010101"] = {akey="I643DB2FD55E6FD2C,1CF82140B944C7B5,,,,,,",de="Anleitung: Jutekutte",en="Recipe: Burlap Cowl",fr="Patron : Capuche en toile de jute",ru="Выкройка: джутовый капюшон",icon="scroll4",val=0,q=1,bop=true,Consumable=true,rss="Outfitter",rsslvl=20},
["A5C5B2D70F01010101"] = {akey="IFAECA2A5545EE0B3,0A5423534A22CA8D,,,,,,",de="Anleitung: Bewehrte Kompakte Lederkapuze",en="Recipe: Fortified Dense Leather Hood",fr="Patron : Capuchon fortifié en cuir dense",ru="Выкройка: Усиленный капюшон из плотной кожи",icon="scroll8b",val=1,q=2,Consumable=true,rss="Outfitter",rsslvl=310},
["F1EBA8FD0701010101"] = {akey="I7FAA35F126C75946,0CBBCA1B5E5DFFF1,,,,,,",de="Anleitung: Lockengespinst-Schulterpolster",en="Recipe: Lockweave Shoulderpads",fr="Patron : Protège-épaules en tisse-boucle",ru="Выкройка: наплечники из жесткой ткани",icon="scroll1a",val=0,q=2,bop=true,Consumable=true,rss="Outfitter",rsslvl=150},
["88BECCFF0F01010101"] = {akey="IFFF31F0827081CAB,42621AD4FAEFB3A2,,,,,,",de="Anleitung: Kompakter Lederschulterschutz",en="Recipe: Dense Leather Shoulders",fr="Patron : Couvre-épaules en cuir dense",ru="Выкройка: Плотные кожаные наплечники",icon="scroll8b",val=0,q=1,bop=true,Consumable=true,rss="Outfitter",rsslvl=300},
["E4D3E0E30601010101"] = {akey="I6C7829E41241B394,C964805B6F620659,,,,,,",de="Anleitung: Leuchtender Empyreum-Wickel",en="Recipe: Luminous Empyrean Wrap",fr="Patron : Étole empyréenne lumineuse",ru="Выкройка: Искристые эмпирейские обмотки",icon="scroll8b",val=0,q=3,bop=true,Consumable=true,rss="Outfitter",rsslvl=375},
["B9D387960201010101"] = {akey="I22C1E9B95B71083E,D86337002DB65713,,,,,,",de="Anleitung: Gestählte Lederbrigantine",en="Recipe: Steeled Leather Brigandine",fr="Patron : Brigandine en cuir renforcé d'acier",ru="Выкройка: бригандина из закаленной кожи",icon="scroll9a",val=0,q=2,bop=true,Consumable=true,rss="Outfitter",rsslvl=280},
["97E9CCD90701010101"] = {akey="I7B3334975E46621A,D6777AD4598B9A85,,,,,,",de="Anleitung: Launische Kniehose",en="Recipe: Wayward Breeches",fr="Patron : Braies mal coupées",ru="Чертеж: штаны своенравия",icon="scroll9a",val=0,q=2,bop=true,accBound=true,Consumable=true,rss="Outfitter",rsslvl=300,rf="Dragonslayer Covenant",rfl=3},
["BEE4B5FC0701010101"] = {akey="I7F8D723E554CFA5D,604BB36EB99B5AE1,,,,,,",de="Anleitung: Zwergenbett",en="Recipe: Dwarven Bed",fr="Plan : Lit de Nain",ru="Эскиз: Гномская кровать",icon="scroll4c",val=0,bop=true,Consumable=true,rss="Outfitter",rsslvl=120},
["B0F19B6201010101"] = {akey="I0C46F8B05E6B429B,3B6624F5AC32ADDC,,,,,,",de="Anleitung: Zaubergesponnener Gurt",en="Recipe: Spellspun Waistband",fr="Patron : Ceinturon ensorcelé",ru="Выкройка: чаропряжный пояс",icon="scroll9a",val=0,q=1,bop=true,Consumable=true,rss="Outfitter",rsslvl=230},
["A595D5D10F01010101"] = {akey="IFA354AA56DA54CB0,7F370E6463C698EE,,,,,,",de="Anleitung: Stellare Verstärkung der Verschlagenheit",en="Recipe: Stellar Devious Augment",fr="Recette : Augmentation de sournoiserie stellaire",ru="Рецепт: Звездный интеллект и критический урон заклинаний",icon="scroll8b",val=0,q=3,bop=true,Consumable=true,rss="Outfitter",rsslvl=375},
["B3C19AD60F01010101"] = {akey="IFAC6A0B339872170,0BD38CEB459A4C35,,,,,,",de="Anleitung: Zorniges Echthaut-Geschirr",en="Recipe: Furious Truehide Harness",fr="Patron : Harnais furieux en peau authentique",ru="Выкройка: Яростный доспех чистой кожи",icon="scroll8b",val=0,q=2,bop=true,Consumable=true,rss="Outfitter",rsslvl=375},
["BCF19B6201010101"] = {akey="I0C46F8BC6D6D9AE6,F98C750715CD7616,,,,,,",de="Anleitung: Leinengurt",en="Recipe: Linen Waistband",fr="Patron : Ceinturon en lin",ru="Выкройка: льняной пояс",icon="scroll1a",val=0,q=1,bop=true,Consumable=true,rss="Outfitter",rsslvl=120},
["A6D79EF40601010101"] = {akey="I6E87ABA64C90A853,0C0D97A1C54319FC,,,,,,",de="Anleitung: Aufbereitetes Lederwams",en="Recipe: Conditioned Leather Jerkin",fr="Patron : Pourpoint en cuir apprêté",ru="Чертеж: камзол из выделанной кожи ",icon="scroll8b",val=1,q=3,Consumable=true,rss="Outfitter",rsslvl=300},
["E3C2FACB0601010101"] = {akey="I697EA16365252BB0,33BB03FE00F04133,,,,,,",de="Anleitung: Maske des Jägers",en="Recipe: Mask of the Hunter",fr="Patron : Masque du chasseur",ru="Выкройка: маска охотника",icon="scroll2a",val=0,q=3,bop=true,Consumable=true,rss="Outfitter",rsslvl=300},
["FEE5F6A10601010101"] = {akey="I643DB2FE61F8099F,2C0C0CD7E828E558,,,,,,",de="Anleitung: Weichleder-Gürtel",en="Recipe: Soft Leather Belt",fr="Patron : Ceinture en cuir souple",ru="Выкройка: ремень из мягкой кожи",icon="scroll4",val=0,q=1,bop=true,Consumable=true,rss="Outfitter",rsslvl=1},
["F2EBA8FD0701010101"] = {akey="I7FAA35F225BEAAC5,0F07556178C205B1,,,,,,",de="Anleitung: Feine Ledergamaschen",en="Recipe: Fine Leather Leggings",fr="Patron : Jambières en cuir de qualité",ru="Выкройка: штаны из выделанной кожи",icon="scroll1a",val=0,q=2,bop=true,Consumable=true,rss="Outfitter",rsslvl=150},
["90C3CFCD0201010101"] = {akey="I29B3E19049A6E130,18A9B61B099BE1B8,,,,,,",de="Anleitung: Zeremonien-Antlitz",en="Recipe: Ceremonial Visage",fr="Patron : Masque de cérémonie",ru="Чертеж: церемониальная маска",icon="scroll9a",val=0,q=2,bop=true,accBound=true,Consumable=true,rss="Outfitter",rsslvl=300,rf="Order of Mathos",rfl=3},
["89BECCFF0F01010101"] = {akey="IFFF31F09754304FB,08A41BC829AA88CA,,,,,,",de="Anleitung: Lanzan-Schulterpolster",en="Recipe: Lanzan Shoulderpads",fr="Patron : Protège-épaules en lanzane",ru="Выкройка: Ланзановые наплечники",icon="scroll8b",val=0,q=1,bop=true,Consumable=true,rss="Outfitter",rsslvl=300},
["C6D7C22801010101"] = {akey="I0510ABC6583625B6,11F347BC0897F821,,,,,,",de="Anleitung: Strahlende Hexengespinst-Handschuhe",en="Recipe: Radiant Witchweave Gloves",fr="Patron : Gants en toile de sorcière rayonnante",ru="Выкройка: перчатки из светящегося ведьмина полотна",icon="scroll1",val=0,q=2,bop=true,accBound=true,Consumable=true,rss="Outfitter",rsslvl=300,rf="The Keepers",rfl=3},
["BAD387960201010101"] = {akey="I22C1E9BA1AC56643,F09CF614B35AFB9E,,,,,,",de="Anleitung: Gestählte Lederstiefel",en="Recipe: Steeled Leather Boots",fr="Patron : Bottes en cuir renforcé d'acier",ru="Выкройка: ботинки из закаленной кожи",icon="scroll9a",val=0,q=2,bop=true,Consumable=true,rss="Outfitter",rsslvl=290},
}

nkItemBase.db.recipe.runecrafter={
["86AB999D0301010101"] = {akey="I33A65586254128E5,10065C3A8F4B1438,,,,,,",de="Anleitung: Eiswandrune",en="Recipe: Icewall Rune",fr="Recette : Rune de mur de glace",ru="Эскиз: руна ледяной стены",icon="scroll8b",val=0,q=2,bop=true,accBound=true,Consumable=true,rss="Runecrafter",rsslvl=200,rf="Mercurial Savants",rfl=2},
["BDDBAD6701010101"] = {akey="I0CEB6DBD37DF6EC7,74C7F8D48657B4A4,,,,,,",de="Anleitung: Flammende Rune des Todeswiderstandes",en="Recipe: Blazing Death Resistance Rune",fr="Recette : Rune de résistance à la Mort flamboyante",ru="Эскиз: яркая руна сопротивляемости Смерти",icon="scroll9a",val=0,q=3,bop=true,accBound=true,Consumable=true,rss="Runecrafter",rsslvl=300,rf="Order of the Death Serpent",rfl=3},
["CBE4B5FC0701010101"] = {akey="I7F8D724B2CEA05E0,1AD0BD42B9C75BAC,,,,,,",de="Anleitung: Baustein: Grausteinrechteck",en="Recipe: Building Block: Greystone Rectangle",fr="Plan : Bloc de construction : rectangle de pierre grise",ru="Чертеж: Стройматериал: Плитка серого камня",icon="scroll4c",val=0,bop=true,Consumable=true,rss="Runecrafter",rsslvl=180},
["9B85B7C00501010101"] = {akey="I580DC29B166C048D,E7F3801E915EDC27,,,,,,",de="Anleitung: Glühende Rune der Gerissenheit",en="Recipe: Incandescent Savvy Rune",fr="Recette : Rune astucieuse incandescente",ru="Эскиз: сияющая руна знаний",icon="scroll8b",val=1,q=3,Consumable=true,rss="Runecrafter",rsslvl=300},
["9DA1EFB90101010101"] = {akey="I173BD09D37C9CDA7,AE3AFA3CD6E98A80,,,,,,",de="Anleitung: Empyreum-Runenscherbe des Tiefgrunds",en="Recipe: Empyrean Recondite Runeshard",fr="Plan : Fragment de rune ésotérique empyréenne",ru="Эскиз: Эмпирейский осколок вычурной руны",icon="cloth12a",val=0,q=3,bop=true,Consumable=true,rss="Runecrafter",rsslvl=375},
["BEDE8DFD0F01010101"] = {akey="IFFA36F3E28CE4112,DCA2610D87F231CB,,,,,,",de="Anleitung: Schimmernde Rune des Zorns",en="Recipe: Gleaming Wrathful Rune",fr="Plan : Rune de courroux luisante",ru="Эскиз: Светящаяся руна гнева",icon="cloth12a",val=0,q=2,bop=true,Consumable=true,rss="Runecrafter",rsslvl=330},
["F4DFA5CA0201010101"] = {akey="I29496FF4057740EC,2DBEEA1587505D9B,,,,,,",de="Anleitung: Leuchtende Rune der Verheerung",en="Recipe: Luminous Devastating Rune",fr="Recette : Rune dévastatrice lumineuse",ru="Эскиз: искристая руна опустошения",icon="scroll8b",val=0,q=2,bop=true,Consumable=true,rss="Runecrafter",rsslvl=200},
["BCEDDC2501010101"] = {akey="I04B736BC23C933BF,276227B414567BD1,,,,,,",de="Anleitung: Flammende Rune der Intelligenz",en="Recipe: Blazing Intelligence Rune",fr="Recette : Rune d'intelligence flamboyante",ru="Эскиз: яркая руна интеллекта",icon="scroll9a",val=0,q=2,bop=true,Consumable=true,rss="Runecrafter",rsslvl=290},
["89F0E6BD0601010101"] = {akey="I67B9B8095EB19609,045FD75D6FEDB86C,,,,,,",de="Anleitung: Flammende Rune der Präzision",en="Recipe: Blazing Precise Rune",fr="Recette : Rune précise flamboyante",ru="Эскиз: яркая руна точности",icon="scroll8b",val=1,q=2,Consumable=true,rss="Runecrafter",rsslvl=300},
["FFEA93F40501010101"] = {akey="I5E84F57F14813B7E,F59DEE569C34DD29,,,,,,",de="Anleitung: Strahlende Rune der Präzision",en="Recipe: Radiant Precise Rune",fr="Recette : Rune précise rayonnante",ru="Эскиз: лучистая руна точности",icon="scroll8b",val=0,q=1,bop=true,Consumable=true,rss="Runecrafter",rsslvl=275},
["CDE1F5FF0101010101"] = {akey="I1FFD70CD71087BC5,16AA2EB21254A476,,,,,,",de="Anleitung: Aurora-Rune der Vereitelung",en="Recipe: Auroral Thwarting Rune",fr="Recette : Rune contrariante aurorale",ru="Эскиз: Аврорская препятствующая руна",icon="cloth12a",val=1,q=2,Consumable=true,rss="Runecrafter",rsslvl=375},
["C7918CDB0201010101"] = {akey="I2B6308C72990CE0D,FAC48A18A17B8ACE,,,,,,",de="Anleitung: Brillante Rune der Zähigkeit",en="Recipe: Brilliant Tough Rune",fr="Recette : Rune solide éclatante",ru="Эскиз: сверкающая руна стойкости",icon="scroll9a",val=0,q=2,bop=true,Consumable=true,rss="Runecrafter",rsslvl=300},
["C284FCF20201010101"] = {akey="I2E5F024249BF529C,0919DFD183AB7113,,,,,,",de="Anleitung: Tödliche Runenscherbe",en="Recipe: Baneful Runeshard",fr="Recette : Fragment de rune néfaste",ru="Эскиз: рунный осколок гибели",icon="scroll9a",val=0,q=3,bop=true,Consumable=true,rss="Runecrafter",rsslvl=290},
["E9E7F5C80401010101"] = {akey="I491D73E977C995A3,11CB0DBD2E4E5086,,,,,,",de="Anleitung: Strahlende Rune der Verheerung",en="Recipe: Radiant Devastating Rune",fr="Recette : Rune dévastatrice rayonnante",ru="Эскиз: лучистая руна опустошения",icon="scroll9a",val=0,q=2,bop=true,Consumable=true,rss="Runecrafter",rsslvl=280},
["92A1EFB90101010101"] = {akey="I173BD0926C7A3820,1177BA79E926B55F,,,,,,",de="Anleitung: Aurora-Rune des Zorns",en="Recipe: Auroral Wrathful Rune",fr="Recette : Rune de courroux aurorale",ru="Эскиз: Аврорская гневная руна",icon="cloth12a",val=0,q=3,bop=true,Consumable=true,rss="Runecrafter",rsslvl=375},
["BEDBAD6701010101"] = {akey="I0CEB6DBE5EA2D5BA,651D56B9F006FF4E,,,,,,",de="Anleitung: Flammende Rune des Erdwiderstandes",en="Recipe: Blazing Earth Resistance Rune",fr="Recette : Rune de résistance à la Terre flamboyante",ru="Эскиз: яркая руна сопротивляемости Земле",icon="scroll9a",val=0,q=3,bop=true,accBound=true,Consumable=true,rss="Runecrafter",rsslvl=300,rf="Mendicant Order",rfl=3},
["CCE4B5FC0701010101"] = {akey="I7F8D724C32DBE3E9,12DD4F6B26661870,,,,,,",de="Anleitung: Baustein: Grünsteinrechteck",en="Recipe: Building Block: Greenstone Rectangle",fr="Plan : Bloc de construction : rectangle de pierre verte",ru="Чертеж: Стройматериал: Плитка зеленого камня",icon="scroll4c",val=0,bop=true,Consumable=true,rss="Runecrafter",rsslvl=240},
["9C85B7C00501010101"] = {akey="I580DC29C5E824A26,DD242D68ED454587,,,,,,",de="Anleitung: Glühende Runenscherbe der Präzision",en="Recipe: Incandescent Precise Runeshard",fr="Recette : Fragment de rune incandescente précise",ru="Эскиз: сияющий рунный осколок точности",icon="scroll8b",val=1,q=3,Consumable=true,rss="Runecrafter",rsslvl=300},
["BFFFBDE40301010101"] = {akey="I3C8F7FBF17EA5F7B,1F77D7805736812B,,,,,,",de="Anleitung: Brillante Rune des Feuerwiderstandes",en="Recipe: Brilliant Fire Resistance Rune",fr="Recette : Rune éclatante de résistance au Feu",ru="Эскиз: сверкающая руна сопротивляемости Огню",icon="scroll9a",val=0,q=2,bop=true,accBound=true,Consumable=true,rss="Runecrafter",rsslvl=290,rf="Ember Scholars",rfl=2},
["9EA1EFB90101010101"] = {akey="I173BD09E5BD60001,D6EE14DC240EA05B,,,,,,",de="Anleitung: Empyreum-Runenscherbe der Wut",en="Recipe: Empyrean Rage Runeshard",fr="Plan : Fragment de rune de rage empyréenne",ru="Эскиз: Эмпирейский осколок руны ярости",icon="cloth12a",val=0,q=3,bop=true,Consumable=true,rss="Runecrafter",rsslvl=375},
["B784BBC00101010101"] = {akey="I180EC23715FE2D01,0204586FE548F6F1,,,,,,",de="Anleitung: Helle Rune der Unerbittlichkeit",en="Recipe: Bright Unrelenting Rune",fr="Recette : Rune implacable brillante",ru="Эскиз: блестящая руна беспощадности",icon="scroll1a",val=0,q=1,bop=true,Consumable=true,rss="Runecrafter",rsslvl=100},
["95DDA68F0101010101"] = {akey="I11E9AE95547E8C05,1FF2B9051E242182,,,,,,",de="Anleitung: Glühende Rune des Rachedursts",en="Recipe: Glowing Vengeful Rune",fr="Recette : Rune vengeresse luminescente",ru="Эскиз: светлая руна мести",icon="scroll4",val=0,q=1,bop=true,Consumable=true,rss="Runecrafter",rsslvl=30},
["F5DFA5CA0201010101"] = {akey="I29496FF53B60E228,65102E32EE6972CE,,,,,,",de="Anleitung: Leuchtende Rune des Elends",en="Recipe: Luminous Calamitous Rune",fr="Recette : Rune calamiteuse lumineuse",ru="Эскиз: искристая руна чародейства",icon="scroll8b",val=0,q=2,bop=true,Consumable=true,rss="Runecrafter",rsslvl=200},
["CEE1F5FF0101010101"] = {akey="I1FFD70CE06AE0167,5F1D5E9BEB6944F0,,,,,,",de="Anleitung: Aurora-Rune der Standhaftigkeit",en="Recipe: Auroral Unwavering Rune",fr="Plan : Rune inébranlable aurorale",ru="Эскиз: Аврорская стойкая руна",icon="cloth12a",val=0,q=2,bop=true,Consumable=true,rss="Runecrafter",rsslvl=365},
["C8918CDB0201010101"] = {akey="I2B6308C805F75AB2,09D875AFD05FA871,,,,,,",de="Anleitung: Flammende Runenscherbe der Wut",en="Recipe: Blazing Rage Runeshard",fr="Recette : Fragment de rune de rage flamboyante",ru="Эскиз: яркий рунный осколок ярости",icon="scroll9a",val=1,q=2,Consumable=true,rss="Runecrafter",rsslvl=290},
["EAE7F5C80401010101"] = {akey="I491D73EA337001DF,0A2E35C91B6A1F77,,,,,,",de="Anleitung: Strahlende Rune des Elends",en="Recipe: Radiant Calamitous Rune",fr="Recette : Rune calamiteuse rayonnante",ru="Эскиз: лучистая руна чародейства",icon="scroll9a",val=0,q=2,bop=true,Consumable=true,rss="Runecrafter",rsslvl=280},
["93A1EFB90101010101"] = {akey="I173BD093420228D0,237A118EF4837C88,,,,,,",de="Anleitung: Schimmernde Rune der Furchtlosigkeit",en="Recipe: Gleaming Intrepid Rune",fr="Plan : Rune intrépide luisante",ru="Эскиз: Светящаяся руна отваги",icon="cloth12a",val=0,q=2,bop=true,Consumable=true,rss="Runecrafter",rsslvl=375},
["BFDBAD6701010101"] = {akey="I0CEB6DBF72C94F7D,3C4F7F09C7E25FBD,,,,,,",de="Anleitung: Flammende Rune des Feuerwiderstandes",en="Recipe: Blazing Fire Resistance Rune",fr="Recette : Rune de résistance au Feu flamboyante",ru="Эскиз: яркая руна сопротивляемости Огню",icon="scroll9a",val=0,q=3,bop=true,accBound=true,Consumable=true,rss="Runecrafter",rsslvl=300,rf="Order of the Flame",rfl=3},
["CDE4B5FC0701010101"] = {akey="I7F8D724D182391EB,56436B7FC4689A35,,,,,,",de="Anleitung: Oranges Runenbindungsgefäß",en="Recipe: Orange Runecraft Vessel",fr="Plan : Nef runique orange",ru="Эскиз: Оранжевый рунический сосуд",icon="scroll4c",val=0,bop=true,Consumable=true,rss="Runecrafter",rsslvl=300},
["9D85B7C00501010101"] = {akey="I580DC29D1799E69A,EF26847DF8A20CB0,,,,,,",de="Anleitung: Glühende Rune der Präzision",en="Recipe: Incandescent Precise Rune",fr="Recette : Rune incandescente précise",ru="Эскиз: сияющая руна точности",icon="scroll8b",val=1,q=3,Consumable=true,rss="Runecrafter",rsslvl=300},
["9FA1EFB90101010101"] = {akey="I173BD09F59C14C60,E8F06BF12F6B6784,,,,,,",de="Anleitung: Aurora-Rune der Beherrschung",en="Recipe: Auroral Dominating Rune",fr="Recette : Rune de domination aurorale",ru="Эскиз: Аврорская порабощающая руна",icon="cloth12a",val=0,q=3,bop=true,Consumable=true,rss="Runecrafter",rsslvl=375},
["C0DE8DFD0F01010101"] = {akey="IFFA36F40394277A4,0FAA52ACB20DD635,,,,,,",de="Anleitung: Schimmernde Rune der Unerbittlichkeit",en="Recipe: Gleaming Unrelenting Rune",fr="Recette : Rune implacable luisante",ru="Эскиз: Светящаяся руна беспощадности",icon="cloth12a",val=1,q=2,Consumable=true,rss="Runecrafter",rsslvl=375},
["B884FCF20201010101"] = {akey="I2E5F0238678C301E,D039B0386B956432,,,,,,",de="Anleitung: Flammende Rune der Weisheit",en="Recipe: Blazing Wisdom Rune",fr="Recette : Rune de sagesse flamboyante",ru="Эскиз: яркая руна мудрости",icon="scroll9a",val=0,q=2,bop=true,Consumable=true,rss="Runecrafter",rsslvl=290},
["96DDA68F0101010101"] = {akey="I11E9AE966DE7567C,F943065ED49873D3,,,,,,",de="Anleitung: Glühende Rune der Unerbittlichkeit",en="Recipe: Glowing Unrelenting Rune",fr="Recette : Rune implacable luminescente",ru="Эскиз: светлая руна беспощадности",icon="scroll4",val=0,q=1,bop=true,Consumable=true,rss="Runecrafter",rsslvl=30},
["F6DFA5CA0201010101"] = {akey="I29496FF61D1EF8CC,5FA4853485DE89C1,,,,,,",de="Anleitung: Leuchtende Rune des Zorns",en="Recipe: Luminous Wrathful Rune",fr="Recette : Rune de courroux lumineuse",ru="Эскиз: искристая руна гнева",icon="scroll8b",val=0,q=1,bop=true,Consumable=true,rss="Runecrafter",rsslvl=200},
["CFE1F5FF0101010101"] = {akey="I1FFD70CF45C4752F,712038FE76C68F68,,,,,,",de="Anleitung: Aurora-Rune der Festigkeit",en="Recipe: Auroral Steadfast Rune",fr="Plan : Rune vaillante aurorale",ru="Эскиз: Аврорская неколебимая руна",icon="cloth12a",val=0,q=2,bop=true,Consumable=true,rss="Runecrafter",rsslvl=365},
["C9918CDB0201010101"] = {akey="I2B6308C952E733EF,1EC93842B8351920,,,,,,",de="Anleitung: Flammende Rune der Wut",en="Recipe: Blazing Rage Rune",fr="Recette : Rune de rage flamboyante",ru="Эскиз: яркая руна ярости",icon="scroll9a",val=1,q=2,Consumable=true,rss="Runecrafter",rsslvl=290},
["C484FCF20201010101"] = {akey="I2E5F0244788F4702,15B08DE8A67DD27E,,,,,,",de="Anleitung: Strahlende Racherune",en="Recipe: Radiant Vengeance Rune",fr="Recette : Rune de vengeance rayonnante",ru="Чертеж: Лучистая руна мести",icon="scroll9a",val=9700,q=2,bop=true,Consumable=true,rss="Runecrafter",rsslvl=290},
["8A8DE93F01010101"] = {akey="I07FA468A61CF51D4,3FA9C0AA3564E6A7,,,,,,",de="Anleitung: Frostige Rune",en="Recipe: Chilling Rune",fr="Recette : Rune effrayante",ru="Эскиз: леденящая руна",icon="scroll1a",val=0,q=2,bop=true,accBound=true,Consumable=true,rss="Runecrafter",rsslvl=100,rf="Mercurial Savants",rfl=2},
["B792948D0301010101"] = {akey="I31A5093765D93F3A,0D5ABA9663AD3A64,,,,,,",de="Anleitung: Versteinernde Rune",en="Recipe: Petrifying Rune",fr="Recette : Rune pétrifiante",ru="Эскиз: руна окаменения",icon="scroll1a",val=0,q=2,bop=true,accBound=true,Consumable=true,rss="Runecrafter",rsslvl=100,rf="The Shale Collegiate",rfl=2},
["A3EEF6E80401010101"] = {akey="I4D1DB723332E8258,06DE0B3A69804C59,,,,,,",de="Anleitung: Windschutz-Rune",en="Recipe: Windshielding Rune",fr="Recette : Rune de défense venteuse",ru="Эскиз: руна ураганной защиты",icon="scroll8b",val=0,q=2,bop=true,accBound=true,Consumable=true,rss="Runecrafter",rsslvl=200,rf="The Storm Inquisition",rfl=2},
["B8C5908E0701010101"] = {akey="I71C422B836A600F1,0DED3BADEEDBC42C,,,,,,",de="Anleitung: Flammende Rune des Wasserwiderstandes",en="Recipe: Blazing Water Resistance Rune",fr="Recette : Rune de résistance à l'Eau flamboyante",ru="Эскиз: яркая руна сопротивляемости Воде",icon="scroll9a",val=0,q=3,bop=true,accBound=true,Consumable=true,rss="Runecrafter",rsslvl=300,rf="Mercurial Savants",rfl=3},
["94A1EFB90101010101"] = {akey="I173BD0940173BBDD,D24D8F212F5724C9,,,,,,",de="Anleitung: Aurora-Rune des Streifhiebs",en="Recipe: Auroral Glancing Rune",fr="Recette : Rune oblique aurorale",ru="Эскиз: Аврорская скользящая руна",icon="cloth12a",val=1,q=2,Consumable=true,rss="Runecrafter",rsslvl=375},
["C0DBAD6701010101"] = {akey="I0CEB6DC055199550,7271415844F83EED,,,,,,",de="Anleitung: Flammende Rune des Lebenswiderstandes",en="Recipe: Blazing Life Resistance Rune",fr="Recette : Rune de résistance à la Vie flamboyante",ru="Эскиз: яркая руна сопротивляемости Жизни",icon="scroll9a",val=0,q=3,bop=true,accBound=true,Consumable=true,rss="Runecrafter",rsslvl=300,rf="Order of Life Serene",rfl=3},
["B5DE8DFD0F01010101"] = {akey="IFFA36F356D2F26C7,E7284D888DDEA6AE,,,,,,",de="Anleitung: Schimmernde Runen-scherbe des Elends",en="Recipe: Gleaming Calamitous Runeshard",fr="Plan : Fragment de rune calamiteuse luisante",ru="Эскиз: Осколок светящейся погибельной руны",icon="cloth12a",val=0,q=1,bop=true,Consumable=true,rss="Runecrafter",rsslvl=300},
["CEE4B5FC0701010101"] = {akey="I7F8D724E15518264,42F6D58CF4091353,,,,,,",de="Anleitung: Runenverwurzelter Wacholder",en="Recipe: Runerooted Juniper",fr="Plan : Genévrier rune-racine",ru="Рецепт: Рунный можжевельник",icon="scroll4c",val=0,bop=true,Consumable=true,rss="Runecrafter",rsslvl=360},
["C8D8CDF20301010101"] = {akey="I3E536C4815557246,0A3AEBED9FF2468F,,,,,,",de="Anleitung: Flammende Rune des Feuerwiderstandes",en="Recipe: Blazing Fire Resistance Rune",fr="Recette : Rune de résistance au Feu flamboyante",ru="Эскиз: яркая руна сопротивляемости Огню",icon="scroll9a",val=0,q=3,bop=true,accBound=true,Consumable=true,rss="Runecrafter",rsslvl=300,rf="Ember Scholars",rfl=3},
["C1DE8DFD0F01010101"] = {akey="IFFA36F416B856A0F,15EDE45F06FE42F9,,,,,,",de="Anleitung: Schimmernde Rune des Rachedursts",en="Recipe: Gleaming Vengeful Rune",fr="Recette : Rune vengeresse luisante",ru="Эскиз: Светящаяся руна мести",icon="cloth12a",val=1,q=2,Consumable=true,rss="Runecrafter",rsslvl=375},
["B984FCF20201010101"] = {akey="I2E5F023923C145DD,29F54F9EA0173511,,,,,,",de="Anleitung: Flammende Rune der Geschicklichkeit",en="Recipe: Blazing Dexterity Rune",fr="Recette : Rune de dextérité flamboyante",ru="Эскиз: яркая руна ловкости",icon="scroll9a",val=0,q=2,bop=true,Consumable=true,rss="Runecrafter",rsslvl=290},
["F7DFA5CA0201010101"] = {akey="I29496FF7346305E6,3E11E854D43BCAFD,,,,,,",de="Anleitung: Leuchtende Rune der Beherrschung",en="Recipe: Luminous Dominating Rune",fr="Recette : Rune de domination lumineuse",ru="Эскиз: искристая руна владычества",icon="scroll8b",val=0,q=1,bop=true,Consumable=true,rss="Runecrafter",rsslvl=200},
["D0E1F5FF0101010101"] = {akey="I1FFD70D0141662E1,8322901382235691,,,,,,",de="Anleitung: Aurora-Rune der Klugheit",en="Recipe: Auroral Sagacious Rune",fr="Plan : Rune de sagacité aurorale",ru="Эскиз: Аврорская прозорливая руна",icon="cloth12a",val=0,q=2,bop=true,Consumable=true,rss="Runecrafter",rsslvl=340},
["CA918CDB0201010101"] = {akey="I2B6308CA5BA25157,13E75EED485B2C5E,,,,,,",de="Anleitung: Flammende Rune der Gewandtheit",en="Recipe: Blazing Deft Rune",fr="Recette : Rune habile flamboyante",ru="Эскиз: яркая руна проворства",icon="scroll9a",val=1,q=2,Consumable=true,rss="Runecrafter",rsslvl=290},
["C584FCF20201010101"] = {akey="I2E5F02456A1A1763,B5934EA519AF377A,,,,,,",de="Anleitung: Brillante Rune des Luftwiderstandes",en="Recipe: Brilliant Air Resistance Rune",fr="Recette : Rune éclatante de résistance à l'Air",ru="Эскиз: сверкающая руна сопротивляемости Воздуху",icon="scroll9a",val=0,q=2,bop=true,accBound=true,Consumable=true,rss="Runecrafter",rsslvl=290,rf="The Storm Inquisition",rfl=2},
["8ABAABF30401010101"] = {akey="I4E6ADD0A5C6EEEDD,E4C24807CB8AE1A0,,,,,,",de="Anleitung: Strahlende Runenscherbe der Unbeugsamkeit",en="Recipe: Radiant Indomitable Runeshard",fr="Recette : Fragment de rune indomptable rayonnante",ru="Эскиз: лучистый рунный осколок стойкости",icon="scroll8b",val=0,q=1,bop=true,Consumable=true,rss="Runecrafter",rsslvl=275},
["A4EEF6E80401010101"] = {akey="I4D1DB72479A03C3D,18E0624F74DD1382,,,,,,",de="Anleitung: Schwelende Rune",en="Recipe: Smoldering Rune",fr="Recette : Rune fumante",ru="Эскиз: тлеющая руна",icon="scroll8b",val=0,q=2,bop=true,accBound=true,Consumable=true,rss="Runecrafter",rsslvl=200,rf="Order of the Flame",rfl=2},
["95A1EFB90101010101"] = {akey="I173BD0955F6468E6,054B1EF8B4498596,,,,,,",de="Anleitung: Aurora-Rune der Klarheit",en="Recipe: Auroral Lucid Rune",fr="Recette : Rune de lucidité aurorale",ru="Эскиз: Аврорская прозрачная руна",icon="cloth12a",val=1,q=2,Consumable=true,rss="Runecrafter",rsslvl=375},
["C1DBAD6701010101"] = {akey="I0CEB6DC1012343B7,48E5A9D26AB43DD9,,,,,,",de="Anleitung: Flammende Rune des Wasserwiderstandes",en="Recipe: Blazing Water Resistance Rune",fr="Recette : Rune de résistance à l'Eau flamboyante",ru="Эскиз: яркая руна сопротивляемости Воде",icon="scroll9a",val=0,q=3,bop=true,accBound=true,Consumable=true,rss="Runecrafter",rsslvl=300,rf="Order of Purity",rfl=3},
["B6DE8DFD0F01010101"] = {akey="IFFA36F36524B29F0,9AD79DCE3AE86708,,,,,,",de="Anleitung: Schimmernde Runen-scherbe der Verheerung",en="Recipe: Gleaming Devastating Runeshard",fr="Plan : Fragment de rune dévastatrice luisante",ru="Эскиз: Осколок светящейся руны опустошения",icon="cloth12a",val=0,q=1,bop=true,Consumable=true,rss="Runecrafter",rsslvl=300},
["96BB9EDB0501010101"] = {akey="I5B679D967EFB8076,38169DBDC58B7BC0,,,,,,",de="Anleitung: Weißglühende Rune der Beharrlichkeit",en="Recipe: Incandescent Tenacious Rune",fr="Recette : Rune tenace incandescente",ru="Эскиз: сияющая руна устойчивости",icon="scroll9a",val=0,q=2,bop=true,accBound=true,Consumable=true,rss="Runecrafter",rsslvl=300,rf="The Keepers",rfl=3},
["E3CCBAFF0601010101"] = {akey="I6FEEA663517ACAF5,27F865AEDFD4C225,,,,,,",de="Anleitung: Helle Rune der Beherrschung",en="Recipe: Bright Dominating Rune",fr="Recette : Rune de domination brillante",ru="Эскиз: блестящая руна владычества",icon="scroll8b",val=0,q=1,bop=true,Consumable=true,rss="Runecrafter",rsslvl=150},
["BA84FCF20201010101"] = {akey="I2E5F023A1A74BD77,E198A3C7B4DE0AE1,,,,,,",de="Anleitung: Flammende Rune der Stärke",en="Recipe: Blazing Strength Rune",fr="Recette : Rune de force flamboyante",ru="Эскиз: яркая руна силы",icon="scroll9a",val=0,q=2,bop=true,Consumable=true,rss="Runecrafter",rsslvl=290},
["E1E7F5C80401010101"] = {akey="I491D73E15DB23889,81B85513D368173E,,,,,,",de="Anleitung: Strahlende Runenscherbe der Zerstörung",en="Recipe: Radiant Destructive Runeshard",fr="Recette : Fragment de rune destructrice rayonnante",ru="Эскиз: лучистый рунный осколок разрушения",icon="scroll9a",val=0,q=2,bop=true,Consumable=true,rss="Runecrafter",rsslvl=230},
["D1E1F5FF0101010101"] = {akey="I1FFD70D16E0875AE,38A7BF3338513A82,,,,,,",de="Anleitung: Aurora-Rune der Leistung",en="Recipe: Auroral Potent Rune",fr="Plan : Rune de puissance aurorale",ru="Эскиз: Аврорская могучая руна",icon="cloth12a",val=0,q=2,bop=true,Consumable=true,rss="Runecrafter",rsslvl=340},
["CB918CDB0201010101"] = {akey="I2B6308CB5497B8B1,CDBFE4965A4A9BBF,,,,,,",de="Anleitung: Flammende Rune der Festigkeit",en="Recipe: Blazing Steadfast Rune",fr="Recette : Rune vaillante flamboyante",ru="Эскиз: яркая руна постоянства",icon="scroll9a",val=1,q=2,Consumable=true,rss="Runecrafter",rsslvl=290},
["C684FCF20201010101"] = {akey="I2E5F024652091079,DA3BE3A3F27D6994,,,,,,",de="Anleitung: Brillante Rune des Todeswiderstandes",en="Recipe: Brilliant Death Resistance Rune",fr="Recette : Rune éclatante de résistance à la Mort",ru="Эскиз: сверкающая руна сопротивляемости Смерти",icon="scroll9a",val=0,q=2,bop=true,accBound=true,Consumable=true,rss="Runecrafter",rsslvl=290,rf="Order of the Death Serpent",rfl=2},
["888985A50601010101"] = {akey="I64A144886D42BCA5,0AC9A012FDCE048D,,,,,,",de="Anleitung: Glühende Rune der Beherrschung",en="Recipe: Glowing Dominating Rune",fr="Recette : Rune de domination luminescente",ru="Эскиз: светлая руна владычества",icon="scroll1a",val=0,q=1,bop=true,Consumable=true,rss="Runecrafter",rsslvl=100},
["B9E0B8D60101010101"] = {akey="I1ACE303961BFD606,E7663558BEA2CBCD,,,,,,",de="Anleitung: Flammende Runenscherbe der Gerissenheit",en="Recipe: Blazing Savvy Runeshard",fr="Recette : Fragment de rune astucieuse flamboyante",ru="Эскиз: яркий рунный осколок знаний",icon="scroll8b",val=1,q=2,Consumable=true,rss="Runecrafter",rsslvl=300},
["B6A4D17301010101"] = {akey="I0E74523660687D8A,E9159B255A72F721,,,,,,",de="Anleitung: Strahlende Runenscherbe der Gerissenheit",en="Recipe: Radiant Savvy Runeshard",fr="Recette : Fragment de rune astucieuse rayonnante",ru="Эскиз: лучистый рунный осколок знаний",icon="scroll8b",val=0,q=1,bop=true,Consumable=true,rss="Runecrafter",rsslvl=275},
["CFC0C0D90201010101"] = {akey="I2B30204F43CA9502,27E43895CDF4DB24,,,,,,",de="Anleitung: Helle Rune des Zorns",en="Recipe: Bright Wrathful Rune",fr="Recette : Rune de courroux brillante",ru="Эскиз: блестящая руна гнева",icon="scroll8b",val=0,q=1,bop=true,Consumable=true,rss="Runecrafter",rsslvl=150},
["B6DBAD6701010101"] = {akey="I0CEB6DB647F547B9,788D761ABFF1E2CD,,,,,,",de="Anleitung: Flammende Rune der Einsicht",en="Recipe: Blazing Insightful Rune",fr="Recette : Rune de perspicacité flamboyante",ru="Эскиз: яркая руна проницательности",icon="scroll9a",val=1,q=2,Consumable=true,rss="Runecrafter",rsslvl=290},
["A5EEF6E80401010101"] = {akey="I4D1DB72542764E9B,1ECE64BB4950F169,,,,,,",de="Anleitung: Eiswandrune",en="Recipe: Icewall Rune",fr="Recette : Rune de mur de glace",ru="Эскиз: руна ледяной стены",icon="scroll8b",val=0,q=2,bop=true,accBound=true,Consumable=true,rss="Runecrafter",rsslvl=200,rf="Order of Purity",rfl=2},
["8494D3D40701010101"] = {akey="I7A94CA046B298170,5418D28BB45BA08E,,,,,,",de="Anleitung: Glühende Runenscherbe der Gerissenheit",en="Recipe: Incandescent Savvy Runeshard",fr="Recette : Fragment de rune astucieuse incandescente",ru="Эскиз: сияющий рунный осколок знаний",icon="scroll8b",val=1,q=3,Consumable=true,rss="Runecrafter",rsslvl=300},
["96A1EFB90101010101"] = {akey="I173BD0960B5C16F9,252E6302277B6DE2,,,,,,",de="Anleitung: Aurora-Rune der Ritterlichkeit",en="Recipe: Auroral Gallant Rune",fr="Recette : Rune téméraire aurorale",ru="Эскиз: Аврорская величественная руна",icon="cloth12a",val=1,q=2,Consumable=true,rss="Runecrafter",rsslvl=375},
["C2DBAD6701010101"] = {akey="I0CEB6DC27A583954,4ED328F0BF271523,,,,,,",de="Anleitung: Flammende Rune der Ablenkung",en="Recipe: Blazing Deflection Rune",fr="Recette : Rune de déviation flamboyante",ru="Эскиз: яркая руна отражения",icon="scroll9a",val=1,q=3,Consumable=true,rss="Runecrafter",rsslvl=300},
["B7DE8DFD0F01010101"] = {akey="IFFA36F370C213A2C,9EF907EE5E7113AD,,,,,,",de="Anleitung: Schimmernde Rune des Elends",en="Recipe: Gleaming Calamitous Rune",fr="Plan : Rune calamiteuse luisante",ru="Эскиз: Светящаяся погибельная руна",icon="cloth12a",val=0,q=1,bop=true,Consumable=true,rss="Runecrafter",rsslvl=310},
["C9ABFFFE0601010101"] = {akey="I6FDFD5C94608AB53,D834C397CD75E9D5,,,,,,",de="Anleitung: Brillante Rune des Luftwiderstandes",en="Recipe: Brilliant Air Resistance Rune",fr="Recette : Rune éclatante de résistance à l'Air",ru="Эскиз: сверкающая руна сопротивляемости Воздуху",icon="scroll9a",val=0,q=2,bop=true,accBound=true,Consumable=true,rss="Runecrafter",rsslvl=290,rf="Zephyrian Collective",rfl=2},
["E2E7F5C80401010101"] = {akey="I491D73E24AE4F984,2371FB464FBD9FD1,,,,,,",de="Anleitung: Strahlende Runenscherbe der Verwüstung",en="Recipe: Radiant Ravaging Runeshard",fr="Recette : Fragment de rune ravageuse rayonnante",ru="Эскиз: лучистый рунный осколок колдовства",icon="scroll9a",val=0,q=2,bop=true,Consumable=true,rss="Runecrafter",rsslvl=230},
["D2E1F5FF0101010101"] = {akey="I1FFD70D22BC190D9,19465149B108470F,,,,,,",de="Anleitung: Aurora-Runenscherbe des Tiefgrunds",en="Recipe: Auroral Recondite Runeshard",fr="Plan : Fragment de rune ésotérique aurorale",ru="Эскиз: Аврорский осколок вычурной руны",icon="cloth12a",val=0,q=2,bop=true,Consumable=true,rss="Runecrafter",rsslvl=350},
["CC918CDB0201010101"] = {akey="I2B6308CC374A4A62,410431462073133E,,,,,,",de="Anleitung: Flammende Rune der Leistung",en="Recipe: Blazing Potent Rune",fr="Recette : Rune de puissance flamboyante",ru="Эскиз: яркая руна мощности",icon="scroll9a",val=1,q=2,Consumable=true,rss="Runecrafter",rsslvl=290},
["C5DA91890501010101"] = {akey="I51246D454255808F,74258E7830BBE7D7,,,,,,",de="Anleitung: Flammende Rune des Erdwiderstandes",en="Recipe: Blazing Earth Resistance Rune",fr="Recette : Rune de résistance à la Terre flamboyante",ru="Эскиз: яркая руна сопротивляемости Земле",icon="scroll9a",val=0,q=3,bop=true,accBound=true,Consumable=true,rss="Runecrafter",rsslvl=300,rf="The Shale Collegiate",rfl=3},
["B7DBAD6701010101"] = {akey="I0CEB6DB74F1E734B,77EA1294FDDD3F05,,,,,,",de="Anleitung: Flammende Rune der Standhaftigkeit",en="Recipe: Blazing Unwavering Rune",fr="Recette : Rune inébranlable flamboyante",ru="Эскиз: яркая руна непоколебимости",icon="scroll9a",val=1,q=2,Consumable=true,rss="Runecrafter",rsslvl=290},
["A6EEF6E80401010101"] = {akey="I4D1DB726362C42C1,CDB4EC3B4FE4EFCC,,,,,,",de="Anleitung: Zerschmetternde Runenscherbe",en="Recipe: Crushing Runeshard",fr="Recette : Fragment de rune écrasante",ru="Эскиз: разрушающий рунный осколок",icon="scroll1a",val=0,q=2,bop=true,accBound=true,Consumable=true,rss="Runecrafter",rsslvl=100,rf="Mendicant Order",rfl=2},
["ABA4FFEC0401010101"] = {akey="I4D9FD22B4846D90A,1FABA183F4932FEA,,,,,,",de="Anleitung: Scherbe der Heilung",en="Recipe: Shard of Healing",fr="Recette : Fragment de soins",ru="Рецепт: осколок исцеления",icon="scroll1a",val=0,q=3,bop=true,Consumable=true,rss="Runecrafter",rsslvl=210},
["97A1EFB90101010101"] = {akey="I173BD09706E2E273,294FCD224B039737,,,,,,",de="Anleitung: Aurora-Rune der Deutlichkeit",en="Recipe: Auroral Unblurring Rune",fr="Recette : Rune nette aurorale",ru="Эскиз: Аврорская фокусирующая руна",icon="cloth12a",val=0,q=3,bop=true,Consumable=true,rss="Runecrafter",rsslvl=375},
["B8DE8DFD0F01010101"] = {akey="IFFA36F382FF7F319,D707AE24F144E4BD,,,,,,",de="Anleitung: Schimmernde Rune der Verheerung",en="Recipe: Gleaming Devastating Rune",fr="Plan : Rune dévastatrice luisante",ru="Эскиз: Светящаяся руна опустошения",icon="cloth12a",val=0,q=1,bop=true,Consumable=true,rss="Runecrafter",rsslvl=310},
["EEDFA5CA0201010101"] = {akey="I29496FEE2DF94DDC,455356BCFD33077E,,,,,,",de="Anleitung: Leuchtende Rune des Rachedursts",en="Recipe: Luminous Vengeful Rune",fr="Recette : Rune vengeresse lumineuse",ru="Эскиз: искристая руна мести",icon="scroll8b",val=0,q=1,bop=true,Consumable=true,rss="Runecrafter",rsslvl=170},
["BC84FCF20201010101"] = {akey="I2E5F023C2AC3A6C3,2623F98100DDA1F9,,,,,,",de="Anleitung: Flammende Runenscherbe der Geschicktheit",en="Recipe: Blazing Dexterity Runeshard",fr="Recette : Fragment de rune de dextérité flamboyante",ru="Эскиз: яркий рунный осколок ловкости",icon="scroll9a",val=0,q=2,bop=true,Consumable=true,rss="Runecrafter",rsslvl=290},
["E3E7F5C80401010101"] = {akey="I491D73E3531247D3,17DC9997824D07BD,,,,,,",de="Anleitung: Strahlende Rune der Genauigkeit",en="Recipe: Radiant Accurate Rune",fr="Recette : Rune adroite rayonnante",ru="Эскиз: лучистая руна меткости",icon="scroll9a",val=0,q=2,bop=true,Consumable=true,rss="Runecrafter",rsslvl=230},
["D3E1F5FF0101010101"] = {akey="I1FFD70D3488050C7,39299553A439AC0C,,,,,,",de="Anleitung: Aurora-Runenscherbe der Wut",en="Recipe: Auroral Rage Runeshard",fr="Plan : Fragment de rune de rage aurorale",ru="Эскиз: Аврорский осколок руны ярости",icon="cloth12a",val=0,q=2,bop=true,Consumable=true,rss="Runecrafter",rsslvl=350},
["CD918CDB0201010101"] = {akey="I2B6308CD07B965D8,2616C33D60228E32,,,,,,",de="Anleitung: Flammende Rune der Unnachgiebigkeit",en="Recipe: Blazing Adamant Rune",fr="Recette : Rune rigide flamboyante",ru="Эскиз: яркая руна твердости",icon="scroll9a",val=1,q=2,Consumable=true,rss="Runecrafter",rsslvl=300},
["F6CF9EED0301010101"] = {akey="I3DA7A7F64B2DD6C2,CFAFC8746B4D5B5C,,,,,,",de="Anleitung: Weißglühende Rune der Unnachgiebigkeit",en="Recipe: Incandescent Adamant Rune",fr="Recette : Rune intransigeante incandescente",ru="Эскиз: сияющая руна твердости",icon="scroll9a",val=0,q=2,bop=true,accBound=true,Consumable=true,rss="Runecrafter",rsslvl=300,rf="The Keepers",rfl=3},
["B8DBAD6701010101"] = {akey="I0CEB6DB866B12300,26D09A1484713D67,,,,,,",de="Anleitung: Flammende Rune der Klugheit",en="Recipe: Blazing Sagacious Rune",fr="Recette : Rune de sagacité flamboyante",ru="Эскиз: яркая руна прозорливости",icon="scroll9a",val=1,q=2,Consumable=true,rss="Runecrafter",rsslvl=290},
["A7EEF6E80401010101"] = {akey="I4D1DB7273B88AB24,EF6E0F1F4C39F510,,,,,,",de="Anleitung: Frostige Rune",en="Recipe: Chilling Rune",fr="Recette : Rune effrayante",ru="Эскиз: леденящая руна",icon="scroll1a",val=0,q=2,bop=true,accBound=true,Consumable=true,rss="Runecrafter",rsslvl=100,rf="Order of Purity",rfl=2},
["ACA4FFEC0401010101"] = {akey="I4D9FD22C784F84CF,428B1607DD4FA8EA,,,,,,",de="Anleitung: Scherbe der Ausdauer",en="Recipe: Shard of Endurance",fr="Recette : Fragment d'endurance",ru="Рецепт: осколок выносливости",icon="scroll1a",val=0,q=3,bop=true,Consumable=true,rss="Runecrafter",rsslvl=210},
["98A1EFB90101010101"] = {akey="I173BD098229A4460,BB52243856605E60,,,,,,",de="Anleitung: Aurora-Rune des Getreuen",en="Recipe: Auroral Stalwart Rune",fr="Recette : Rune fidèle aurorale",ru="Эскиз: Аврорская преданная руна",icon="cloth12a",val=0,q=3,bop=true,Consumable=true,rss="Runecrafter",rsslvl=375},
["B9DE8DFD0F01010101"] = {akey="IFFA36F39262C7EB6,9F7ADE0ECA5901E9,,,,,,",de="Anleitung: Aurora-Runenscherbe des Elends",en="Recipe: Auroral Calamitous Runeshard",fr="Plan : Fragment de rune calamiteuse aurorale",ru="Эскиз: Аврорский осколок погибельной руны",icon="cloth12a",val=0,q=2,bop=true,Consumable=true,rss="Runecrafter",rsslvl=375},
["EFDFA5CA0201010101"] = {akey="I29496FEF51D80EBD,15D3CD7F59B3A8EF,,,,,,",de="Anleitung: Leuchtende Rune der Unerbittlichkeit",en="Recipe: Luminous Unrelenting Rune",fr="Recette : Rune fanatique lumineuse",ru="Эскиз: искристая руна беспощадности",icon="scroll8b",val=0,q=1,bop=true,Consumable=true,rss="Runecrafter",rsslvl=170},
["BD84FCF20201010101"] = {akey="I2E5F023D3E14193E,D9D2C6792DE76252,,,,,,",de="Anleitung: Flammende Runenscherbe der Intelligenz",en="Recipe: Blazing Intelligence Runeshard",fr="Recette : Fragment de rune d'intelligence flamboyante",ru="Эскиз: яркий рунный осколок интеллекта",icon="scroll9a",val=0,q=2,bop=true,Consumable=true,rss="Runecrafter",rsslvl=290},
["E4E7F5C80401010101"] = {akey="I491D73E451B395D3,37BFDDA1757EF008,,,,,,",de="Anleitung: Strahlende Rune der Schärfe",en="Recipe: Radiant Sharp Rune",fr="Recette : Rune incisive rayonnante",ru="Эскиз: лучистая руна концентрации",icon="scroll9a",val=0,q=2,bop=true,Consumable=true,rss="Runecrafter",rsslvl=230},
["DA9FDD980301010101"] = {akey="I33174FDA4B267596,6BFDA0D5649552BB,,,,,,",de="Anleitung: Flammende Rune des Todeswiderstandes",en="Recipe: Blazing Death Resistance Rune",fr="Recette : Rune de résistance à la Mort flamboyante",ru="Эскиз: яркая руна сопротивляемости Смерти",icon="scroll9a",val=0,q=3,bop=true,accBound=true,Consumable=true,rss="Runecrafter",rsslvl=300,rf="The Grim Disciples",rfl=3},
["D4E1F5FF0101010101"] = {akey="I1FFD70D4615B6608,3D4AFF73C7C1D561,,,,,,",de="Anleitung: Aurora-Rune der Unnachgiebigkeit",en="Recipe: Auroral Adamant Rune",fr="Plan : Rune rigide aurorale",ru="Эскиз: Аврорская адамантовая руна",icon="cloth12a",val=0,q=2,bop=true,Consumable=true,rss="Runecrafter",rsslvl=350},
["CE918CDB0201010101"] = {akey="I2B6308CE696B91AF,03C6E9D57C60F13A,,,,,,",de="Anleitung: Flammende Rune der Entschlossenheit",en="Recipe: Blazing Resolute Rune",fr="Recette : Rune de résolution flamboyante",ru="Эскиз: яркая руна бодрости",icon="scroll9a",val=1,q=2,Consumable=true,rss="Runecrafter",rsslvl=290},
["97A986EA0201010101"] = {akey="I2D4194974253B253,0C9271996083F6D3,,,,,,",de="Anleitung: Glühende Runenscherbe der Verheerung",en="Recipe: Incandescent Devastating Runeshard",fr="Recette : Fragment de rune dévastatrice incandescente",ru="Эскиз: сияющий рунный осколок опустошения",icon="scroll9a",val=0,q=3,bop=true,Consumable=true,rss="Runecrafter",rsslvl=300},
["B9DBAD6701010101"] = {akey="I0CEB6DB97A363F67,1BEEC0BF1496CD57,,,,,,",de="Anleitung: Flammende Rune der Zähigkeit",en="Recipe: Blazing Tough Rune",fr="Recette : Rune solide flamboyante",ru="Эскиз: яркая руна гибкости",icon="scroll9a",val=0,q=3,bop=true,Consumable=true,rss="Runecrafter",rsslvl=300},
["A8EEF6E80401010101"] = {akey="I4D1DB7280A2756D6,231D5F64F943B56A,,,,,,",de="Anleitung: Versteinernde Rune",en="Recipe: Petrifying Rune",fr="Recette : Rune pétrifiante",ru="Эскиз: руна окаменения",icon="scroll1a",val=0,q=2,bop=true,accBound=true,Consumable=true,rss="Runecrafter",rsslvl=100,rf="Mendicant Order",rfl=2},
["ADA4FFEC0401010101"] = {akey="I4D9FD22D455D1A58,35CF62B8A3782069,,,,,,",de="Anleitung: Transportierbare Lebensquelle",en="Recipe: Portable Lifespring",fr="Plan : Source de vie portable",ru="Чертеж: портативный источник Жизни",icon="scroll1a",val=0,q=3,bop=true,Consumable=true,rss="Runecrafter",rsslvl=260},
["EECCD97301010101"] = {akey="I0E76666E730CF067,334C188B47AA2FA6,,,,,,",de="Anleitung: Zerschmetternde Runenscherbe",en="Recipe: Crushing Runeshard",fr="Recette : Fragment de rune écrasante",ru="Эскиз: разрушающий рунный осколок",icon="scroll1a",val=0,q=2,bop=true,accBound=true,Consumable=true,rss="Runecrafter",rsslvl=100,rf="The Shale Collegiate",rfl=2},
["99A1EFB90101010101"] = {akey="I173BD0996FBBFF1F,CD547B4D61BD2589,,,,,,",de="Anleitung: Aurora-Rune der Härte",en="Recipe: Auroral Hardy Rune",fr="Recette : Rune durcie aurorale",ru="Эскиз: Аврорская закаленная руна",icon="cloth12a",val=0,q=3,bop=true,Consumable=true,rss="Runecrafter",rsslvl=375},
["D0C0CCB40401010101"] = {akey="I469320506DAD2FF1,FC908B82D7DEB007,,,,,,",de="Anleitung: Helle Rune der Flüchtigkeit",en="Recipe: Bright Elusive Rune",fr="Recette : Rune brillante insaisissable",ru="Эскиз: блестящая руна парирования",icon="scroll4",val=0,q=1,bop=true,Consumable=true,rss="Runecrafter",rsslvl=70},
["BADE8DFD0F01010101"] = {akey="IFFA36F3A54F46EDE,149904B85A7F1527,,,,,,",de="Anleitung: Aurora-Runenscherbe der Verheerung",en="Recipe: Auroral Devastating Runeshard",fr="Plan : Fragment de rune dévastatrice aurorale",ru="Эскиз: Аврорский осколок разрушительной руны",icon="cloth12a",val=0,q=2,bop=true,Consumable=true,rss="Runecrafter",rsslvl=375},
["80C2EE8D0201010101"] = {akey="I21BBA100477FBB5B,3C1F5FF2951B311B,,,,,,",de="Anleitung: Glühende Rune der Flüchtigkeit",en="Recipe: Glowing Elusive Rune",fr="Recette : Rune insaisissable luminescente",ru="Эскиз: светлая руна парирования",icon="scroll4",val=0,q=1,bop=true,Consumable=true,rss="Runecrafter",rsslvl=1},
["F0DFA5CA0201010101"] = {akey="I29496FF01F05B0D3,48D15D565EA68D0B,,,,,,",de="Anleitung: Leuchtende Rune der Genauigkeit",en="Recipe: Luminous Accurate Rune",fr="Recette : Rune attentive lumineuse",ru="Эскиз: искристая руна меткости",icon="scroll8b",val=0,q=2,bop=true,Consumable=true,rss="Runecrafter",rsslvl=170},
["C9E1F5FF0101010101"] = {akey="I1FFD70C9487BC0A7,1125FFDBE982CDB3,,,,,,",de="Anleitung: Aurora-Rune des Tiefgrunds",en="Recipe: Auroral Recondite Rune",fr="Plan : Rune ésotérique aurorale",ru="Эскиз: Аврорская вычурная руна",icon="cloth12a",val=0,q=2,bop=true,Consumable=true,rss="Runecrafter",rsslvl=320},
["C3918CDB0201010101"] = {akey="I2B6308C358453F83,F1FFDFB8EE82C698,,,,,,",de="Anleitung: Brillante Rune des Erdwiderstandes",en="Recipe: Brilliant Earth Resistance Rune",fr="Recette : Rune éclatante de résistance à la Terre",ru="Эскиз: сверкающая руна сопротивляемости Земле",icon="scroll9a",val=0,q=2,bop=true,accBound=true,Consumable=true,rss="Runecrafter",rsslvl=290,rf="Mendicant Order",rfl=2},
["BE84FCF20201010101"] = {akey="I2E5F023E43B52849,EBD5A0DC3944ACCB,,,,,,",de="Anleitung: Flammende Runenscherbe der Stärke",en="Recipe: Blazing Strength Runeshard",fr="Recette : Fragment de rune de force flamboyante",ru="Эскиз: яркий рунный осколок силы",icon="scroll9a",val=0,q=2,bop=true,Consumable=true,rss="Runecrafter",rsslvl=290},
["E5E7F5C80401010101"] = {akey="I491D73E52402626A,5A9F5225DE3AE5B9,,,,,,",de="Anleitung: Strahlende Rune des Rachedursts",en="Recipe: Radiant Vengeful Rune",fr="Recette : Rune vengeresse rayonnante",ru="Эскиз: лучистая руна мести",icon="scroll9a",val=0,q=1,bop=true,Consumable=true,rss="Runecrafter",rsslvl=260},
["D1E891C20201010101"] = {akey="I2844745174F41B2E,FD099FB4484C858E,,,,,,",de="Anleitung: Brillante Rune des Todeswiderstandes",en="Recipe: Brilliant Death Resistance Rune",fr="Recette : Rune éclatante de résistance à la Mort",ru="Эскиз: сверкающая руна сопротивляемости Смерти",icon="scroll9a",val=0,q=2,bop=true,accBound=true,Consumable=true,rss="Runecrafter",rsslvl=290,rf="The Grim Disciples",rfl=2},
["CF918CDB0201010101"] = {akey="I2B6308CF2AC5B6A9,18B82FB66436E539,,,,,,",de="Anleitung: Flammende Rune der Vereitelung",en="Recipe: Blazing Thwarting Rune",fr="Recette : Rune contrariante flamboyante",ru="Эскиз: яркая руна противостояния",icon="scroll9a",val=1,q=2,Consumable=true,rss="Runecrafter",rsslvl=290},
["98A986EA0201010101"] = {akey="I2D4194981B662B9C,1B504A9B8EEA7EFC,,,,,,",de="Anleitung: Glühende Rune des Elends",en="Recipe: Incandescent Calamitous Rune",fr="Recette : Rune calamiteuse incandescente",ru="Эскиз: сияющая руна чародейства",icon="scroll9a",val=0,q=3,bop=true,Consumable=true,rss="Runecrafter",rsslvl=300},
["BADBAD6701010101"] = {akey="I0CEB6DBA6F95A22E,6B5BEFCE5070D47E,,,,,,",de="Anleitung: Flammende Rune der Beständigkeit",en="Recipe: Blazing Enduring Rune",fr="Recette : Rune durable flamboyante",ru="Эскиз: яркая руна выносливости",icon="scroll9a",val=1,q=2,Consumable=true,rss="Runecrafter",rsslvl=300},
["AEA4FFEC0401010101"] = {akey="I4D9FD22E61147C45,47D23D1B2ED56AE1,,,,,,",de="Anleitung: Transportierbares Geschütz",en="Recipe: Portable Turret",fr="Plan : Tourelle portable",ru="Чертеж: портативная огневая установка",icon="scroll1a",val=0,q=3,bop=true,Consumable=true,rss="Runecrafter",rsslvl=260},
["9AA1EFB90101010101"] = {akey="I173BD09A4AB5CDD8,ED37BF5754EE8A86,,,,,,",de="Anleitung: Aurora-Rune des Spiegelns",en="Recipe: Auroral Mirroring Rune",fr="Recette : Rune miroitante aurorale",ru="Эскиз: Аврорская зеркальная руна",icon="cloth12a",val=0,q=3,bop=true,Consumable=true,rss="Runecrafter",rsslvl=375},
["D1C0CCB40401010101"] = {akey="I469320514B0696EB,33E252EDBEF7C53B,,,,,,",de="Anleitung: Leuchtende Rune der Flüchtigkeit",en="Recipe: Luminous Elusive Rune",fr="Recette : Rune insaisissable lumineuse",ru="Эскиз: искристая руна парирования",icon="scroll1a",val=0,q=1,bop=true,Consumable=true,rss="Runecrafter",rsslvl=140},
["BBDE8DFD0F01010101"] = {akey="IFFA36F3B1381615E,F4E35137F3B84AD6,,,,,,",de="Anleitung: Aurora-Rune des Elends",en="Recipe: Auroral Calamitous Rune",fr="Plan : Rune calamiteuse aurorale",ru="Эскиз: Аврорская погибельная руна",icon="cloth12a",val=0,q=2,bop=true,Consumable=true,rss="Runecrafter",rsslvl=375},
["F6ACB66001010101"] = {akey="I0C0D96766B6A4AE6,B81F4657679EDC71,,,,,,",de="Anleitung: Brillante Rune des Erdwiderstandes",en="Recipe: Brilliant Earth Resistance Rune",fr="Recette : Rune éclatante de résistance à la Terre",ru="Эскиз: сверкающая руна сопротивляемости Земле",icon="scroll9a",val=0,q=2,bop=true,accBound=true,Consumable=true,rss="Runecrafter",rsslvl=290,rf="The Shale Collegiate",rfl=2},
["ABE6DFAC0101010101"] = {akey="I1597F32B5B411C17,067ACB424C2A1465,,,,,,",de="Anleitung: Glühende Rune des Zorns",en="Recipe: Glowing Wrathful Rune",fr="Recette : Rune de courroux luminescente",ru="Эскиз: светлая руна гнева",icon="scroll1a",val=0,q=1,bop=true,Consumable=true,rss="Runecrafter",rsslvl=100},
["F1DFA5CA0201010101"] = {akey="I29496FF17175D0BF,0598D1CB4D0F2942,,,,,,",de="Anleitung: Leuchtende Rune der Schärfe",en="Recipe: Luminous Sharp Rune",fr="Recette : Rune incisive lumineuse",ru="Эскиз: искристая руна концентрации",icon="scroll8b",val=0,q=2,bop=true,Consumable=true,rss="Runecrafter",rsslvl=170},
["E2EEF0AD0701010101"] = {akey="I75BC376271FE5721,0EEAF7262A9F1339,,,,,,",de="Anleitung: Windschutz-Rune",en="Recipe: Windshielding Rune",fr="Recette : Rune de défense venteuse",ru="Эскиз: руна ураганной защиты",icon="scroll8b",val=0,q=2,bop=true,accBound=true,Consumable=true,rss="Runecrafter",rsslvl=200,rf="Zephyrian Collective",rfl=2},
["D2D8A01601010101"] = {akey="I02C82C525870655B,3DE76E240D4E463D,,,,,,",de="Anleitung: Flammende Runenscherbe der Unbeugsamkeit",en="Recipe: Blazing Indomitable Runeshard",fr="Recette : Fragment de rune indomptable flamboyante",ru="Эскиз: яркий рунный осколок стойкости",icon="scroll8b",val=1,q=2,Consumable=true,rss="Runecrafter",rsslvl=300},
["CAE1F5FF0101010101"] = {akey="I1FFD70CA3DF6BBD2,48784A94509C6636,,,,,,",de="Anleitung: Aurora-Rune der Wut",en="Recipe: Auroral Rage Rune",fr="Plan : Rune de rage aurorale",ru="Эскиз: Аврорская руна ярости",icon="cloth12a",val=0,q=2,bop=true,Consumable=true,rss="Runecrafter",rsslvl=320},
["C4918CDB0201010101"] = {akey="I2B6308C45D193B4F,D29E71CEE739D326,,,,,,",de="Anleitung: Brillante Rune des Feuerwiderstandes",en="Recipe: Brilliant Fire Resistance Rune",fr="Recette : Rune éclatante de résistance au Feu",ru="Эскиз: сверкающая руна сопротивляемости Огню",icon="scroll9a",val=0,q=2,bop=true,accBound=true,Consumable=true,rss="Runecrafter",rsslvl=290,rf="Order of the Flame",rfl=2},
["BF84FCF20201010101"] = {akey="I2E5F023F681EDDE8,CC7432F231FBB959,,,,,,",de="Anleitung: Flammende Runenscherbe der Weisheit",en="Recipe: Blazing Wisdom Runeshard",fr="Recette : Fragment de rune de sagesse flamboyante",ru="Эскиз: яркий рунный осколок мудрости",icon="scroll9a",val=0,q=2,bop=true,Consumable=true,rss="Runecrafter",rsslvl=290},
["E6E7F5C80401010101"] = {akey="I491D73E6791B3D1C,4AF4B00A47EAB3B1,,,,,,",de="Anleitung: Strahlende Rune der Unerbittlichkeit",en="Recipe: Radiant Unrelenting Rune",fr="Recette : Rune fanatique rayonnante",ru="Эскиз: лучистая руна беспощадности",icon="scroll9a",val=0,q=1,bop=true,Consumable=true,rss="Runecrafter",rsslvl=260},
["96A9C3FA0101010101"] = {akey="I1F50D49665722B23,FC66D16639ACBBE8,,,,,,",de="Anleitung: Rune des Abgründigen-Lehrlings",en="Recipe: Rune of the Abyssal Apprentice",fr="Recette : Rune de l'Apprenti abyssal",ru="Эскиз: руна послушника Глубинных",icon="tornscroll1",val=0,q=3,bop=true,Consumable=true,rss="Runecrafter",rsslvl=300},
["D0918CDB0201010101"] = {akey="I2B6308D0140C9E01,19EAAB0A2B45E1B9,,,,,,",de="Anleitung: Flammende Runenscherbe des Tiefgrunds",en="Recipe: Blazing Recondite Runeshard",fr="Recette : Fragment de rune absconse flamboyante",ru="Эскиз: яркий рунный осколок могущества",icon="scroll9a",val=1,q=2,Consumable=true,rss="Runecrafter",rsslvl=290},
["99A986EA0201010101"] = {akey="I2D419499252682C9,3966F65951313604,,,,,,",de="Anleitung: Glühende Runenscherbe des Elends",en="Recipe: Incandescent Calamitous Runeshard",fr="Recette : Fragment de rune calamiteuse incandescente",ru="Эскиз: сияющий рунный осколок чародейства",icon="scroll9a",val=0,q=3,bop=true,Consumable=true,rss="Runecrafter",rsslvl=300},
["BBDBAD6701010101"] = {akey="I0CEB6DBB006E8A79,82268C5B02435D9E,,,,,,",de="Anleitung: Flammende Racherune",en="Recipe: Blazing Vengeance Rune",fr="Recette : Rune de vengeance flamboyante",ru="Эскиз: Яркая руна доблести",icon="scroll9a",val=12300,q=3,bop=true,Consumable=true,rss="Runecrafter",rsslvl=300},
["C9E4B5FC0701010101"] = {akey="I7F8D72492D49765B,68EB22223B39B2D5,,,,,,",de="Anleitung: Baustein: Grausteinplatte",en="Recipe: Building Block: Greystone Tile",fr="Plan : Bloc de construction : carreau de pierre grise",ru="Чертеж: Стройматериал: Черепица серого камня",icon="scroll4c",val=0,bop=true,Consumable=true,rss="Runecrafter",rsslvl=60},
["9BA1EFB90101010101"] = {akey="I173BD09B2D3914E0,022881EA3CC3FB35,,,,,,",de="Anleitung: Empyreum-Rune des Tiefgrunds",en="Recipe: Empyrean Recondite Rune",fr="Plan : Rune ésotérique empyréenne",ru="Эскиз: Эмпирейская вычурная руна",icon="cloth12a",val=0,q=3,bop=true,Consumable=true,rss="Runecrafter",rsslvl=375},
["D2C0CCB40401010101"] = {akey="I4693205231C02A20,2437B0D2A8A79332,,,,,,",de="Anleitung: Strahlende Rune der Flüchtigkeit",en="Recipe: Radiant Elusive Rune",fr="Recette : Rune insaisissable rayonnante",ru="Эскиз: лучистая руна парирования",icon="scroll9a",val=0,q=1,bop=true,Consumable=true,rss="Runecrafter",rsslvl=240},
["BCDE8DFD0F01010101"] = {akey="IFFA36F3C53C2B3D1,C4B2078C2822100A,,,,,,",de="Anleitung: Aurora-Rune der Verheerung",en="Recipe: Auroral Devastating Rune",fr="Plan : Rune dévastatrice aurorale",ru="Эскиз: Аврорская разрушительная руна",icon="cloth12a",val=0,q=2,bop=true,Consumable=true,rss="Runecrafter",rsslvl=375},
["F2DFA5CA0201010101"] = {akey="I29496FF23BD86BCE,FAB6F876DD34B932,,,,,,",de="Anleitung: Leuchtende Runenscherbe der Zerstörung",en="Recipe: Luminous Destructive Runeshard",fr="Recette : Fragment de rune destructrice lumineuse",ru="Эскиз: искристый рунный осколок разрушения",icon="scroll8b",val=0,q=2,bop=true,Consumable=true,rss="Runecrafter",rsslvl=170},
["87F0E6BD0601010101"] = {akey="I67B9B8072E33832B,2682CDD697E44185,,,,,,",de="Anleitung: Flammende Rune der Gerissenheit",en="Recipe: Blazing Savvy Rune",fr="Recette : Rune astucieuse flamboyante",ru="Эскиз: яркая руна знаний",icon="scroll8b",val=1,q=2,Consumable=true,rss="Runecrafter",rsslvl=300},
["FDEA93F40501010101"] = {akey="I5E84F57D34E6D0CB,165F9E91114DB38F,,,,,,",de="Anleitung: Strahlende Rune der Gerissenheit",en="Recipe: Radiant Savvy Rune",fr="Recette : Rune astucieuse rayonnante",ru="Эскиз: лучистая руна знаний",icon="scroll8b",val=0,q=1,bop=true,Consumable=true,rss="Runecrafter",rsslvl=275},
["95BAD5DE0301010101"] = {akey="I3BD55D1517C2B5EC,103440811ED602C6,,,,,,",de="Anleitung: Brillante Rune des Lebenswiderstandes",en="Recipe: Brilliant Life Resistance Rune",fr="Recette : Rune éclatante de résistance à la Vie",ru="Эскиз: сверкающая руна сопротивляемости Жизни",icon="scroll9a",val=0,q=2,bop=true,accBound=true,Consumable=true,rss="Runecrafter",rsslvl=290,rf="Students of the Vale",rfl=2},
["D3D8A01601010101"] = {akey="I02C82C534DC6674C,1E8683888605D61A,,,,,,",de="Anleitung: Glühende Runenscherbe der Unbeugsamkeit",en="Recipe: Incandescent Indomitable Runeshard",fr="Recette : Fragment de rune indomptable incandescente",ru="Эскиз: сияющий рунный осколок стойкости",icon="scroll8b",val=1,q=3,Consumable=true,rss="Runecrafter",rsslvl=300},
["93BCA2C90301010101"] = {akey="I39289E13063FDDF3,6033E86578760BF2,,,,,,",de="Anleitung: Schwelende Rune",en="Recipe: Smoldering Rune",fr="Recette : Rune fumante",ru="Эскиз: тлеющая руна",icon="scroll8b",val=0,q=2,bop=true,accBound=true,Consumable=true,rss="Runecrafter",rsslvl=200,rf="Ember Scholars",rfl=2},
["CBE1F5FF0101010101"] = {akey="I1FFD70CB35A1FD01,774BC8260B6F8B28,,,,,,",de="Anleitung: Aurora-Rune der Einsicht",en="Recipe: Auroral Insightful Rune",fr="Plan : Rune perspicace aurorale",ru="Эскиз: Аврорская проницательная руна",icon="cloth12a",val=0,q=2,bop=true,Consumable=true,rss="Runecrafter",rsslvl=360},
["C5918CDB0201010101"] = {akey="I2B6308C5096E786D,16048DE2053C54EA,,,,,,",de="Anleitung: Brillante Rune des Lebenswiderstandes",en="Recipe: Brilliant Life Resistance Rune",fr="Recette : Rune éclatante de résistance à la Vie",ru="Эскиз: сверкающая руна сопротивляемости Жизни",icon="scroll9a",val=0,q=2,bop=true,accBound=true,Consumable=true,rss="Runecrafter",rsslvl=290,rf="Order of Life Serene",rfl=2},
["C084FCF20201010101"] = {akey="I2E5F02402071AFAD,C192599DC2214947,,,,,,",de="Anleitung: Wildheitsrune",en="Recipe: Feral Rune",fr="Recette : Rune sauvage",ru="Эскиз: руна дикости",icon="scroll9a",val=0,q=3,bop=true,Consumable=true,rss="Runecrafter",rsslvl=290},
["E7E7F5C80401010101"] = {akey="I491D73E77111F2FE,5FE5F5EB2FC0A7B0,,,,,,",de="Anleitung: Strahlende Rune des Zorns",en="Recipe: Radiant Wrathful Rune",fr="Recette : Rune de courroux rayonnante",ru="Эскиз: лучистая руна гнева",icon="scroll9a",val=0,q=1,bop=true,Consumable=true,rss="Runecrafter",rsslvl=270},
["D1918CDB0201010101"] = {akey="I2B6308D1738211E3,C8D1328AB1D95CCD,,,,,,",de="Anleitung: Flammende Rune des Tiefgrunds",en="Recipe: Blazing Recondite Rune",fr="Recette : Rune absconse flamboyante",ru="Эскиз: яркая руна могущества",icon="scroll9a",val=1,q=2,Consumable=true,rss="Runecrafter",rsslvl=290},
["9AA986EA0201010101"] = {akey="I2D41949A1392B96F,503192E60303BF24,,,,,,",de="Anleitung: Glühende Rune der Verheerung",en="Recipe: Incandescent Devastating Rune",fr="Recette : Rune dévastatrice incandescente",ru="Эскиз: сияющая руна опустошения",icon="scroll9a",val=0,q=3,bop=true,Consumable=true,rss="Runecrafter",rsslvl=300},
["D2859FE40101010101"] = {akey="I1C87C2D213C1BA20,0BEE1F200BDEE5A1,,,,,,",de="Anleitung: Brillante Rune des Wasserwiderstandes",en="Recipe: Brilliant Water Resistance Rune",fr="Recette : Rune éclatante de résistance à l'Eau",ru="Эскиз: сверкающая руна сопротивляемости Воде",icon="scroll9a",val=0,q=2,bop=true,accBound=true,Consumable=true,rss="Runecrafter",rsslvl=290,rf="Mercurial Savants",rfl=2},
["BCDBAD6701010101"] = {akey="I0CEB6DBC3AA3A2B0,142966BF8DA0A816,,,,,,",de="Anleitung: Flammende Rune des Luftwiderstandes",en="Recipe: Blazing Air Resistance Rune",fr="Recette : Rune de résistance à l'Air flamboyante",ru="Эскиз: яркая руна сопротивляемости Воздуху",icon="scroll9a",val=0,q=3,bop=true,accBound=true,Consumable=true,rss="Runecrafter",rsslvl=300,rf="The Storm Inquisition",rfl=3},
["EEF1E7850301010101"] = {akey="I30B9F8EE713F62B5,1354A2B0D831DC33,,,,,,",de="Anleitung: Flammende Rune des Luftwiderstandes",en="Recipe: Blazing Air Resistance Rune",fr="Recette : Rune de résistance à l'Air flamboyante",ru="Эскиз: яркая руна сопротивляемости Воздуху",icon="scroll9a",val=0,q=3,bop=true,accBound=true,Consumable=true,rss="Runecrafter",rsslvl=300,rf="Zephyrian Collective",rfl=3},
["CAE4B5FC0701010101"] = {akey="I7F8D724A22A896C0,FAED7938C695F6AF,,,,,,",de="Anleitung: Baustein: Grünsteinplatte",en="Recipe: Building Block: Greenstone Tile",fr="Plan : Bloc de construction : carreau de pierre verte",ru="Чертеж: Стройматериал: Черепица зеленого камня",icon="scroll4c",val=0,bop=true,Consumable=true,rss="Runecrafter",rsslvl=120},
["9CA1EFB90101010101"] = {akey="I173BD09C4F1668BA,FA8BA9F6A9DF46D7,,,,,,",de="Anleitung: Empyreum-Rune der Wut",en="Recipe: Empyrean Rage Rune",fr="Plan : Rune de rage empyréenne",ru="Эскиз: Эмпирейская руна ярости",icon="cloth12a",val=0,q=3,bop=true,Consumable=true,rss="Runecrafter",rsslvl=375},
["A78A9C840501010101"] = {akey="I508705273C189B4E,1E34A5AEA86DE930,,,,,,",de="Anleitung: Helle Rune des Rachedursts",en="Recipe: Bright Vengeful Rune",fr="Recette : Rune vengeresse brillante",ru="Эскиз: блестящая руна мести",icon="scroll1a",val=0,q=1,bop=true,Consumable=true,rss="Runecrafter",rsslvl=100},
["BDDE8DFD0F01010101"] = {akey="IFFA36F3D45708CEF,D6B45EA1337ED733,,,,,,",de="Anleitung: Schimmernde Rune der Beherrschung",en="Recipe: Gleaming Dominating Rune",fr="Plan : Rune de domination luisante",ru="Эскиз: Светящаяся руна владычества",icon="cloth12a",val=0,q=2,bop=true,Consumable=true,rss="Runecrafter",rsslvl=330},
["F3DFA5CA0201010101"] = {akey="I29496FF3533E1735,20855BC6A269DBB8,,,,,,",de="Anleitung: Leuchtende Runenscherbe der Verwüstung",en="Recipe: Luminous Ravaging Runeshard",fr="Recette : Fragment de rune ravageuse lumineuse",ru="Эскиз: искристый рунный осколок колдовства",icon="scroll8b",val=0,q=2,bop=true,Consumable=true,rss="Runecrafter",rsslvl=170},
["88F0E6BD0601010101"] = {akey="I67B9B808578490F5,B3DF609B136D16F9,,,,,,",de="Anleitung: Flammende Runenscherbe der Präzision",en="Recipe: Blazing Precise Runeshard",fr="Recette : Fragment de rune précise flamboyante",ru="Эскиз: яркий рунный осколок точности",icon="scroll8b",val=1,q=2,Consumable=true,rss="Runecrafter",rsslvl=300},
["FEEA93F40501010101"] = {akey="I5E84F57E027176B8,E6E015546DCE5500,,,,,,",de="Anleitung: Strahlende Runenscherbe der Präzision",en="Recipe: Radiant Precise Runeshard",fr="Recette : Fragment de rune précise rayonnante",ru="Эскиз: лучистый рунный осколок точности",icon="scroll8b",val=0,q=1,bop=true,Consumable=true,rss="Runecrafter",rsslvl=275},
["CCE1F5FF0101010101"] = {akey="I1FFD70CC2FF230C0,4BF5CDE0320F6874,,,,,,",de="Anleitung: Aurora-Rune der Gewandtheit",en="Recipe: Auroral Deft Rune",fr="Plan : Rune habile aurorale",ru="Эскиз: Аврорская руна подвижности",icon="cloth12a",val=0,q=2,bop=true,Consumable=true,rss="Runecrafter",rsslvl=360},
["C6918CDB0201010101"] = {akey="I2B6308C60D42C9B7,109861969CB1EF2B,,,,,,",de="Anleitung: Brillante Rune des Wasserwiderstandes",en="Recipe: Brilliant Water Resistance Rune",fr="Recette : Rune éclatante de résistance à l'Eau",ru="Эскиз: сверкающая руна сопротивляемости Воде",icon="scroll9a",val=0,q=2,bop=true,accBound=true,Consumable=true,rss="Runecrafter",rsslvl=290,rf="Order of Purity",rfl=2},
["C184FCF20201010101"] = {akey="I2E5F0241542C76C1,C5B3C3BDE5A8EF4E,,,,,,",de="Anleitung: Belebende Rune",en="Recipe: Invigorating Rune",fr="Recette : Rune tonifiante",ru="Эскиз: рунный осколок шанса",icon="scroll9a",val=0,q=3,bop=true,Consumable=true,rss="Runecrafter",rsslvl=290},
["E8E7F5C80401010101"] = {akey="I491D73E870D7D1D0,19BE7B94C1AF93C2,,,,,,",de="Anleitung: Strahlende Rune der Beherrschung",en="Recipe: Radiant Dominating Rune",fr="Recette : Rune de domination rayonnante",ru="Эскиз: лучистая руна владычества",icon="scroll9a",val=0,q=1,bop=true,Consumable=true,rss="Runecrafter",rsslvl=270},
["F0ADE2C90701010101"] = {akey="I793896F0358B2DE6,0306B5740716492D,,,,,,",de="Anleitung: Flammende Rune des Lebenswiderstandes",en="Recipe: Blazing Life Resistance Rune",fr="Recette : Rune de résistance à la Vie flamboyante",ru="Эскиз: яркая руна сопротивляемости Жизни",icon="scroll9a",val=0,q=3,bop=true,accBound=true,Consumable=true,rss="Runecrafter",rsslvl=300,rf="Students of the Vale",rfl=3},
}

nkItemBase.db.recipe.survival={
["81A699BE0301010101"] = {akey="I37C653017BC6BA46,8D615317FF7E1104,,,,,,",de="Anleitung: Fass mit Äpfeln",en="Recipe: Barrel of Apples",fr="Plan : Tonneau de pommes",ru="Рецепт: Бочка яблок",icon="scroll4c",val=0,bop=true,Consumable=true,rss="Survival",rsslvl=120},
["DDCC83BD0301010101"] = {akey="I37A0E65D015BDC9F,4B0A9DDAC3A1D262,,,,,,",de="Anleitung: Kuchen der Feen",en="Recipe: Cake of the Fae",fr="Gâteau des Fées",ru="Рецепт: Пирог по-фейски",icon="sealed_parchment",val=0,q=2,Consumable=true,rss="Survival",rsslvl=330},
["E492E6EF0F01010101"] = {akey="IFDF989640114789E,EBA8C784CCF4B6D2,,,,,,",de="Anleitung: Alter Aal",en="Recipe: Aged Eel",fr="Recette : Vieille anguille",ru="Рецепт: Выдержанный угорь",icon="scroll5b",val=0,q=1,Consumable=true,rss="Survival",rsslvl=365},
["82A699BE0301010101"] = {akey="I37C65302497ABD67,87384800EB386C19,,,,,,",de="Anleitung: Küchenmesser",en="Recipe: Kitchen Knife",fr="Plan : Couteau de cuisine",ru="Чертеж: Кухонный нож",icon="scroll4c",val=0,bop=true,Consumable=true,rss="Survival",rsslvl=180},
["FEC290B60301010101"] = {akey="I36C4217E4C16870A,2B8CE088C0AB1356,,,,,,",de="Anleitung: Festmahl des Geschicks",en="Recipe: Feast of Aptitude",fr="Recette : Festin d'aptitude",ru="Рецепт: амброзия способностей",icon="scroll4d",val=12500,q=1,Consumable=true,rss="Survival",rsslvl=300},
["DECC83BD0301010101"] = {akey="I37A0E65E39285657,5ACFC6919A9D4F91,,,,,,",de="Anleitung: Irrlicht-Sahnepastete",en="Recipe: Wispy Whipped Pastry",fr="Recette : Pâtisserie légère du Feu-follet",ru="Рецепт: Воздушное пирожное",icon="sealed_parchment",val=0,q=2,Consumable=true,rss="Survival",rsslvl=340},
["A2C48FA40601010101"] = {akey="I6483E22234D47E63,E955301FA50D74DA,,,,,,",de="Anleitung: Aal-Filet",en="Recipe: Eel Fillet",fr="Recette : Filet d'anguille",ru="Рецепт: филе угря",icon="scroll4d",val=9700,q=1,Consumable=true,rss="Survival",rsslvl=285},
["E592E6EF0F01010101"] = {akey="IFDF9896547F9BE6C,1398CF19C3919979,,,,,,",de="Anleitung: Premium-Fliegenfänger",en="Recipe: Prime Flycatcher",fr="Recette : Attrape-mouches de premier choix",ru="Рецепт: Первичная мухоловка",icon="scroll5b",val=0,q=1,Consumable=true,rss="Survival",rsslvl=355},
["83A699BE0301010101"] = {akey="I37C6530324999551,28F1EE33678DF4AC,,,,,,",de="Anleitung: Korb mit Karotten",en="Recipe: Basket of Carrots",fr="Plan : Panier de carottes",ru="Рецепт: Корзина моркови",icon="scroll4c",val=0,bop=true,Consumable=true,rss="Survival",rsslvl=240},
["DFCC83BD0301010101"] = {akey="I37A0E65F1A947A0E,7A014A2D65B75501,,,,,,",de="Anleitung: Schmaus des Wesens der Tiefe",en="Recipe: Deep Ones' Delight",fr="Recette : Plaisir des Profonds",ru="Рецепт: Деликатес глубинных",icon="sealed_parchment",val=0,q=2,Consumable=true,rss="Survival",rsslvl=320},
["A3C48FA40601010101"] = {akey="I6483E22307AA0E7B,F34A405B2CFEBE5A,,,,,,",de="Anleitung: Fleckfischsteak",en="Recipe: Ember Steak",fr="Recette : Steak braisé",ru="Рецепт: угольный стейк",icon="scroll4d",val=9700,q=1,Consumable=true,rss="Survival",rsslvl=270},
["E692E6EF0F01010101"] = {akey="IFDF98966649C0A49,06DD9F1809BA10F7,,,,,,",de="Anleitung: Kraken-Horsd'œuvre",en="Recipe: Kraken Hors D'oeuvres",fr="Recette : Hors d'œuvres au kraken",ru="Рецепт: Закуски из кракена",icon="scroll5b",val=0,q=1,Consumable=true,rss="Survival",rsslvl=370},
["84A699BE0301010101"] = {akey="I37C653047295FB84,3751CE22B8DB66FC,,,,,,",de="Anleitung: Kiste mit Artischocken",en="Recipe: Crate of Artichokes",fr="Plan : Caisse d'artichauts",ru="Рецепт: Ящик артишоков",icon="scroll4c",val=0,bop=true,Consumable=true,rss="Survival",rsslvl=300},
["E0CC83BD0301010101"] = {akey="I37A0E66022017304,0EF2900F4D8D4900,,,,,,",de="Anleitung: Zombiegeformter Pudding",en="Recipe: Zombie Molded Pudding",fr="Recette : Pudding en forme de zombie",ru="Рецепт: Пудинг в форме зомби",icon="sealed_parchment",val=0,q=2,Consumable=true,rss="Survival",rsslvl=350},
["A4C48FA40601010101"] = {akey="I6483E224377ED516,26F990A05A087EB5,,,,,,",de="Anleitung: Rochen in Aspik",en="Recipe: Jellied Ray",fr="Recette : Raie en gelée",ru="Рецепт: заливной скат",icon="scroll4d",val=9700,q=1,Consumable=true,rss="Survival",rsslvl=280},
["E792E6EF0F01010101"] = {akey="IFDF9896736659DF6,E0F47EB8698564BD,,,,,,",de="Anleitung: Gefüllte Champignons",en="Recipe: Stuffed Mushrooms",fr="Recette : Champignons farcis",ru="Рецепт: Фаршированные грибы",icon="scroll5b",val=0,q=1,Consumable=true,rss="Survival",rsslvl=365},
["E5BFB9E40F01010101"] = {akey="IFC8E5FE56865332A,2C851CC872208CAE,,,,,,",de="Anleitung: Oranger Seestern",en="Recipe: Orange Sea Star",fr="Recette : Étoile de mer orange",ru="Рецепт: Оранжевая морская звезда",icon="scroll8b",val=10000,bop=true,Consumable=true,rss="Survival",rsslvl=305},
["85A699BE0301010101"] = {akey="I37C6530504C9B714,49542537C4382E25,,,,,,",de="Anleitung: Dekorative Rote Süßbeere",en="Recipe: Decorative Red Sweetberry",fr="Recette : Baie rouge décorative",ru="Рецепт: Укрпшение из красной калины",icon="scroll4c",val=0,bop=true,Consumable=true,rss="Survival",rsslvl=360},
["A5C48FA40601010101"] = {akey="I6483E2255A3D6D55,EA5FACB5780B0079,,,,,,",de="Anleitung: Schnapper-Dörrfleisch",en="Recipe: Snapper Jerky",fr="Recette : Vivaneau séché",ru="Рецепт: вяленый люциан",icon="scroll4d",val=9700,q=1,Consumable=true,rss="Survival",rsslvl=295},
["E085F3930401010101"] = {akey="I427CC2E07D9AB55D,E571C11632215A0F,,,,,,",de="Anleitung: Fischgrätensäge",en="Recipe: Fish Spine Saw",fr="Recette : Scie en arêtes de poisson",ru="Чертеж: Пила из рыбьего позвоночника",icon="scroll8b",val=0,bop=true,Consumable=true,rss="Survival",rsslvl=300},
["E892E6EF0F01010101"] = {akey="IFDF98968158D1CFB,5149DC9CD334AF67,,,,,,",de="Anleitung: Gekühlter Oktopus",en="Recipe: Chilled Octopus",fr="Recette : Pieuvre glacée",ru="Рецепт: Охлажденный осьминог",icon="scroll5b",val=0,q=1,Consumable=true,rss="Survival",rsslvl=355},
["E6BFB9E40F01010101"] = {akey="IFC8E5FE61AF06599,D12DB1C7CAEEBEC9,,,,,,",de="Anleitung: Roter Seestern",en="Recipe: Red Sea Star",fr="Recette : Étoile de mer rouge",ru="Рецепт: Красная морская звезда",icon="scroll8b",val=30000,bop=true,Consumable=true,rss="Survival",rsslvl=375},
["E185F3930401010101"] = {akey="I427CC2E14FCDC3B5,1AF6F035E84F3E00,,,,,,",de="Anleitung: Handschuhe des Überlebenskünstlers",en="Recipe: Survivalist's Gloves",fr="Recette : Gants de survie",ru="Рецепт: Перчатки скаута",icon="scroll8b",val=0,bop=true,Consumable=true,rss="Survival",rsslvl=300},
["E285F3930401010101"] = {akey="I427CC2E232BF7848,2CF9CA9873AC052A,,,,,,",de="Anleitung: Hosen des Überlebenskünstlers",en="Recipe: Survivalist's Trousers",fr="Recette : Chausses de survie",ru="Рецепт: Штаны скаута",icon="scroll8b",val=0,bop=true,Consumable=true,rss="Survival",rsslvl=300},
["E385F3930401010101"] = {akey="I427CC2E352E064D0,2B301572453070F5,,,,,,",de="Anleitung: Wams des Überlebenskünstlers",en="Recipe: Survivalist's Vest",fr="Recette : Gilet de survie",ru="Рецепт: Жилет скаута",icon="scroll8b",val=0,bop=true,Consumable=true,rss="Survival",rsslvl=300},
["F9C290B60301010101"] = {akey="I36C421790938D692,145F260BBEC89739,,,,,,",de="Anleitung: Breitmaul-Sashimi",en="Recipe: Widemouth Sashimi",fr="Recette : Sashimi de perche truitée",ru="Рецепт: сашими из широкопаста",icon="scroll4d",val=350,q=1,Consumable=true,rss="Survival",rsslvl=165},
["E485F3930401010101"] = {akey="I427CC2E45B7FA7BD,30C01ECBBC8A3266,,,,,,",de="Anleitung: Stiefel des Überlebenskünstlers",en="Recipe: Survivalist's Boots",fr="Recette : Bottes de survie",ru="Рецепт: Сапоги скаута",icon="scroll8b",val=0,bop=true,Consumable=true,rss="Survival",rsslvl=300},
["FAC290B60301010101"] = {akey="I36C4217A64530C3F,2F3153B624199290,,,,,,",de="Anleitung: Flinker Haifisch-Imbiss",en="Recipe: Speedy Shark Snack",fr="Recette : Petit en-cas de requin",ru="Рецепт: палочки из быстрой акулы",icon="scroll4d",val=100,q=1,Consumable=true,rss="Survival",rsslvl=35},
["FBC290B60301010101"] = {akey="I36C4217B780C1A1F,E2E0A3FCD12352EA,,,,,,",de="Anleitung: Festmahl der Effizienz",en="Recipe: Feast of Efficacy",fr="Recette : Festin d'efficacité",ru="Рецепт: амброзия эффективности",icon="scroll4d",val=12500,q=1,Consumable=true,rss="Survival",rsslvl=300},
["DBCC83BD0301010101"] = {akey="I37A0E65B2B7477AE,241700E4506F9A89,,,,,,",de="Anleitung: Festmahl der Beherrschung",en="Recipe: Feast of Domination",fr="Recette : Festin de domination",ru="Рецепт: Пир покорения",icon="sealed_parchment",val=0,q=3,Consumable=true,rss="Survival",rsslvl=375},
["80A699BE0301010101"] = {akey="I37C653004E89C34F,81EE2C68D8D9B548,,,,,,",de="Anleitung: Aufgerollte Bettrolle",en="Recipe: Rolled Bedroll",fr="Patron : Couchage roulé",ru="Выкройка: Спальный мешок",icon="scroll4c",val=0,bop=true,Consumable=true,rss="Survival",rsslvl=60},
["FCC290B60301010101"] = {akey="I36C4217C2C85A078,4258E4715D736F0B,,,,,,",de="Anleitung: Frittierter Oktopus",en="Recipe: Fried Octopus",fr="Recette : Poulpe frit",ru="Рецепт: жареный осьминог",icon="scroll4d",val=350,q=1,Consumable=true,rss="Survival",rsslvl=155},
["DCCC83BD0301010101"] = {akey="I37A0E65C1888777D,52FD8863570398EC,,,,,,",de="Anleitung: Racheschmaus",en="Recipe: Feast of Vengeance",fr="Recette : Festin de vengeance",ru="Рецепт: Пир отмщения",icon="sealed_parchment",val=0,q=3,Consumable=true,rss="Survival",rsslvl=375},
["9EDF93FB0301010101"] = {akey="I3F64EF9E74CD8011,40BF19CAEC19EC66,,,,,,",de="Anleitung: Schneidflossen-koteletts",en="Recipe: Sharpfin Chops",fr="Recette : Grillades de Vive coupante",ru="Рецепт: Котлеты из острошкура",icon="scroll5b",val=0,q=1,Consumable=true,rss="Survival",rsslvl=355},
["E392E6EF0F01010101"] = {akey="IFDF9896372EE312B,E95D3C3E32902DC5,,,,,,",de="Anleitung: Sonnensuppe",en="Recipe: Sun Soup",fr="Recette : Soupe du soleil",ru="Рецепт: Солнечный суп",icon="scroll5b",val=0,q=1,Consumable=true,rss="Survival",rsslvl=370},
}

nkItemBase.db.recipe.items={
["C2C6E9F10F01010101"] = {akey="IFE3A6342495D47C8,5BEFA3945B4B48A1,,,,,,",de="Wolkenbruch-Anleitungen",en="Cloudburst Instructions",fr="Instructions de l'Averse",ru="Инструкции Облачного взрыва",icon="scroll2a",val=0,bop=true},
["E0A99BDB0F01010101"] = {akey="IFB66D4E07B682644,36C35C37354D568D,,,,,,",de="Alchemie: Anleitungen für Fortgeschrittene",en="Alchemy: Advanced Recipes",fr="Alchimie : recettes avancées",ru="Алхимия: продвинутые рецепты",icon="book6",val=1},
}

